#!/bin/bash
#
# call_mail_ret.sh
#
# send mail with attachments (mailreports)
#
# usage: call_mail_ret.sh <address> <cc> <returnaddr> <subject> <bodyfile> <attachments>
###################################################################################
#
# Wenn es keine Anhaenge gibt und der Body leer ist, dann Ende
if [[ -z "$6" && ! -s "$5" ]]
 then
  exit 0
fi
#
SUBJECT=$(echo $4)
MAIL=`which mail`
if [[ -z "$MAIL" ]]
 then
  MAIL=`which mailx`
  if [[ -z "$MAIL" ]]
   then
    MAIL=`which s-nail`
  fi
fi
if [[ -n "$MAIL" ]]
 then
  MAILPRG=`readlink -e "$MAIL"`
  if [[ "$MAILPRG" == *s-nail || "$MAILPRG" == *mailx* && "$MAILPRG" != *bsd-mailx ]]
   then
    if [[ -n "$2" ]]
     then
      if [[ -n "$3" ]]
       then
        eval '$MAILPRG -c "$2" -r "$3" -s "$SUBJECT" '"$6"' "$1" <"$5"'
      else
        eval '$MAILPRG -c "$2" -s "$SUBJECT" '"$6"' "$1" <"$5"'
      fi
    elif [[ -n "$3" ]]
     then
      eval '$MAILPRG -r "$3" -s "$SUBJECT" '"$6"' "$1" <"$5"'
    else
      eval '$MAILPRG -s "$SUBJECT" '"$6"' "$1" <"$5"'
    fi
  else
    if [[ -n "$2" ]]
     then
      eval '$MAILPRG -c "$2" -s "$SUBJECT" "$1" <"$5"'
    else
      eval '$MAILPRG -s "$SUBJECT" "$1" <"$5"'
    fi
  fi
else
  echo "ERROR: No mail program found."
fi
