#!/bin/bash
#
# get_report_csvs.sh
#
# read all csv date for one report
#
# usage: get_report_csvs.sh [-z <zipfilename>] <url> <attachmentpath> <reportsid> [<serveraliasnames>]
######################################################################################################
#
ULSREPUSER=doreport
ULSREPPWD=getreport
ULSREPHOST=ulsap:11975
#
unset ZIPFILE
#
if [[ "$1" = "-z" ]]
 then
  if which zip &>/dev/null
   then
    ZIPFILE="${2:-csv-files}"
    ZIPFILE="${ZIPFILE%.zip}.zip"
  fi
  shift
  shift
fi
#
if cd $2
 then
  httpget -s -u "$ULSREPUSER" -p "$ULSREPPWD" $ULSREPHOST "$1" | while read id lfnr name
   do
    fn="${name:-table}_$lfnr.csv"
    httpget -q -f "$fn" -u "$ULSREPUSER" -p "$ULSREPPWD" $ULSREPHOST "get_report_csv.s2w?reportsid=$3&id=$id&serveraliasnames=$4"
    if [[ -s "$fn" ]]
     then
      if [[ -z "$ZIPFILE" ]]
       then
        echo "-a \"$fn\""
      fi
    else
      rm "$fn"
    fi
  done
  if [[ -n "$ZIPFILE" ]]
   then
    if ls *.csv &>/dev/null
     then
      zip "$ZIPFILE" *.csv &>/dev/null
      echo "-a \"$ZIPFILE\""
    fi
  fi
fi
