#!/bin/bash
#
# postinst.sh
#
# Postinstall script V 1.9.2 -> 1.9.3
#
# Wenn gnuplot kein pngcairo zur Verfuegung stellt, dann auf png aendern
# und encoding anpassen, denn UTF-8 wird nur von pngcairo unterstuetzt
#
# Wenn kein Maria-DB ab V 10.0, dann gibts kein "default_regex_flags"
#
# DB-Kennwoerter aendern
#######################################################################################
#
export PATH=/usr/local/bin:/usr/bin:$PATH
#
ULSDIR="$1"
#
MYSQLDEFAULTS="$2"
MYSQLO="mysql --defaults-extra-file=$MYSQLDEFAULTS -B -N logging"
MYSQLMO="mysql --defaults-extra-file=$MYSQLDEFAULTS -B -N mysql"
MYSQLM="mysql --defaults-extra-file=$MYSQLDEFAULTS -n mysql"
#
if echo "set terminal" | gnuplot 2>&1 | fgrep -q pngcairo
 then
  if fgrep -q 'set terminal png font ' "$ULSDIR/html/user/loggingout_grafik.s3w"
   then
    echo "pngcairo is supportet by gnuplot - patch loggingout_grafik.s3w to pngcairo"
    sed -i 's/set terminal png font /set terminal pngcairo font /' "$ULSDIR/html/user/loggingout_grafik.s3w"
    sed -i 's/^#.*#set encoding utf8/set encoding utf8/;s/^set encoding iso_8859/#pngcairo is available#set encoding iso_8859/' "$ULSDIR/wwwbin/loggingout_grafik_prescript.plt"
    sed -i 's/ | recode UTF-8..ISO-8859-15 | gnuplot / | gnuplot /' "$ULSDIR/wwwbin/loggingout_grafik.sh"
  fi
else
  if fgrep -q 'set terminal pngcairo font ' "$ULSDIR/html/user/loggingout_grafik.s3w"
   then
    echo "pngcairo is not supportet by gnuplot - patch loggingout_grafik.s3w to png"
    sed -i 's/set terminal pngcairo font /set terminal png font /' "$ULSDIR/html/user/loggingout_grafik.s3w"
    sed -i 's/^set encoding utf8/#has no pngcairo#set encoding utf8/;s/^#.*#set encoding iso_8859/set encoding iso_8859/' "$ULSDIR/wwwbin/loggingout_grafik_prescript.plt"
    sed -i 's/ | gnuplot / | recode UTF-8..ISO-8859-15 | gnuplot /' "$ULSDIR/wwwbin/loggingout_grafik.sh"
  fi
fi
#
if gnuplot -V | grep -q 'gnuplot 4.[0-5]'
 then
  if grep -q '^set grid xtics ytics lt 1 linecolor rgb "#E0E0E0"' "$ULSDIR/wwwbin/loggingout_grafik_prescript.plt"
   then
    echo "gnuplot version is less than 4.6 change linetype for xytics"
    sed -i 's/^set grid xtics ytics lt 1 linecolor rgb "#E0E0E0"/#no support for linecolor#set grid xtics ytics lt 1 linecolor rgb "#E0E0E0"/' "$ULSDIR/wwwbin/loggingout_grafik_prescript.plt"
  fi
else
  if grep -q '^#.*#set grid xtics ytics lt 1 linecolor rgb "#E0E0E0"' "$ULSDIR/wwwbin/loggingout_grafik_prescript.plt"
   then
    echo "gnuplot version is greater or equal to 4.6 change linetype for xytics"
    sed -i 's/^#.*#set grid xtics ytics lt 1 linecolor rgb "#E0E0E0"/set grid xtics ytics lt 1 linecolor rgb "#E0E0E0"/' "$ULSDIR/wwwbin/loggingout_grafik_prescript.plt"
  fi
fi
#
#
if cd $ULSDIR/ulsmeld
 then
  REGEXPFLAGS=`$MYSQLO -e "show variables like '%regex%'"`
  if [[ -z "$REGEXPFLAGS" ]]
   then
    grep -q "^ *%mysqlwrite[(]\"set default_regex_flags='DOTALL'\"[)]" test_limits.s2w && sed -i "s/^\( *%mysqlwrite[(]\"set default_regex_flags='DOTALL'\"[)]\)/%%\1/" ../html/user/login.i2w test_isalive.s2w test_klimits.s2w test_kombilimits.s2w test_limits.s2w utt_escalation.s2w
  else
    grep -q "^%% *%mysqlwrite[(]\"set default_regex_flags='DOTALL'\"[)]" test_limits.s2w && sed -i "s/^%%\( *%mysqlwrite[(]\"set default_regex_flags='DOTALL'\"[)]\)/\1/" ../html/user/login.i2w test_isalive.s2w test_klimits.s2w test_kombilimits.s2w test_limits.s2w utt_escalation.s2w
  fi
fi
#
#
if [[ ! -f $ULSDIR/database.conf && ! -f $ULSDIR/u2w.conf ]]
 then
  LOGGINGPWD=`tr -Cd '[:alnum:],.:_+=/%-' </dev/urandom | head -c 12`
  LOGGINGADMINPWD=`tr -Cd '[:alnum:],.:_+=/%-' </dev/urandom | head -c 12`
  LOGGINGLESENPWD=`tr -Cd '[:alnum:],.:_+=/%-' </dev/urandom | head -c 12`
  LOGGINGTESTPWD=`tr -Cd '[:alnum:],.:_+=/%-' </dev/urandom | head -c 12`
  echo "LOGGINGHOST='localhost'
LOGGINGPWD='$LOGGINGPWD'

LOGGINGADMINHOST='localhost'
LOGGINGADMINPWD='$LOGGINGADMINPWD'

LOGGINGLESENHOST='localhost'
LOGGINGLESENPWD='$LOGGINGLESENPWD'

LOGGINGTESTHOST='localhost'
LOGGINGTESTPWD='$LOGGINGTESTPWD'" >"$ULSDIR/database.conf"
  chmod 640 "$ULSDIR/database.conf"
  chown uls:ulsuser "$ULSDIR/database.conf"
  echo "# Hosts and password for DB-Connection

# User 'logging': store data from clients
logginghost = 'localhost'
loggingpwd = '$LOGGINGPWD'

# User 'logginglesen': User menu
logginglesenhost = 'localhost'
logginglesenpwd = '$LOGGINGLESENPWD'

# User 'loggingadmin': Admin menu
loggingadminhost = 'localhost'
loggingadminpwd = '$LOGGINGADMINPWD'

# User 'loggingtest': check limits
loggingtesthost = 'localhost'
loggingtestpwd = '$LOGGINGTESTPWD'" >"$ULSDIR/u2w.conf"
  chmod 640 "$ULSDIR/u2w.conf"
  chown uls:ulsuser "$ULSDIR/u2w.conf"
  #
  # Kennwoerter in der DB aendern
  $MYSQLMO -e "select user, host from user where user = 'logging'" | while read u h
   do
    $MYSQLM -e "set password for '$u'@'$h' = password('$LOGGINGPWD')"
  done
  $MYSQLMO -e "select user, host from user where user = 'logginglesen'" | while read u h
   do
    $MYSQLM -e "set password for '$u'@'$h' = password('$LOGGINGLESENPWD')"
  done
  $MYSQLMO -e "select user, host from user where user = 'loggingadmin'" | while read u h
   do
    $MYSQLM -e "set password for '$u'@'$h' = password('$LOGGINGADMINPWD')"
  done
  $MYSQLMO -e "select user, host from user where user = 'loggingtest'" | while read u h
   do
    $MYSQLM -e "set password for '$u'@'$h' = password('$LOGGINGTESTPWD')"
  done
  #
  sed -i "s|-b $ULSDIR/wwwbin|-Xi $ULSDIR/u2w.conf -b $ULSDIR/wwwbin|" $(grep -l "U2WPARS=.*-b $ULSDIR/wwwbin" `grep -vl 'U2WPARS=.*-Xi ' /etc/unix2web/*.conf`)
  for i in $(grep -l "U2WPARS=.*-b $ULSDIR/wwwbin" /etc/unix2web/*.conf)
   do
    /etc/init.d/unix2web restart $i
  done
fi
#
if grep -q ' uls .*/srv/uls/jobs/ping_clients.sh' /etc/cron.d/ulsserver
 then
  echo "WARNING: changed /etc/cron.d/ulsserver to run ping_clients.sh as wwwuls"
  sed -i '/ uls .*\/srv\/uls\/jobs\/ping_clients.sh/s/ uls / wwwuls /' /etc/cron.d/ulsserver
fi
