set @@character_set_client = 'utf8';

-- Bei Server, die auf "no alarms" und firstseen auf '0000-00-00' stehen
-- Ein Datum eintragen, wenn in serverdates gefunden


delimiter //

DROP procedure IF EXISTS activateserver//
create procedure activateserver()
  deterministic
  sql security invoker
  begin

  declare noalarmsdays integer;

-- Serverdates

    create temporary table loggingtmp.sn (primary key(serverID))
      select ID as serverID from server
      where firstseen = '0000-00-00' and state = 'noalarms';

    create temporary table loggingtmp.sd
      (primary key(ID, mindate))
      select serverID as ID, min(fdate) as mindate
      from loggingtmp.sn
      join serverdates using(serverID)
      group by serverID;

    update server join loggingtmp.sd using(ID)
      set firstseen = mindate;

    select wert+0 from systemvars where name = 'noalarmsdays'
      into noalarmsdays;

    if noalarmsdays > 0 then
      delete from loggingtmp.sn;
      insert into loggingtmp.sn (serverID)
        select ID as serverID from server
        where firstseen != '0000-00-00' and firstseen != '9999-12-31' and state = 'noalarms';
      update server join loggingtmp.sn on sn.serverID = server.ID
        set state = 'active'
        where firstseen <= curdate() - interval noalarmsdays day;
    end if;

    drop temporary table loggingtmp.sn, loggingtmp.sd;

  end//

GRANT EXECUTE on PROCEDURE activateserver to loggingadmin@'localhost'//
