set @@character_set_client = 'utf8';

delimiter //

drop trigger if exists autoisalive_au//
create trigger autoisalive_au after update on autoisalive
  for each row 
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID, userID, username, action,
     classes, server, section, teststep, details, unit, newvalues)
  select NEW.verfahrenID, NEW.accessID, 'autoisalive', NEW.ID,
    coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'update',
    showreg(NEW.classes, NEW.classes_v), showreg(NEW.server, NEW.server_v), showreg(NEW.section, NEW.section_v),
    showreg(NEW.teststep, NEW.teststep_v), showreg(NEW.details, NEW.details_v),
    showreg(NEW.einheit, NEW.einheit_v),
    concat('period=', NEW.maxperiods, '\nperiodunit=', intervalle.name, '\nmsglevel=', NEW.msglevel,
           '\nnotifymode=', NEW.notifymode, '\nautoclose=', NEW.autoclose, '\nmessage=', quotenl(NEW.meldung),
           '\ndestination1=', notifdestname(NEW.meldungszielID), '\ndestination2=', notifdestname(NEW.meldungsziel2ID),
           '\nremark=', quotenl(NEW.bemerkungen), '\nactive=', NEW.aktiv)
  from intervalle
  where NEW.TS != OLD.TS and intervalle.ID = NEW.intervalleID;
end//


drop trigger if exists autoisalive_ai//
create trigger autoisalive_ai after insert on autoisalive
  for each row 
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID, userID, username, action,
     classes, server, section, teststep, details, unit, newvalues)
  select NEW.verfahrenID, NEW.accessID, 'autoisalive', NEW.ID,
    coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'insert',
    showreg(NEW.classes, NEW.classes_v), showreg(NEW.server, NEW.server_v), showreg(NEW.section, NEW.section_v),
    showreg(NEW.teststep, NEW.teststep_v), showreg(NEW.details, NEW.details_v),
    showreg(NEW.einheit, NEW.einheit_v),
    concat('period=', NEW.maxperiods, '\nperiodunit=', intervalle.name, '\nmsglevel=', NEW.msglevel,
           '\nnotifymode=', NEW.notifymode, '\nautoclose=', NEW.autoclose, '\nmessage=', quotenl(NEW.meldung),
           '\ndestination1=', notifdestname(NEW.meldungszielID), '\ndestination2=', notifdestname(NEW.meldungsziel2ID),
           '\nremark=', quotenl(NEW.bemerkungen), '\nactive=', NEW.aktiv)
  from intervalle
  where intervalle.ID = NEW.intervalleID;
end//


drop trigger if exists autoisalive_bd//
create trigger autoisalive_bd before delete on autoisalive
  for each row
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID, userID, username, action,
     classes, server, section, teststep, details, unit, newvalues)
  select OLD.verfahrenID, OLD.accessID, 'autoisalive', OLD.ID,
    coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'delete',
    showreg(OLD.classes, OLD.classes_v), showreg(OLD.server, OLD.server_v), showreg(OLD.section, OLD.section_v),
    showreg(OLD.teststep, OLD.teststep_v), showreg(OLD.details, OLD.details_v),
    showreg(OLD.einheit, OLD.einheit_v),
    coalesce(if(OLD.bemerkungen = @isaliveremark, '', concat('remark=', quotenl(@isaliveremark))),'');
end//

delimiter ;
