set @@character_set_client = 'utf8';

delimiter //

drop trigger if exists autokombilimits_au//
create trigger autokombilimits_au after update on autokombilimits
  for each row 
begin
  if NEW.TS != OLD.TS then
    insert into changeprot
     (domainID, accessID, changedtable, tableID,
      userID, username, action, classes, server, section, teststep, newvalues)
    values
     (NEW.verfahrenID, NEW.accessID, 'autokombilimits', NEW.ID,
      coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'update',
      showreg(NEW.classes, NEW.classes_v), showreg(NEW.server, NEW.server_v), showreg(NEW.section, NEW.section_v),
      showreg(NEW.teststep, NEW.teststep_v),
      concat('expression=', NEW.expression, '\nrelation=', NEW.relation, '\ninfolevel=',
             NEW.infolevel, '\nwarnlevel=', NEW.warnlevel, '\nerrorlevel=', NEW.errorlevel,
             '\nnotifymode=', NEW.notifymode, '\nmessage=', quotenl(NEW.meldung),
             '\ndestination1=', notifdestname(NEW.meldungszielID),
             '\ndestination2=', notifdestname(NEW.meldungsziel2ID), '\nremark=',
             quotenl(NEW.bemerkungen), '\nactive=', NEW.aktiv));
  end if;
end//


drop trigger if exists autokombilimits_ai//
create trigger autokombilimits_ai after insert on autokombilimits
  for each row 
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID,
     userID, username, action, classes, server, section, teststep, newvalues)
  values
    (NEW.verfahrenID, NEW.accessID, 'autokombilimits', NEW.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'insert',
     showreg(NEW.classes, NEW.classes_v), showreg(NEW.server, NEW.server_v), showreg(NEW.section, NEW.section_v),
     showreg(NEW.teststep, NEW.teststep_v),
     concat('expression=', NEW.expression, '\nrelation=', NEW.relation, '\ninfolevel=',
            NEW.infolevel, '\nwarnlevel=', NEW.warnlevel, '\nerrorlevel=', NEW.errorlevel,
            '\nnotifymode=', NEW.notifymode, '\nmessage=', quotenl(NEW.meldung),
            '\ndestination1=', notifdestname(NEW.meldungszielID),
            '\ndestination2=', notifdestname(NEW.meldungsziel2ID), '\nremark=',
            quotenl(NEW.bemerkungen), '\nactive=', NEW.aktiv));
end//


drop trigger if exists autokombilimits_bd//
create trigger autokombilimits_bd before delete on autokombilimits
  for each row 
begin
  insert into changeprot
    (domainID, accessID, changedtable, tableID,
     userID, username, action, classes, server, section, teststep, newvalues)
  values
    (OLD.verfahrenID, OLD.accessID, 'autokombilimits', OLD.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'delete',
     showreg(OLD.classes, OLD.classes_v), showreg(OLD.server, OLD.server_v), showreg(OLD.section, OLD.section_v),
     showreg(OLD.teststep, OLD.teststep_v),
     coalesce(if(OLD.bemerkungen = @combilimitsremark, '', concat('remark=', quotenl(@combilimitsremark))),''));
end//

delimiter ;
