set @@character_set_client = 'utf8';

delimiter //

drop trigger if exists gautocombilimits_au//
create trigger gautocombilimits_au after update on gautocombilimits
  for each row 
begin
  insert into changeprot
    (groupID, accessID, changedtable, tableID, userID, username, action,
     domain, classes, server, section, teststep, newvalues)
  select NEW.groupID, NEW.accessID, 'gautocombilimits', NEW.ID,
    coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'update',
    showreg(NEW.domain, NEW.domain_v), showreg(NEW.classes, NEW.classes_v), showreg(NEW.server, NEW.server_v),
    showreg(NEW.section, NEW.section_v), showreg(NEW.teststep, NEW.teststep_v),
    concat('expression=', NEW.expression, '\nrelation=', NEW.relation, '\ninfolevel=',
           NEW.infolevel, '\nwarnlevel=', NEW.warnlevel, '\nerrorlevel=', NEW.errorlevel,
           '\nnotifymode=', NEW.notifymode, '\nmessage=', quotenl(NEW.meldung),
           '\ndestination1=', notifdestname(NEW.meldungszielID),
           '\ndestination2=', notifdestname(NEW.meldungsziel2ID), '\nremark=',
           quotenl(NEW.bemerkungen), '\nonlyifnoother=', NEW.nootherflag, '\nactive=', NEW.aktiv)
  from dual
  where NEW.TS != OLD.TS;
end//


drop trigger if exists gautocombilimits_ai//
create trigger gautocombilimits_ai after insert on gautocombilimits
  for each row 
begin
  insert into changeprot
    (groupID, accessID, changedtable, tableID, userID, username, action,
     domain, classes, server, section, teststep, newvalues)
  values
    (NEW.groupID, NEW.accessID, 'gautocombilimits', NEW.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'insert',
     showreg(NEW.domain, NEW.domain_v), showreg(NEW.classes, NEW.classes_v), showreg(NEW.server, NEW.server_v),
     showreg(NEW.section, NEW.section_v), showreg(NEW.teststep, NEW.teststep_v),
     concat('expression=', NEW.expression, '\nrelation=', NEW.relation, '\ninfolevel=',
            NEW.infolevel, '\nwarnlevel=', NEW.warnlevel, '\nerrorlevel=', NEW.errorlevel,
            '\nnotifymode=', NEW.notifymode, '\nmessage=', quotenl(NEW.meldung),
            '\ndestination1=', notifdestname(NEW.meldungszielID),
            '\ndestination2=', notifdestname(NEW.meldungsziel2ID), '\nremark=',
            quotenl(NEW.bemerkungen), '\nonlyifnoother=', NEW.nootherflag, '\nactive=', NEW.aktiv));
end//


drop trigger if exists gautocombilimits_bd//
create trigger gautocombilimits_bd before delete on gautocombilimits
  for each row 
begin
  insert into changeprot
    (groupID, accessID, changedtable, tableID, userID, username, action,
     domain, classes, server, section, teststep, newvalues)
  values
    (OLD.groupID, OLD.accessID, 'gautocombilimits', OLD.ID,
     coalesce(@userid,0), coalesce(@username,'SYSTEM'), 'delete',
     showreg(OLD.domain, OLD.domain_v), showreg(OLD.classes, OLD.classes_v), showreg(OLD.server, OLD.server_v),
     showreg(OLD.section, OLD.section_v), showreg(OLD.teststep, OLD.teststep_v),
     coalesce(if(OLD.bemerkungen = @combilimitsremark, '', concat('remark=', quotenl(@combilimitsremark))),''));
end//

delimiter ;
