set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS genreg//
create function genreg(r varchar(2000)) returns varchar(2000)
  deterministic
  sql security invoker
  begin
    declare rx varchar(2000);
    if length(r) = 0
     then
      return '.*';
    end if;
    if r = '␣' OR r = ' ' then
      return '^ $';
    end if;
    set rx = REPLACE(trim(r), '\\', '\\\\');
    set rx = REPLACE(rx, '.', '\\.');
    set rx = REPLACE(rx, '*', '.*');
    set rx = REPLACE(rx, '\\\\.*', '\\*');
    set rx = REPLACE(rx, '?', '.');
    set rx = REPLACE(rx, '^', '\\^');
    set rx = REPLACE(rx, '$', '\\$');
    set rx = REPLACE(rx, '[', '\\[');
    set rx = REPLACE(rx, ']', '\\]');
    set rx = REPLACE(rx, '\\\\.', '\\?');
    set rx = REPLACE(rx, '+', '\\+');
    set rx = REPLACE(rx, '(', '\\(');
    set rx = REPLACE(rx, ')', '\\)');
    set rx = REPLACE(rx, '|', '\\|');
    set rx = REPLACE(rx, ',', '$|^');
    return CONCAT('^', rx, '$');
  end//

GRANT EXECUTE on FUNCTION genreg
  to logginglesen@'localhost', loggingadmin@'localhost', logging@'localhost'//


DROP PROCEDURE IF EXISTS genreg//
create procedure genreg(r varchar(4000), OUT i varchar(2000), OUT e varchar(2000))
  deterministic
  sql security invoker
  begin
    declare rx varchar(4000);
    declare ri, re, ra varchar(2000);
    declare k int;

    if r NOT REGEXP '^!|,!'
     then
      set i = genreg(r);
      set e = '';
    else
      set rx = r;
      set re = '';
      set ri = '';
      while rx != ''
       do
        set k = instr(rx, ',');
        if k = 0
         then
          set ra = rx;
          set rx = '';
        else
          set ra = left(rx, k-1);
          set rx = substring(rx, k+1);
        end if;
        if left(ra, 1) = '!'
         then
          if re = ''
           then
            set re = substring(ra, 2);
          else
            set re = concat(re, ',', substring(ra, 2));
          end if;
        else
          if ri = ''
           then
            set ri = ra;
          else
            set ri = concat(ri, ',', ra);
          end if;
        end if;
      end while;
      set i = genreg(ri);
      set e = genreg(re);
    end if;
  end//

GRANT EXECUTE on PROCEDURE genreg
  to logginglesen@'localhost', loggingadmin@'localhost', logging@'localhost'//
