set @@character_set_client = 'utf8';

##################################
# newkompautos.sql
#
# Komprimierungen aus Autokomprimierungen einrichten
#
# wird aufgerufen, wenn neue werteindizes eingerichtet werden
#############################################################

delimiter //

DROP procedure IF EXISTS newkompautos//
create procedure newkompautos(wi integer unsigned, cls varchar(50), srv varchar(50),
                   sec varchar(100), tst varchar(600), det varchar(100),
                   eh varchar(100), vid integer unsigned, aid integer unsigned,
                   wtype enum('num','str','dat','blob'))
  deterministic
  sql security invoker
 begin

  declare i, z integer;
  declare mgf, akid, lwi integer unsigned;
  declare hids, dids, wids, mids, spids varchar(100);
  declare kompcur cursor for
    select ID, hourIDs, dayIDs, weekIDs, monthIDs, specialIDs
    from autokomprimierung
    where verfahrenID = vid and aktiv = '1' and accessID = aid
      and testreg(srv, server, server_v) and testreg(sec, section, section_v)
      and testreg(tst, teststep, teststep_v) and testreg(det, details, details_v)
      and testreg(eh, einheit, einheit_v);
  declare continue handler for not found set z = 1;

  select max(ID) from groupfunctions
      where aggregationtypes != '' OR aggregationspecialtypes != '' into mgf;

  open kompcur;
  set z = 0;
  repeat
    fetch kompcur into akid, hids, dids, wids, mids, spids;
    if z != 1 then
      if hids != '' then
        set i = 1;
        while i <= mgf do
          if find_in_set(i, hids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(wtype, aggregationtypes)) then
            insert ignore into lwerteindizes
                (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
              select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Hour'
              from werteindizes where ID = wi;
            set lwi = (select lwerteindizes.ID from lwerteindizes
                       join werteindizes using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                       where werteindizes.ID = wi and groupfunctionsID = i and period = 'Hour');
            insert ignore into komprimierungids
              set autokomprimierungID = akid, groupautoID = 0, lwerteindizesID = lwi;
            call kautos(lwi, cls, srv, sec, tst, i, 'Hour', det, eh, vid, aid);
          end if;
          set i = i + 1;
        end while;
      end if;
      if dids != '' then
        set i = 1;
        while i <= mgf do
          if find_in_set(i, dids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(wtype, aggregationtypes)) then
            insert ignore into lwerteindizes
                (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
              select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Day'
              from werteindizes where ID = wi;
            set lwi = (select lwerteindizes.ID from lwerteindizes
                       join werteindizes using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                       where werteindizes.ID = wi and groupfunctionsID = i and period = 'Day');
            insert ignore into komprimierungids
              set autokomprimierungID = akid, groupautoID = 0, lwerteindizesID = lwi;
            call kautos(lwi, cls, srv, sec, tst, i, 'Day', det, eh, vid, aid);
          end if;
          set i = i + 1;
        end while;
      end if;
      if wids != '' then
        set i = 1;
        while i <= mgf do
          if find_in_set(i, wids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(wtype, aggregationtypes)) then
            insert ignore into lwerteindizes
                (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
              select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Week'
              from werteindizes where ID = wi;
            set lwi = (select lwerteindizes.ID from lwerteindizes
                       join werteindizes using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                       where werteindizes.ID = wi and groupfunctionsID = i and period = 'Week');
            insert ignore into komprimierungids
              set autokomprimierungID = akid, groupautoID = 0, lwerteindizesID = lwi;
            call kautos(lwi, cls, srv, sec, tst, i, 'Week', det, eh, vid, aid);
          end if;
          set i = i + 1;
        end while;
      end if;
      if mids != '' then
        set i = 1;
        while i <= mgf do
          if find_in_set(i, mids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(wtype, aggregationtypes)) then
            insert ignore into lwerteindizes
                (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
              select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Month'
              from werteindizes where ID = wi;
            set lwi = (select lwerteindizes.ID from lwerteindizes
                       join werteindizes using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                       where werteindizes.ID = wi and groupfunctionsID = i and period = 'Month');
            insert ignore into komprimierungids
              set autokomprimierungID = akid, groupautoID = 0, lwerteindizesID = lwi;
            call kautos(lwi, cls, srv, sec, tst, i, 'Month', det, eh, vid, aid);
          end if;
          set i = i + 1;
        end while;
      end if;
      if spids != '' then
        set i = 1;
        while i <= mgf do
          if find_in_set(i, spids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(wtype, aggregationspecialtypes)) then
            insert ignore into lwerteindizes
                (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
              select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'special'
              from werteindizes where ID = wi;
            set lwi = (select lwerteindizes.ID from lwerteindizes
                       join werteindizes using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                       where werteindizes.ID = wi and groupfunctionsID = i and period = 'special');
            insert ignore into komprimierungids
              set autokomprimierungID = 0, groupautoID = akid, lwerteindizesID = lwi;
            call kautos(lwi, cls, srv, sec, tst, i, 'special', det, eh, vid, aid);
          end if;
          set i = i + 1;
        end while;
      end if;
    end if;
  until z = 1 end repeat;
  close kompcur;

end//

GRANT EXECUTE on PROCEDURE newkompautos to logging@'localhost', loggingadmin@'localhost'//
