set @@character_set_client = 'utf8';

CREATE TABLE `lwertedates` (
  `lwerteindizesID` int(10) unsigned NOT NULL DEFAULT '0',
  `serverID` int(10) unsigned NOT NULL DEFAULT '0',
  `accessID` int(10) unsigned NOT NULL DEFAULT '0',
  `sectionID` int(10) unsigned NOT NULL DEFAULT '0',
  `teststepID` int(10) unsigned NOT NULL DEFAULT '0',
  `teststepdetailsID` int(10) unsigned NOT NULL DEFAULT '0',
  `period` enum('H','D','W','M','s') DEFAULT 'H',
  `fdate` date NOT NULL DEFAULT '0000-00-00',
  `ldate` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`lwerteindizesID`,`fdate`),
  KEY `serverID` (`serverID`,`sectionID`,`teststepID`,`period`,
                  `fdate`,`ldate`,`accessID`,`teststepdetailsID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `lteststepdates` (
  `serverID` int(10) unsigned NOT NULL DEFAULT '0',
  `accessID` int(10) unsigned NOT NULL DEFAULT '1',
  `sectionID` int(10) unsigned NOT NULL DEFAULT '0',
  `teststepID` int(10) unsigned NOT NULL DEFAULT '0',
  `period` enum('H','D','W','M','s') DEFAULT 'H',
  `fdate` date NOT NULL DEFAULT '0000-00-00',
  `ldate` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`serverID`,`accessID`,`sectionID`,`teststepID`,`period`,`fdate`),
  KEY `serverID` (`serverID`,`sectionID`,`period`,`fdate`,`ldate`,`accessID`,`teststepID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `lsectiondates` (
  `serverID` int(10) unsigned NOT NULL DEFAULT '0',
  `accessID` int(10) unsigned NOT NULL DEFAULT '1',
  `sectionID` int(10) unsigned NOT NULL DEFAULT '0',
  `period` enum('H','D','W','M','s') DEFAULT 'H',
  `fdate` date NOT NULL DEFAULT '0000-00-00',
  `ldate` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`serverID`,`accessID`,`sectionID`,`period`,`fdate`),
  KEY `serverID` (`serverID`,`period`,`fdate`,`accessID`,`sectionID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `lserverdates` (
  `serverID` int(10) unsigned NOT NULL DEFAULT '0',
  `accessID` int(10) unsigned NOT NULL DEFAULT '1',
  `period` enum('H','D','W','M','s') DEFAULT 'H',
  `fdate` date NOT NULL DEFAULT '0000-00-00',
  `ldate` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`serverID`,`accessID`,`period`,`fdate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



delimiter //


DROP procedure IF EXISTS inslwdates//
create procedure inslwdates()

  deterministic
  sql security invoker
  begin
    declare lwid, z integer;
    declare p enum('H','D','W','M','s');
    declare ofd, fd, ld date;
    declare sid, sec, tst, aid integer;
    declare lwertezeitencur cursor for
      select lwerteindizesID, min(datum) as mind
      from lwertezeiten
      group by lwerteindizesID
      order by lwerteindizesID;
    declare lwertedatescur cursor for
      select serverID, accessID, sectionID, teststepID, period, fdate, ldate
      from lwertedates
      order by serverID, accessID, sectionID, teststepID, period, fdate;
    declare lteststepdatescur cursor for
      select serverID, accessID, sectionID, period, fdate, ldate
      from lteststepdates
      order by serverID, accessID, sectionID, period, fdate;
    declare lsectiondatescur cursor for
      select serverID, accessID, period, fdate, ldate
      from lsectiondates
      order by serverID, accessID, period, fdate;
    declare continue handler for not found set z = 1;

--  fill wertedates
    set z = 0;
    open lwertezeitencur;
    fetch lwertezeitencur into lwid, fd;
    while z = 0 do
      while fd is not NULL do
        set ld = (select l1.datum
                  from lwertezeiten as l1
                  left join lwertezeiten as l2
                    on l2.lwerteindizesID = l1.lwerteindizesID and l2.datum = l1.datum + interval 1 day
                  where l1.lwerteindizesID = lwid and l1.datum >= fd and l2.lwerteindizesID is NULL
                  order by l1.datum limit 1);
        if ld is not NULL then
          insert ignore into lwertedates
            (lwerteindizesID, serverID, accessID, sectionID, teststepID, teststepdetailsID, period, fdate, ldate)
            select lwerteindizes.ID, serverID, accessID, sectionID, teststepID, teststepdetailsID, left(period, 1), fd, ld
            from lwerteindizes where ID = lwid;
          set fd = (select min(datum) as mind from lwertezeiten where lwerteindizesID = lwid and datum > ld);
        else
          set fd = NULL;
        end if;
      end while;
      set z = 0;
      fetch lwertezeitencur into lwid, fd;
    end while;

--  fill teststepdates
    set z = 0;
    open lwertedatescur;
    fetch lwertedatescur into sid, aid, sec, tst, p, fd, ld;
    while z = 0 do
      if (select count(*) from lteststepdates
          where serverID = sid and accessID = aid and sectionID = sec and teststepID = tst and period = p
          and fdate <= fd and ld <= ldate) = 0 then

        set ofd = (select min(fdate) as fdm from lteststepdates
            where serverID = sid and accessID = aid and sectionID = sec and teststepID = tst and period = p
            and fdate <= fd and fd <= ldate);
        if ofd is NULL then
          insert ignore into lteststepdates
            (serverID, accessID, sectionID, teststepID, period, fdate, ldate)
            values (sid, aid, sec, tst, p, fd, ld);
        else
          update lteststepdates set ldate = ld
            where serverID = sid and accessID = aid and sectionID = sec and teststepID = tst and period = p
              and fdate = ofd and ldate < ld;
        end if;
      end if;
      set z = 0;
      fetch lwertedatescur into sid, aid, sec, tst, p, fd, ld;
    end while;

--   fill lsectiondates
    set z = 0;
    open lteststepdatescur;
    fetch lteststepdatescur into sid, aid, sec, p, fd, ld;
    while z = 0 do
      if (select count(*) from lsectiondates
          where serverID = sid and accessID = aid and sectionID = sec and period = p
          and fdate <= fd and ld <= ldate) = 0 then

        set ofd = (select min(fdate) as fdm from lsectiondates
            where serverID = sid and accessID = aid and sectionID = sec and period = p
            and fdate <= fd and fd <= ldate);
        if ofd is NULL then
          insert ignore into lsectiondates
            (serverID, accessID, sectionID, period, fdate, ldate)
            values (sid, aid, sec, p, fd, ld);
        else
          update lsectiondates set ldate = ld
            where serverID = sid and accessID = aid and sectionID = sec and period = p
              and fdate = ofd and ldate < ld;
        end if;
      end if;
      set z = 0;
      fetch lteststepdatescur into sid, aid, sec, p, fd, ld;
    end while;
      
--  fill lserverdates
    set z = 0;
    open lsectiondatescur;
    fetch lsectiondatescur into sid, aid, p, fd, ld;
    while z = 0 do
      if (select count(*) from lserverdates
          where serverID = sid and accessID = aid and period = p
          and fdate <= fd and ld <= ldate) = 0 then

        set ofd = (select min(fdate) as fdm from lserverdates
            where serverID = sid and accessID = aid and period = p
            and fdate <= fd and fd <= ldate);
        if ofd is NULL then
          insert ignore into lserverdates
            (serverID, accessID, period, fdate, ldate)
            values (sid, aid, p, fd, ld);
        else
          update lserverdates set ldate = ld
            where serverID = sid and accessID = aid and period = p
              and fdate = ofd and ldate < ld;
        end if;
      end if;
      set z = 0;
      fetch lsectiondatescur into sid, aid, p, fd, ld;
    end while;
      
end//


GRANT EXECUTE on PROCEDURE inslwdates to 'loggingadmin'@'localhost'//


call inslwdates()//

delimiter ;

drop table lwertezeiten;
drop table lteststepzeiten;
drop table lsectionzeiten;
drop table lserverzeiten;
