set @@character_set_client = 'utf8';

CREATE TABLE `wertedates` (
  `werteindizesID` int(10) unsigned NOT NULL DEFAULT '0',
  `serverID` int(10) unsigned NOT NULL DEFAULT '0',
  `accessID` int(10) unsigned NOT NULL DEFAULT '0',
  `sectionID` int(10) unsigned NOT NULL DEFAULT '0',
  `teststepID` int(10) unsigned NOT NULL DEFAULT '0',
  `teststepdetailsID` int(10) unsigned NOT NULL DEFAULT '0',
  `fdate` date NOT NULL DEFAULT '0000-00-00',
  `ldate` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`werteindizesID`,`fdate`),
  KEY `serverID` (`serverID`,`sectionID`,`teststepID`,`fdate`,`ldate`,`accessID`,`teststepdetailsID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `teststepdates` (
  `serverID` int(10) unsigned NOT NULL DEFAULT '0',
  `accessID` int(10) unsigned NOT NULL DEFAULT '1',
  `sectionID` int(10) unsigned NOT NULL DEFAULT '0',
  `teststepID` int(10) unsigned NOT NULL DEFAULT '0',
  `fdate` date NOT NULL DEFAULT '0000-00-00',
  `ldate` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`serverID`,`accessID`,`sectionID`,`teststepID`,`fdate`),
  KEY `serverID`(`serverID`,`sectionID`,`fdate`,`ldate`,`accessID`,`teststepID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `sectiondates` (
  `serverID` int(10) unsigned NOT NULL DEFAULT '0',
  `accessID` int(10) unsigned NOT NULL DEFAULT '1',
  `sectionID` int(10) unsigned NOT NULL DEFAULT '0',
  `fdate` date NOT NULL DEFAULT '0000-00-00',
  `ldate` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`serverID`,`accessID`,`sectionID`,`fdate`),
  KEY `serverID`(`serverID`,`fdate`,`ldate`,`accessID`,`sectionID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


CREATE TABLE `serverdates` (
  `serverID` int(10) unsigned NOT NULL DEFAULT '0',
  `accessID` int(10) unsigned NOT NULL DEFAULT '1',
  `fdate` date NOT NULL DEFAULT '0000-00-00',
  `ldate` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`serverID`,`accessID`,`fdate`),
  KEY `srvid` (`fdate`,`ldate`,`accessID`,`serverID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



delimiter //


DROP procedure IF EXISTS inswdates//
create procedure inswdates()

  deterministic
  sql security invoker
  begin
    declare wid, z integer;
    declare ofd, fd, ld date;
    declare sid, sec, tst, aid integer;
    declare wertezeitencur cursor for
      select werteindizesID, min(datum) as mind
      from wertezeiten
      group by werteindizesID
      order by werteindizesID;
    declare wertedatescur cursor for
      select serverID, accessID, sectionID, teststepID, fdate, ldate
      from wertedates
      order by serverID, accessID, sectionID, teststepID, fdate;
    declare teststepdatescur cursor for
      select serverID, accessID, sectionID, fdate, ldate
      from teststepdates
      order by serverID, accessID, sectionID, fdate;
    declare sectiondatescur cursor for
      select serverID, accessID, fdate, ldate
      from sectiondates
      order by serverID, accessID, fdate;
    declare continue handler for not found set z = 1;

--  fill wertedates
    set z = 0;
    open wertezeitencur;
    fetch wertezeitencur into wid, fd;
    while z = 0 do
      while fd is not NULL do
        set ld = (select l1.datum
                  from wertezeiten as l1
                  left join wertezeiten as l2
                    on l2.werteindizesID = l1.werteindizesID and l2.datum = l1.datum + interval 1 day
                  where l1.werteindizesID = wid and l1.datum >= fd and l2.werteindizesID is NULL
                  order by l1.datum limit 1);
        if ld is not NULL then
          insert ignore into wertedates
            (werteindizesID, serverID, accessID, sectionID, teststepID, teststepdetailsID, fdate, ldate)
            select werteindizes.ID, serverID, accessID, sectionID, teststepID, teststepdetailsID, fd, ld
            from werteindizes where ID = wid;
          set fd = (select min(datum) as mind from wertezeiten where werteindizesID = wid and datum > ld);
        else
          set fd = NULL;
        end if;
      end while;
      set z = 0;
      fetch wertezeitencur into wid, fd;
    end while;

--  fill teststepdates
    set z = 0;
    open wertedatescur;
    fetch wertedatescur into sid, aid, sec, tst, fd, ld;
    while z = 0 do
      if (select count(*) from teststepdates
          where serverID = sid and accessID = aid and sectionID = sec and teststepID = tst
          and fdate <= fd and ld <= ldate) = 0 then

        set ofd = (select min(fdate) as fdm from teststepdates
            where serverID = sid and accessID = aid and sectionID = sec and teststepID = tst
            and fdate <= fd and fd <= ldate);
        if ofd is NULL then
          insert ignore into teststepdates
            (serverID, accessID, sectionID, teststepID, fdate, ldate)
            values (sid, aid, sec, tst, fd, ld);
        else
          update teststepdates set ldate = ld
            where serverID = sid and accessID = aid and sectionID = sec and teststepID = tst
              and fdate = ofd and ldate < ld;
        end if;
      end if;
      set z = 0;
      fetch wertedatescur into sid, aid, sec, tst, fd, ld;
    end while;

--   fill sectiondates
    set z = 0;
    open teststepdatescur;
    fetch teststepdatescur into sid, aid, sec, fd, ld;
    while z = 0 do
      if (select count(*) from sectiondates
          where serverID = sid and accessID = aid and sectionID = sec
          and fdate <= fd and ld <= ldate) = 0 then

        set ofd = (select min(fdate) as fdm from sectiondates
            where serverID = sid and accessID = aid and sectionID = sec
            and fdate <= fd and fd <= ldate);
        if ofd is NULL then
          insert ignore into sectiondates
            (serverID, accessID, sectionID, fdate, ldate)
            values (sid, aid, sec, fd, ld);
        else
          update sectiondates set ldate = ld
            where serverID = sid and accessID = aid and sectionID = sec
              and fdate = ofd and ldate < ld;
        end if;
      end if;
      set z = 0;
      fetch teststepdatescur into sid, aid, sec, fd, ld;
    end while;
      
--  fill serverdates
    set z = 0;
    open sectiondatescur;
    fetch sectiondatescur into sid, aid, fd, ld;
    while z = 0 do
      if (select count(*) from serverdates
          where serverID = sid and accessID = aid
          and fdate <= fd and ld <= ldate) = 0 then

        set ofd = (select min(fdate) as fdm from serverdates
            where serverID = sid and accessID = aid
            and fdate <= fd and fd <= ldate);
        if ofd is NULL then
          insert ignore into serverdates
            (serverID, accessID, fdate, ldate)
            values (sid, aid, fd, ld);
        else
          update serverdates set ldate = ld
            where serverID = sid and accessID = aid
              and fdate = ofd and ldate < ld;
        end if;
      end if;
      set z = 0;
      fetch sectiondatescur into sid, aid, fd, ld;
    end while;
      
end//

GRANT EXECUTE on PROCEDURE inswdates to loggingadmin@'localhost'//

call inswdates()//



DROP procedure IF EXISTS wzeiten//
create procedure wzeiten(wid integer, sid integer, sec integer, tst integer,
                         det integer, aid integer, dt date)
  deterministic
  sql security invoker
 begin
  declare fd, ld date;

  set fd = NULL;
  set ld = '0000-00-00';
  select fdate, ldate from wertedates
    where werteindizesID = wid and fdate <= dt and dt - interval 1 day <= ldate
      order by fdate, ldate desc
      limit 1
    into fd, ld;
  if ld < dt then
    if fd is NULL then
      insert ignore into wertedates
        (werteindizesID, serverID, sectionID, teststepID, teststepdetailsID, accessID, fdate, ldate)
        values (wid, sid, sec, tst, det, aid, dt, dt); 
    else
      update wertedates set ldate = dt
        where werteindizesID = wid and fdate = fd and ldate <= dt;
    end if;
    set fd = NULL;
    set ld = '0000-00-00';
    select fdate, ldate from teststepdates
        where serverID = sid and sectionID = sec and teststepID = tst and accessID = aid
          and fdate <= dt and dt - interval 1 day <= ldate
        order by fdate, ldate desc
        limit 1
      into fd, ld;
    if ld < dt then
      if fd is NULL then
        insert ignore into teststepdates
          (serverID, sectionID, teststepID, accessID, fdate, ldate)
          values (sid, sec, tst, aid, dt, dt);
      else
        update teststepdates set ldate = dt
          where serverID = sid and sectionID = sec and teststepID = tst and accessID = aid
            and fdate = fd and ldate <= dt;
      end if;
      set fd = NULL;
      set ld = '0000-00-00';
      select fdate, ldate from sectiondates
          where serverID = sid and sectionID = sec and accessID = aid
            and fdate <= dt and dt - interval 1 day <= ldate
          order by fdate, ldate desc
          limit 1
        into fd, ld;
      if ld < dt then
        if fd is NULL then
          insert ignore into sectiondates (serverID, sectionID, accessID, fdate, ldate)
            values (sid, sec, aid, dt, dt);
        else
          update sectiondates set ldate = dt
            where serverID = sid and sectionID = sec and accessID = aid
              and fdate = fd and ldate <= dt;
        end if;
        set fd = NULL;
        set ld = '0000-00-00';
        select fdate, ldate from serverdates
            where serverID = sid and accessID = aid
              and fdate <= dt and dt - interval 1 day <= ldate
            order by fdate, ldate desc
            limit 1
          into fd, ld;
        if ld < dt then
          if fd is NULL then
            insert ignore into serverdates (serverID, accessID, fdate, ldate)
            values (sid, aid, dt, dt);
          else
            update serverdates set ldate = dt
              where serverID = sid and accessID = aid
                and fdate = fd and ldate <= dt;
          end if;
        end if;
      end if;
    end if;
  end if;
end//

GRANT INSERT, UPDATE(ldate) ON `logging`.`wertedates` to 'logging'@'localhost'//
GRANT INSERT, UPDATE(ldate) ON `logging`.`teststepdates` to 'logging'@'localhost'//
GRANT INSERT, UPDATE(ldate) ON `logging`.`sectiondates` to 'logging'@'localhost'//
GRANT INSERT, UPDATE(ldate) ON `logging`.`serverdates` to 'logging'@'localhost'//
GRANT SELECT ON `logging`.`sectiondates` to 'loggingtest'@'localhost'//
GRANT SELECT ON `logging`.`teststepdates` to 'loggingtest'@'localhost'//
