set @@character_set_client = 'utf8';

set @uname = coalesce((select name from mysql.plugin where name = 'unix_socket' OR name = 'auth_socket'), '');
set @cmd = (select case when @uname != '' then 'select concat(@uname, " already installed") as Info'
                        when @@version_comment like 'MySQL%' then "install plugin auth_socket soname 'auth_socket.so'"
                        else "install plugin unix_socket soname 'auth_socket'" end);
prepare dosql from @cmd;
execute dosql;
drop prepare dosql;

set @cmd = (select case when @@version_comment like 'MySQL%' then "GRANT USAGE ON *.* TO 'wwwuls'@'localhost' IDENTIFIED with auth_socket"
                   else "GRANT USAGE ON *.* TO 'wwwuls'@'localhost' IDENTIFIED VIA unix_socket" end);
prepare dosql from @cmd;
execute dosql;
drop prepare dosql;

GRANT EXECUTE ON `logging`.* TO 'wwwuls'@'localhost';
GRANT SELECT ON `logging`.* TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`bwerte` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`cwerte` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`pwerte` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`swerte` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`twerte` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`zwerte` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`twertelimits` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`tisalive` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`tkombilimits` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`section` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`teststep` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`teststepdetails` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`einheiten` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`serverdates` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`sectiondates` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`teststepdates` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`wertedates` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`kombidetails` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`komprimierungids` TO 'wwwuls'@'localhost';
GRANT INSERT ON `logging`.`lwerteindizes` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (lastdatum, lastwert, sid, llastdatum) ON `logging`.`letztewerte` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (beschreibung), DELETE ON `logging`.`sstbeschreibung` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (mindesttage) ON `logging`.`werteindizes` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (transferip, lastdnstest) ON `logging`.`server` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE ON `logging`.`beschreibung` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (hidden) ON `logging`.`wertelimits` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (hidden) ON `logging`.`kombilimits` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (hidden) ON `logging`.`isalive` TO 'wwwuls'@'localhost';
GRANT INSERT, DELETE ON `logging`.`daten` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (werteindizesID, datenID) ON `logging`.`bwerte` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (datumbis), DELETE ON `logging`.`ueberwachungspausen` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE (hidden) ON `logging`.`lwertelimits` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE ON `logging`.`ssremarks` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE, DELETE ON `logging`.`serverdoku` TO 'wwwuls'@'localhost';
GRANT INSERT, UPDATE(ldate) ON `logging`.`wertedates` to 'wwwuls'@'localhost';
GRANT INSERT, UPDATE(ldate) ON `logging`.`teststepdates` to 'wwwuls'@'localhost';
GRANT INSERT, UPDATE(ldate) ON `logging`.`sectiondates` to 'wwwuls'@'localhost';
GRANT INSERT, UPDATE(ldate) ON `logging`.`serverdates` to 'wwwuls'@'localhost';
