set @@character_set_client = 'utf8';

delimiter //

DROP procedure IF EXISTS appendblob//
create procedure appendblob(bid bigint unsigned)
  deterministic
  sql security invoker
 begin

  declare ba5 varchar(32);
  declare d, nd bigint unsigned;

  set d = (select datenID from bwerte where ID = bid);
  if d > 0 then
    select md5(concat(daten, @b)) from daten where daten.ID = d into ba5;
    set nd = (select d.ID from daten as d join daten as e on e.ID = d
              where d.md5sum = ba5 and d.daten = concat(e.daten, @b));
    if nd is NULL then
      insert into daten (md5sum, daten)
        select ba5, concat(daten, @b) from daten where daten.ID = d;
      set nd = last_insert_id();
    end if;
    update bwerte set datenID = nd where ID=bid;
    delete daten
      from daten
      left join bwerte on bwerte.datenID = daten.ID
      where daten.ID = d and bwerte.datenID is NULL;
  else
    set ba5 = md5(@b);
    set nd = (select ID from daten where md5sum = ba5 and daten = @b);
    if nd is NULL then
      insert into daten set md5sum = ba5, daten = @b;
      set nd = last_insert_id();
    end if;
    update bwerte set datenID = nd where ID=bid;
  end if;

end//

GRANT EXECUTE on PROCEDURE appendblob to logging@'localhost'//
