set @@character_set_client = 'utf8';

#######################################
# delgroupautos.sql
#
# Wird aufgerufen aus Admin-Menue, wenn
# einer Gruppe Verfahren entfernt
# werden oder einem Verfahren Gruppen
# entfernt werden
#
#######################################

delimiter //

DROP procedure IF EXISTS delgroupautos//
create procedure delgroupautos(groupids varchar(20000), domids varchar(20000),
                               accid integer unsigned)
  deterministic
  sql security invoker
 begin

  create temporary table loggingtmp.sids (primary key (ID))
    select server.ID from server
      where find_in_set(server.verfahrenID, domids);

  create temporary table loggingtmp.wids (primary key (ID))
    select werteindizes.ID, serverID, sectionID, teststepID, teststepdetailsID, accessID
    from werteindizes
    join loggingtmp.sids on sids.ID = werteindizes.serverID
      where werteindizes.accessID = accid;

  create temporary table loggingtmp.gids (primary key (ID))
    select ID from gruppen where find_in_set(ID, groupids);

-- komprimierte Limits

  delete lwertelimits from lwertelimits
    join lwerteindizes on lwerteindizes.ID = lwertelimits.lwerteindizesID
    join loggingtmp.wids
      using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
    join gautoclimits on gautoclimits.ID = lwertelimits.groupautoID
    join loggingtmp.gids on gids.ID = gautoclimits.groupID;
-- master
  delete lwertelimits from lwertelimits
    join lwerteindizes on lwerteindizes.ID = lwertelimits.lwerteindizesID
    join loggingtmp.wids
      using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
    join loggingtmp.gids on gids.ID = lwertelimits.slavegroupID;

  create temporary table loggingtmp.ano (primary key(ID))
    select lwerteindizes.ID
    from loggingtmp.wids
    join lwerteindizes
      using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
    join lwertelimits as l on l.lwerteindizesID = lwerteindizes.ID
    left join gautoclimits as ga on ga.ID = l.groupautoID and not ga.nootherflag
    where ga.ID is not NULL OR autollimitsID > 0
    group by lwerteindizes.ID;
  update lwertelimits as l
    join gautoclimits as ga on ga.ID = l.groupautoID and ga.nootherflag
    left join loggingtmp.ano on ano.ID = l.lwerteindizesID
    set l.hidden = false
    where ano.ID is NULL;
  drop temporary table loggingtmp.ano;


-- Kombilimits

  delete kombilimits from kombilimits
    join loggingtmp.sids on sids.ID = kombilimits.serverID
    join gautocombilimits on gautocombilimits.ID = kombilimits.groupautoID
    join loggingtmp.gids on gids.ID = gautocombilimits.groupID
    where kombilimits.accessID = accid;
-- master
  delete kombilimits from kombilimits
    join loggingtmp.sids on sids.ID = kombilimits.serverID
    join loggingtmp.gids on gids.ID = kombilimits.slavegroupID
    where kombilimits.accessID = accid;

  create temporary table loggingtmp.ano (primary key(serverID, sectionID, teststepID, accessID))
    select k.serverID, k.sectionID, k.teststepID, k.accessID
    from kombilimits as k
    join loggingtmp.sids on sids.ID = k.serverID
    left join gautocombilimits as ga on ga.ID = k.groupautoID and not ga.nootherflag
    where ga.ID is not NULL OR autokombilimitsID > 0
    group by serverID, sectionID, teststepID, accessID;
  update kombilimits as k
    join gautocombilimits as ga on ga.ID = k.groupautoID and ga.nootherflag
    left join loggingtmp.ano
      on k.serverID = ano.serverID and k.sectionID = ano.sectionID
        and k.teststepID = ano.teststepID and k.accessID = ano.accessID
    set k.hidden = false
    where ano.serverID is NULL;
  drop temporary table loggingtmp.ano;


-- Komprimierung

  delete komprimierungids from komprimierungids
    join lwerteindizes on lwerteindizes.ID = komprimierungids.lwerteindizesID
    join loggingtmp.wids
      using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
    join gautocompression on gautocompression.ID = komprimierungids.groupautoID
    join loggingtmp.gids on gids.ID = gautocompression.groupID;
-- master
  delete komprimierungids from komprimierungids
    join lwerteindizes on lwerteindizes.ID = komprimierungids.lwerteindizesID
    join loggingtmp.wids
      using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
    join loggingtmp.gids on gids.ID = komprimierungids.slavegroupID;


-- isAlive

  delete isalive from isalive
    join loggingtmp.wids on wids.ID = isalive.werteindizesID
    join gautoisalive on gautoisalive.ID = isalive.groupautoID
    join loggingtmp.gids on gids.ID = gautoisalive.groupID;
-- master
  delete isalive from isalive
    join loggingtmp.wids on wids.ID = isalive.werteindizesID
    join loggingtmp.gids on gids.ID = isalive.slavegroupID;

  create temporary table loggingtmp.ano (primary key(ID))
    select wids.ID
    from loggingtmp.wids
    join isalive as i on i.werteindizesID = wids.ID
    left join gautoisalive as ga on ga.ID = i.groupautoID and not ga.nootherflag
    where ga.ID is not NULL or autoisaliveID > 0
    group by wids.ID;
  update isalive as i
    join gautoisalive as ga on ga.ID = i.groupautoID and ga.nootherflag
    join loggingtmp.ano on ano.ID = i.werteindizesID
    set i.hidden = false;
  drop temporary table loggingtmp.ano;


-- Limits

  delete wertelimits from wertelimits
    join loggingtmp.wids on wids.ID = wertelimits.werteindizesID
    join gautolimits on gautolimits.ID = wertelimits.groupautoID
    join loggingtmp.gids on gids.ID = gautolimits.groupID;
-- master
  delete wertelimits from wertelimits
    join loggingtmp.wids on wids.ID = wertelimits.werteindizesID
    join loggingtmp.gids on gids.ID = wertelimits.slavegroupID;

  create temporary table loggingtmp.ano (primary key(ID))
    select wids.ID
    from loggingtmp.wids
    join wertelimits as l on l.werteindizesID = wids.ID
    left join gautolimits as ga on ga.ID = l.groupautoID and not ga.nootherflag
    where ga.ID is not NULL OR autolimitsID > 0
    group by wids.ID;
  update wertelimits as l
    join gautolimits as ga on ga.ID = l.groupautoID and ga.nootherflag
    join loggingtmp.ano on ano.ID = l.werteindizesID
    set l.hidden = false
    where ano.ID is not NULL;


  drop temporary table loggingtmp.ano, loggingtmp.wids, loggingtmp.sids, loggingtmp.gids;

end//

GRANT EXECUTE on PROCEDURE delgroupautos to loggingadmin@'localhost'//
