set @@character_set_client = 'utf8';

-- ---------------------------------------------------
-- genpassword.sql
--
-- generate password with length len with
-- at least one uppercase and one special character
-- 
-- deterministic ist eigentlich nicht richtig,
-- aber die Funktions sollte trotzdem Binlog-Save sein
-- ---------------------------------------------------

delimiter //


DROP function IF EXISTS genpassword//
create function genpassword(len integer unsigned) returns varchar(100)
  sql security invoker
  deterministic
 begin

  declare pwd varchar(100);
  declare c, lc varchar(1);
  declare lo, sc, uc integer unsigned;

  set sc = 1;
  set uc = 1;
  set lo = 0;
  set lc = '';
  set pwd = '';
  while lo < len do
    set c = char(floor(rand()*90)+33 using utf8);
    if sc AND c REGEXP '[!@#%_$/=?~<>,.;*+-]' then
      set pwd = concat(pwd, c);
      set lo = lo + 1;
      set sc = 0;
    elseif uc AND c REGEXP BINARY '[A-Z]' then
      set pwd = concat(pwd, c);
      set lo = lo + 1;
      set uc = 0;
    elseif lo < len - sc - uc AND c != lc AND c REGEXP BINARY '[0-9a-z]' then
      set pwd = concat(pwd, c);
      set lo = lo + 1;
      set lc = c;
    end if;
  end while;
  return pwd;

end//
