set @@character_set_client = 'utf8';

#######################################
# serverautos.sql
#
# Wird aufgerufen aus Admin-Menue, wenn
# ein Server das Verfahren wechselt,
# der Name oder die Klasse geändert wird
#
# ODER
#
# Wenn der Servername über
# die Server-DB Schnittstelle geändert
# wird
#######################################

delimiter //

DROP procedure IF EXISTS serverautos//
create definer = 'logginglesen'@'localhost'
 procedure serverautos(si integer unsigned)
  deterministic
  sql security definer
 begin

  declare dom, cls varchar(50);
  declare srv varchar(30);
  declare sec varchar(50);
  declare tst varchar(200);
  declare det, eh varchar(100);
  declare vid, i, wi, ei, ti, aid, slaveid, fdwid, akid integer unsigned;
  declare z integer;
  declare dtype, ctype enum('num','str','dat','blob');
  declare q, fkt varchar(10000);
  declare cnstvars, uwids varchar(3000);
  declare mgf, lwi integer unsigned;
  declare hids, dids, wids, mids varchar(100);
  declare spids varchar(30);
  declare cwtype varchar(10);

  declare klimcur cursor for
    select a.ID, aids.sectionID, aids.teststepID, aids.accessID, a.expression
    from autokombilimits as a
    join loggingtmp.aids on aids.autokombilimitsID = a.ID;
  declare gclimcur cursor for
    select ga.ID, gaids.slavegroupID, gaids.sectionID, gaids.teststepID, gaids.accessID, ga.expression
    from gautocombilimits as ga
    join loggingtmp.gaids on gaids.gautocombilimitsID = ga.ID;
  declare kdetcur cursor for
    select a.ID, aids.sectionID, aids.teststepID, aids.accessID, a.formel, einheiten.type
    from autokombidetails as a
    join loggingtmp.aids on aids.autokombidetailsID = a.ID
    join teststepdetails as td on td.ID = a.teststepdetailsID
    left join einheiten on einheiten.ID = td.einheitID and einheiten.type != 'str';
  declare gcdetcur cursor for
    select ga.ID, gaids.sectionID, gaids.teststepID, gaids.accessID, ga.formel, einheiten.type
    from gautocombidetails as ga
    join loggingtmp.gaids on gaids.gautocombidetailsID = ga.ID
    join teststepdetails as td on td.ID = ga.teststepdetailsID
    left join einheiten on einheiten.ID = td.einheitID and einheiten.type != 'str';
  declare ccdetcur cursor for
    select a.ID, aids.sectionID, aids.teststepID, aids.accessID, a.formel, einheiten.type
    from autoccdetails as a
    join loggingtmp.aids on aids.autoccdetailsID = a.ID
    join teststepdetails as td on td.ID = a.teststepdetailsID
    left join einheiten on einheiten.ID = td.einheitID and einheiten.type != 'str';
  declare gccdetcur cursor for
    select ga.ID, gaids.sectionID, gaids.teststepID, gaids.accessID, ga.formel, einheiten.type
    from gautoccdetails as ga
    join loggingtmp.gaids on gaids.gautoccdetailsID = ga.ID
    join teststepdetails as td on td.ID = ga.teststepdetailsID
    left join einheiten on einheiten.ID = td.einheitID and einheiten.type != 'str';
  declare kompcur cursor for
    select a.ID, hourIDs, dayIDs, weekIDs, monthIDs, specialIDs, aids.wid,
      aids.section, aids.teststep, aids.detail, aids.unit, aids.accessID, wtype
    from autokomprimierung as a
    join loggingtmp.aids on aids.autokomprimierungID = a.ID;
  declare gcompcur cursor for
    select ga.ID, gaids.slavegroupID, hourIDs, dayIDs, weekIDs, monthIDs, specialIDs, gaids.wid,
      gaids.section, gaids.teststep, gaids.detail, gaids.unit, gaids.accessID, wtype
    from gautocompression as ga
    join loggingtmp.gaids on gaids.gautocompressionID = ga.ID;
  declare continue handler for not found set z = 1;

  select verfahrenID, coalesce(cl.name, ''), servername, verfahren.name
    from server as s
    join verfahren on verfahren.ID = s.verfahrenID
    left join serverclasses as cl on cl.ID = s.serverclassesID
    where s.ID = si into vid, cls, srv, dom;

  create temporary table loggingtmp.wids
      (primary key(ID, accessID), key serverID(serverID, sectionID, teststepID, teststepdetailsID, accessID))
    select werteindizes.ID, serverID, sectionID, teststepID, teststepdetailsID, accessID,
      section.name as section, teststep.name as teststep, teststepdetails.name as detail,
      einheiten.name as unit, type as wtype
    from werteindizes
    join section on section.ID = sectionID
    join teststep on teststep.ID = teststepID
    join teststepdetails on teststepdetails.ID = teststepdetailsID
    join einheiten on einheiten.ID = einheitID
    where serverID = si;

  create temporary table loggingtmp.lwids
      (primary key(ID, accessID), key serverID(serverID, sectionID, teststepID, teststepdetailsID, accessID))
    select lwerteindizes.ID, serverID, sectionID, teststepID, teststepdetailsID, accessID,
      section.name as section, teststep.name as teststep,
      concat(gf.code, '[', left(period, 1), '](', teststepdetails.name, ')') as detail,
      einheiten.name as unit, type as wtype
    from lwerteindizes
    join groupfunctions as gf on gf.ID = lwerteindizes.groupfunctionsID
    join section on section.ID = sectionID
    join teststep on teststep.ID = teststepID
    join teststepdetails on teststepdetails.ID = teststepdetailsID
    join einheiten on einheiten.ID = einheitID
    where serverID = si;

  -- groupID: Gruppen-ID, zu der das Limit gesucht wird
  -- slavegroupID: Wenn groupID zur Mastergruppe, dann slavegroupID auf Gruppe der Rechte
  create temporary table loggingtmp.gids (key uk(groupID, accessID, slavegroupID))
    select distinct g.gruppenID as groupID, accessID, NULL as slavegroupID
    from gruppenrechte as g
    where g.verfahrenID = vid and g.admin = '1'
    union all
    select distinct mg.mastergroupID as groupID, g.accessID, mg.slavegroupID
    from masterslavegroups as mg
    join gruppenrechte as g
      on g.gruppenID = mg.slavegroupID and g.verfahrenID = vid and g.admin = '1';


-- Auto Limits

  create temporary table loggingtmp.aids (primary key(autolimitsID, wid))
    select distinct a.ID as autolimitsID, w.ID as wid
    from autolimits as a
    join groupfunctions on groupfunctions.ID = groupfunctionsID
    join loggingtmp.wids as w 
      on w.accessID = a.accessID
      and testreg(w.section, a.section, a.section_v)
      and testreg(w.teststep, a.teststep, a.teststep_v)
      and testreg(w.detail, a.details, a.details_v)
      and testreg(w.unit, a.einheit, a.einheit_v)
    where verfahrenID = vid
      and testreg(cls, a.classes, a.classes_v)
      and testreg(srv, a.server, a.server_v)
      and if(notifymode like 'S%', find_in_set('str', flags) AND wtype = 'str',
             find_in_set(wtype, flags));

  delete wertelimits
    from wertelimits
    join loggingtmp.wids on wids.ID = wertelimits.werteindizesID
    left join loggingtmp.aids
      on aids.wid = wids.ID and aids.autolimitsID = wertelimits.autolimitsID
    where wertelimits.autolimitsID > 0 and aids.autolimitsID is NULL;
  delete loggingtmp.aids
    from loggingtmp.aids
    join wertelimits
      on wertelimits.autolimitsID = aids.autolimitsID and wertelimits.werteindizesID = aids.wid;
  insert into wertelimits
     (werteindizesID, autolimitsID, infowert, warnwert, errorwert, exclude, vergleich,
      groupfunctionsID, anzmittel, meldung, meldungszielID, ziel1level, meldungsziel2ID,
      ziel2level, notifymode, bemerkungen)
    select wid, autolimitsID, infowert, warnwert, errorwert, exclude, vergleich, groupfunctionsID,
      anzmittel, meldung, meldungszielID, ziel1level, meldungsziel2ID, ziel2level,
      notifymode, bemerkungen
    from autolimits
    join loggingtmp.aids on aids.autolimitsID = autolimits.ID;
  drop temporary table loggingtmp.aids;


-- Group-Auto Limits

  create temporary table loggingtmp.gaids (key uk(gautolimitsID, wid, slavegroupID))
    select distinct ga.ID as gautolimitsID, w.ID as wid, g.slavegroupID
    from gautolimits as ga
    join groupfunctions on groupfunctions.ID = groupfunctionsID
    join loggingtmp.gids as g on g.groupID = ga.groupID and g.accessID = ga.accessID
    join loggingtmp.wids as w
      on w.accessID = g.accessID
      and testreg(w.section, ga.section, ga.section_v)
      and testreg(w.teststep, ga.teststep, ga.teststep_v)
      and testreg(w.detail, ga.details, ga.details_v)
      and testreg(w.unit, ga.einheit, ga.einheit_v)
    where testreg(dom, ga.domain, ga.domain_v)
      and testreg(cls, ga.classes, ga.classes_v)
      and testreg(srv, ga.server, ga.server_v)
      and if(notifymode like 'S%', find_in_set('str',flags) AND wtype = 'str',
             find_in_set(wtype,flags));

  delete wertelimits
    from wertelimits
    join loggingtmp.wids on wids.ID = wertelimits.werteindizesID
    left join loggingtmp.gaids
      on gaids.wid = wids.ID and gaids.gautolimitsID = wertelimits.groupautoID
        and gaids.slavegroupID <=> wertelimits.slavegroupID
    where wertelimits.groupautoID > 0 and gaids.gautolimitsID is NULL;
  delete loggingtmp.gaids
    from loggingtmp.gaids
    join wertelimits
      on wertelimits.werteindizesID = gaids.wid and wertelimits.groupautoID = gaids.gautolimitsID
        and wertelimits.slavegroupID <=> gaids.slavegroupID;
  insert into wertelimits
     (werteindizesID, groupautoID, slavegroupID, infowert, warnwert, errorwert, exclude, vergleich,
      groupfunctionsID, anzmittel, meldung, meldungszielID, ziel1level, meldungsziel2ID,
      ziel2level, notifymode, bemerkungen)
    select wid, gautolimits.ID, gaids.slavegroupID, infowert, warnwert, errorwert, exclude, vergleich,
      groupfunctionsID, anzmittel, meldung, meldungszielID, ziel1level, meldungsziel2ID,
      ziel2level, notifymode, bemerkungen
    from gautolimits
    join loggingtmp.gaids on gaids.gautolimitsID = gautolimits.ID;
  drop temporary table loggingtmp.gaids;

  create temporary table loggingtmp.ano (primary key(ID))
    select wids.ID
    from loggingtmp.wids
    join wertelimits as l on l.werteindizesID = wids.ID
    left join gautolimits as ga on ga.ID = l.groupautoID and not ga.nootherflag
    where ga.ID is not NULL OR autolimitsID > 0
    group by wids.ID;
  update wertelimits as l
    join gautolimits as ga on ga.ID = l.groupautoID and ga.nootherflag
    left join loggingtmp.ano on ano.ID = l.werteindizesID
    set l.hidden = ano.ID is not NULL;
  drop temporary table loggingtmp.ano;


-- Auto isAlive

  create temporary table loggingtmp.aids (primary key(autoisaliveID, wid))
    select distinct a.ID as autoisaliveID, w.ID as wid
    from autoisalive as a
    join loggingtmp.wids as w
      on w.accessID = a.accessID and testreg(w.section, a.section, a.section_v)
        and testreg(w.teststep, a.teststep, a.teststep_v) and testreg(w.detail, a.details, a.details_v)
        and testreg(w.unit, a.einheit, a.einheit_v)
    where verfahrenID = vid and testreg(cls, a.classes, a.classes_v)
      and testreg(srv, a.server, a.server_v);

  delete isalive
    from isalive
    join loggingtmp.wids on wids.ID = isalive.werteindizesID
    left join loggingtmp.aids
      on aids.wid = wids.ID and aids.autoisaliveID = isalive.autoisaliveID
    where isalive.autoisaliveID > 0 and aids.autoisaliveID is NULL;
  delete loggingtmp.aids
    from loggingtmp.aids
    join isalive
      on isalive.autoisaliveID = aids.autoisaliveID and isalive.werteindizesID = aids.wid;
  insert into isalive
     (werteindizesID, maxperiods, intervalleID, meldung, meldungszielID, meldungsziel2ID,
      notifymode, autoisaliveID, bemerkungen, autoclose, msglevel)
    select wid, maxperiods, intervalleID, meldung, meldungszielID, meldungsziel2ID,
      notifymode, autoisalive.ID, bemerkungen, autoclose, msglevel
    from autoisalive
    join loggingtmp.aids on aids.autoisaliveID = autoisalive.ID;
  drop temporary table loggingtmp.aids;

-- Group-Auto isAlive

  create temporary table loggingtmp.gaids (key uk(gautoisaliveID, wid, slavegroupID))
    select distinct ga.ID as gautoisaliveID, w.ID as wid, g.slavegroupID
    from gautoisalive as ga
    join loggingtmp.wids as w
      on w.accessID = ga.accessID and testreg(w.section, ga.section, ga.section_v)
        and testreg(w.teststep, ga.teststep, ga.teststep_v)
        and testreg(w.detail, ga.details, ga.details_v)
        and testreg(w.unit, ga.einheit, ga.einheit_v)
    join loggingtmp.gids as g on g.groupID = ga.groupID and g.accessID = ga.accessID
    where testreg(dom, ga.domain, ga.domain_v)
      and testreg(cls, ga.classes, ga.classes_v)
      and testreg(srv, ga.server, ga.server_v);

  delete isalive
    from isalive
    join loggingtmp.wids on wids.ID = isalive.werteindizesID
    left join loggingtmp.gaids
      on gaids.wid = wids.ID and gaids.gautoisaliveID = isalive.groupautoID
        and gaids.slavegroupID <=> isalive.slavegroupID
    where isalive.groupautoID > 0 and gaids.gautoisaliveID is NULL;
  delete loggingtmp.gaids
    from loggingtmp.gaids
    join isalive
      on isalive.groupautoID = gaids.gautoisaliveID and isalive.slavegroupID <=> gaids.slavegroupID
        and isalive.werteindizesID = gaids.wid;
  insert into isalive
     (werteindizesID, maxperiods, intervalleID, meldung, meldungszielID, meldungsziel2ID,
      notifymode, groupautoID, slavegroupID, bemerkungen, autoclose, msglevel)
    select wid, maxperiods, intervalleID, meldung, meldungszielID, meldungsziel2ID,
      notifymode, gautoisalive.ID, gaids.slavegroupID, bemerkungen, autoclose, msglevel
    from gautoisalive
    join loggingtmp.gaids on gaids.gautoisaliveID = gautoisalive.ID;
  drop temporary table loggingtmp.gaids;

  create temporary table loggingtmp.ano (primary key(ID))
    select wids.ID
    from loggingtmp.wids
    join isalive as i on i.werteindizesID = wids.ID
    left join gautoisalive as ga on ga.ID = i.groupautoID and not ga.nootherflag
    where ga.ID is not NULL OR autoisaliveID > 0
    group by wids.ID;
  update isalive as i
    join gautoisalive as ga on ga.ID = i.groupautoID and ga.nootherflag
    left join loggingtmp.ano on ano.ID = i.werteindizesID
    set i.hidden = ano.ID is not NULL;
  drop temporary table loggingtmp.ano;


-- Kombilimits

  create temporary table loggingtmp.aids
    (primary key(autokombilimitsID, sectionID, teststepID, accessID))
    select distinct a.ID as autokombilimitsID, w.sectionID, w.teststepID, w.accessID
    from autokombilimits as a
    join loggingtmp.wids as w
      on w.accessID = a.accessID and testreg(w.section, a.section, a.section_v)
        and testreg(w.teststep, a.teststep, a.teststep_v) and find_in_set(w.detail, a.details)
    where verfahrenID = vid
      and testreg(cls, a.classes, a.classes_v)
      and testreg(srv, a.server, a.server_v);

  delete kombilimits
    from kombilimits
    join loggingtmp.wids
      on wids.sectionID = kombilimits.sectionID and wids.teststepID = kombilimits.teststepID
        and wids.accessID = kombilimits.accessID
    left join loggingtmp.aids
      on aids.sectionID = kombilimits.sectionID and aids.teststepID = kombilimits.teststepID
        and aids.accessID = kombilimits.accessID and aids.autokombilimitsID = kombilimits.autokombilimitsID
    where kombilimits.serverID = si and kombilimits.autokombilimitsID > 0
      and aids.autokombilimitsID is NULL;
  delete loggingtmp.aids
    from loggingtmp.aids
    join kombilimits
      on kombilimits.autokombilimitsID = aids.autokombilimitsID
        and kombilimits.sectionID = aids.sectionID and kombilimits.teststepID = aids.teststepID
        and kombilimits.accessID = aids.accessID and kombilimits.serverID = si;

  open klimcur;
  set z = 0;
  fetch klimcur into akid, ei, ti, aid, fkt;
  while z != 1 do
    call convert_combi(si, ei, ti, aid, fkt, '', '', q, fdwid, ctype, cnstvars, uwids);
    if q != '' then
      insert into kombilimits
        (serverID, sectionID, teststepID, expression, expressionsql, relation, infolevel,
         warnlevel, errorlevel, notifymode, meldung, meldungszielID, dest1level,
         meldungsziel2ID, dest2level, aktiv, autokombilimitsID, bemerkungen, accessID, usedwIDs)
        select si, ei, ti, expression, concat('select ', q), relation, infolevel,
          warnlevel, errorlevel, notifymode, meldung, meldungszielID, dest1level,
          meldungsziel2ID, dest2level, aktiv, ID, bemerkungen, accessID, trim(leading ',' from uwids)
        from autokombilimits
        where ID = akid;
    end if;
    fetch klimcur into akid, ei, ti, aid, fkt;
  end while;
  close klimcur;

  drop temporary table loggingtmp.aids;

-- Group-Kombilimits

  create temporary table loggingtmp.gaids
    (key uk(gautocombilimitsID, sectionID, teststepID, accessID, slavegroupID))
    select distinct ga.ID as gautocombilimitsID, w.sectionID, w.teststepID, w.accessID, g.slavegroupID
    from gautocombilimits as ga
    join loggingtmp.wids as w
      on  w.accessID = ga.accessID
    join loggingtmp.gids as g on g.groupID = ga.groupID and g.accessID = ga.accessID
    where testreg(dom, ga.domain, ga.domain_v) and testreg(cls, ga.classes, ga.classes_v)
      and testreg(srv, ga.server, ga.server_v) and testreg(w.section, ga.section, ga.section_v)
      and testreg(w.teststep, ga.teststep, ga.teststep_v) and find_in_set(w.detail, ga.details);

  delete kombilimits
    from kombilimits
    join loggingtmp.wids
      on wids.sectionID = kombilimits.sectionID and wids.teststepID = kombilimits.teststepID
        and wids.accessID = kombilimits.accessID
    left join loggingtmp.gaids
      on gaids.sectionID = kombilimits.sectionID and gaids.teststepID = kombilimits.teststepID
        and gaids.accessID = kombilimits.accessID and gaids.gautocombilimitsID = kombilimits.groupautoID
        and gaids.slavegroupID <=> kombilimits.slavegroupID
    where kombilimits.serverID = si and groupautoID > 0
      and gaids.gautocombilimitsID is NULL;
  delete loggingtmp.gaids
    from loggingtmp.gaids
    join kombilimits
      on kombilimits.groupautoID = gaids.gautocombilimitsID and kombilimits.serverID = si
        and kombilimits.sectionID = gaids.sectionID and kombilimits.teststepID = gaids.teststepID
        and kombilimits.accessID = gaids.accessID;

  open gclimcur;
  set z = 0;
  fetch gclimcur into akid, slaveid, ei, ti, aid, fkt;
  while z != 1 do
    call convert_combi(si, ei, ti, aid, fkt, '', '', q, fdwid, ctype, cnstvars, uwids);
    if q != '' then
      insert into kombilimits
        (serverID, sectionID, teststepID, expression, expressionsql, relation, infolevel,
          warnlevel, errorlevel, notifymode, meldung, meldungszielID, dest1level,
          meldungsziel2ID, dest2level, aktiv, slavegroupID, groupautoID, bemerkungen, accessID, usedwIDs)
        select si, ei, ti, expression, concat('select ', q), relation, infolevel,
          warnlevel, errorlevel, notifymode, meldung, meldungszielID, dest1level,
          meldungsziel2ID, dest2level, aktiv, slaveid, ID, bemerkungen, accessID, trim(leading ',' from uwids)
        from gautocombilimits
        where ID = akid;
    end if;
    fetch gclimcur into akid, slaveid, ei, ti, aid, fkt;
  end while;
  close gclimcur;

  create temporary table loggingtmp.sstids
      (primary key(serverID, sectionID, teststepID, accessID))
    select distinct si as serverID, sectionID, teststepID, accessID
    from loggingtmp.gaids;
  drop temporary table loggingtmp.gaids;
 
  create temporary table loggingtmp.ano (primary key(serverID, sectionID, teststepID, accessID))
    select serverID, sectionID, teststepID, sstids.accessID
    from loggingtmp.sstids
    join kombilimits as k using (serverID, sectionID, teststepID, accessID)
    left join gautocombilimits as ga on ga.ID = k.groupautoID and not ga.nootherflag
    where ga.ID is not NULL OR autokombilimitsID > 0
    group by serverID, sectionID, teststepID, sstids.accessID;
  update kombilimits as k
    join gautocombilimits as ga on ga.ID = k.groupautoID and ga.nootherflag
    left join loggingtmp.ano
      on ano.serverID = k.serverID and ano.sectionID = k.sectionID
        and ano.teststepID = k.teststepID and ano.accessID = k.accessID
    set k.hidden = ano.serverID is not NULL;
  drop temporary table loggingtmp.ano, loggingtmp.sstids;


-- Auto Limits for compressed Values
--   nur loeschen, neue werden ueber kautos angelegt

  delete lwertelimits
    from lwertelimits
    join loggingtmp.lwids as w on w.ID = lwertelimits.lwerteindizesID
    left join autollimits as a
      on a.verfahrenID = vid and a.accessID = w.accessID
        and testreg(cls, a.classes, a.classes_v)
        and testreg(srv, a.server, a.server_v)
        and testreg(w.section, a.section, a.section_v)
        and testreg(w.teststep, a.teststep, a.teststep_v)
        and testreg(w.detail, a.details, a.details_v)
        and testreg(w.unit, a.einheit, a.einheit_v)
        and a.ID = lwertelimits.autollimitsID
    where a.ID IS NULL and lwertelimits.autollimitsID > 0;

-- Group-Auto Limits for compressed Values
--   nur loeschen, neue werden nach der Komprimierung angelegt

  delete lwertelimits
    from lwertelimits
    join loggingtmp.lwids as w on w.ID = lwertelimits.lwerteindizesID
    left join (loggingtmp.gids as g, gautoclimits as ga)
      on ga.groupID = g.groupID and ga.accessID = g.accessID
        and lwertelimits.slavegroupID <=> g.slavegroupID
        and w.accessID = g.accessID
        and testreg(dom, ga.domain, ga.domain_v)
        and testreg(cls, ga.classes, ga.classes_v)
        and testreg(srv, ga.server, ga.server_v)
        and testreg(w.section, ga.section, ga.section_v)
        and testreg(w.teststep, ga.teststep, ga.teststep_v)
        and testreg(w.detail, ga.details, ga.details_v)
        and testreg(w.unit, ga.einheit, ga.einheit_v)
        and ga.ID = lwertelimits.groupautoID
    where ga.ID IS NULL and lwertelimits.groupautoID > 0;

-- Autokomprimierung

  select max(ID) from groupfunctions into mgf;

  create temporary table loggingtmp.aids
    (primary key(autokomprimierungID, wid),
     key serverID(serverID, sectionID, teststepID, teststepdetailsID, accessID))
    select distinct a.ID as autokomprimierungID, w.ID as wid,
      w.serverID, w.sectionID, w.teststepID, w.teststepdetailsID, w.accessID,
      w.section, w.teststep, w.detail, w.unit, w.wtype
    from autokomprimierung as a
    join loggingtmp.wids as w
      on w.accessID = a.accessID and testreg(w.section, a.section, a.section_v)
        and testreg(w.teststep, a.teststep, a.teststep_v) and testreg(w.detail, a.details, a.details_v)
        and testreg(w.unit, a.einheit, a.einheit_v)
    where verfahrenID = vid and aktiv = '1' and testreg(srv, a.server, a.server_v);

  delete komprimierungids
    from komprimierungids
    join loggingtmp.lwids on lwids.ID = komprimierungids.lwerteindizesID
    left join loggingtmp.aids on aids.autokomprimierungID = komprimierungids.autokomprimierungID
    where komprimierungids.autokomprimierungID > 0 and aids.autokomprimierungID is NULL;

  delete loggingtmp.aids
    from loggingtmp.aids
    join loggingtmp.lwids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
    join komprimierungids
      on komprimierungids.autokomprimierungID = aids.autokomprimierungID
        and komprimierungids.lwerteindizesID = lwids.ID;

  open kompcur;
  set z = 0;
  fetch kompcur into akid, hids, dids, wids, mids, spids, wi, sec, tst, det, eh, aid, cwtype;
  while z != 1 do
    create temporary table loggingtmp.grights (key uk(groupID, slavegroupID))
      select groupID, slavegroupID from loggingtmp.gids where gids.accessID = aid;
    if hids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, hids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Hour'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'Hour');
          insert ignore into komprimierungids
            set autokomprimierungID = akid, lwerteindizesID = lwi;
          call kautos(lwi, cls, srv, sec, tst, i, 'Hour', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    if dids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, dids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Day'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'Day');
          insert ignore into komprimierungids
            set autokomprimierungID = akid, lwerteindizesID = lwi;
          call kautos(lwi, cls, srv, sec, tst, i, 'Day', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    if wids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, wids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Week'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'Week');
          insert ignore into komprimierungids
            set autokomprimierungID = akid, lwerteindizesID = lwi;
          call kautos(lwi, cls, srv, sec, tst, i, 'Week', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    if mids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, mids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Month'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'Month');
          insert ignore into komprimierungids
            set autokomprimierungID = akid, lwerteindizesID = lwi;
          call kautos(lwi, cls, srv, sec, tst, i, 'Month', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    if spids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, spids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationspecialtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'special'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'special');
          insert ignore into komprimierungids
            set autokomprimierungID = akid, lwerteindizesID=lwi;
          call kautos(lwi, cls, srv, sec, tst, i, 'special', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    drop temporary table loggingtmp.grights;
    fetch kompcur into akid, hids, dids, wids, mids, spids, wi, sec, tst, det, eh, aid, cwtype;
  end while;
  close kompcur;
   
  drop temporary table loggingtmp.aids;


-- Group-Autokomprimierung

  create temporary table loggingtmp.gaids
     (key uk(gautocompressionID, wid, slavegroupID),
      key serverID(serverID, sectionID, teststepID, teststepdetailsID, accessID))
    select ga.ID as gautocompressionID, w.ID as wid, g.slavegroupID,
      w.serverID, w.sectionID, w.teststepID, w.teststepdetailsID, w.accessID,
      w.section, w.teststep, w.detail, w.unit, w.wtype
    from gautocompression as ga
    join loggingtmp.gids as g on g.groupID = ga.groupID and g.accessID = ga.accessID
    join loggingtmp.wids as w
      on w.accessID = ga.accessID and testreg(w.section, ga.section, ga.section_v)
        and testreg(w.teststep, ga.teststep, ga.teststep_v) and testreg(w.detail, ga.details, ga.details_v)
        and testreg(w.unit, ga.einheit, ga.einheit_v)
    where ga.aktiv = '1' and testreg(dom, ga.domain, ga.domain_v)
      and testreg(srv, ga.server, ga.server_v)
    group by gautocompressionID, wid, g.slavegroupID;

  delete komprimierungids
    from komprimierungids
    join loggingtmp.lwids on lwids.ID = komprimierungids.lwerteindizesID
    left join loggingtmp.gaids
      on gaids.gautocompressionID = komprimierungids.groupautoID
        and gaids.slavegroupID <=> komprimierungids.slavegroupID
    where komprimierungids.groupautoID > 0 and gaids.gautocompressionID is NULL;

  delete loggingtmp.gaids
    from loggingtmp.gaids
    join loggingtmp.lwids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
    join komprimierungids
      on komprimierungids.groupautoID = gaids.gautocompressionID
        and komprimierungids.slavegroupID <=> gaids.slavegroupID
        and komprimierungids.lwerteindizesID = lwids.ID;

  open gcompcur;
  set z = 0;
  fetch gcompcur into akid, slaveid, hids, dids, wids, mids, spids, wi, sec, tst, det, eh, aid, cwtype;
  while z != 1 do
    create temporary table loggingtmp.grights (key uk(groupID, slavegroupID))
      select groupID, slavegroupID from loggingtmp.gids where gids.accessID = aid;
    if hids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, hids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Hour'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'Hour');
          insert ignore into komprimierungids (groupautoID, lwerteindizesID, slavegroupID) values
            (akid, lwi, slaveid);
          call kautos(lwi, cls, srv, sec, tst, i, 'Hour', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    if dids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, dids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Day'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'Day');
          insert ignore into komprimierungids (groupautoID, lwerteindizesID, slavegroupID) values
            (akid, lwi, slaveid);
          call kautos(lwi, cls, srv, sec, tst, i, 'Day', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    if wids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, wids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Week'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'Week');
          insert ignore into komprimierungids (groupautoID, lwerteindizesID, slavegroupID) values
            (akid, lwi, slaveid);
          call kautos(lwi, cls, srv, sec, tst, i, 'Week', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    if mids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, mids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'Month'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'Month');
          insert ignore into komprimierungids (groupautoID, lwerteindizesID, slavegroupID) values
            (akid, lwi, slaveid);
          call kautos(lwi, cls, srv, sec, tst, i, 'Month', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    if spids != '' then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, spids)
              and exists (select * from groupfunctions
                          where ID = i and find_in_set(cwtype, aggregationspecialtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
                 groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, 'special'
            from loggingtmp.wids where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join loggingtmp.wids using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where wids.ID = wi and groupfunctionsID = i and period = 'special');
          insert ignore into komprimierungids (groupautoID, lwerteindizesID, slavegroupID) values
            (akid, lwi, slaveid);
          call kautos(lwi, cls, srv, sec, tst, i, 'special', det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
    drop temporary table loggingtmp.grights;
    fetch gcompcur into akid, slaveid, hids, dids, wids, mids, spids, wi, sec, tst, det, eh, aid, cwtype;
  end while;
  close gcompcur;
   
  drop temporary table loggingtmp.gaids;

--
-- Ab hier reicht bei Gruppen das Read-Only-Flag
--

  delete from loggingtmp.gids;
  insert into loggingtmp.gids (groupID, accessID)
    select g.gruppenID as groupID, accessID
    from gruppenrechte as g, server as s
    where s.ID = si and g.verfahrenID = s.verfahrenID;


-- Auto-Kombidetails

  create temporary table loggingtmp.aids
    (primary key(autokombidetailsID, sectionID, teststepID, accessID))
    select distinct a.ID as autokombidetailsID, w.sectionID, w.teststepID, w.accessID
    from autokombidetails as a
    join loggingtmp.wids as w
      on w.accessID = a.accessID and testreg(w.section, a.section, a.section_v)
      and testreg(w.teststep, a.teststep, a.teststep_v) and find_in_set(w.detail, a.details)
    where a.verfahrenID = vid and a.aktiv = '1' and testreg(srv, a.server, a.server_v);

  delete kombidetails
    from kombidetails
    join loggingtmp.wids
      on wids.sectionID = kombidetails.sectionID and wids.teststepID = kombidetails.teststepID and wids.accessID = kombidetails.accessID
    left join loggingtmp.aids on aids.autokombidetailsID = kombidetails.autokombidetailsID
    where kombidetails.serverID = si and kombidetails.autokombidetailsID > 0
      and aids.autokombidetailsID is NULL;
  delete loggingtmp.aids
    from loggingtmp.aids
    join kombidetails 
      on kombidetails.serverID = si and kombidetails.autokombidetailsID = aids.autokombidetailsID
      and kombidetails.sectionID = aids.sectionID and kombidetails.teststepID = aids.teststepID
      and kombidetails.accessID = aids.accessID;

  open kdetcur;
  set z = 0;
  fetch kdetcur into akid, ei, ti, aid, fkt, dtype;
  while z != 1 do
    call convert_combi(si, ei, ti, aid, fkt, 'b', 'datum,', q, fdwid, ctype, cnstvars, uwids);
    if q != '' then
      insert into kombidetails
        (serverID, sectionID, teststepID, teststepdetailsID, formel, formelsql,
         constvars, firstdetwiID, autokombidetailsID, bemerkungen, stringflag,
         aktiv, accessID, usedwIDs)
      select si, ei, ti, teststepdetailsID, formel, q,
        cnstvars, fdwid, ID, bemerkungen, coalesce(dtype, ctype) != 'num', '1', accessID, trim(leading ',' from uwids)
      from autokombidetails
      where ID = akid;
    end if;
    fetch kdetcur into akid, ei, ti, aid, fkt, dtype;
  end while;
  close kdetcur;

  drop temporary table loggingtmp.aids;


-- Group Auto-Kombidetails

  create temporary table loggingtmp.gaids
    (primary key(gautocombidetailsID, sectionID, teststepID, accessID))
    select distinct ga.ID as gautocombidetailsID, w.sectionID, w.teststepID, w.accessID
    from gautocombidetails as ga
    join loggingtmp.wids as w
      on w.accessID = ga.accessID and testreg(w.section, ga.section, ga.section_v)
        and testreg(w.teststep, ga.teststep, ga.teststep_v) and find_in_set(w.detail, ga.details)
    join loggingtmp.gids as g on g.groupID = ga.groupID and g.accessID = ga.accessID
    where ga.aktiv = '1' and testreg(srv, ga.server, ga.server_v)
      and testreg(dom, ga.domain, ga.domain_v);

  delete kombidetails
    from kombidetails
    join loggingtmp.wids
      on wids.sectionID = kombidetails.sectionID and wids.teststepID = kombidetails.teststepID and wids.accessID = kombidetails.accessID
    left join loggingtmp.gaids on gaids.gautocombidetailsID = kombidetails.groupautoID
    where kombidetails.serverID = si and kombidetails.groupautoID > 0
      and gaids.gautocombidetailsID is NULL;
  delete loggingtmp.gaids
    from loggingtmp.gaids
    join kombidetails
      on kombidetails.serverID = si and kombidetails.groupautoID = gaids.gautocombidetailsID
        and kombidetails.sectionID = gaids.sectionID and kombidetails.teststepID = gaids.teststepID
        and kombidetails.accessID = gaids.accessID;

  open gcdetcur;
  set z = 0;
  fetch gcdetcur into akid, ei, ti, aid, fkt, dtype;
  while z != 1 do
    call convert_combi(si, ei, ti, aid, fkt, 'b', 'datum,', q, fdwid, ctype, cnstvars, uwids);
    if q != '' then
      insert into kombidetails
        (serverID, sectionID, teststepID, teststepdetailsID, formel, formelsql,
         constvars, firstdetwiID, groupautoID, bemerkungen, stringflag,
         aktiv, accessID, usedwIDs)
      select si, ei, ti, teststepdetailsID, formel, q,
        cnstvars, fdwid, ID, bemerkungen, coalesce(dtype, ctype) != 'num', '1', accessID, trim(leading ',' from uwids)
      from gautocombidetails
      where ID = akid;
    end if;
    fetch gcdetcur into akid, ei, ti, aid, fkt, dtype;
  end while;
  close gcdetcur;

  drop temporary table loggingtmp.gaids;


-- Auto compressed combidetails

  create temporary table loggingtmp.aids
    (primary key(autoccdetailsID, sectionID, teststepID, accessID))
    select distinct a.ID as autoccdetailsID, w.sectionID, w.teststepID, w.accessID
    from autoccdetails as a
    join loggingtmp.lwids as w
      on w.accessID = a.accessID and testreg(w.section, a.section, a.section_v)
      and testreg(w.teststep, a.teststep, a.teststep_v)
      and find_in_set(w.detail, a.details)
    where verfahrenID = vid and aktiv = '1'
      and testreg(srv, a.server, a.server_v);

  delete ccdetails
    from ccdetails
    join loggingtmp.lwids
      on lwids.sectionID = ccdetails.sectionID and lwids.teststepID = ccdetails.teststepID and lwids.accessID = ccdetails.accessID
    left join loggingtmp.aids on aids.autoccdetailsID = ccdetails.domautoID
      where ccdetails.serverID = si and ccdetails.domautoID > 0 and aids.autoccdetailsID is NULL;
  delete loggingtmp.aids
    from loggingtmp.aids
    join ccdetails
      on ccdetails.serverID = si and ccdetails.domautoID = aids.autoccdetailsID
      and ccdetails.sectionID = aids.sectionID and ccdetails.teststepID = aids.teststepID
      and ccdetails.accessID = aids.accessID;

  open ccdetcur;
  set z = 0;
  fetch ccdetcur into akid, ei, ti, aid, fkt, dtype;
  while z != 1 do
    call convert_ccombi(si, ei, ti, aid, fkt, 'b', 'datum,', q, fdwid, ctype, cnstvars, uwids);
    if q != '' then
      insert into ccdetails
        (serverID, sectionID, teststepID, teststepdetailsID, formel, formelsql,
         constvars, firstdetwiID, domautoID, bemerkungen, stringflag,
         aktiv, accessID, usedwIDs)
      select si, ei, ti, teststepdetailsID, formel, q,
        cnstvars, fdwid, ID, bemerkungen, coalesce(dtype, ctype) != 'num', '1', accessID, trim(leading ',' from uwids)
      from autoccdetails
      where ID = akid;
    end if;
    fetch ccdetcur into akid, ei, ti, aid, fkt, dtype;
  end while;
  close ccdetcur;

  drop temporary table loggingtmp.aids;


-- Group-Auto compressed combidetails

  create temporary table loggingtmp.gaids
    (primary key(gautoccdetailsID, sectionID, teststepID, accessID))
    select distinct ga.ID as gautoccdetailsID, w.sectionID, w.teststepID, w.accessID
    from gautoccdetails as ga
    join loggingtmp.lwids as w
      on w.accessID = ga.accessID and testreg(w.section, ga.section, ga.section_v)
        and testreg(w.teststep, ga.teststep, ga.teststep_v) and find_in_set(w.detail, ga.details)
    join loggingtmp.gids as g on g.groupID = ga.groupID and g.accessID = ga.accessID
    where ga.aktiv = '1' and testreg(srv, ga.server, ga.server_v)
      and testreg(dom, ga.domain, ga.domain_v);

  delete ccdetails
    from ccdetails
    join loggingtmp.lwids
      on lwids.sectionID = ccdetails.sectionID and lwids.teststepID = ccdetails.teststepID and lwids.accessID = ccdetails.accessID
    left join loggingtmp.gaids on gaids.gautoccdetailsID = ccdetails.groupautoID
    where ccdetails.serverID = si and ccdetails.groupautoID > 0
      and gaids.gautoccdetailsID is NULL;
  delete loggingtmp.gaids
    from loggingtmp.gaids
    join ccdetails
      on ccdetails.serverID = si and ccdetails.groupautoID = gaids.gautoccdetailsID
        and ccdetails.sectionID = gaids.sectionID and ccdetails.teststepID = gaids.teststepID
        and ccdetails.accessID = gaids.accessID;

  open gccdetcur;
  set z = 0;
  fetch gccdetcur into akid, ei, ti, aid, fkt, dtype;
  while z != 1 do
    call convert_ccombi(si, ei, ti, aid, fkt, 'b', 'datum,', q, fdwid, ctype, cnstvars, uwids);
    if q != '' then
      insert into ccdetails
        (serverID, sectionID, teststepID, teststepdetailsID, formel, formelsql,
         constvars, firstdetwiID, groupautoID, bemerkungen, stringflag,
         aktiv, accessID, usedwIDs)
      select si, ei, ti, teststepdetailsID, formel, q,
        cnstvars, fdwid, ID, bemerkungen, coalesce(dtype, ctype) != 'num', '1', accessID, trim(leading ',' from uwids)
      from gautoccdetails
      where ID = akid;
    end if;
    fetch gccdetcur into akid, ei, ti, aid, fkt, dtype;
  end while;
  close gccdetcur;

  drop temporary table loggingtmp.gaids;


-- Aufraeumen

drop temporary table loggingtmp.wids, loggingtmp.lwids, loggingtmp.gids;

end//

GRANT EXECUTE on PROCEDURE serverautos to loggingadmin@'localhost'//
GRANT EXECUTE on PROCEDURE serverautos to logginglesen@'localhost'//
