set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS showreg//
create function showreg(rx varchar(2000), rv varchar(2000)) returns varchar(4000)
  deterministic
  sql security invoker
  begin

    if rx = '^ $' and rv = '' then
      return '␣';
    elseif rx = '.*' or rv = '' then
      return concat(getreg(rx), getvreg(rv));
    else
      return concat(getreg(rx), ',', getvreg(rv));
    end if;
  end//

GRANT EXECUTE on FUNCTION showreg
  to logginglesen@'localhost', loggingtest@'localhost', loggingadmin@'localhost'//


DROP FUNCTION IF EXISTS showregnull//
create function showregnull(rx varchar(2000), rv varchar(2000)) returns varchar(4000)
  deterministic
  sql security invoker
  begin

    if rx = '^ $' and rv = '' then
      return '␣';
    elseif rx = '.*' and rv = '' then
      return '*';
    elseif rx = '.*' or rv = '' then
      return concat(getreg(rx), getvreg(rv));
    else
      return concat(getreg(rx), ',', getvreg(rv));
    end if;
  end//

GRANT EXECUTE on FUNCTION showregnull
  to logginglesen@'localhost', loggingtest@'localhost', loggingadmin@'localhost'//
