set @@character_set_client = 'utf8';

-- Tabellen limgrpstat, limgrpstats und limgrpelemstats bereinigen


delimiter //

DROP procedure IF EXISTS cleanlimgrpstats//
create procedure cleanlimgrpstats()
  deterministic
  sql security invoker
 begin

  delete limgrpstat
    from limgrpstat
    left join limitgroup on limitgroup.ID = limitgroupID
    where limitgroup.ID is NULL;  

  delete limgrpstats
    from limgrpstats
    left join limitgroup on limitgroup.ID = limitgroupID
    left join verfahren on verfahren.ID = verfahrenID
    left join serverclasses on serverclasses.ID = classID
    where limitgroup.ID is NULL OR verfahren.ID is NULL OR serverclasses.ID is NULL;

    create temporary table loggingtmp.lmtg
      (primary key (limtype, groupautoID))
        select 'L' as limtype, gautolimits.ID as groupautoID
          from gautolimits
      union all
        select 'I' as limtype, gautoisalive.ID as groupautoID
          from gautoisalive
      union all
        select 'C' as limtype, gautocombilimits.ID as groupautoID
          from gautocombilimits;

  delete limgrpelemstats
    from limgrpelemstats
    left join limitgroup on limitgroup.ID = limitgroupID
    left join loggingtmp.lmtg using(limtype, groupautoID)
    left join limitgroupelement on limitgroupelement.ID = limgrpelemID
    left join verfahren on verfahren.ID = verfahrenID
    left join serverclasses on serverclasses.ID = classID
    where limitgroup.ID is NULL OR lmtg.limtype is NULL OR limitgroupelement.ID is NULL
      OR verfahren.ID is NULL OR serverclasses.ID is NULL;

  drop temporary table loggingtmp.lmtg;

end//
