set @@character_set_client = 'utf8';

-- Kombidetails und Kombilimits aus Autos bestimmen
--
-- s  : eingegebene Funktion
-- gwb: 'b'      bei Aufruf aus kombidetails, leer bei kombilimits
-- gwd: 'datum,' bei Aufruf aus kombidetails, leer bei kombilimits

delimiter //

DROP procedure IF EXISTS convert_combi//
create procedure convert_combi(srvid integer unsigned, secid integer unsigned,
    tstid integer unsigned, aid integer unsigned, s varchar(3000), gwb varchar(1),
    gwd varchar(6), OUT q varchar(5000), OUT fdwid integer unsigned,
    OUT ctype enum('num','str','dat','blob'), OUT constvars varchar(3000), OUT wids varchar(2000))
  deterministic
  sql security invoker
 begin

  declare di, d, e, l, pro, back, i, slen, rsrvid, rsecid, rtstid integer;
  declare code, sdf, ADN varchar(20);
  declare p1, p2, p3, p, srv varchar(50);
  declare rp1, rp2, rp3 integer;
  declare tst varchar(200);
  declare ds varchar(600);
  declare rds varchar(310);
  declare sec, eh, neh, df varchar(100);
  declare sel varchar(150);
  declare wtc varchar(1);
  declare ftype, utype enum('num','str','dat','blob');

  set constvars = '';
  set wids = '';

  if s REGEXP 'into |create |drop |alter |insert |select|delete |update |from |call |;|:='
   then
    set q = '';
  else
    set fdwid = 0;
    set ctype = 'num';
    set q = '';
    set i = 1;
    set e = 1;
    set slen = char_length(s);
    while e <= slen
     do
      set d = locate('$', s, e);
      if d > 0 then
        set q = concat(q, substring(s, e, d-e));
        set e = locate('(', s, d);
        if e > 0 then
          set code = substring(s, d+1, e-d-1);
          set e = e+1;
          call getpar(s, e, ds, i);
          if i > 0 then
            call getpar(s, e, p1, i);
          else
            set p1 = '';
          end if;
          if i > 0 then
            call getpar(s, e, p2, i);
          else
            set p2 = '';
          end if;
          if i > 0 then
            call getpar(s, e, p3, i);
          else
            set p3 = '';
          end if;
          while i > 0 do
            call getpar(s, e, p, i);
          end while;
          if ds REGEXP '^\\|' then
            set rp1 = locate('|', ds, 2);
            set srv = substring(ds, 2, rp1-2);
            set rp2 = locate('|', ds, rp1+1);
            set sec = substring(ds, rp1+1, rp2-rp1-1);
            set rp3 = locate('|', ds, rp2+1);
            set tst = substring(ds, rp2+1, rp3-rp2-1);
            set rds = substring(ds, rp3+1);
            if srv = '' then
              set rsrvid = srvid;
            else
              set rsrvid = (select ss.ID from server ss, server so
                            where so.ID = srvid and ss.verfahrenID = so.verfahrenID
                              and ss.servername = srv);
            end if;
            if sec = '' then
              set rsecid = secid;
            else
              set rsecid = (select ID from section where bname = sec OR name = sec
                            order by bname != sec limit 1);
            end if;
            if tst = '' then
              set rtstid = tstid;
            else
              set rtstid = (select ID from teststep where bname = tst OR name = tst
                            order by bname != tst limit 1);
            end if;
          else
            set rsrvid = srvid;
            set rsecid = secid;
            set rtstid = tstid;
            set rds = ds;
          end if;
          set l = locate('@', rds);
          if l > 0 then
            set neh = substring(rds, l+1);
            set rds = left(rds, l-1);
          else
            set neh = '';
          end if;
          set l = locate('/', rds);
          set di = 0;
          if l > 0 then
            set eh = substring(rds, l+1);
            set rds = left(rds, l-1);
            select werteindizes.ID, type, if(einheiten.name = '[E]', 'e', left(wtab, 1)) into di, utype, wtc
              from werteindizes, teststepdetails, einheiten
              where serverID = rsrvid and sectionID = rsecid
                and teststepID = rtstid and teststepdetailsID = teststepdetails.ID
                and teststepdetails.name = rds and einheiten.name = eh
                and einheiten.ID = einheitID and accessID = aid
              order by teststepdetails.bname != rds, einheiten.bname != eh
              limit 1;
          else
            select werteindizes.ID, type, if(einheiten.name = '[E]', 'e', left(wtab, 1)) into di, utype, wtc
              from werteindizes, teststepdetails, einheiten
              where serverID = rsrvid and sectionID = rsecid
                and teststepID = rtstid and teststepdetailsID = teststepdetails.ID
                and teststepdetails.name = rds
                and einheiten.ID = einheitID and accessID = aid
              order by teststepdetails.bname != rds
              limit 1;
          end if;
          if di > 0 then
            if fdwid = 0 and ds NOT REGEXP '^\\|' then
              set fdwid = di;
            end if;
            if NOT find_in_set(di, wids) then
              set wids = concat(wids, ',', di);
            end if;
            if utype != 'num' then
              set ADN = '';
            else
              set ADN = '0+';
            end if;
            if neh != '' then
              if (select einheiten.name = '[E]'
                    from werteindizes, teststepdetails, einheiten
                    where werteindizes.ID= di and teststepdetails.ID=teststepdetailsID
                      and einheiten.ID=einheitID)
               then
                set df = concat(", '", neh, "')");
                set sdf = "ehwconv(";
              else
                select concat('*',eho.sifaktor/ehn.sifaktor) into df
                           from werteindizes, teststepdetails,
                             einheiten as eho, einheiten as ehn
                           where werteindizes.ID = di
                            and teststepdetails.ID=teststepdetailsID and eho.ID=einheitID
                            and eho.sifaktor > 0 and ehn.name = neh
                            and eho.einheitenID = ehn.einheitenID
                            and ehn.sifaktor > 0;
                set sdf = '';
              end if;
            else
              set df = '';
              set sdf = '';
            end if;
            set sel = '';
            case code
            when 'ACCEL_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','accel')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @accel",di,df," ");
                if constvars not like concat('%accel:' , di, '%') then
                  set constvars = concat('accel:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'AVERAGE_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','avg')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @avg",di,df," ");
                if constvars not like concat('%avg:' , di, '%') then
                  set constvars = concat('avg:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'RATIO_LAST2AVG' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','last/avg')",df,")");
              else
                set slen = 0;
              end if;
            when 'RATIO_LAST2AVG_1' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','last/avg-1')",df,")");
              else
                set slen = 0;
              end if;
            when 'COUNT_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','count'))");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @count",di,df," ");
                if constvars not like concat('%count:' , di, '%') then
                  set constvars = concat('count:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'DATETIME_OF' then
              set ftype = 'dat';
              if gwb != '' then
                set sel = 'datum';
              else
                set slen = 0;
              end if;
            when 'DEV_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','dev')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @devi",di,df," ");
                if constvars not like concat('%devi:' , di, '%') then
                  set constvars = concat('devi:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'DIFFER_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','differ'))");
              else
                set sel = concat("(0+mode",wtc,"wert",gwb,"('",di,"',",gwd,"2,'differ'))");
              end if;
            when 'FIRST_OF' then
              set ftype = utype;
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(",ADN,sdf,"group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','first')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @first",di,df," ");
                if constvars not like concat('%first:' , di, '%') then
                  set constvars = concat('first:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'FIRST_SIZE_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','firstsize')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @firstsize",di,df," ");
                if constvars not like concat('%firstsize:' , di, '%') then
                  set constvars = concat('firstsize:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'GRAD_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','grad')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @grad",di,df," ");
                if constvars not like concat('%grad:' , di, '%') then
                  set constvars = concat('grad:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'GRADIENT' then
              set ftype = 'num';
              if p1 != '' then
                if p1 like '%h%' then
                  set pro = p1+0;
                else
                  set pro = (p1+0)*24;
                end if;
                if p2 != '' then
                  if p2 like '%h%' then
                    set back = p2+0;
                  else
                    set back = (p2+0)*24;
                  end if;
                else
                  set back = 24;
                end if;
              end if;
              set sel = concat("(gradient('",di,"',",back,",",pro,"))");
            when 'LAST_OF' then
              set ftype = utype;
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(",ADN,sdf,"group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','last')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @last",di,df," ");
                if constvars not like concat('%last:' , di, '%') then
                  set constvars = concat('last:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'LAST-FIRST_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','last-first')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @lmf",di,df," ");
                if constvars not like concat('%lmf:' , di, '%') then
                  set constvars = concat('lmf:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'MAX_OF' then
              set ftype = utype;
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(",ADN,"group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','max')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @max",di,df," ");
                if constvars not like concat('%max:' , di, '%') then
                  set constvars = concat('max:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'MIN_OF' then
              set ftype = utype;
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(",ADN,"group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','min')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @min",di,df," ");
                if constvars not like concat('%min:' , di, '%') then
                  set constvars = concat('min:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'MAX-MIN_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','max-min')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @mmm",di,df," ");
                if constvars not like concat('%mmm:' , di, '%') then
                  set constvars = concat('mmm:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'PREDICTION' then
              set ftype = 'num';
              if p1 != '' then
                if p1 like '%h%' then
                  set pro = p1+0;
                else
                  set pro = (p1+0)*24;
                end if;
                if p2 != '' then
                  if p2 like '%h%' then
                    set back = p2+0;
                  else
                    set back = (p2+0)*24;
                  end if;
                else
                  set back = 24;
                end if;
              end if;
              set sel = concat("(prediction',gwb,'('",di,"',",gwd,back,",",pro,")",df,")");
            when 'PREV_OF' then
              set ftype = utype;
              set sel = concat("(",ADN,sdf,"mode",wtc,"wert",gwb,"('",di,"',",gwd,"2,'first')",df,")");
            when 'PREV_SIZE_OF' then
              set ftype = 'num';
              set sel = concat("(0+mode",wtc,"wert",gwb,"('",di,"',",gwd,"2,'firstsize')",df,")");
            when 'REGCOUNT' then
              set ftype = 'num';
              if p2 != '' && gwb = '' then
                set sel = concat("(regcount('",di,"','",p1,"','",p2,"'))");
              else
                set slen = 0;
              end if;
            when 'SIZE_OF' then
              set ftype = 'num';
              set sel = concat("(0+mode",wtc,"wert",gwb,"('",di,"',",gwd,"1,'size')",df,")");
            when 'SUM_OF' then
              set ftype = 'num';
              if p1 != '' AND (gwb = '' OR p1 REGEXP '[hmds]') then
                set sel = concat("(0+group",wtc,"wert",gwb,"('",di,"',",gwd,"'",p1,"','sum')",df,")");
              elseif gwb != '' AND p1 = '' then
                set sel = concat(" @sum",di,df," ");
                if constvars not like concat('%sum:' , di, '%') then
                  set constvars = concat('sum:', di, ' ', constvars);
                end if;
              else
                set slen = 0;
              end if;
            when 'VALUE_OF' then
              set ftype = utype;
              if gwb != '' then
                set sel = concat("(",ADN,sdf,"get",wtc,"wertvb('",di,"',datum,datum,'last')",df,")");
              else
                set sel = concat("(select ",ADN,sdf,"lastwert",df," from letztewerte where ID='",di,"')");
              end if;
            else
              set sel = '';
            end case;
            if sel != '' then
              set q = concat(q, sel);
              if ftype != 'num' then
                set ctype = 'str';
              end if;
            end if;
          else
            set slen = 0;
          end if;
        else
          set slen = 0;
        end if;
      else
        set q = concat(q, substring(s, e));
        set e = slen+1;
      end if;
    end while;
    if slen = 0 then
      set q = '';
    end if;
  end if;
  set constvars = rtrim(constvars);
  set wids = trim(leading ',' from wids);
end//

GRANT EXECUTE on PROCEDURE convert_combi
  to logginglesen@'localhost', loggingadmin@'localhost', logging@'localhost'//
