set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS getcwertvbfilter//
create function getcwertvbfilter(wid integer, von datetime, bis datetime,
  mode varchar(12), zvon time, zbis time)
                  returns varchar(30)
deterministic
sql security invoker
begin
  declare r, l varchar(20);
  declare ld datetime;
  declare va, ba, vo, bo time;
  declare f integer;
  if TIME(zvon) < TIME(zbis)
   then
    set va = TIME(zvon);
    set ba = TIME(zbis);
    set vo = '00:00:00';
    set bo = '23:59:59';
  else
    set va = '00:00:00';
    set ba = '23:59:59';
    set vo = TIME(zvon);
    set bo = TIME(zbis);
  end if;
  case mode
    when 'min' then
      select min(wert+0) from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r;
    when 'max' then
      select max(wert+0) from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r;
    when 'avg' then
      select avg(wert+0), max(length(0+replace(wert, '.',''))) from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r, f;
      return round(r, f + 2 - locate('.', r));
    when 'last/avg' then
      select wert+0 from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      order by datum desc limit 1 into l, ld;
      select avg(wert+0), max(length(0+replace(wert, '.',''))) from cwerte
      where werteindizesID = wid and von <= datum and datum < ld
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r, f;
      if r != 0 then
        return round(l/r, f + 2 - locate('.', l/r));
      else
        return NULL;
      end if;
    when 'last/avg-1' then
      select wert+0 from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      order by datum desc limit 1 into l, ld;
      select avg(wert+0), max(length(0+replace(wert, '.',''))) from cwerte
      where werteindizesID = wid and von <= datum and datum < ld
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r, f;
      if r != 0 then
        return round(l/r-1, f + 2 - locate('.', l/r-1));
      else
        return NULL;
      end if;
    when 'dev' then
      select stddev_samp(wert+0) from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r;
    when 'sum' then
      select sum(wert+0), max(locate('.', reverse(wert))) from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r, f;
      if f < 0 then
        set f = 0;
      end if;
      return round(r, f);
    when 'max-min' then
      select max(wert+0)-min(wert+0) from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r;
    when 'last-first' then
      return (select wert from cwerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum desc limit 1)
           - (select wert from cwerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum limit 1);
    when 'last-first+' then
      set r = (select wert from cwerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum desc limit 1)
           - (select wert from cwerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum limit 1);
      if r < 0 then
        return NULL;
      end if;
    when 'last-first-' then
      set r = (select wert from cwerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum desc limit 1)
           - (select wert from cwerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum limit 1);
      if r > 0 then
        return NULL;
      end if;
    when 'differ' then
      return BINARY (select wert from cwerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum desc limit 1)
          != BINARY (select wert from cwerte
              where werteindizesID = wid and von <= datum and datum <= bis
                and ((va <= TIME(datum) and TIME(datum) <= ba)
                     or vo <= TIME(datum) or TIME(datum) <= bo)
              order by datum limit 1);
    when 'count' then
      select count(*) from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      into r;
    when 'grad' then
      return gradientcvbfilter(wid, von, bis, zvon, zbis);
    when 'accel' then
      return accelc(wid, von, bis, zvon, zbis, '',
              '', '', '', '', '', '', '', '', '', '', '');
    when 'last' then
      select wert from cwerte
      where werteindizesID = wid and von <= datum and datum <= bis
        and ((va <= TIME(datum) and TIME(datum) <= ba)
             or vo <= TIME(datum) or TIME(datum) <= bo)
      order by datum desc limit 1
      into r;
    else
      return NULL;
  end case;
  return r;
end//

GRANT EXECUTE on FUNCTION getcwertvbfilter to logginglesen@'localhost', loggingtest@'localhost'//
