set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS getewertvbextfilter//
create function getewertvbextfilter(wid integer, von datetime(6), bis datetime(6),
  mode varchar(12), zvon time, zbis time, wtf varchar(20),
  vg1 varchar(3), wf1 varchar(250),
  m2 varchar(3), vg2 varchar(3), wf2 varchar(250),
  m3 varchar(3), vg3 varchar(3), wf3 varchar(250),
  m4 varchar(3), vg4 varchar(3), wf4 varchar(250))
                  returns varchar(300)
deterministic
sql security invoker
begin
  declare i integer;
  declare e, w varchar(200);

  select coalesce(wert,lastwert) from twerte, letztewerte
    where werteindizesID = wid and datum >= von and letztewerte.ID = wid
  limit 1 into e;
  set i = instr(e, ' ');
  if i > 0 then
    set e = substr(e, i+1);
    set w = getewertvbextfilteru(wid, von, bis, mode, zvon, zbis, wtf,
              vg1, wf1, m2, vg2, wf2,  m3, vg3, wf3, m4, vg4, wf4, e);
    if w = '' OR mode = 'count' OR mode like 'last/avg%' then
      return w;
    elseif mode = 'grad' then
      return concat(w, ' ', e, '/h');
    elseif mode = 'accel' then
      return concat(w, ' ', e, '/h²');
    else
      return concat(w, ' ', e);
    end if;
  else
    return '';
  end if;

end//

GRANT EXECUTE on FUNCTION getewertvbextfilter
   to logginglesen@'localhost', loggingtest@'localhost', loggingadmin@'localhost'//
