set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS getwertvbextfilter//
create function getwertvbextfilter(wid integer, von datetime(6), bis datetime(6),
  mode varchar(12), zvon time, zbis time, wtf varchar(20),
  vg1 varchar(3), wf1 varchar(250),
  m2 varchar(3), vg2 varchar(3), wf2 varchar(250),
  m3 varchar(3), vg3 varchar(3), wf3 varchar(250),
  m4 varchar(3), vg4 varchar(3), wf4 varchar(250))
                  returns varchar(20000)
deterministic
sql security invoker
begin
  declare wt varchar(30);
  select wtab from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID
      into wt;
  case wt
    when 'bwerte' then return getbwertvbz(wid, von, bis, mode, zvon, zbis); 
    when 'swerte' then return getswertvbextfilter(wid, von, bis, mode, zvon, zbis, wtf,
                                vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4);
    when 'twerte' then return gettwertvbextfilter(wid, von, bis, mode, zvon, zbis, wtf,
                                vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4);
    when 'cwerte' then return getcwertvbextfilter(wid, von, bis, mode, zvon, zbis, wtf,
                                vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4);
    when 'pwerte' then return getpwertvbextfilter(wid, von, bis, mode, zvon, zbis, wtf,
                                vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4);
    else               return getzwertvbextfilter(wid, von, bis, mode, zvon, zbis, wtf,
                                vg1, wf1, m2, vg2, wf2, m3, vg3, wf3, m4, vg4, wf4);
  end case;
end//

GRANT EXECUTE on FUNCTION getwertvbextfilter to logginglesen@'localhost'//
