set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS getwertvbfilter//
create function getwertvbfilter(wid integer, von datetime(6), bis datetime(6),
  mode varchar(12), zvon time, zbis time)
                  returns varchar(20000)
deterministic
sql security invoker
begin
  declare wt varchar(30);
  select wtab from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID
      into wt;
  case wt
    when 'swerte' then return getswertvbfilter(wid, von, bis, mode, zvon, zbis);
    when 'twerte' then return gettwertvbfilter(wid, von, bis, mode, zvon, zbis);
    when 'cwerte' then return getcwertvbfilter(wid, von, bis, mode, zvon, zbis);
    when 'pwerte' then return getpwertvbfilter(wid, von, bis, mode, zvon, zbis);
    else               return getzwertvbfilter(wid, von, bis, mode, zvon, zbis);
  end case;
end//

GRANT EXECUTE on FUNCTION getwertvbfilter to logginglesen@'localhost', loggingtest@'localhost'//
