set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS gradientevbextfilter//
create function gradientevbextfilter(wid integer, von datetime(6), bis datetime(6),
  zvon time, zbis time, wtf varchar(20),
  vg1 varchar(3), wf1 varchar(250),
  m2 varchar(3), vg2 varchar(3), wf2 varchar(250),
  m3 varchar(3), vg3 varchar(3), wf3 varchar(250),
  m4 varchar(3), vg4 varchar(3), wf4 varchar(250), neh varchar(100)) returns varchar(50)
deterministic
sql security invoker
begin
  declare s, u, sx, sxx, syx, sy double;
  declare va, ba, vo, bo time;
  if TIME(zvon) < TIME(zbis)
   then
    set va = TIME(zvon);
    set ba = TIME(zbis);
    set vo = '24:00:00';
    set bo = '-00:00:01';
  else
    set va = '24:00:00';
    set ba = '-00:00:01';
    set vo = TIME(zvon);
    set bo = TIME(zbis);
  end if;
  set u = UNIX_TIMESTAMP(von);
      select sum(pow(UNIX_TIMESTAMP(datum)-u,2)), sum(UNIX_TIMESTAMP(datum)-u),
             count(datum), sum(ehwconv(wert,neh)*(UNIX_TIMESTAMP(datum)-u)),
             sum(ehwconv(wert,neh)) from twerte
        where werteindizesID = wid and von <= datum and datum <= bis
          and ((va <= TIME(datum) and TIME(datum) <= ba)
               or vo <= TIME(datum) or TIME(datum) <= bo)
          and (wtf = '' or find_in_set(DAYOFWEEK(datum), wtf))
          and extfilter(ehwconv(wert,neh), vg1, ehwconv(wf1, neh), m2, vg2,
            ehwconv(wf2, neh), m3, vg3, ehwconv(wf3, neh), m4, vg4, ehwconv(wf4, neh))
        into sxx, sx, s, syx, sy;
  if sxx > 0
   then
    return 3600*(syx-sy*sx/s)/(sxx-sx*sx/s);
  else
     return '';
  end if;
end//

GRANT EXECUTE on FUNCTION gradientevbextfilter
  to logginglesen@'localhost', loggingtest@'localhost', 'loggingadmin'@'localhost'//
