set @@character_set_client = 'utf8';

delimiter //

DROP FUNCTION IF EXISTS gradienttvb//
create function gradienttvb(wid integer, von datetime, bis datetime) returns varchar(50)
deterministic
sql security invoker
begin
  declare s, u, sx, sxx, syx, sy double;
  set u = UNIX_TIMESTAMP(von);
  select sum(pow(UNIX_TIMESTAMP(datum)-u,2)), sum(UNIX_TIMESTAMP(datum)-u),
         count(datum), sum((wert+0)*(UNIX_TIMESTAMP(datum)-u)),
         sum((wert+0)) from twerte
    where werteindizesID = wid and von <= datum and datum <= bis
    into sxx, sx, s, syx, sy;
  if sxx > 0
   then
    return 3600*(syx-sy*sx/s)/(sxx-sx*sx/s);
  else
     return '';
  end if;
end//

GRANT EXECUTE on FUNCTION gradienttvb to logginglesen@'localhost', loggingtest@'localhost', loggingadmin@'localhost'//
