set @@character_set_client = 'utf8';

-- combined aggregation limits
-- combined aggregation details

delimiter //

DROP FUNCTION IF EXISTS grouplwert//
create function grouplwert(lwid integer, back varchar(10), mode varchar(12))
                          returns varchar(30)
  deterministic
  sql security invoker
  begin
    declare anz integer;
    declare vondate datetime;
    set anz = back + 0;
    case right(back, 1)
      when 'm' then
        set vondate = now() - interval anz minute;
      when 'h' then
        set vondate = now() - interval anz hour;
      when 'd' then
        set vondate = now() - interval anz day;
      else
        return modelwert(lwid, back, mode);
    end case;
    return getlwertvb(lwid, vondate, now(), mode);
end//

GRANT EXECUTE on FUNCTION grouplwert to logginglesen@'localhost', loggingtest@'localhost'//
