set @@character_set_client = 'utf8';

-- aggregatet combined details


delimiter //

DROP FUNCTION IF EXISTS grouplwertb//
create function grouplwertb(lwid integer, bis datetime, back varchar(10), mode varchar(12))
    returns varchar(30)
  deterministic
  sql security invoker
  begin
    declare bm, bh integer;

    case right(back, 1)
      when 'm' then
        set bm = back + 0;
      when 'h' then
        set bm = (back + 0)*60;
      when 'd' then
        set bm = (back + 0)*1440;
      else
        return modelwertb(lwid, bis, back, mode);
    end case;
    if find_in_set(mode, 'last,first,size,firstsize,lastsize,differ,last/avg,last/avg-1') then
      return getlwertvb(lwid, bis - interval bm minute, bis, mode);
    else
      set bh = bm / 2;
      return getlwertvb(lwid, bis - interval (bm-bh) minute, bis + interval bh minute, mode);
   end if;
end//

GRANT EXECUTE on FUNCTION grouplwertb to logginglesen@'localhost', loggingtest@'localhost'//
