set @@character_set_client = 'utf8';

-- combined details
-- combined limits


delimiter //

DROP FUNCTION IF EXISTS modewertb//
create function modewertb(wid integer, bis datetime(6), anz integer, mode varchar(12)) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare wt varchar(30);
    select wtab from werteindizes, teststepdetails, einheiten
      where werteindizes.ID=wid and teststepdetailsID=teststepdetails.ID
        and einheitID=einheiten.ID
      into wt;
    case wt
      when 'bwerte' then return modebwertb(wid, bis, anz, mode);
      when 'swerte' then return modeswertb(wid, bis, anz, mode);
      when 'twerte' then return modetwertb(wid, bis, anz, mode);
      when 'cwerte' then return modecwertb(wid, bis, anz, mode);
      when 'pwerte' then return modepwertb(wid, bis, anz, mode);
      else               return modezwertb(wid, bis, anz, mode);
    end case;
  end//

GRANT EXECUTE on FUNCTION modewertb to logginglesen@'localhost', loggingtest@'localhost'//
