set @@character_set_client = 'utf8';

##################################
# newkompautos.sql
#
# Komprimierungen aus Autokomprimierungen einrichten
#
# wird aufgerufen, wenn neue werteindizes eingerichtet werden
#############################################################

delimiter //

DROP procedure IF EXISTS newkompautos//
create procedure newkompautos(wi integer unsigned, cls varchar(50), srv varchar(50),
                   sec varchar(100), tst varchar(600), det varchar(100),
                   eh varchar(100), vid integer unsigned, aid integer unsigned,
                   wtype enum('num','str','dat','blob'))
  deterministic
  sql security invoker
 begin

  declare i, z integer;
  declare mgf, akid, lwi integer unsigned;
  declare cmode enum('Hour','Day','Week','Month','special');
  declare cids varchar(100);
  declare kompcur cursor for
      select ID, 'Hour' as c, hourIDs
      from autokomprimierung
      where verfahrenID = vid and aktiv = '1' and accessID = aid
        and testreg(srv, server, server_v) and testreg(sec, section, section_v)
        and testreg(tst, teststep, teststep_v) and testreg(det, details, details_v)
        and testreg(eh, einheit, einheit_v)
        and hourIDs != ''
    union all
      select ID, 'Day' as c, dayIDs
      from autokomprimierung
      where verfahrenID = vid and aktiv = '1' and accessID = aid
        and testreg(srv, server, server_v) and testreg(sec, section, section_v)
        and testreg(tst, teststep, teststep_v) and testreg(det, details, details_v)
        and testreg(eh, einheit, einheit_v)
        and dayIDs != ''
    union all
      select ID, 'Week' as c, weekIDs
      from autokomprimierung
      where verfahrenID = vid and aktiv = '1' and accessID = aid
        and testreg(srv, server, server_v) and testreg(sec, section, section_v)
        and testreg(tst, teststep, teststep_v) and testreg(det, details, details_v)
        and testreg(eh, einheit, einheit_v)
        and weekIDs != ''
    union all
      select ID, 'Month' as c, monthIDs
      from autokomprimierung
      where verfahrenID = vid and aktiv = '1' and accessID = aid
        and testreg(srv, server, server_v) and testreg(sec, section, section_v)
        and testreg(tst, teststep, teststep_v) and testreg(det, details, details_v)
        and testreg(eh, einheit, einheit_v)
        and monthIDs != ''
    union all
      select ID, 'special' as c, specialIDs
      from autokomprimierung
      where verfahrenID = vid and aktiv = '1' and accessID = aid
        and testreg(srv, server, server_v) and testreg(sec, section, section_v)
        and testreg(tst, teststep, teststep_v) and testreg(det, details, details_v)
        and testreg(eh, einheit, einheit_v)
        and specialIDs != '';
  declare continue handler for not found set z = 1;

  select max(ID) from groupfunctions
      where aggregationtypes != '' OR aggregationspecialtypes != '' into mgf;

  open kompcur;
  set z = 0;
  repeat
    fetch kompcur into akid, cmode, cids;
    if z != 1 then
      set i = 1;
      while i <= mgf do
        if find_in_set(i, cids)
            and exists (select * from groupfunctions
                        where ID = i and find_in_set(wtype, aggregationtypes)) then
          insert ignore into lwerteindizes
              (serverID, sectionID, teststepID, teststepdetailsID, accessID,
               groupfunctionsID, period)
            select serverID, sectionID, teststepID, teststepdetailsID, accessID, i, cmode
            from werteindizes where ID = wi;
          set lwi = (select lwerteindizes.ID from lwerteindizes
                     join werteindizes using(serverID, sectionID, teststepID, teststepdetailsID, accessID)
                     where werteindizes.ID = wi and groupfunctionsID = i and period = cmode);
          insert ignore into komprimierungids
            set autokomprimierungID = akid, groupautoID = 0, lwerteindizesID = lwi;
          call kautos(lwi, cls, srv, sec, tst, i, cmode, det, eh, vid, aid);
        end if;
        set i = i + 1;
      end while;
    end if;
  until z = 1 end repeat;
  close kompcur;

end//

GRANT EXECUTE on PROCEDURE newkompautos to logging@'localhost', loggingadmin@'localhost'//
