set @@character_set_client = 'utf8';

delimiter //
DROP FUNCTION IF EXISTS predictionz//
create function predictionz(wid integer, hback integer, hforw integer) returns varchar(50)
  deterministic
  sql security invoker
  begin
    declare vondate datetime;
    declare s, u, sx, sxx, syx, sy double;
    set vondate = now() - interval hback hour;
    set u = UNIX_TIMESTAMP(now() + interval hforw hour);
    select sum(pow(UNIX_TIMESTAMP(datum)-u,2)), sum(UNIX_TIMESTAMP(datum)-u),
           count(datum), sum((wert+0)*(UNIX_TIMESTAMP(datum)-u)),
           sum((wert+0)) from zwerte
      where werteindizesID = wid and vondate <= datum and datum <= now()
      into sxx, sx, s, syx, sy;
    if sxx > 0 && s > 1
     then
      return (sy-sx*syx/sxx)/(s-sx*sx/sxx);
    else
      return NULL;
    end if;
  end//

GRANT EXECUTE on FUNCTION predictionz to logginglesen@'localhost', loggingtest@'localhost'//
