SET character_set_client = utf8;

CREATE temporary TABLE loggingtmp.htnew (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `lang` varchar(10) NOT NULL DEFAULT 'de',
  `name` varchar(100) NOT NULL DEFAULT '',
  `text` text NOT NULL,
  `includes` varchar(500) NOT NULL DEFAULT '',
  `helpset` set('ConfigHints') NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `langname` (`lang`,`name`),
  KEY `helpset` (`helpset`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Hilfetexte';

INSERT INTO loggingtmp.htnew VALUES (7,'de','LimitsFestlegen','<p>Limits (Grenzwerte) k&ouml;nnen zu allen Details eingetragen, gel&ouml;scht oder\nge&auml;ndert werden. Die Kontrolle auf verletzte Limits findet alle 5 Minuten\nstatt. </p>\n\n<p>Es wird der aktuelle (neueste) Wert mit den eingetragenen Limits von\nInfo/Warn/Fehler verglichen. Ist einer der Limits verletzt, so wird eine\nMeldung an das Meldungsziel versandt.<br>\n</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <col width=\"38*\"><col width=\"218*\"><thead>\n    <tr style=\"font-weight: bold\">\n      <td width=\"15%\">Tabellenspalte</td>\n      <td width=\"85%\">Erkl&auml;rung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td width=\"15%\" height=\"15\">Detail</td>\n      <td width=\"85%\">F&uuml;r jedes existierende Detail wird eine Zeile zum\n        festlegen von Limits angezeigt.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">aktueller Wert</td>\n      <td width=\"85%\">Der letzte (neueste) Wert ggf mit Einheit f&uuml;r das\n        Detail.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Vergleich</td>\n      <td width=\"85%\">Der Vergleichsoperator. der mit dem aktuellen Wert\n        gegen die Limits verwendet wird. =&gt;(1)</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Info<br>\n        Warn<br>\n        Fehler</td>\n      <td width=\"85%\">Drei Limits k&ouml;nnen eingetragen werden, die sich durch\n        jeweils h&ouml;here Priorit&auml;t im Remedy Ticket unterscheiden. Verletzt der\n        aktuelle Wert einen von diesen Limits, so wird eine Meldung\n      ausgel&ouml;st.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Logfile Modus</td>\n      <td width=\"85%\">JEDER! eingehende Wert f&uuml;r dieses Detail l&ouml;st eine\n        Meldung aus. Dies &uuml;berschreibt eventuell eingetragene Werte f&uuml;r\n        Info/Warn/Fehler. ACHTUNG: dies kann uU zu einem erheblichen\n        Aufkommen von Meldungen f&uuml;hren und sollte nur mit &auml;u&szlig;erster Vorsicht\n        eingesetzt werden!</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Meldung</td>\n      <td width=\"85%\">Hier kann eine zus&auml;tzliche Meldung (max 200 Zeichen)\n        eingetragen werden, eine standardisierte Benachrichtigung wird immer\n        geschickt. In der Meldung k&ouml;nnen Platzhalter verwendet werden\n      =&gt;(2)</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Meldungsziel</td>\n      <td width=\"85%\">Zwei Drop-down-Listen mit den verf&uuml;gbaren\n        Benachrichtigungszielen, die f&uuml;r dieses Verfahren definiert sind.\n\n        <p>Die Checkboxen I W F (Info, Warn, Fehler) legen die Limits fest,\n        bei deren Verletzung eine Benachrichtigung an das jeweilige\n        Meldungsziel geschickt wird.</p>\n      </td>\n    </tr>\n    <tr>\n      <td width=\"15%\">mitteln &uuml;ber</td>\n      <td width=\"85%\">Der definierte Vergleich wird standardm&auml;&szlig;ig gegen den\n        aktuellen Wert durchgef&uuml;hrt (\"mitteln &uuml;ber\" = 1). Wird \"mitteln &uuml;ber\"\n        gr&ouml;&szlig;er gew&auml;hlt, so wird der arithmetische Mittelwert aus dieser\n        Anzahl der zuletzt eingegangenen Werte ermittelt, damit wird dann der\n        definierte Vergleich gegen die Limits ausgef&uuml;hrt. Dies ist nur bei\n        numerischen Werten wirksam. =&gt;(3)</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">aktiv</td>\n      <td width=\"85%\">Damit kann ein Grenzwert aktiviert oder auch\n        deaktiviert werden.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">l&ouml;schen</td>\n      <td width=\"85%\">Damit wird diese Limit-Definition gel&ouml;scht.</td>\n    </tr>\n  </tbody>\n</table>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><b>(1)</b> Die Vergleichsoperatoren</p>\n\n<p>Definitionen von Ausdr&uuml;cken, die zur weiteren Beschreibung der\nVergleichsoperator verwendet werden:</p>\n\n<table cellpadding=\"4\" border=\"1\" cellspacing=\"0\">\n  <tbody>\n    <tr style=\"font-weight: bold\">\n      <td>Datentyp</td>\n      <td>Bedeutung</td>\n    </tr>\n    <tr>\n      <td>Integer</td>\n      <td>sind ganze Zahlen</td>\n    </tr>\n    <tr>\n      <td>Float</td>\n      <td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n    </tr>\n    <tr>\n      <td>Zahlen</td>\n      <td>wird als Equivalent f&uuml;r die Menge von Integer und Float\n      verwendet</td>\n    </tr>\n    <tr>\n      <td>String</td>\n      <td>wird f&uuml;r beliebige Textausdr&uuml;cke verwendet</td>\n    </tr>\n    <tr>\n      <td>&lt;wert&gt;</td>\n      <td>ist der aktuelle Wert</td>\n    </tr>\n    <tr>\n      <td>&lt;limit&gt;</td>\n      <td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler als DiffLimit\n        eingetragen ist</td>\n    </tr>\n    <tr>\n      <td>&lt;regexp&gt;</td>\n      <td>ist ein regul&auml;rer Ausdruck, der POSIX 1003.2 (wie zB in \"man 7\n        regex\" beschrieben) entsprechen muss und der bei Info/Warn/Fehler\n        eingetragen ist. Er wird anstelle des &lt;limit&gt; verwendet</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Vor dem Vergleich werden die Ausdr&uuml;cke &lt;wert&gt; und &lt;limit&gt; erst\nin gleiche Datentypen umgewandelt. Die Datentypnumwandlung erfolgt nach\nfolgender Vorschrift:</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <tbody>\n    <tr style=\"font-weight: bold\">\n      <td>\n        <div style=\"text-align: center\">\n        Datentyp<br style=\"margin-left: auto; margin-right: auto\">\n        &lt;wert&gt;</div>\n      </td>\n      <td>\n        <div style=\"text-align: center\">\n        Datentyp<br>\n        &lt;limit&gt;</div>\n      </td>\n      <td>Vergleich wird durchgef&uuml;hrt als Datentyp</td>\n    </tr>\n    <tr>\n      <td>Integer</td>\n      <td>Integer</td>\n      <td>Integer</td>\n    </tr>\n    <tr>\n      <td>Integer</td>\n      <td>Float</td>\n      <td>Float</td>\n    </tr>\n    <tr>\n      <td>Float</td>\n      <td>Integer</td>\n      <td>Float</td>\n    </tr>\n    <tr>\n      <td>String</td>\n      <td>beliebig</td>\n      <td>String</td>\n    </tr>\n    <tr>\n      <td>beliebig</td>\n      <td>String</td>\n      <td>String<br>\n      </td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Allgemein gilt dabei f&uuml;r die Vergleiche:</p>\n<ul>\n  <li>Bei String-Vergleichen wird Gro&szlig;-Kleinschreibung unterschieden.</li>\n  <li>\"!\" ist die Negation des Vergleichs.</li>\n  <li>\"|\"\n    <ul>\n      <li>Integer, Float: bildet Absolutwerte von beiden Ausdr&uuml;cken bevor\n        verglichen wird (abs)</li>\n      <li>String: vergleicht beide Ausdr&uuml;cke unabh&auml;ngig von\n        Gro&szlig;-Kleinschreibung (ignore case)<br>\n      </li>\n    </ul>\n  </li>\n</ul>\n\n<p><span style=\"color: #FF0000; background-color: #FFFFFF\">Hinweis:</span><br\nstyle=\"color: #FF0000; background-color: #FFFFFF\">\nDie Vergleiche erfolgen nur gegen die LETZTE! Zeile eines uU mehrzeiligen\nWerts zB Protokolldateiinhalte. Also nicht unbedingt gegen den gesamten\nInhalt des Wertes.<br>\n</p>\n\n<p>Wenn nicht anders angegeben, gelten die Vergleiche sowohl f&uuml;r Integer,\nFloat und Strings.<br>\n</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <tbody>\n    <tr style=\"font-weight: bold\">\n      <td style=\"text-align: center\">Operand</td>\n      <td style=\"text-align: center\">Vergleichsoperator</td>\n      <td style=\"text-align: center\">Operand</td>\n      <td>durchgef&uuml;hrter Vergleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">&lt;</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>kleiner</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">&lt;|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>kleiner (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">&lt;=</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>kleiner gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">&lt;=|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>kleiner gleich (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">&gt;</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gr&ouml;&szlig;er</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">&gt;|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gr&ouml;&szlig;er (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">&gt;=</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gr&ouml;&szlig;er gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">&gt;=|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gr&ouml;&szlig;er gleich (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">=</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">=|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gleich (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td align=\"center\" style=\"text-align: center\">!=</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>ungleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">==</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gleich, keine Datentypenumwandlung (immer String)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">==|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gleich, keine Datentypenumwandlung (immer String) (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">!==</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>ungleich, keine Datentypenumwandlung (immer String)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">~~</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>&lt;wert&gt; enth&auml;lt &lt;limit&gt; als Substring</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">~~|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>&lt;wert&gt; enth&auml;lt &lt;limit&gt; als Substring (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">!~~</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>&lt;wert&gt; enth&auml;lt nicht &lt;limit&gt; als Substring</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">!~~|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>&lt;wert&gt; enth&auml;lt nicht &lt;limit&gt; als Substring (ignore\n      case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">~</td>\n      <td style=\"text-align: center\">&lt;regexp&gt;</td>\n      <td>&lt;wert&gt; matches &lt;regexp&gt;</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">!~</td>\n      <td style=\"text-align: center\">&lt;regexp&gt;</td>\n      <td>&lt;wert&gt; does not match &lt;regexp&gt;</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">~|</td>\n      <td style=\"text-align: center\">&lt;regexp&gt;</td>\n      <td>&lt;wert&gt; matches &lt;regexp&gt; (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;wert&gt;</td>\n      <td style=\"text-align: center\">!~|</td>\n      <td style=\"text-align: center\">&lt;regexp&gt;</td>\n      <td>&lt;wert&gt; does not match &lt;regexp&gt; (ignore case)<br>\n      </td>\n    </tr>\n  </tbody>\n</table>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><b>(2)</b> Verwendung von Platzhaltern</p>\n\n<p>Im Text von \"Meldung\" k&ouml;nnen folgende Platzhalter verwendet werden, die\nvor der Versendung der \"Meldung\" durch den entsprechenden Ausdruck ersetzt\nwerden.<br>\n</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <col width=\"56*\"><col width=\"200*\"><thead>\n    <tr valign=\"top\" style=\"font-weight: bold\">\n      <td width=\"22%\">Platzhalter</td>\n      <td width=\"78%\">wird ersetzt durch</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr valign=\"top\">\n      <td width=\"22%\">$COMPARE</td>\n      <td width=\"78%\">den angewandte Vergleich</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"22%\">$DETAIL</td>\n      <td width=\"78%\">das Detail (die &Uuml;berschrift der Tabellenspalte)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"22%\">$LIMIT</td>\n      <td width=\"78%\">den verletzten Limit (Info/Warn/Fehler)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"22%\">$SECTION</td>\n      <td width=\"78%\">die Sektion</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"22%\">$SERVER</td>\n      <td width=\"78%\">den Namen des Rechners</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"22%\">$TESTSTEP</td>\n      <td width=\"78%\">die Bezeichnung des Testschritts, ggf mit Doppelpunkten\n        bei rekursiven Testschritten</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"22%\">$UNIT</td>\n      <td width=\"78%\">die Einheit des Werts</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"22%\">$VALUE</td>\n      <td width=\"78%\">den aktuellen Wert, der die Limits-Verletzung ausgel&ouml;st\n        hat</td>\n    </tr>\n  </tbody>\n</table>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><b>(3)</b> \"mitteln &uuml;ber\" und &Uuml;berwachungspausen</p>\n\n<p>Ist f&uuml;r einen Server eine oder mehrere &Uuml;berwachungspausen definiert, so\nwerden bei dem zu berechnenden Mittelwert <b>trotzdem</b> Werte aus der\n&Uuml;berwachungspause verwendet. Dies ist ggf bei der Definition der\n&Uuml;berwachungpause(n) und bei \"mitteln &uuml;ber\" zu beachten.<br>\n</p>','','ConfigHints'),(4,'de','DetailbeschreibungFestlegen','<p>F&uuml;r jedes Detail kann manuell eine Beschreibung hinterlegt werden. Die\nBeschreibung gilt nur f&uuml;r exakt dieses Detail.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <col width=\"38*\"><col width=\"218*\"><thead>\n    <tr>\n      <td width=\"15%\"><span\n      style=\"font-weight: bold\">Tabellenspalte</span></td>\n      <td width=\"85%\"><span style=\"font-weight: bold\">Erkl&auml;rung</span></td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td width=\"15%\">Detail</td>\n      <td width=\"85%\">F&uuml;r jedes existierende Detail wird eine Zeile zum\n        festlegen und bearbeiten von Beschreibungen angezeigt.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Beschreibung</td>\n      <td width=\"85%\">Beschreibung f&uuml;r dieses Detail</td>\n    </tr>\n  </tbody>\n</table>\n<p>','','ConfigHints'),(5,'de','DiffLimitsFestlegen','<p>DiffLimits k&ouml;nnen zu allen Details eingetragen, gel&ouml;scht oder ge&auml;ndert\nwerden. Die Kontrolle auf verletzte DiffLimits findet alle 5 Minuten statt.\n</p>\n\n<p>Es wird jeweils der vorige Wert vom aktuellen (neuesten) Wert subtrahiert\nund das Ergebnis (die Differenz) mit dem eingetragenen DiffLimit von\nInfo/Warn/Fehler verglichen. Bei Textausdr&uuml;cken ist nur ein gleich/ungleich\nm&ouml;glich und ist auch <b>nur</b> f&uuml;r einzeilige Werte verwendbar. Ist ein\nDiffLimit verletzt, so wird eine Meldung an das Meldungsziel versandt.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <col width=\"38*\"><col width=\"218*\"><thead>\n    <tr>\n      <td width=\"15%\"><span\n        style=\"font-weight: bold\">Tabellenspalte</span><span\n        style=\"font-weight: bold\"></span></td>\n      <td width=\"85%\"><span style=\"font-weight: bold\">Erkl&auml;rung</span></td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td width=\"15%\">Detail</td>\n      <td width=\"85%\">F&uuml;r jedes existierende Detail wird eine Zeile zum\n        festlegen und bearbeiten von DiffLimits angezeigt.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">letzte Differenz</td>\n      <td width=\"85%\">Voriger Wert subtrahiert vom aktuellen Wert mit\n        Einheit, bzw voriger und aktueller Textausdruck.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Vergleich</td>\n      <td width=\"85%\">Der auf die letzte Differenz zu den DiffLimits\n        anzuwendende Vergleichsoperator =&gt;(1)</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Info<br>\n        Warn<br>\n        Fehler</td>\n      <td width=\"85%\">Diese drei DiffLimits k&ouml;nnen eingetragen werden. Sie\n        unterscheiden sich durch eine jeweils h&ouml;here Priorit&auml;t im Remedy\n        Ticket (nur bei Remedy Meldungszielen). Verletzt die ermittelte\n        Differenz einen von diesen DiffLimits, so wird eine Meldung\n        ausgel&ouml;st. Bei Details mit Textausdr&uuml;cken kann nur die Priorit&auml;t\n        ausgew&auml;hlt werden.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Meldung</td>\n      <td width=\"85%\">Hier kann eine zus&auml;tzliche Meldung (max 200 Zeichen)\n        eingetragen werden, eine standardisierte Benachrichtigung wird immer\n        geschickt. In der Meldung k&ouml;nnen Platzhalter verwendet werden\n      =&gt;(2)</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">Meldungsziel</td>\n      <td width=\"85%\">Eine Drop-down-Liste mit den verf&uuml;gbaren\n        Benachrichtigungszielen, die f&uuml;r dieses Verfahren definiert sind.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">aktiv</td>\n      <td width=\"85%\">Damit kann ein DiffLimit aktiviert oder deaktiviert\n        werden.</td>\n    </tr>\n    <tr>\n      <td width=\"15%\">l&ouml;schen</td>\n      <td width=\"85%\">Damit wird diese DiffLimit-Definition gel&ouml;scht.</td>\n    </tr>\n  </tbody>\n</table>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><b>(1)</b> Die Vergleichsoperatoren</p>\n\n<p>Definitionen von Ausdr&uuml;cken, die zur weiteren Beschreibung der\nVergleichsoperator verwendet werden:</p>\n\n<table cellpadding=\"4\" border=\"1\" cellspacing=\"0\">\n  <tbody>\n    <tr style=\"font-weight: bold\">\n      <td>Datentyp</td>\n      <td>Bedeutung</td>\n    </tr>\n    <tr>\n      <td>Integer</td>\n      <td>sind ganze Zahlen</td>\n    </tr>\n    <tr>\n      <td>Float</td>\n      <td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n    </tr>\n    <tr>\n      <td>Zahlen</td>\n      <td>wird als Equivalent f&uuml;r die Menge von Integer und Float\n      verwendet</td>\n    </tr>\n    <tr>\n      <td>String</td>\n      <td>wird f&uuml;r beliebige Textausdr&uuml;cke verwendet</td>\n    </tr>\n    <tr>\n      <td>&lt;differenz&gt;</td>\n      <td>voriger Wert subtrahiert vom aktuellen Wert</td>\n    </tr>\n    <tr>\n      <td>&lt;limit&gt;</td>\n      <td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler als DiffLimit\n        eingetragen ist</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Vor dem Vergleich werden die Ausdr&uuml;cke &lt;differenz&gt; und &lt;limit&gt;\nerst in gleiche Datentypen umgewandelt. Die Datentypnumwandlung erfolgt nach\nfolgender Vorschrift:</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <tbody>\n    <tr style=\"font-weight: bold\">\n      <td>\n        <div style=\"text-align: center\">\n        Datentyp<br style=\"margin-left: auto; margin-right: auto\">\n        &lt;differenz&gt;</div>\n      </td>\n      <td>\n        <div style=\"text-align: center\">\n        Datentyp<br>\n        &lt;limit&gt;</div>\n      </td>\n      <td>Vergleich wird durchgef&uuml;hrt als Datentyp</td>\n    </tr>\n    <tr>\n      <td>Integer</td>\n      <td>Integer</td>\n      <td>Integer</td>\n    </tr>\n    <tr>\n      <td>Integer</td>\n      <td>Float</td>\n      <td>Float</td>\n    </tr>\n    <tr>\n      <td>Float</td>\n      <td>Integer</td>\n      <td>Float</td>\n    </tr>\n    <tr>\n      <td>String</td>\n      <td>beliebig</td>\n      <td>String</td>\n    </tr>\n    <tr>\n      <td>beliebig</td>\n      <td>String</td>\n      <td>String</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Allgemein gilt dabei f&uuml;r die Vergleiche:</p>\n<ul>\n  <li>Bei String-Vergleichen wird Gro&szlig;-Kleinschreibung unterschieden.</li>\n  <li>\"!\" ist die Negation des Vergleichs.</li>\n  <li>\"|\"\n    <ul>\n      <li>Integer, Float: bildet Absolutwerte von beiden Ausdr&uuml;cken bevor\n        verglichen wird (abs)</li>\n      <li>String: vergleicht beide Ausdr&uuml;cke unabh&auml;ngig von\n        Gro&szlig;-Kleinschreibung (ignore case)</li>\n    </ul>\n  </li>\n</ul>\n\n<p>Diese Vergleiche gelten f&uuml;r Integer und Float:</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <tbody>\n    <tr style=\"font-weight: bold\">\n      <td style=\"text-align: center\">Operand</td>\n      <td>Vergleichsoperator</td>\n      <td style=\"text-align: center\">Operand</td>\n      <td>durchgef&uuml;hrter Vergleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">&lt;</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>kleiner</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">&lt;|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>kleiner (abs)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">&lt;=</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>kleiner gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">&lt;=|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>kleiner gleich (abs)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">&gt;</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gr&ouml;&szlig;er</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">&gt;|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gr&ouml;&szlig;er (abs)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">&gt;=</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gr&ouml;&szlig;er gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">&gt;=|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gr&ouml;&szlig;er gleich (abs)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">=</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">=|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gleich (abs)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td align=\"center\">!=</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>ungleich</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Diese Vergleiche gelten f&uuml;r Strings:</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <tbody>\n    <tr style=\"font-weight: bold\">\n      <td style=\"text-align: center\">Operand</td>\n      <td style=\"text-align: center\">Vergleichsoperator</td>\n      <td style=\"text-align: center\">Operand</td>\n      <td>durchgef&uuml;hrter Vergleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td style=\"text-align: center\">==</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td style=\"text-align: center\">!==</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>ungleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td style=\"text-align: center\">==|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>gleich (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center\">&lt;differenz&gt;</td>\n      <td style=\"text-align: center\">!==|</td>\n      <td style=\"text-align: center\">&lt;limit&gt;</td>\n      <td>ungleich (ignore case)</td>\n    </tr>\n  </tbody>\n</table>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><b>(2)</b> Verwendung von Platzhaltern</p>\n\n<p>Im Text von \"Meldung\" k&ouml;nnen folgende Platzhalter verwendet werden, die\nvor der Versendung der \"Meldung\" durch den entsprechenden Ausdruck ersetzt\nwerden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <col width=\"56*\"><col width=\"200*\"><thead>\n    <tr style=\"font-weight: bold\">\n      <td width=\"20%\">Platzhalter</td>\n      <td width=\"78%\">wird ersetzt durch</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td width=\"20%\">$COMPARE</td>\n      <td width=\"78%\">den angewandte Vergleich</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$DETAIL</td>\n      <td width=\"78%\">das Detail (die &Uuml;berschrift der Tabellenspalte)</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$DIFF</td>\n      <td width=\"78%\">die aktuelle Differenz, die die DiffLimit-Verletzung\n        ausgel&ouml;st hat</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$LIMIT</td>\n      <td width=\"78%\">das verletzte DiffLimit (Info/Warn/Fehler)</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$PREVVALUE</td>\n      <td width=\"78%\">den vorigen Wert</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$SECTION</td>\n      <td width=\"78%\">die Sektion</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$SERVER</td>\n      <td width=\"78%\">den Namen des Rechners</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$TESTSTEP</td>\n      <td width=\"78%\">die Bezeichnung des Testschritts, ggf mit Doppelpunkten\n        bei rekursiven Testschritten</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$UNIT</td>\n      <td width=\"78%\">die Einheit des Differenzwerts</td>\n    </tr>\n    <tr>\n      <td width=\"20%\">$VALUE</td>\n      <td width=\"78%\">den aktuellen Wert</td>\n    </tr>\n  </tbody>\n</table>\n\n<p><br>\n</p>','','ConfigHints'),(9,'de','UeberwachungspausenBearbeiten','<p>&Uuml;berwachungspausen werden definiert, wenn in einem bestimmten Zeitraum\neinmalig, langfristig oder regelm&auml;&szlig;ig die &Uuml;berwachung der Limits, DiffLimits\nund isAlive f&uuml;r einen Server ausgesetzt werden soll. <br>\n</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <thead>\n    <tr>\n      <th width=\"13%\">\n        <div style=\"text-align: left\">\n        Tabellenspalte</div>\n      </th>\n      <th width=\"87%\">\n        <div style=\"text-align: left\">\n        Erkl&auml;rung</div>\n      </th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td width=\"13%\">Server</td>\n      <td width=\"87%\">Hier wird der Server, eine mit Komma getrennte Liste\n        von Servern oder ein Textausdruck mit Platzhaltern eingetragen, f&uuml;r\n        die diese &Uuml;berwachungspause gelten soll.</td>\n    </tr>\n    <tr>\n      <td width=\"13%\">Datum Von Bis</td>\n      <td width=\"87%\">Die &Uuml;berwachungspause gilt genau in dem Zeitraum der\n        beiden Datumsangaben.\n\n        <table border=\"1\" cellspacing=\"0\" cellpadding=\"4\">\n          <caption></caption>\n          <tbody>\n            <tr style=\"font-weight: bold\">\n              <td>Von</td>\n              <td>Bis</td>\n              <td>Erkl&auml;rung</td>\n            </tr>\n            <tr>\n              <td>&lt;leer&gt;</td>\n              <td>&lt;leer&gt;</td>\n              <td>Die &Uuml;berwachungspause gilt unbegrenzt lange.</td>\n            </tr>\n            <tr>\n              <td>&lt;leer&gt;</td>\n              <td>YYYY-MM-DD</td>\n              <td>Die &Uuml;berwachungspause gilt bis zum angegebenen Datum\n                23:59h, bzw. \"Zeit Bis\".</td>\n            </tr>\n            <tr>\n              <td>YYYY-MM-DD</td>\n              <td>&lt;leer&gt;</td>\n              <td>Die &Uuml;berwachungspause beginnt am angegebenen Datum 00:00h,\n                bzw \"Zeit Von\" und gilt unbegrenzt.</td>\n            </tr>\n            <tr>\n              <td>YYYY-MM-DD</td>\n              <td>YYYY-MM-DD</td>\n              <td>Die &Uuml;berwachungspause gilt genau in dem Zeitraum der beiden\n                Datumsangaben.</td>\n            </tr>\n          </tbody>\n        </table>\n      </td>\n    </tr>\n    <tr>\n      <td width=\"13%\">Tage</td>\n      <td width=\"87%\">Hier werden die Wochentage festgelegt, an denen die\n        &Uuml;berwachungspause im Zeitraum von \"Datum Von Bis\" nur aktiv sein\n      soll.</td>\n    </tr>\n    <tr>\n      <td width=\"13%\">Zeit Von Bis</td>\n      <td width=\"87%\">Der Zeitraum (Zeitangabe, HH:MM), f&uuml;r den diese\n        &Uuml;berwachungspause im Zeitraum von \"Datum Von Bis\" und an den\n        festgelegten Wochentagen gelten soll.</td>\n    </tr>\n    <tr>\n      <td width=\"13%\">l&ouml;schen</td>\n      <td width=\"87%\">Damit kann die entsprechende &Uuml;berwachungspause gel&ouml;scht\n        werden.</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Es k&ouml;nnen mehrere &Uuml;berwachungspausen f&uuml;r einen Server festgelegt werden.\nAlle Eintragungen einer &Uuml;berwachungspause sind spaltenweise von links nach\nrechts logisch und-verkn&uuml;pft. Abgelaufene &Uuml;berwachungspausen werden\nautomatisch in der darauffolgenden Nacht gel&ouml;scht.</p>\n\n<p><span style=\"color: #FF0000\">Hinweis:</span> <br>\nIst f&uuml;r einen Server eine oder mehrere Limits mit \"mitteln &uuml;ber\" &gt; 1\ndefiniert, so werden bei dem zu berechnenden Mittelwert trotzdem Werte aus\nder &Uuml;berwachungspause verwendet. Dies ist ggf bei der Definition der\n&Uuml;berwachungpause(n) und bei \"mitteln &uuml;ber\" zu beachten. Siehe auch Infos zu\n\"Limits festlegen\".</p>','','ConfigHints'),(6,'de','isAliveFestlegen','<p>isAlive kann zu allen Details eingetragen, gel&ouml;scht oder ge&auml;ndert werden.\nDie Kontrolle auf &uuml;berschrittene Fristen findet alle 5 Minuten statt. </p>\n\n<p>Es wird die Differenz vom Zeitstempel des letzten Werts und dem aktuellen\nDatum und der Uhrzeit gebildet. Das Ergebnis wird mit der eingetragenen Frist\nverglichen. Ist die Frist &uuml;berschritten, so wird eine Meldung an das\nMeldungsziel versandt.<br>\n</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <col width=\"38*\"><col width=\"218*\"><thead>\n    <tr valign=\"top\" style=\"font-weight: bold\">\n      <td width=\"15%\">Tabellenspalte</td>\n      <td width=\"85%\">Erkl&auml;rung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr valign=\"top\">\n      <td width=\"15%\" height=\"15\">Detail</td>\n      <td width=\"85%\">F&uuml;r jedes existierende Detail wird eine Zeile zum\n        festlegen von isAlive angezeigt.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"15%\">Frist</td>\n      <td width=\"85%\">Eingabe der Frist (Anzahl, Zeiteinheit), nachder eine\n        Benachrichtigung ausgel&ouml;st werden soll.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"15%\">Meldung</td>\n      <td width=\"85%\">Hier kann eine zus&auml;tzliche Meldung (max 200 Zeichen)\n        eingetragen werden, eine standardisierte Benachrichtigung wird immer\n        geschickt . F&uuml;r die Verwendung von Platzhaltern in der Meldung.\n        =&gt;(1)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"15%\">Meldungsziel</td>\n      <td width=\"85%\">Zwei Drop-down-Listen mit den verf&uuml;gbaren\n        Benachrichtigungszielen, die f&uuml;r dieses Verfahren definiert sind.</td>\n    </tr>\n    <tr>\n      <td>einmal<br>\n        24h<br>\n        Frist</td>\n      <td>Benachrichtigung nur einmal, erneut nach 24 Stunden oder nach\n        erneutem Ablauf der Frist ausl&ouml;sen, falls keine neuen Werte\n        eingegangen sind. Es m&uuml;ssen jedoch immer mindestens 24 Stunden\n        vergangen sein, bevor eine erneute Benachrichtigung ausgel&ouml;st\n      wird.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"15%\">letzter Wert vor</td>\n      <td width=\"85%\">Zeigt an, vor welcher Zeit der letzte Wert f&uuml;r dieses\n        Detail eingegangen ist.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"15%\">aktiv</td>\n      <td width=\"85%\">Damit kann eine isAlive-Definition aktiviert oder auch\n        deaktiviert werden.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"15%\">l&ouml;schen</td>\n      <td width=\"85%\">Damit wird diese isAlive-Definition gel&ouml;scht.</td>\n    </tr>\n  </tbody>\n</table>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><b>(1)</b> Verwendung von Platzhaltern</p>\n\n<p>Im Text von \"Meldung\" k&ouml;nnen folgende Platzhalter verwendet werden, die\nvor der Versendung der \"Meldung\" durch den entsprechenden Ausdruck ersetzt\nwerden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <col width=\"56*\"><col width=\"200*\"><thead>\n    <tr valign=\"top\" style=\"font-weight: bold\">\n      <td width=\"20%\">Platzhalter</td>\n      <td width=\"78%\">wird ersetzt durch</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr valign=\"top\">\n      <td width=\"20%\">$DETAIL</td>\n      <td width=\"78%\">Detail (&Uuml;berschrift der Tabellenspalte)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"20%\">$LASTDATE</td>\n      <td width=\"78%\">Zeitstempel des letzten vorhanden Werts</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"20%\">$SECTION</td>\n      <td width=\"78%\">Sektion</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"20%\">$SERVER</td>\n      <td width=\"78%\">Name des Rechners</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"20%\">$TESTSTEP</td>\n      <td width=\"78%\">Bezeichnung des Testschritts, ggf mit Doppelpunkten bei\n        rekursiven Testschritten</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"20%\">$TIMEDIFF</td>\n      <td width=\"78%\">Die festgestellte Zeitdifferenz (die die Frist\n        &uuml;berschritten hat und zur Ausl&ouml;sung der Benachrichtigung gef&uuml;hrt\n      hat)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"20%\">$TIMELIMIT</td>\n      <td width=\"78%\">Definierte Frist</td>\n    </tr>\n  </tbody>\n</table>','','ConfigHints'),(8,'de','AutoLimitsFestlegen','<p>&Uuml;ber Auto-Limits k&ouml;nnen Limits automatisiert definiert werden.</p>\n\n<p>T&auml;glich um 18:00h werden alle vorhandenen Daten &uuml;berpr&uuml;ft, ob Server -\nSektion - Testschritt - Detail - Einheit Kombinationen existieren, die zu den\nhier eingetragenen Kombinationen passen und bisher noch keine definierten\nLimits besitzen. Nur dann werden die passenden Kombinationen mit den hier\ndefinierten Limits ausgestattet.<br>\n</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <col width=\"33*\"><col width=\"223*\"><thead>\n    <tr valign=\"top\">\n      <th width=\"13%\">Tabellenspalte</th>\n      <th width=\"87%\">\n        <div style=\"text-align: left\">\n        Erkl&auml;rung</div>\n      </th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr valign=\"top\">\n      <td width=\"13%\">Server<br>\n        Sektion<br>\n        Testschritt</td>\n      <td width=\"87%\">Hier wird festgelegt, f&uuml;r welche Server - Sektion -\n        Testschritt Kombination dieser Auto-Limit gelten soll. Siehe\n      =&gt;(1)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">Detail<br>\n        Einheit</td>\n      <td width=\"87%\">Hier wird festgelegt, f&uuml;r welche Detail - Einheit\n        Kombination dieser Auto-Limit gelten soll. Siehe =&gt;(1)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">Vergleich</td>\n      <td width=\"87%\"><font size=\"3\">Der Vergleichsoperand. der mit dem\n        aktuellen Wert gegen die Limits verwendet wird. Siehe\n      =&gt;(2)</font></td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">Info<br>\n        Warn<br>\n        Fehler</td>\n      <td width=\"87%\">Drei Limits mit unterschiedlichen Priorit&auml;ten. Siehe\n        =&gt;(2)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">Meldung</td>\n      <td width=\"87%\"><font size=\"3\">Hier kann eine zus&auml;tzliche Meldung (max\n        200 Zeichen) eingetragen werden, eine standardisierte\n        Benachrichtigung wird immer geschickt. Siehe =&gt;(2)</font></td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">Meldungsziel</td>\n      <td width=\"87%\"><font size=\"3\">Zwei Drop-down-Listen mit den\n        verf&uuml;gbaren Benachrichtigungszielen, die f&uuml;r dieses Verfahren\n        definiert sind. Siehe =&gt;(2)</font></td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">mitteln &uuml;ber</td>\n      <td width=\"87%\">Anzahl der Werte, &uuml;ber die ein arithmetischer\n        Mittelwert gebildet werden soll, mit dem dann der Vergleich\n        durchgef&uuml;hrt wird. Siehe =&gt;(2)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">aktiv</td>\n      <td width=\"87%\">Damit wird dieser Auto-Limit aktiviert oder\n      deaktiviert.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">l&ouml;schen</td>\n      <td width=\"87%\">Damit wird dieser Auto-Limit gel&ouml;scht. Bestehende\n        Limits werden jedoch nicht gel&ouml;scht.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">alle &auml;ndern</td>\n      <td width=\"87%\">Damit wird dieser Auto-Limit JETZT auf ALLE passenden\n        Server - Sektion - Testschritt - Detail - Einheit Kombinationen\n        angewendet. Es werden auch die schon bestehenden Limits zu diesen\n        Kombinationen ge&auml;ndert. Schon bestehende Limits, die manuell\n        deaktiviert wurden, bleiben deaktiviert.</td>\n    </tr>\n  </tbody>\n</table>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><span style=\"font-weight: bold\">(1)</span> Textausdr&uuml;cke in Feldern</p>\n\n<p>In den Feldern k&ouml;nnen konstante Textausdr&uuml;cke, Textausdr&uuml;cke mit\nPlatzhaltern (Wildcards) oder eine komma-getrennte Kombination aus beiden\neingetragen werden. Als Platzhalter k&ouml;nnen \"*\" f&uuml;r einen beliebigen Ausdruck\nund \"?\" f&uuml;r ein beliebiges Zeichen benutzt werden.</p>\n\n<p>Beispiele:</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <tbody>\n    <tr>\n      <td>konstanter Textausdruck:</td>\n      <td>lxabcd5<br>\n        rm300_agr<br>\n        wscdbp93</td>\n    </tr>\n    <tr>\n      <td>Liste von konstanten Textausdr&uuml;cken:</td>\n      <td>lxabcp1,lxabcp2,lvxxx78<br>\n        WSCOWIWEB1,WSCOWIWEB2</td>\n    </tr>\n    <tr>\n      <td>Textausdruck mit Platzhalter:</td>\n      <td>*appserver*</td>\n    </tr>\n    <tr>\n      <td>Liste von konstanten Textausdr&uuml;cken mit Komma<br>\n        getrennt von Textausdr&uuml;cken mit Platzhaltern:</td>\n      <td>wscdb*,wscowi*,wscapp25<br>\n        xpolpa1,xpolpd*,*art*</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein\nPlatzhalter \"*\".</p>\n\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdr&uuml;cken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><b>(2)</b> Hierbei handelt es sich um die gleichen Angaben, die bei\n\"Limits festlegen\" eingetragen werden m&uuml;ssen. Entsprechende\nZusatzinformationen finden sich dort.<br>\n</p>','','ConfigHints'),(69,'de','News','<p><span style=\"font-weight: bold;\">2009-01-19:</span><br>\nBenutzer, die f&uuml;r sie freigegebene Reports und Favoriten verwenden,\nerhalten nur Ausgaben zu Werten, die aus Verfahren stammen, f&uuml;r die sie\neine Zugriffsberechtigung besitzen. Die Kombilimits wurden um\nviele Funktionen erweitert. Diese\nneuen Funktionen sind auch in den Meldungstexten verwendbar. </p>\n<p>Bei Limit-Definitionen ist jetzt \"mitteln &uuml;ber\" mit \"count\"\nauch bei\nTextwerten m&ouml;glich. </p><p>F&uuml;r komprimierte Werte k&ouml;nnen jetzt auch &Uuml;berwachungen gesetzt\nwerden. </p>\n<p>F&uuml;r\nalle Server (insbesondere f&uuml;r Clusterknoten) m&uuml;ssen alle IP-Adressen\nhinterlegt werden, von denen Werte an den ULS-Server geschickt werden.\nWerte werden verworfen, wenn sie von nicht definierten\nServernamen-IP-Adress-Kombinationen stammen.</p>\n<p>Werte k&ouml;nnen in einem unabh&auml;ngigen Textformat zum\nULS-Server geschickt werden. Dies wird unterst&uuml;tzt durch die\nImplementierung\nvon put_test_tgz.s2w (siehe dazu auch \"ULS-0013DE-02W Der ULS-Client\nf&uuml;r Unix\").</p>\n<p><span style=\"font-weight: bold;\">2008-02-13:</span><br>\nDas Men&uuml; im linken Frame wird nur noch tagesgenau angezeigt, da die\nzeitliche Zusammenfassung f&uuml;r Server, Sektion, Testschritt und Details\nentsprechend ge&auml;ndert wurde. Es kann also vorkommen, dass Men&uuml;eintr&auml;ge\nangezeigt werden, obwohl f&uuml;r diese [noch] keine Werte vorliegen. </p>\n<p><span style=\"font-weight: bold;\">2007-12-19:</span><br>\nDas Navigieren in der Weboberfl&auml;che sollte schneller geworden sein!</p>\n<p>Es k&ouml;nnen jetzt mehrere [Auto-]Limits pro Detail festgelegt\nwerden. Zus&auml;tzlich zum \"mitteln &uuml;ber\" k&ouml;nnen jetzt eine Reihe von\nAggregatfunktionen\nauf eine Anzahl von Werten oder f&uuml;r einen Zeitbereich verwendet werden.\nZu\njeder &Uuml;berwachungsdefinitionen kann eine Bemerkung eingetragen werden.\nAlle\nvon einer Auto-&Uuml;berwachungsdefinition erzeugten &Uuml;berwachungen werden\nnur dann\ngel&ouml;scht, wenn diese Auto-&Uuml;berwachungsdefinition gel&ouml;scht wird.\n&Uuml;berwachungspausen k&ouml;nnen jetzt f&uuml;r Rechner und Sektion definiert\nwerden. </p>\n<p>F&uuml;r Reportdetails k&ouml;nnen Filter auf Werte gesetzt werden und\nnur Werte\naus\nbestimmten Tageszeitbereichen und Wochentagen verwendet werden. </p>\n<p>Unter <span style=\"color: rgb(0, 0, 205);\">ausgel&ouml;ste\nBenachrichtigungen</span> werden die in den letzten zwei Tagen\nausgel&ouml;sten\nBenachrichtigungen angezeigt und k&ouml;nnen dort auch als erledigt\ngekennzeichnet\nwerden.</p>\n<p><span style=\"font-weight: bold;\">2006-11-28:</span><br>\nNeu ist die <span style=\"color: rgb(0, 0, 205);\">Auto-Detailauswahl</span>,\nmit der eine Zusammenstellung von Details &uuml;ber Textausdr&uuml;cke erstellt\nwerden\nkann, &auml;hnlich wie die Autodetails f&uuml;r Reports. Ist die resultierende\nErgebnismenge zu gro&szlig;, dann erfolgt keine Anzeige und die\nAuto-Detailauswahl\nsollte weiter eingeschr&auml;nkt werden. Eine solche Auto-Detailauswahl kann\nauch\nals Favorit abgespeichert oder einem Report als Autodetail hinzugef&uuml;gt\nwerden.</p>\n<p>Neben den aktuellen (online) Werten k&ouml;nnen jetzt auch\nkomprimierte\nWerte in\nReports verwendet werden. </p>\n<p>Die KombiLimits (&uuml;ber <span style=\"color: rgb(0, 0, 205);\">Verwalten\n--\nKombiLimits</span>) sind entsprechend der anderen &Uuml;berwachungen\nautomatisierbar und k&ouml;nnen jetzt in den Detailtabellen auch angezeigt,\ndefiniert und ge&auml;ndert werden.</p>\n<p>Bei einer angezeigten Grafik kann mit <span style=\"color: rgb(0, 0, 255);\">&lt;=</span> und <span style=\"color: rgb(0, 0, 255);\">=&gt;</span> um den\neingestellten Zeitbereich\nvor- und zur&uuml;ckgebl&auml;ttert werden, womit zB ein schneller Vergleich von\nheute\nzu gestern m&ouml;glich ist.</p>\n<p>Die <span style=\"color: rgb(0, 0, 255);\">Status-&Uuml;bersicht</span>\nzeigt\nfarblich aufbereitet die &uuml;berschrittenen &Uuml;berwachungen im Verh&auml;ltnis zu\nden\ndefinierten &Uuml;berwachungen. Drill-Down ist durch entsprechendes\nAnklicken\nm&ouml;glich.</p>\n<p>Unter <span style=\"color: rgb(0, 0, 255);\">Verwalten\n--\nAuto-&Uuml;berwachungen</span> werden ALLE definierten\nAuto-&Uuml;berwachungen f&uuml;r ein\nVerfahren in EINEM Textfeld angezeigt, bzw k&ouml;nnen dar&uuml;ber definiert\nwerden,\naber Vorsicht: dadurch werden alle bisher definierten\nAuto-&Uuml;berwachungen\ngel&ouml;scht und durch die neuen ersetzt.</p>\n<p><span style=\"font-weight: bold;\">2006-03-23:</span><br>\nF&uuml;r eine automatisierte Anpassung der Aufbewahrungszeiten von Werten\nkann\njetzt <span style=\"color: rgb(0, 0, 255);\">Verwalten --\nAufbewahrung --\nAuto-Aufbewahrung festlegen</span> verwendet werden. Unter <span style=\"color: rgb(0, 0, 255);\">Verwalten -- Limits --\nKombi-Limits</span>\nk&ouml;nnen jetzt auch &Uuml;berwachungen f&uuml;r Kombinationen von mehreren Details\nerstellt werden.</p>\n<p><span style=\"font-weight: bold;\">2006-03-08:</span><br>\nUnter <span style=\"color: rgb(0, 0, 255);\">Verwalten --\nKomprimierung</span>\nk&ouml;nnen Funktionen festgelegt werden, um Werte auf Kennzahlen pro\nZeiteinheit\nzu reduzieren. Der Zugriff auf die komprimierten Werte erfolgt aus dem\nHauptmen&uuml; &uuml;ber <span style=\"color: rgb(0, 0, 255);\">komprimierte\nWerte</span>.</p>\n<p><span style=\"font-weight: bold;\">2006-02-22:</span><br>\nUnter <span style=\"color: rgb(0, 0, 255);\">Verwalten --\nOptionen</span> kann\njetzt die \"Maximale Anzahl Details pro Grafik\" festgelegt werden. In\nMeldungstexten von Benachrichtigungen kann jetzt $AVERAGEOVER als\nPlatzhalter\nverwendet werden. Er wird ersetzt durch die Anzahl der Werte, &uuml;ber die\ngemittelt wurde (\"mitteln &uuml;ber\").</p>\n<p><span style=\"font-weight: bold;\">2006-02-21:</span><br>\nEs wurden einige neue Online-Hilfstexte eingearbeitet und $VALUE_OF(\n&lt;detail&gt;) zur Verwendung in Meldungstexten von\nBenachrichtigungen\neingef&uuml;gt.</p>\n<p><span style=\"font-weight: bold;\">2006-01-03:</span><br>\nUnter <span style=\"color: rgb(0, 0, 255);\">Verwalten --\nOptionen</span> kann\ndie \"Standardgr&ouml;&szlig;e von Grafiken\" mit einer Drop-Down Liste festgelegt\nwerden.</p>\n<p><span style=\"font-weight: bold;\">2005-12-15:</span><br>\nNach dem Aktivieren von \"zeige Online-Hilfstexte\" unter <span style=\"color: rgb(0, 0, 255);\">Verwalten -- Optionen</span>\nwerden in einigen\nMasken unterst&uuml;tzende Zusatzinformationen angezeigt.</p>\n<p><span style=\"font-weight: bold;\">2005-11-30:</span><br>\nAnstelle des vollst&auml;ndigen Abschaltens der &Uuml;berwachung f&uuml;r Server,\nk&ouml;nnen\njetzt &uuml;ber <span style=\"color: rgb(0, 0, 255);\">Verwalten\n--\n&Uuml;berwachungspausen -- &lt;verfahren&gt;</span>\n&Uuml;berwachungspausen f&uuml;r\nServer definiert werden. Diese erlauben zB das Durchf&uuml;hren von\nWartungsarbeiten, ohne dass dabei Benachrichtigungen ausgel&ouml;st werden,\nobwohl\ndie definierten [Diff-]Limits/isAlive immer noch aktiv sind.</p>','','ConfigHints'),(138,'de','Aufbewahrung_pro_Sektion_festlegen','<p>Festlegen der Aufbewahrungszeit für alle Details einer\nVerfahren - Server - Sektion - Testschritt Kombination.\nDie Aufbewahrungszeit gilt automatisch auch für neu\nhinzukommende Details.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Testschritt</td>\n<td>Für alle Details dieses Testschritts wird die Aufbewahrungszeit festgelegt.</td>\n</tr>\n<tr>\n<td>Tage</td>\n<td>Anzahl der Tage, für die alle Details aufbewahrt werden sollen.</td>\n</tr>\n<tr>\n<td>priorisiert</td>\n<td>Bei aktivierter Checkbox gilt die hier definierte\nAufbewahrungszeit endgültig, auch wenn in \"Aufbewahrungszeiten\nfestlegen\" eine andere Anzahl von Tagen eingetragen ist.</td>\n</tr>\n</tbody>\n</table>\n<p>Über \"Aufbewahrungszeiten festlegen\" kann die\nAufbewahrungszeit für <span style=\"font-weight: bold;\">einzelne</span>\nDetails eines Testschritts\nfestgelegt werden. Im Allgemeinen gilt die größere Anzahl von Tagen als\neffektive Aufbewahrungszeit. Über das Aktivieren von Checkbox\n\"priorisiert\" kann, wie oben beschrieben, das Verhalten geändert werden.</p>\r','','ConfigHints'),(139,'de','set_storetime','<!-- Changes:\n  set_storetime, de\n\n  -----\n  2015-12-03, roveda: new format\n\n  -----\n  includes: _retention_general_info_de\n-->\n<hr>\n<h2>Aufbewahrung festlegen</h2>\n<p>\nFestlegen der Aufbewahrungszeit für die Werte einzelner Details\neiner Verfahren - Server - Sektion - Testschritt Kombination.\nSiehe auch <a href=\"#_retention_general_info_de\">Allgemeines zu Aufbewahrungszeiten</a>.\n</p>\n\n<h3>Beschreibung der Schaltflächen</h3>\n<table>\n <thead>\n  <tr>\n    <td>Schaltfläche</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td><span class=\"button\">Änderungen</span></td>\n    <td>\n      Zeigt die durchgeführten Änderungen an Aufbewahrungsdefinitionen. Auch für gelöschte Definitionen.\n    </td>\n  </tr>\n </tbody>\n</table>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n<table>\n<thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody>\n  <tr>\n    <td>Detail</td>\n    <td>Für dieses Detail wird die Aufbewahrungszeit festgelegt.</td>\n  </tr>\n  <tr>\n    <td>Tage</td>\n    <td>Anzahl der Tage, für die die Werte dieses Details aufbewahrt werden sollen.</td>\n  </tr>\n  <tr>\n    <td>Änderungen</td>\n    <td>Anzeige der durchgeführten Änderungen für die jeweilige Definition.</td>\n  </tr>\n</tbody>\n</table>\n','_retention_general_info_de','ConfigHints'),(153,'de','set_autoisalive','<p>isAlive-Überwachungen prüfen, ob bestimmte Werte innerhalb eines Zeitraums eingegangen sind.</p>\n<p>Hier werden automatisch zu verwendende isAlive-Überwachungen (Auto-isAlive) für alle Werte, die zu definierten \nServer -- Sektion -- Testschritt -- Detail -- Einheit Mustern dieses Verfahrens passen, festgelegt.</p>\n<p>Bei Eingang von Werten mit bisher nicht vorhandenen \nServer -- Sektion -- Testschritt -- Detail -- Einheit Kombinationen \nwird geprüft, ob diese zu den hier definierten Mustern passen und ggf \nwerden die eingetragenen isAlive-Überwachungen wirksam.</p>\n<p>Die Kontrolle auf überschrittene isAlive-Überwachungen erfolgt zyklisch alle 5 Minuten.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<td>Tabellenspalte</td>\n<td>Erklärung</td>\n</tr>\n</thead><tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>\nServer<br>\nSektion<br>\nTestschritt\n</td>\n<td>Hier wird festgelegt, für welche Server -- Sektion -- Testschritt Muster dieser Auto-isAlive gelten soll, siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>\nDetail<br>\nEinheit\n</td>\n<td>Hier wird festgelegt, für welche Detail -- Einheit Muster dieser Auto-isAlive gelten soll,\nsiehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Zeitraum</td>\n<td>Eingabe des Zeitraums (Anzahl, Zeiteinheit), nach der eine Benachrichtigung ausgelöst werden soll.</td>\n</tr>\n<tr>\n<td>Benachricht.Modus</td>\n<td>Die Benachrichtigung erfolgt nach Ablauf des eingetragenen Zeitraums und danach, falls die Bedingung immer noch erfüllt ist, wieder nach Ablauf der hier vorgegebenen Zeit.\n<pre>\n   1h\n  12h\n  24h\n  Zeitraum\n</pre>\n</td>\n</tr>\n<tr>\n<td>Meldung</td>\n<td>Hier kann eine benutzerdefinierte Meldung (max 3000 Zeichen) eingetragen werden,\neine standardisierte Meldung wird bei einer Benachrichtigung immer geschickt. Siehe\n\"Platzhalter und Funktionen in Meldung\"</td>\n</tr>\n<tr>\n<td>Meldungsziel</td>\n<td>Zwei für dieses Verfahren freigegebene Benachrichtigungsziele können über die \nDrop-Down-Listen eingestellt werden.</td>\n</tr>\n<tr>\n<td>\naktiv<br>\nlöschen<br>\nalle ändern\n</td>\n<td>Damit wird dieser Auto-isAlive deaktiviert, aktiviert, gelöscht oder alle hieraus abgeleiteten isAlive-Überwachungen werden bzgl der vorgenommenen Änderungen angepasst.</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in Meldung</h4>\n\n<p>Im Text von \'Meldung\' können folgende Platzhalter und Funktionen\nverwendet werden, die vor der Versendung der Benachrichtigung durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Platzhalter</td>\n    <td>wird ersetzt durch</td>\n    <td style=\"text-align: center;\">Limits</td>\n    <td style=\"text-align: center;\">KombiLimits</td>\n    <td style=\"text-align: center;\">isAlive</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGEOVER</td>\n    <td>die Anzahl der Werte oder Zeitbereich von \"mitteln über\"</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$COMPARE</td>\n    <td>den angewandten Vergleich</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$DETAIL</td>\n    <td>das Detail (die Überschrift der Tabellenspalte)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$DOMAIN</td>\n    <td>die Bezeichnung des Verfahrens</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTDATE</td>\n    <td>der Zeitstempel des letzten vorhanden Werts</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTVALUE</td>\n    <td>der letzte Wert</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$LIMIT</td>\n    <td>den verletzten Limit (Info/Warn/Fehler)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$PREVVALUE</td>\n    <td>der Wert des vorigen Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$SAVEDATE</td>\n    <td>der Zeitstempel, an dem der letzte Wert im ULS eingegangen ist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$SECTION</td>\n    <td>die Sektion</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$SERVER</td>\n    <td>den Namen des Rechners</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TESTSTEP</td>\n    <td>die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$TIMEDIFF</td>\n    <td>die festgestellte Zeitdifferenz (die die Frist überschritten hat und zur Auslösung der Benachrichtigung\n    geführt hat)</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TIMELIMIT</td>\n    <td>die definierte Frist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$UNIT</td>\n    <td>die Einheit des Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$VALUE</td>\n    <td>der (uU berechnete) Wert, der die Limits-Verletzung ausgelöst hat</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n</tbody>\n</table>\n\n<p>Funktionen</p>\n<p>Die folgenden Funktionen könnne in Meldungstexten verwendet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr style=\"font-weight: bold;\">\n    <td>Funktion</td>\n    <td>Berechnung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGE_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Berechnet den arithmetischen Mittelwert für eine Anzahl von Werten eines Details.</td>\n  </tr>\n  <tr>\n    <td>$COUNT_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Ermittelt die Anzahl der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$DEV_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n  <td>Ermittelt die Standardabweichung der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n  <td>$DIFF_OF(&lt;detail&gt;[/&lt;unit&gt;])</td>\n<td>Ermittelt die Differenz (Unix Kommando diff) der letzten beiden Werte (können\nauch Dateien sein) und liefert maximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei würde\nes sich sinnvollerweise um Werte mit Textinhalten handeln. Unterstützte Dateiformate mit Komprimierung\nsind:.gz und .bz2. Alle anderen Dateiformate werden verglichen wie sie sind.\n</td>\n</tr><tr>\n<td>$DIFFER_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt, ob der erste Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen, sich&nbsp; zum letzten Wert unterscheidet. Ergibt 0 oder 1 als Ergebnis.</td>\n</tr><tr>\n<td>$FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$GRAD_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den Gradienten (lineare Steigung) der Werte des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_range&gt; [ &lt;time_past&gt;])</td>\n<td>Berechnet die lineare Steigung pro &lt;time_range&gt; (Standard: 1d) für Werte, die\nfür das angegebene Detail vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist &lt;time_past&gt; nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den &lt;time_range&gt;\numgerechnet. Man kann also die Werte der letzten 24h\nbetrachten (&lt;time_past&gt; = 24h) und daraus den Gradienten pro 8 Stunden\n(&lt;time_range&gt; = 8h) berechnen.\n</td>\n</tr>\n<tr>\n<td>$LAST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den letzten (aktuellsten) Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen. Dies kann ein neuerer&nbsp;Wert sein als der über $VALUE_OF ermittelte.</td>\n</tr><tr>\n<td>$LAST-FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Maximum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Minimum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_future&gt; [, &lt;time_past&gt;])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der für ein Detail vorliegenden Werte innerhalb eines\nzurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte einem linearen Wachstum unterliegen. Wird &lt;time_past&gt; nicht\nangegeben, dann wird &lt;time_future&gt; verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten Hälfte von &lt;time_past&gt; liegen\nund die in der zweiten Hälfte von &lt;time_past&gt; liegen, wird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der angenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten Steigung wird der Endwert zu &lt;time_future&gt; berechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(&lt;detail&gt;[/&lt;unit&gt;],&lt;&gt; &lt;regexp&gt;, &lt;time_range&gt;)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregulären Ausdrucks &lt;regexp&gt; in allen Werten des &lt;detail&gt;,\ndie in &lt;time_range&gt; (nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Summe der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$UNIT_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ermittelt die Einheit des &lt;detail&gt;</td>\n</tr><tr>\n<td>$VALUE_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ist&nbsp;der&nbsp;Wert des &lt;detail&gt; zum Zeitpunkt der Überwachungskontrolle. Dies ist nicht unbedingt der neueste Wert für dieses &lt;detail&gt;. </td>\n</tr>\n</tbody>\n</table>\n\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\r','','ConfigHints'),(154,'de','autoisalive_nt',' <!-- \n server=\nsection=Oracle DB*\nteststep=_backup_disk\ndetail=message\nunit= \nperiod=175\nperiodunit=hour\nnotifymode=24\nmessage=Skript $TESTSTEP wurde nicht ausgeführt!\ndestination1=Remedy:Artus\ndestination2=\nremark=\naccess=all\n-->\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Parametername</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>\n      server=<br>\n      section=<br>\n      teststep=<br>\n      detail=<br>\n      unit=<br>\n    </td>\n    <td>\n      Server -- Sektion -- Testschritt -- Detail -- Einheit Muster festlegen, \n      jede Angabe kann dabei ein Textmuster enthalten, \n      wie in \"Ausdrücke in Textfeldern\" beschrieben.\n    </td>\n   \n  </tr><tr>\n    <td>period=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>periodunit=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>notifymode=</td>\n    <td>\n      &nbsp;\n    </td>\n\n  </tr><tr>\n    <td>message=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>\n      destination1=<br>\n      destination2=\n    </td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>remark=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>access=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr>\n </tbody>\n</table>\n\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\r','','ConfigHints'),(62,'de','Details_fuer_Report_bearbeiten_Textmodus','<p>Bearbeiten aller Reportdetails eines Reports im Textmodus.</p>\n<p>Alle Reportdetails werden in einer Textbox angezeigt und\nlassen sich\nver&auml;ndern. Jedes Reportdetail wird in exakt EINER Zeile\nangezeigt\n(auch die Beschreibung!) und bearbeitet. Jedes Element des\nReportdetails wird\ndurch einen senkrechten Strich \"|\" vom darauffolgenden getrennt.</p>\n<p>In der folgenden Tabelle werden die Elemente einer\nReportdetailzeile\nbeschrieben. Die Elemente sind identisch zu denen von \"Details f&uuml;r\nReport\n... bearbeiten\", die Drop-Down Listen stehen hier nicht zur Verf&uuml;gung,\nes m&uuml;ssen equivalente Textausdr&uuml;cke verwendet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td>Name</td>\n<td>Optionaler Name des Reportdetails. Dies wird als Titel\ndes Reportdetails angezeigt.</td>\n</tr>\n<tr>\n<td>Beschreibung</td>\n<td>Optionale ausf&uuml;hrliche Beschreibung (max 64000 Zeichen,\nText oder HTML) zu diesem Reportdetail. Aufgrund der nachfolgenden\nVerarbeitungsschritte darf die gesamte Beschreibung keinen\nZeilenumbruch enthalten.</td>\n</tr>\n<tr>\n<td>Zeitraum</td>\n<td>&Uuml;ber den Zeitraum wird die Menge der zu verarbeitenden\nWerte festgelegt. Anstelle der aufgef&uuml;hrten vorgegebenen Zeitr&auml;ume kann\nauch ein beliebiger konstanter Zeitraum eingetragen werden. Siehe \"Zeitraum im Textmodus\"<br>\n</td>\n</tr>\n<tr>\n<td>Ausgabe</td>\n<td>Legt die Darstellung oder die Funktion fest, die auf\ndie selektierten Werte angewendet wird. Siehe \"Ausgabem&ouml;glichkeiten im Textmodus\"<br>\n</td>\n</tr>\n<tr><td>Grafikgr</td><td>Legt die Gr&ouml;&szlig;e der Grafik fest:<br><div style=\"margin-left: 40px;\">640x480<br>\n800x600<br>\n1024x768<br>\n1280x960<br>\n1600x1200</div></td></tr><tr>\n<td>Verfahren</td>\n<td>Optionale Angabe des/der Verfahren, siehe \"Ausdr&uuml;cke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Optionale Angabe des/der Server, siehe \"Ausdr&uuml;cke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Sektion</td>\n<td>Optionale Angabe der Sektion(en), siehe \"Ausdr&uuml;cke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Testschritt</td>\n<td>Optionale Angabe des/der Testschritt(e), siehe \"Ausdr&uuml;cke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Detail</td>\n<td>Optionale Angabe des/der Detail(s), siehe \"Ausdr&uuml;cke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Einheit</td>\n<td>Optionale Angabe der Einheit(en), siehe \"Ausdr&uuml;cke in Textfeldern\"</td>\n</tr><tr><td>o/k/ok</td><td>Die Buchstaben \'o\' f&uuml;r online Werte, \'k\' f&uuml;r komprimierte Werte, \'ok\' f&uuml;r online und komprimierte Werte.</td></tr><tr><td>Stil</td><td>Legt den Stil f&uuml;r die Darstellung der Werte in einer Grafik fest:<br>dots, points, lines, linespoints, impulses, steps, fsteps, histeps, boxes</td></tr><tr><td>#D</td><td>Legt die maxuimale Anzahl von Tabellenspalten in Tabellen oder Wertelinien in Grafiken fest.</td></tr>\n</tbody>\n</table>\n<p>Erweiterte optionale Angaben</p><table style=\"text-align: left; width: 100px;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\"><tbody><tr><td>Z.von</td><td></td></tr><tr><td>Z.bis</td><td></td></tr><tr><td>W.Tage</td><td></td></tr><tr><td>Vgl1</td><td></td></tr><tr><td>W1</td><td></td></tr><tr><td>A/O</td><td></td></tr><tr><td>Vgl2</td><td></td></tr><tr><td>W2</td><td></td></tr><tr><td>A/O</td><td></td></tr><tr><td>Vgl3</td><td></td></tr><tr><td>W3</td><td></td></tr><tr><td>A/O</td><td></td></tr><tr><td>Vgl4</td><td></td></tr><tr><td>W4</td><td></td></tr></tbody></table><p>Die Verwendung des Textmodus zur Definition eines kompletten\nReports hat\nfolgende Vorteile:<br>\n</p>\n<ul>\n<li>&uuml;ber copy&amp;paste kann der komplette Report in\nDokumente &uuml;bernommen werden</li>\n<li>ein Report kann aus anderen Dokumenten &uuml;ber\ncopy&amp;paste in diese Textbox eingef&uuml;gt werden</li>\n<li>es lassen sich leicht Kopien von Reports f&uuml;r andere\nServer(-Kombinationen) erstellen</li>\n<li>es k&ouml;nnen beliebige Zeitr&auml;ume definiert werden</li>\n</ul>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Zeitraum im Textmodus </h4>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td><span style=\"font-weight: bold;\">einzutragender\nAusdruck</span></td>\n<td><span style=\"font-weight: bold;\">verwendeter\nZeitraum</span></td>\n</tr>\n<tr>\n<td>zweistd</td>\n<td>die letzten zwei Stunden</td>\n</tr>\n<tr>\n<td>heute</td>\n<td>Heute</td>\n</tr>\n<tr>\n<td>gestern</td>\n<td>Gestern 00:00h bis 23:59h</td>\n</tr>\n<tr>\n<td>abgestern</td>\n<td>ab gestern 00:00h bis heute 23:59h</td>\n</tr>\n<tr>\n<td>woche</td>\n<td>diese Woche</td>\n</tr>\n<tr>\n<td>7tage</td>\n<td>die zur&uuml;ckliegenden 7 Tage und heute</td>\n</tr>\n<tr>\n<td>letztewoche</td>\n<td>die letzte Woche von Montag 00:00h bis Sonntag\n23:59h</td>\n</tr>\n<tr>\n<td>abwoche</td>\n<td>ab Monatg 00:00h letzter Woche bis heute 23:59h</td>\n</tr>\n<tr>\n<td>komplett</td>\n<td>der kompletter Zeitraum, f&uuml;r den ausgew&auml;hlten\nWerte vorliegen</td>\n</tr>\n<tr>\n<td>YYYY-MM-DD hh:mm:ss,YYYY-MM-DD hh:mm:ss</td>\n<td>exakt f&uuml;r den so definierten Zeitraum, auch wenn\nkeine Werte (mehr) daf&uuml;r vorliegen</td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausgabem&ouml;glichkeiten im Textmodus</h4>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td><span style=\"font-weight: bold;\">einzutragender\nAusdruck</span></td>\n<td><span style=\"font-weight: bold;\">Ausgabe\nals</span></td>\n</tr>\n<tr>\n<td>Tabelle</td>\n<td>Alle Werte werden als Tabelle mit Zeitstempel\nangezeigt.</td>\n</tr>\n<tr>\n<td>letzte_Werte</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die nur den letzten Wert aus dem Zeitraum enth&auml;lt.</td>\n</tr>\n<tr>\n<td>grafik</td>\n<td>Die Werte werden als Grafik angezeigt, deren\nAufl&ouml;sung hier festgelegt wird.</td>\n</tr>\n<tr>\n<td>min</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die das Minimum der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>max</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die das Maximum der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>avg</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die den arithmetische Mittelwert der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>std</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Standardabweichung der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>sum</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Summe aller Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>max-min</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Differenz vom Maximum zum Minimum der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>last-first</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Differenz vom (zeitlich) letzten Wert zum (zeitlich)\nersten Wert enth&auml;lt. Damit l&auml;sst sich zB die Zuwachsrate pro\nZeiteinheit darstellen.</td>\n</tr>\n<tr>\n<td>count</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Anzahl der Werte enth&auml;lt.</td>\n</tr><tr><td>grad</td><td></td></tr><tr><td>histogramm</td><td></td></tr><tr><td>histmin</td><td></td></tr><tr><td></td><td></td></tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdr&uuml;cke in Textfeldern</h4>\n<p>In den Feldern k&ouml;nnen konstante Textausdr&uuml;cke, Textausdr&uuml;cke\nmit Platzhaltern (Wildcards) oder eine komma-getrennte Kombination aus\nbeiden eingetragen werden. Als Platzhalter k&ouml;nnen \"*\" f&uuml;r einen\nbeliebigen\nAusdruck und \"?\" f&uuml;r ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td>konstanter Textausdruck:</td>\n<td>lxabcd5<br>\nrm300_agr<br>\nwscdbp93</td>\n</tr>\n<tr>\n<td>Liste von konstanten Textausdr&uuml;cken:</td>\n<td>lxabcp1,lxabcp2,lvxxx78<br>\nWSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n<td>Textausdruck mit Platzhalter:</td>\n<td>*appserver*</td>\n</tr>\n<tr>\n<td>Liste von konstanten Textausdr&uuml;cken mit Komma<br>\ngetrennt von Textausdr&uuml;cken mit Platzhaltern:</td>\n<td>wscdb*,wscowi*,wscapp25<br>\nxpolpa1,xpolpd*,*art*</td>\n</tr>\n</tbody>\n</table>\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet,\nalso wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja\nals\nSeparator einer Liste von Textausdr&uuml;cken verwendet wird, sollte\nanstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>','','ConfigHints'),(159,'de','report_details_bearbeiten','<!-- Changes:\n  report_details_bearbeiten, de\n\n  -----\n  2015-12-10, roveda: Created the help page.\n\n  -----\n  includes: _timeinterval_in_reportdetails_de,_report_output_function_de\n\n-->\n\n<h2>Details für Report bearbeiten</h2>\n\n<p>\n  Hier werden die Details des ausgewählten Reports bearbeitet.\n</p>\n<p>\n  Einem Report können Reportdetails über <span class=\"button\">zum&nbsp;Report&nbsp;hinzufügen</span>,\n  <span class=\"button\">Autodetails&nbsp;anfügen</span> \n  oder über den <span class=\"button\">Textmodus</span> \n  hinzugefügt werden. Reportdetails können in beliebiger Reihenfolge\n  angeordnet werden, sie können sich auf verschiedene vorgegebene\n  Zeitbereiche beziehen und können als Tabelle, Grafik oder berechneter\n  Wert angezeigt werden.\n</p>\n\n<h3>Beschreibung der Schaltflächen</h3>\n<table>\n <thead>\n  <tr>\n    <td>Schaltfläche</td>\n    <td>Erklärung</td>\n  </tr>\n </thead> <tbody>\n  <tr>\n    <td><span class=\"button\">Report&nbsp;ansehen</span></td>\n    <td>\n      Führt den Report aus und zeigt das Ergebnis an.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">PDF&nbsp;Download</span></td>\n    <td>\n      Führt den Report aus und zeigt das Ergebnis als PDF Dokument an.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Autodetails&nbsp;anfügen</span></td>\n    <td>\n      Damit kann ein Reportdetail hinzugefügt werden, dass im folgenden Formular \n      über eine manuelle Texteingabe von Verfahren, Server, Sektion, Testschritt, Detail und\n      weiteren Angaben definiert wird.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Textmodus</span></td>\n    <td>\n      Erlaubt die Bearbeitung der Reportdetails im Textmodus. Dabei werden alle\n      Reportdetails in einem Textfeld angezeigt und können dann zB über\n      copy&amp;paste auch mit anderen Editoren bearbeitet werden, bzw.\n      von oder in Dokumentationen übernommen werden.\n    </td>\n  </tr>\n </tbody>\n</table>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead> <tbody>\n  <tr>\n    <td>Nr.</td>\n    <td>\n      Laufende Nummer des Reportdetails innerhalb dieses Reports. Dies legt die\n      Reihenfolge der Anzeige der Reportdetails fest. Siehe \"neue Pos.\" für\n      Änderungen der Reihenfolge. Wurde dieses Reportdetail über \n      <span class=\"button\">Autodetails&nbsp;anfügen</span> \n      oder <span class=\"button\">Textmodus</span>\n      dem Report hinzugefügt, so ist die Positionsnummer als Link ausgeführt. \n      Ein Klick darauf erlaubt das Bearbeiten des Reportdetails.\n    </td>\n  </tr>\n  <tr>\n    <td>\n      Name<br>\n      Beschreibung\n    </td>\n    <td>\n      Optionaler Name des Reportdetails. Dies wird als Titel des Reportdetails angezeigt. \n      <tt>$#</tt> kann als Platzhalter für eine laufende (Kapitel-)Nummer bei der Ausgabe verwendet werden.\nDies kann auch verschachtelt angewandt werden, z.B. mit <tt>$#.#</tt> oder auch <tt>$#.#.#</tt>.\n      Desweiteren kann eine optionale ausführliche Beschreibung (max 64000 Zeichen) zu diesem Reportdetail eingetragen werden. \n      HTML ist möglich. Es stehen Platzhalter zur Verfügung, die durch passende Treffermengen ersetzt werden:\n      <table>\n        <tr>\n          <td>$CLASSES</td>\n          <td>\n            Wird ersetzt durch die Liste aller passenden Serverklassen.\n          </td>\n        </tr>\n        <tr>\n          <td>$DOMAINS</td>\n          <td>\n            Wird ersetzt durch die Liste aller passenden Verfahren.\n          </td>\n        </tr>\n        <tr>\n          <td>$DETAILS</td>\n          <td>\n            Wird ersetzt durch die Liste aller passenden Details.\n          </td>\n        </tr>\n        <tr>\n          <td>$IPADDRESSES</td>\n          <td>\n            Wird ersetzt durch die Liste aller IP-Adressen aller passenden Server.\n          </td>\n        </tr>\n        <tr>\n          <td>$SECTIONS</td>\n          <td>\n            Wird ersetzt durch die Liste aller passenden Sektionen.\n          </td>\n        </tr>\n        <tr>\n          <td>$SERVERS</td>\n          <td>\n            Wird ersetzt durch die Liste aller passenden Server.\n          </td>\n        </tr>\n        <tr>\n          <td>$TESTSTEPS</td>\n          <td>\n            Wird ersetzt durch die Liste aller passenden Testschritte.\n          </td>\n        </tr>\n        <tr>\n          <td>$UNITS</td>\n          <td>\n            Wird ersetzt durch die Liste aller passenden Einheiten.\n          </td>\n        </tr>\n      </table>\n    </td>\n  </tr>\n  <tr>\n    <td>Zeitraum</td>\n    <td>\n      Eine\n      Drop-Down Liste mit allen zur Verfügung stehenden Zeitbereichen. Es\n      sind nur vorgegebene Zeitbereiche möglich, frei definierbare\n      Zeitbereiche können hier nicht spezifiziert werden. Über den\n      Zeitbereich wird die Menge der zu verarbeitenden Werte selektiert.\n      Siehe auch <a href=\"#_timeinterval_in_reportdetails_de\">Zeitraum</a>.\n    </td>\n  </tr>\n  <tr>\n    <td>\n      Ausgabe<br>\n      Grafikgröße<br>\n      Stil\n    </td>\n    <td>\n      Die Drop-Down-Listen legen fest, wie die zu verarbeitenden Werte\n      für dieses Reportdetail dargestellt, bzw welche Funktion auf sie angewandt werden\n      soll. Siehe auch <a href=\"#_report_output_function_de\">Ausgabemöglichkeiten</a>.\n    </td>\n  </tr>\n  <tr>\n    <td># D</td>\n    <td>\n      Legt die maximale Anzahl der in einer Tabelle oder Grafik darzustellenden\n      (Werte-)Details fest. Sind mehr (Werte-)Details in der Ergebnismenge des Reportdetails vorhanden, \n      so werden weitere Tabellen oder Grafiken aufeinanderfolgend angezeigt, bis alle (Werte-)Details ausgegeben wurden.\n    </td>\n  </tr>\n  <tr>\n    <td>neue Pos.</td>\n    <td>\n      Hier die neue Position (Nr.) des Reportdetails eintragen, an die es verschoben werden soll.\n    </td>\n  </tr>\n  <tr>\n    <td>löschen</td>\n    <td>Löscht dieses Reportdetail unwiederbringlich!</td>\n  </tr>\n </tbody>\n</table>\n\n','_timeinterval_in_reportdetails_de,_report_output_function_de','ConfigHints'),(216,'de','_timeinterval_in_reportdetails_de','<!-- Changes:\n  _timeinterval_in_reportdetails_de, de\n\n  -----\n  2015-11-30, roveda: Created the help page.\n  2015-12-03, roveda: design changes\n\n  -----\n  no includes possible\n\n-->\n\n<hr>\n<h3 id=\"_timeinterval_in_reportdetails_de\">Zeitraum</h3> \n\n<p>Festlegen des gewünschten Zeitraums für den die Werte dargestellt werden sollen.<br>\n</p>\n<table>\n<thead>\n  <tr>\n    <th>Zeitraum</th>\n    <th>Erklärung</th>\n  </tr>\n<tbody>\n  <tr>\n    <td>zwei Stunden</td>\n    <td>die Werte der zwei letzten vollständigen Stunden</td>\n  </tr>\n  <tr>\n    <td>ab zwei Stunden</td>\n    <td>die Werte der zwei letzten vollständigen Stunden und bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>Heute</td>\n    <td>alle Werte ab heute 00:00:00 Uhr </td>\n  </tr>\n  <tr>\n    <td>Gestern</td>\n    <td>nur die Werte von gestern</td>\n  </tr>\n  <tr>\n    <td>ab Gestern</td>\n    <td>die Werte von gestern bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>diese Woche</td>\n    <td>alle Werte ab Montag dieser Woche 00:00:00 Uhr bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>7 Tage</td>\n    <td>die Werte der letzten 7 Tage bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>ab 7 Tage</td>\n    <td>die Werte der letzten 7 Tage und bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>letzte Woche</td>\n    <td>die Werte von Montag bis Sonntag der vorigen Woche</td>\n  </tr>\n  <tr>\n    <td>ab letzter Woche</td>\n    <td>alle Werte ab Montag der vorigen Woche bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>Monat</td>\n    <td>die Werte ab dem Datum des gestrigen Tages des vorigen Monats bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>letzter Monat</td>\n    <td>die Werte ab dem 01. des vorigen Monats bis zum letzten Tag des vorigen Monats</td>\n  </tr>\n  <tr>\n    <td>ab letztem Monat</td>\n    <td>die Werte ab dem 01. des vorigen Monats bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>3 Monate</td>\n    <td>die Werte der letzten 3 vollständigen Monate</td>\n  </tr>\n  <tr>\n    <td>Jahr</td>\n    <td>die Werte ab dem Datum des gestrigen Tages des vorigen Jahres bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>komplett</td>\n    <td>alle vorhandenen Werte ohne zeitliche Einschränkung</td>\n  </tr>\n</tbody>\n</table>\n','','ConfigHints'),(218,'de','_report_output_function_de','<!-- Changes:\n  _report_output_function_de, de\n\n  -----\n  2015-11-30, roveda: Created the help page.\n  2015-12-03, roveda: design changes\n\n  -----\n  no includes possible\n\n-->\n\n<hr>\n<h3 id=\"_report_output_function_de\">Ausgabemöglichkeiten</h3> \n \n<p>\n  Liste der möglichen Ausgabefunktionen und Erläuterungen.\n</p>\n\n<table>\n <thead>\n  <tr>\n    <td>Ausgabe</td>\n    <td>Beschreibung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td>keine Daten</td>\n    <td>Es werden keine Daten ausgegeben. Diese Einstellung kann für Reportdetails ausschließlich mit Überschriften und/oder Beschreibungstexten verwendet werden.</td>\n  </tr>\n  <tr>\n    <td>Tabelle</td>\n    <td>Die Werte werden als Tabelle mit Zeitstempel angezeigt.</td>\n  </tr>\n  <tr>\n    <td>CSV-Tabelle</td>\n    <td>\n      Die Ausgabe der Werte erfolgt als csv, der Separator kann über \n      <span class=\"button\">Verwalten</span> <span class=\"internal_link\">Optionen</span> \"csv Trennzeichen\".\n    </td>\n  </tr>\n  <tr>\n    <td>letzte Werte</td>\n    <td>Gibt (für jeden Server, je nach Gruppierung) eine einzeilige Tabelle aus, die nur den letzten Wert enthält.</td>\n  </tr>\n  <tr>\n    <td>Grafik</td>\n    <td>Die Werte werden als Grafik angezeigt, deren Auflösung im Drop-Down Feld \"Grafikgröße\" festgelegt wird.</td>\n  </tr>\n  <tr>\n    <td>Minimalwerte</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die das Minimum der Werte enthält.</td>\n  </tr>\n  <tr>\n    <td>Maximalwerte</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die das Maximum der Werte enthält.</td>\n  </tr>\n  <tr>\n    <td>Mittelwerte</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die den arithmetische Mittelwert der Werte enthält.</td>\n  </tr>\n  <tr>\n    <td>Std. Abweichung</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Standardabweichung der Werte enthält.</td>\n  </tr>\n  <tr>\n    <td>Summe</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Summe aller Werte enthält.</td>\n  </tr>\n  <tr>\n    <td>Max - Min</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Differenz von Maximum zum Minimum der Werte enthält.</td>\n  </tr>\n  <tr>\n    <td>Last - First</td>\n    <td>\n      Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Differenz vom (zeitlich) letzten Wertes \n      zum (zeitlich) ersten Wert enthält. Damit lässt sich zB die Zuwachsrate pro Zeiteinheit darstellen.\n    </td>\n  </tr>\n  <tr>\n    <td>Count</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Anzahl von Werten enthält.</td>\n  </tr>\n  <tr>\n    <td>Steigung</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Steigung (Gradienten) der Werte für den gewählten Zeitbereich anzeigt.</td>\n  </tr>\n  <tr>\n    <td>First</td>\n    <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die den ersten Wert aus dem gewählten Zeitbereich enthält.</td>\n  </tr>\n  <tr>\n    <td>Beschleunigung</td>\n    <td>&nbsp;</td>\n  </tr>\n  <tr>\n    <td>Histogramm</td>\n    <td>\n      Gibt ein Histogramm der letzten Werte für die Kombination aller variablen\n      Angaben aus. In dem Reportdetail wird dabei üblicherweise eine oder\n      mehrere Angaben mit Wildcards versehen. Nur für Werte mit identischen Einheiten!\n    </td>\n  </tr>\n  <tr>\n    <td>Hist. Min</td>\n    <td>Gibt ein Histogramm der Minima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>Hist. Max</td>\n    <td>Gibt ein Histogramm der Maxima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>Hist. Mittelw.</td>\n    <td>Gibt ein Histogramm der Mittelwerte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>Hist. Std. Ab.</td>\n    <td>Gibt ein Histogramm der Standardabweichungen für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>Hist. Summe</td>\n    <td>Gibt ein Histogramm der Summen für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>Hist. Max-Min</td>\n    <td>Gibt ein Histogramm der berechneten Maxima-Minima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>Hist. Last-First</td>\n    <td>Gibt ein Histogramm der berechnete letzten Werte minus der ersten Werte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>Hist. Count</td>\n    <td>Gibt ein Histogramm der Anzahl der Werte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>Hist. Grad</td>\n    <td>Gibt ein Histogramm der Gradienten für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n  </tr>\n  <tr>\n    <td>animiertes GIF</td>\n    <td>TODO</td>\n  </tr>\n  <tr>\n    <td>Kompr.-KombiDetails</td>\n    <td>TODO</td>\n  </tr>\n  <tr>\n    <td>Limits Übersicht</td>\n    <td>Tabellarische Darstellung der definierten Limits.</td>\n  </tr>\n  <tr>\n    <td>KombiLimits Übersicht</td>\n    <td>Tabellarische Darstellung der definierten KombiLimits.</td>\n  </tr>\n  <tr>\n    <td>isAlive Übersicht</td>\n    <td>Tabellarische Darstellung der definierten isAlive.</td>\n  </tr>\n  <tr>\n    <td>kompr. Limits Übersicht</td>\n    <td>Tabellarische Darstellung der definierten Limits auf komprimierte Werte.</td>\n  </tr>\n  <tr>\n    <td>KombiDetails Übersicht</td>\n    <td>Tabellarische Darstellung der definierten KombiDetails.</td>\n  </tr>\n  <tr>\n    <td>Kompr.-KombiDetails Übersicht</td>\n    <td>Tabellarische Darstellung der definierten KombiDetails auf komprimierte Werte.</td>\n  </tr>\n  <tr>\n    <td>Aufbewahrung Übersicht</td>\n    <td>Tabellarische Darstellung der definierten Aufbewahrungszeiten.</td>\n  </tr>\n  <tr>\n    <td>Status Übersicht</td>\n    <td>TODO</td>\n  </tr>\n  <tr>\n    <td>überschrittene Limits</td>\n    <td>TODO</td>\n  </tr>\n  <tr>\n    <td>überschrittene isAlive</td>\n    <td>TODO</td>\n  </tr>\n  <tr>\n    <td>überschrittene kompr.-Limits</td>\n    <td>TODO</td>\n  </tr>\n  <tr>\n    <td>ausgelöste Benachrichtigungen</td>\n    <td>TODO</td>\n  </tr>\n </tbody>\n</table>\n','','ConfigHints'),(177,'de','myisalive','<p>Hier werden die ausgelösten isAlive Benachrichtigungen der letzten 48 Stunden angezeigt.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n    <tr>\n      <td>Tabellenspalte</td>\n      <td>Erklärung</td>\n    </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n      <td>Server</td>\n      <td>Der Name des Servers, bei dem die isAlive-Überwachung ausgelöst hat.</td>\n    </tr>\n    <tr>\n      <td>URL</td>\n      <td>Der Sektion -- Testschritt -- Detail Kombination (ULS Resource Locator),\n        bei dem die isAlive-Überwachung ausgelöst hat. Mit\n        Klick auf diesen Weblink wird die zugehörige isAlive-Definition\n        angezeigt.</td>\n    </tr>\n    <tr>\n      <td>letzter Wert</td>\n      <td>Anzeige des letzten, <span style=\"font-weight: bold;\">aktuellen</span> Wertes, der für diese\n        Sektion -- Testschritt -- Detail Kombination im ULS vorliegt.</td>\n    </tr>\n    <tr>\n      <td>Zeitstempel</td>\n      <td>Der Zeitstempel vom letzten (neuesten) Wert.</td>\n    </tr>\n    <tr>\n      <td>Meldungszeit</td>\n      <td>Der Zeitstempel, an dem die isAlive-Überwachung ausgelöst wurde.</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Die isAlive-Meldungen werden nicht mehr angezeigt,</p>\n<ul>\n  <li>wenn die Meldungszeit länger als 48 Stunden zurückliegt,</li>\n  <li>wenn die isAlive-Überwachung deaktiviert oder gelöscht wurde,</li>\n  <li>wenn alle Werte dieser Server -- Sektion -- Testschritt -- Detail Kombination\n    (durch den ULS Server) gelöscht wurden.</li>\n</ul>\r','','ConfigHints'),(172,'de','report_kopieren','<p>Der Report wird kopiert, dabei wird der Server für jedes Reportdetail mit\ndem neuen Servernamen ersetzt. Beziehen sich Reportdetails auf verschiedene\nServernamen, so müssen diese Eintragungen nachträglich manuell angepasst\nwerden.</p>\n<p>Für das Kopieren von komplexen Reports wird empfohlen, <span style=\"color: rgb(0, 0, 0); background-color: rgb(169, 169, 169);\">Textmodus</span>\nüber <span style=\"color: rgb(0, 0, 255);\">Verwalten --\nReports bearbeiten -- ändern</span> zu verwenden.</p>\r','','ConfigHints'),(173,'de','reports_bearbeiten_all','<!-- Changes:\n  reports_bearbeiten_all, de\n  2016-04-12, roveda: Changed to match new css\n-->\n<hr>\n<h2>Reports bearbeiten</h2>\n<p>\n  Reports haben einen Namen, eine Beschreibung und eine beliebige\n  Zusammenstellung von Reportdetails mit Tabellen, Grafiken oder berechneten Werten (Minimum,\n  Maximun, Durchschnitt etc).\n</p>\n<p>\n  Hier können vorhandene Reports bearbeitet werden oder in der untersten\n  Zeile der Tabelle neu angelegt werden.\n</p>\n\n<table>\n  <thead>\n    <tr>\n      <td>Tabellenspalte</td>\n      <td>Erklärung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>Reportname</td>\n      <td>\n        Der Name des Reports. Dieser muss beim Neuanlegen eingetragen\n        werden. Er muss nicht eindeutig sein (maximal 50 Zeichen).\n      </td>\n    </tr>\n    <tr>\n      <td>Beschreibung</td>\n      <td>\n        Der Ersteller des Reports kann hier eine Beschreibung des Reports\n        eintragen. Dieser wird beim Aufruf des Reports angezeigt (maximal\n        64000 Zeichen). HTML ist möglich.\n      </td>\n    </tr>\n    <tr>\n      <td>Verfahren</td>\n      <td>\n        Mit dieser Drop-Down Liste kann der entsprechende Report für alle\n        ULS Benutzer des gewählten Verfahrens zur Verfügung gestellt werden. \n        Siehe <a href=\"#reports_verfahren_benutzer\">Reports, Verfahren und Benutzer</a>.\n      </td>\n    </tr>\n    <tr>\n      <td>Details</td>\n      <td>Auf den Link \"ändern\" klicken, um die Details des jeweiligen Reports zu bearbeiten.</td>\n    </tr>\n    <tr>\n      <td>kopieren</td>\n      <td>Kopiert diesen Report. Reportname und Servername können dabei geändert werden.</td>\n    </tr>\n    <tr>\n      <td>löschen</td>\n      <td>Löscht diesen Report.</td>\n    </tr>\n  </tbody>\n</table>\n\n<hr>\n<h3 id=\"reports_verfahren_benutzer\">Reports, Verfahren und Benutzer</h3>\n<p>\n  Ein Benutzer besitzt die Zugriffsrechte auf <b>mehrere</b> Verfahren.\n  Er erstellt einen Report, der sich auf Werte dieser Verfahren bezieht. Diesen Report gibt er für alle\n  ULS Benutzer <b>eines</b> Verfahrens frei.\n  Ein anderer Benutzer kann also diesen Report aufrufen, es wird jedoch u.U.\n  nicht alles angezeigt, falls der Benutzer nicht auf alle im Report\n  referenzierten Verfahren Zugriff hat.\n</p>\n<hr>\n<h3>Platzhalter</h3>\n<p>\nFür die Ausgabe von dynamischen Angaben in Berichten werden eine Reihe von Platzhaltern zur Verfügung gestellt.\nSie können im Reportnamen und in der Beschreibung verwendet werden.\nDiese sind in der folgenden Tabelle beschrieben.\n</p>\n<table>\n  <thead>\n    <tr>\n      <td>Platzhalter</td>\n      <td>Beschreibung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>$CONTACT</td>\n      <td>Ansprechpartner für den Server</td>\n    </tr>\n    <tr>\n      <td>$DESCRIPTION</td>\n      <td>Beschreibung des Servers (nicht verfügbar im Reportnamen)</td>\n    </tr>\n    <tr>\n      <td>$DOMAIN</td>\n      <td>Verfahren, zu dem der Server zugeordnet ist.</td>\n    </tr>\n    <tr>\n      <td>$IPADDRESS</td>\n      <td>IP-Adresse des Servers.</td>\n    </tr>\n    <tr>\n      <td>$LOCATION</td>\n      <td>Standort des Servers.</td>\n    </tr>\n    <tr>\n      <td>$MAINTENANCEWINDOW</td>\n      <td>Wartungsfenster des Servers.</td>\n    </tr>\n    <tr>\n      <td>$SERVER</td>\n      <td>Der Name des Servers.</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Beispiel für einen Reportnamen: Standardreport für $SERVER</p>\n<p>Beispiel für eine Beschreibung: $SERVER ($IPADDRESS, $DESCRIPTION) steht in $LOCATION, Wartungsfenster: $MAINTENANCEWINDOW\n</p>','','ConfigHints'),(89,'de','ueberschrittene_DiffLimits','<p>Diese &Uuml;bersicht zeigt alle Server-Sektion-Testschritt-Detail\nKombinationen\nan, bei denen DiffLimits verletzt wurden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Tabellenspalte</td>\n<td>Erkl&auml;rung</td>\n</tr>\n<tr>\n<td>Status</td>\n<td>Zeigt einen gelben, blauen oder roten Indikator an,\nabh&auml;ngig vom verletzten Limit (Info, Warn, Fehler). Mit Klick auf\ndiesen Indikator wird die dazugeh&ouml;rige Wertegrafik oder Tabelle (ab\nGestern) angezeigt.</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Name des Servers, bei dem die\nSektion-Testschritt-Detail Kombinationen &uuml;berschritten wurde.</td>\n</tr>\n<tr>\n<td>URL</td>\n<td>Sektion-Testschritt-Detail bei der die Verletzung des\nDiffLimits aufgetreten ist. Mit Klick auf diesen Weblink wird die\nzugeh&ouml;rige DiffLimit-Definition angezeigt.</td>\n</tr>\n<tr>\n<td>letzte Differenz</td>\n<td>Anzeige der Differenz des <span style=\"font-weight: normal;\">aktuellen</span> Wertes\nzum vorherigen, bzw voriger und aktueller Textausdruck, der f&uuml;r diese\nSektion-Testschritt-Detail Kombination im ULS vorliegt.</td>\n</tr>\n<tr>\n<td>Zeitstempel</td>\n<td>Der Zeitstempel vom aktuellen (letzten) Wert.</td>\n</tr>\n<tr>\n<td>Meldungszeit</td>\n<td>Der Zeitstempel der Benachrichtigung (Meldung an\nMeldungsziel).</td>\n</tr>\n</tbody>\n</table>\n<p>Server-Sektion-Testschritt-Detail Kombinationen werden nicht\nmehr\nangezeigt,</p>\n<ul>\n<li>wenn die DiffLimits aufgrund der neu eingegangenen Werte\nnicht mehr verletzt sind,</li>\n<li>wenn die DiffLimit-Definition deaktiviert oder gel&ouml;scht\nwurde,</li>\n<li>wenn alle Werte dieser Server-Sektion-Testschritt-Detail\nKombinationen (durch den ULS Server) gel&ouml;scht wurden.</li>\n</ul>\n<p></p>','','ConfigHints'),(180,'de','ueberschrittene_KombiLimits','<p>Hier werden die ausgelösten KombiLimits Benachrichtigungen der letzten 48 Stunden angezeigt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Tabellenspalte</td>\n<td>Erklärung</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Status</td>\n<td>Zeigt einen blauen, gelben oder roten Indikator an,\nabhängig vom verletzten KombiLimit (Info, Warn, Fehler). Mit Klick auf\ndiesen Indikator wird die dazugehörige Tabelle oder Wertegrafik (ab gestern)\nangezeigt.</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Name des Servers, bei dem die KombiLimit Überwachung ausgelöst wurde.</td>\n</tr>\n<tr>\n<td>URL</td>\n<td>Sektion -- Testschritt Kombination, bei der die KombiLimit\nÜberwachung ausgelöst wurde. Mit Klick auf diesen Weblink wird die\nzugehörige Überwachungsdefinition angezeigt.</td>\n</tr>\n<tr>\n<td>Vergleich</td>\n<td>Zeigt den ausgeführten Vergleich, basierend auf der Bedingung des KombiLimits.</td>\n</tr>\n<tr>\n<td>Meldungszeit</td>\n<td>Der Zeitstempel der Benachrichtigung (erfolgte Meldung an das Meldungsziel).</td>\n</tr>\n</tbody>\n</table>\n<p>Überschrittene KombiLimits werden nicht mehr angezeigt, wenn:</p>\n<ul>\n<li>die KombiLimits aufgrund der neu eingegangenen Werte nicht mehr verletzt sind,</li>\n<li>die KombiLimit-Definition deaktiviert oder gelöscht wurde,</li>\n<li>alle Werte dieser Server -- Sektion -- Testschritt Kombinationen (durch den ULS Server) gelöscht wurden.</li>\n</ul>\r','','ConfigHints'),(181,'de','mylimits','<p>Hier werden die ausgelösten Limits Benachrichtigungen der letzten 48 Stunden angezeigt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Tabellenspalte</td>\n<td>Erklärung</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Status</td>\n<td>Zeigt einen blauen, gelben oder roten Indikator an,\nabhängig vom verletzten Limit (Info, Warn, Fehler). Mit Klick auf\ndiesen Indikator wird die dazugehörige Tabelle oder Wertegrafik (ab\nGestern) angezeigt.</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Name des Servers, bei dem die Limit-Überwachung ausgelöst wurde.</td>\n</tr>\n<tr>\n<td>URL</td>\n<td>Sektion -- Testschritt -- Detail Kombination, bei der die Limit-Überwachung ausgelöst wurde. \nMit Klick auf diesen Weblink wird die zugehörige Überwachungsdefinition angezeigt.</td>\n</tr>\n<tr>\n<td>letzter Wert</td>\n<td>Anzeige des letzten, <span style=\"font-weight: bold;\">aktuellen</span> Wertes,\nder für diese Sektion -- Testschritt -- Detail Kombination im ULS vorliegt.</td>\n</tr>\n<tr>\n<td>Zeitstempel</td>\n<td>Der Zeitstempel vom letzten (neuesten) Wert.</td>\n</tr>\n<tr>\n<td>Meldungszeit</td>\n<td>Der Zeitstempel, an dem die Limit-Überwachung ausgelöst wurde.</td>\n</tr>\n</tbody>\n</table>\n<p>Sektion -- Testschritt -- Detail Kombinationen werden nicht mehr angezeigt, wenn:</p>\n<ul>\n<li>die Limits aufgrund der neu eingegangenen Werte nicht mehr verletzt sind,</li>\n<li>die Limit-Definition deaktiviert oder gelöscht wurde,</li>\n<li>alle Werte dieser Server -- Sektion -- Testschritt -- Detail Kombinationen (durch den ULS Server) gelöscht wurden.</li>\n<li>wenn die Server -- Sektion -- Testschritt -- Detail Kombination mit Benachrichtigungsmodus \"jeder Wert\" \nüberwacht wird und seit 24h kein neuer Wert eingegangen ist</li>\n</ul>\r','','ConfigHints'),(92,'de','ueberschrittene_isAlive','<p>Diese &Uuml;bersicht zeigt alle Server-Sektion-Testschritt-Detail\nKombinationen\nan, bei denen isAlive &Uuml;berwachungen ausgel&ouml;st wurden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Tabellenspalte</td>\n<td>Erkl&auml;rung</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Name des Servers, bei dem&nbsp;die isAlive\n&Uuml;berwachung ausgel&ouml;st wurde.</td>\n</tr>\n<tr>\n<td>URL</td>\n<td>Sektion-Testschritt-Detail bei der&nbsp;die isAlive\n&Uuml;berwachung ausgel&ouml;st wurde. Mit Klick auf diesen Weblink wird die\nzugeh&ouml;rige &Uuml;berwachungsdefinition angezeigt.</td>\n</tr>\n<tr>\n<td>letzter Wert</td>\n<td>Anzeige des letzten, <span style=\"font-weight: bold;\">aktuellen</span> Wertes,\nder f&uuml;r diese Sektion-Testschritt-Detail Kombination im ULS vorliegt.</td>\n</tr>\n<tr>\n<td>Zeitstempel</td>\n<td>Der Zeitstempel von \"letzter Wert\".</td>\n</tr>\n<tr>\n<td>Meldungszeit</td>\n<td>Der Zeitstempel der Benachrichtigung (Meldung an\nMeldungsziel).</td>\n</tr>\n</tbody>\n</table>\n<p>Server-Sektion-Testschritt-Detail Kombinationen werden nicht\nmehr\nangezeigt,</p>\n<ul>\n<li>wenn die isAlive &Uuml;berwachung aufgrund&nbsp;neu\neingegangener Werte nicht mehr verletzt ist,</li>\n<li>wenn die isAlive-Definition deaktiviert oder gel&ouml;scht wurde,</li>\n<li>wenn alle Werte dieser Server-Sektion-Testschritt-Detail\nKombinationen (durch den ULS Server) gel&ouml;scht wurden.</li>\n</ul>','','ConfigHints'),(156,'de','report_autodetails_bearbeiten','<p>Das Auto-Detail eines Reports kann hier bearbeitet werden, um die Ergebnismenge zu verändern.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Abgrenzung</td>\n<td>Hier kann ein Vorspann zu dem Reportdetail definiert werden, zB eine horizontale Linie \n(&lt;hr color=\"#6E3AA6\"&gt;)</td>\n</tr>\n<tr>\n<td>Name</td>\n<td>Dieser Textausdruck wird als Überschrift für dieses Reportdetail im Report angezeigt.</td>\n</tr>\n<tr>\n<td>Beschreibung</td>\n<td>Hier kann eine ausführliche Erklärung (64000 Zeichen, Text oder HTML) zu diesem Reportdetail eingetragen werden.</td>\n</tr>\n<tr>\n<td>Verfahren</td>\n<td>Optionale Angabe des/der Verfahren, siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Optionale Angabe des/der Server, siehe \"Ausdrücke in Textfeldern\"</td>\n</tr><tr>\n<td>Sektion</td>\n<td >Optionale Angabe der Sektion(en), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr><tr>\n<td>Testschritt</td><td>Optionale Angabe des/der Testschritt(e), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr><tr>\n<td>Detail</td>\n<td>Optionale Angabe des/der Detail(s), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr><tr>\n<td>Einheit</td>\n<td>Optionale Angabe der Einheit(en), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr><tr>\n<td>Zeitraum</td>\n<td>Eine\nDrop-Down-Liste mit allen verfügbaren vorgegebenen dynamischen\nZeitabschnitten. Es muss der undefinierte (leere) Eintrag ausgewählt\nwerden, wenn \"Von\" und \"Bis\" verwendet werden sollen. Über den\nZeitbereich wird prinzipiell die Menge der zu verarbeitenden Werte\nselektiert. Siehe \"Zeitraum\"</td>\n</tr>\n<tr>\n  <td>Offset</td>\n  <td>der Offset entspicht den Pfeilen bei Grafiken und Tabellen. Eine -3 z.B. ist der angezeigte Zeitraum drei mal zurück. Beispiel: Man hat letzte Woche ausgewählt, dann ist -3 vor 4 Wochen. Bei Gestern ist -3 dann vor 4 Tagen.</td>\n</tr>\n<tr>\n<td>Von</td>\n<td>Hier kann ein konkreter Zeitstempel\nim Format YYYY-MM-DD hh:mm:ss eingetragen werden. Es legt den\nAnfangszeitpunkt des zu verwendenden Zeitraums fest, siehe \"Zeitraum Von Bis\".</td>\n</tr>\n<tr>\n<td>Bis</td>\n<td>Hier\nkann ein konkreter Zeitstempel im Format YYYY-MM-DD hh:mm:ss\neingetragen werden. Es legt den Endzeitpunkt des zu verwendenden\nZeitraums fest, siehe \"Zeitraum Von Bis\".</td>\n</tr>\n<tr>\n<td>Ausgabe</td>\n<td>Diese\nDrop-Down Liste legt fest, wie die zu verarbeitenden Werte für dieses\nReportdetail dargestellt, bzw welche Funktion auf sie angewendet werden\nsoll, siehe \"Ausgabemöglichkeiten\"<br>\n</td>\n</tr>\n<tr>\n<td>Grafikgröße</td>\n<td>Festlegung der Größe der auszugebenden Grafiken. Ist nur wirksam, wenn eine grafische Ausgabe gewählt wurde, siehe \"<!-- include: __Grafikgroessen.html -->\".</td>\n</tr>\n<tr>\n<td>Stil</td>\n<td>legt den Stil der Wertelinien in einer Grafik fest:\n<pre>\n  Dots\n  Points \n  Lines \n  Linespoints \n  Impulses \n  Steps \n  Fsteps \n  Histeps \n  Boxes\n</pre>\n</td>\n</tr>\n<tr>\n<td># D</td>\n<td>Legt\ndie maximale Anzahl der in einer Tabelle oder Grafik darzustellenden Details fest. Sind mehr Details in der Ergebnismenge des Reportdetails vorhanden, so werden weitere Tabellen oder Grafiken aufeinanderfolgend angezeigt.</td>\n</tr>\n<tr>\n<td>Gruppierung</td>\n<td>Gruppierung der Ausgabe nach:\n<pre>\n  Server\n  Sektion\n  Testschritt\n  Detail\n  Wochentag\n</pre>\nEine Gruppierung ist nur möglich, wenn alle beteiligten Details die gleiche Einheit haben.\n</tr>\n<tr>\n  <td>Gruppen Fußzeile</td>\n  <td>Es können Zusatzberechnungen zu der Gruppierung aktiviert werden.\n  </td>\n</tr>\n<tr>\n<td>Sortierung</td>\n<td>Sortierung des Ergebnisses nach:\n<pre>\n  Server\n  Sektion\n  Testschritt\n  Detail\n  Einheit\n  Wert\n</pre>  \n</td>\n</tr>\n<tr>\n<td>Werte</td>\n<td>legt fest, ob aktuelle (online) Werte und/oder komprimierte Werte in diesem Reportdetail berücksichtigt werden sollen.</td>\n</tr>\n</tbody>\n</table>\n\n<p>Folgende zusätzliche Angaben sind im erweiterten Modus möglich.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead> <tr>\n<td>Tabellenspalte</td>\n<td> Erklärung </td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>y1 Achse</td>\n  <td>\n    <table  border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n     <tbody style=\"vertical-align: top;text-align: left;\">\n      <tr>\n        <td>Einheit</td>\n        <td>Einheit für die Y-Achse festlegen.</td>\n      </tr>\n      <tr>\n        <td>Min</td>\n        <td>Minimum der Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>Max</td>\n        <td>Maximum der Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>Stil</td>\n        <td>Anzeigestil aller Details dieser Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>logarithmisch</td>\n        <td>logarithmische Skalierung festlegen.</td>\n      </tr>\n    </tbody>\n    </table>\n  </td>\n</tr>\n<tr>\n  <td>y2 Achse</td>\n  <td>\n    <table  border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n     <tbody style=\"vertical-align: top;text-align: left;\">\n      <tr>\n        <td>Einheit</td>\n        <td>Einheit für die Y-Achse festlegen.</td>\n      </tr>\n      <tr>\n        <td>Min</td>\n        <td>Minimum der Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>Max</td>\n        <td>Maximum der Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>Stil</td>\n        <td>Stil aller Details dieser Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>logarithmisch</td>\n        <td>logarithmische Skalierung festlegen.</td>\n      </tr>\n      </tbody>\n    </table>\n    </td>\n</tr>\n<tr>\n  <td>Zeit</td>\n  <td>Nur die Werte aus diesem Zeitraum werden bei der Ausgabe berücksichtigt.\n    <table  border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n    <tbody style=\"vertical-align: top;text-align: left;\">\n      <tr>\n        <td>von</td>\n        <td>Startuhrzeit festlegen, Format: hh:mm.</td>\n      </tr>\n      <tr>\n        <td>bis</td>\n        <td>Startuhrzeit festlegen, Format: hh:mm.</td>\n      </tr>\n      </tbody>\n    </table>\n  </td>\n</tr>\n<tr>\n  <td>Wochentage</td>\n  <td>Nur Werte aus den aktivierten Wochentagen werden bei der Ausgabe berücksichtigt. Ist keiner aktiviert, gilt keine Einschränkung.</td>\n</tr>\n<tr>\n  <td>Werte</td>\n  <td>Die Werte können über mehrere Bedingungen gefiltert werden.  </td>\n  </tr>\n  </tbody>\n  </table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Zeitraum</h4>\n<p>Festlegen des gewünschten Zeitraums für den die Werte dargestellt werden sollen.<br>\n</p>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <th>Zeitraum</th>\n    <th>Erklärung</th>\n  </tr>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>zwei Stunden</td>\n    <td>die Werte der zwei letzten vollständigen Stunden</td>\n  </tr>\n  <tr>\n    <td>ab zwei Stunden</td>\n    <td>die Werte der zwei letzten vollständigen Stunden und bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>Heute</td>\n    <td>alle Werte ab heute 00:00:00 Uhr </td>\n  </tr>\n  <tr>\n    <td>Gestern</td>\n    <td>nur die Werte von gestern</td>\n  </tr>\n  <tr>\n    <td>ab Gestern</td>\n    <td>die Werte von gestern bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>diese Woche</td>\n    <td>alle Werte ab Montag dieser Woche 00:00:00 Uhr bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>7 Tage</td>\n    <td>die Werte der letzten 7 Tage bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>ab 7 Tage</td>\n    <td>die Werte der letzten 7 Tage und bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>letzte Woche</td>\n    <td>die Werte von Montag bis Sonntag der vorigen Woche</td>\n  </tr>\n  <tr>\n    <td>ab letzter Woche</td>\n    <td>alle Werte ab Montag der vorigen Woche bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>Monat</td>\n    <td>die Werte ab dem Datum des gestrigen Tages des vorigen Monats bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>letzter Monat</td>\n    <td>die Werte ab dem 01. des vorigen Monats bis zum letzten Tag des vorigen Monats</td>\n  </tr>\n  <tr>\n    <td>ab letztem Monat</td>\n    <td>die Werte ab dem 01. des vorigen Monats bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>3 Monate</td>\n    <td>die Werte der letzten 3 vollständigen Monate</td>\n  </tr>\n  <tr>\n    <td>Jahr</td>\n    <td>die Werte ab dem Datum des gestrigen Tages des vorigen Jahres bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>komplett</td>\n    <td>alle vorhandenen Werte ohne zeitliche Einschränkung</td>\n  </tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Zeitraum Von Bis</h4>\n<p>Über diese beiden konkreten Zeitstempel kann ein exakt definierter\nZeitraum angegeben werden, der nicht über die vorgegebenen Zeiträume\neinstellbar ist. Die beiden Zeitstempel sind konstant.</p>\n<p>Das Format ist immer \"YYYY-MM-DD hh:mm:ss\" (ISO 8601 / EN 28601).\n\n</p>\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausgabemöglichkeiten</h4>\n<p>Es wird die Ausgabefunktion festgelegt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Ausgabe</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\"><tr>\n  <td>Tabelle</td>\n  <td>Die Werte werden als Tabelle mit Zeitstempel angezeigt.</td>\n</tr>\n<tr>\n  <td>letzte Werte</td>\n  <td>Gibt (für jeden Server, je nach Gruppierung) eine einzeilige Tabelle aus, die nur den letzten Wert enthält.</td>\n</tr>\n<tr>\n  <td>Grafik</td>\n  <td>Die Werte werden als Grafik angezeigt, deren Auflösung im Drop-Down Feld \"Grafikgröße\" festgelegt wird.</td>\n</tr>\n<tr>\n  <td>Min</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die das Minimum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Max</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die das Maximum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Mittelwert</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die den arithmetische Mittelwert der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Std.Abweichung</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Standardabweichung der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Summe</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Summe aller Werte enthält.</td>\n</tr>\n<tr>\n  <td>Max-Min</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Differenz von Maximum zum Minimum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Last-First</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Differenz vom (zeitlich) letzten Wertes zum (zeitlich) ersten Wert enthält. Damit lässt sich zB die Zuwachsrate pro Zeiteinheit darstellen.</td>\n</tr>\n<tr>\n  <td>Count</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Anzahl von Werten enthält.</td>\n</tr>\n<tr>\n  <td>Grad</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Steigung der Werte für den gewählten Zeitbereich anzeigt.</td>\n</tr>\n<tr>\n  <td>First</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die den ersten Wert aus dem gewählten Zeitbereich enthält.</td>\n</tr>\n<tr>\n  <td>Beschleunigung</td>\n  <td>&nbsp;</td>\n</tr>\n<tr>\n  <td>Histogramm</td>\n  <td>Gibt ein Histogramm der letzten Werte für die Kombination aller variablen\nAngaben aus. In dem Reportdetail wird dabei üblicherweise eine oder\nmehrere Angaben mit Wildcards versehen. Nur für Werte\nmit identischen Einheiten!<br>\n</td>\n</tr>\n<tr>\n  <td>Hist.Min</td>\n  <td>Gibt ein Histogramm der Minima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Max</td>\n  <td>Gibt ein Histogramm der Maxima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Mittelw</td>\n  <td>Gibt ein Histogramm der Mittelwerte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Std.Ab.</td>\n  <td>Gibt ein Histogramm der Standardabweichungen für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Summe</td>\n  <td>Gibt ein Histogramm der Summen für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Max-Min</td>\n  <td>Gibt ein Histogramm der berechneten Maxima-Minima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Last-First</td>\n  <td>Gibt ein Histogramm der berechnete letzten Werte minus der ersten Werte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Count</td>\n  <td>Gibt ein Histogramm der Anzahl der Werte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Grad</td>\n  <td>Gibt ein Histogramm der Gradienten für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Limits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Limits.</td>\n</tr>\n<tr>\n  <td>KombiLimits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten KombiLimits.</td>\n</tr>\n<tr>\n  <td>isAlive Übersicht</td>\n  <td>Tabellarische Darstellung der definierten isAlive.</td>\n</tr>\n<tr>\n  <td>kompr.Limits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Limits auf komprimierte Werte.</td>\n</tr>\n<tr>\n  <td>KombiDetails Übersicht</td>\n  <td>Tabellarische Darstellung der definierten KombiDetails.</td>\n</tr>\n<tr>\n  <td>Aufbewahrung Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Aufbewahrungszeiten.</td>\n</tr>\n</tbody>\n</table>\r','','ConfigHints'),(140,'de','set_autorettime','<!-- Changes:\n  set_autorettime, de\n\n  -----\n  2015-12-03, roveda: new format\n\n  -----\n  includes: _retention_general_info_de,_expressions_in_textfields_de\n-->\n<hr>\n<h2>Auto Aufbewahrung für Verfahren festlegen</h2>\n\n<p>\nHier werden die automatisch zu verwendenden Aufbewahrungszeiten\nfür alle nicht komprimierten Werte festgelegt, die zu bestimmten \nServer - Sektion - Testschritt - Detail - Einheit\nMustern passen. Siehe auch <a href=\"#_retention_general_info_de\">Allgemeines zu Aufbewahrungszeiten</a>.\n</p>\n<p>\nBei Eingang von Werten mit im ULS bisher unbekannten \nServer - Sektion - Testschritt - Detail - Einheit Kombinationen \nwird für diese geprüft, ob sie zu den hier definierten Mustern passen und ggf. \nwerden die definierten Aufbewahrungszeiten wirksam.\n</p>\n\n<h3>Beschreibung der Schaltflächen</h3>\n<table>\n <thead>\n  <tr>\n    <td>Schaltfläche</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td><span class=\"button\">Textmodus</span></td>\n    <td>\n      Zeigt alle Aufbewahrungsdefinitionen in einem Textformat in einer Textbox an.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Änderungen</span></td>\n    <td>\n      Zeigt alle Änderungen für alle Aufbewahrungsdefinitionen. Auch für gelöschte Definitionen.\n    </td>\n  </tr>\n </tbody>\n</table>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead> \n <tbody>\n  <tr>\n    <td>\n      Server<br>\n      Sektion<br>\n      Testschritt<br>\n      Detail<br>\n      Einheit\n    </td>\n    <td>\n      Festlegen, für welche\n      Server - Sektion - Testschritt - Detail - Einheit Kombination diese Auto-Aufbewahrung\n      gelten soll. Siehe <a href=\"#_expressions_in_textfields_de\">Ausdrücke in Textfeldern</a>.\n    </td>\n  </tr>\n  <tr>\n    <td>Tage</td>\n    <td>Eingabe der Aufbewahrungszeit in Tagen.</td>\n  </tr>\n  <tr>\n    <td>\n      aktiv<br>\n      löschen\n    </td>\n    <td>\n      Damit wird diese Auto-Aufbewahrung aktiviert, deaktiviert oder gelöscht. \n      Beim Löschen werden die daraus erzeugten Aufbewahrungszeiten ebenfalls gelöscht.\n    </td>\n  </tr>\n  <tr>\n    <td>Bemerkung</td>\n    <td>Es kann eine Beschreibung zu dieser Auto-Aufbewahrungsdefinition hinterlegt werden.</td>\n  </tr>\n</tbody>\n</table>\n\n','_retention_general_info_de,_expressions_in_textfields_de','ConfigHints'),(204,'de','_retention_general_info_de','<!-- Changes:\n  _retention_general_info_de, de\n\n  -----\n  2015-12-03, roveda: Created this help page.\n\n  -----\n  no includes possible\n-->\n\n<hr>\n<h3 id=\"_retention_general_info_de\">Allgemeines zu Aufbewahrungszeiten</h3> \n\n<p>\nAlle eingehenden Werte werden standardmäßig für 14 Tage aufbewahrt und dann gelöscht. \nDie Aufbewahrungszeit kann individuell verlängert oder verkürzt werden.\nSollen bestimmte Kennwerte komprimiert oder aggregiert werden, so kann dies unter \n<span class=\"button\">Verwalten</span> <span class=\"internal_link\">Komprimierung</span>\ndefiniert werden.\n</p>\n\n','','ConfigHints'),(141,'de','set_autocomprrettime','<p>Festlegen der automatisch zu verwendeten Aufbewahrungszeiten\nfür komprimierte Werte, die zu einem definierten Server\n-- Sektion -- Testschritt -- Detail -- Einheit Muster passen.</p>\n<p>Bei Eingang von Werten mit bisher nicht vorhandener \nServer -- Sektion -- Testschritt -- Detail -- Einheit Kombination \nwird geprüft, ob diese zu dem hier definierten Muster passt und ggf \nwird die definierte Aufbewahrungszeit hinterlegt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>\n    Server<br>\n    Sektion<br>\n    Testschritt\n  </td>\n<td>Festlegen, für welche\nServer -- Sektion -- Testschritt Kombination diese Auto-Aufbewahrung\ngelten soll. Siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>\nDetail<br>\nEinheit\n</td>\n<td>Festlegen, für welche\nDetail -- Einheit Kombination diese Auto-Aufbewahrung gelten soll.\nSiehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n  <td>Komprimierung</td>\n  <td>Festlegen, für welche Komprimierung die Auto-Aufbewahrung gelten soll.</td>\n</tr>\n<tr>\n  <td>Zeitraum</td>\n  <td>Festlegen, für welchen Zeitraum die Auto-Aufbewahrung gelten soll.</td>\n</tr>\n<tr>\n<td>Tage</td>\n<td>Eingabe der Aufbewahrungszeit in Tagen.</td>\n</tr>\n<tr>\n<td>aktiv</td>\n<td>Damit wird diese Auto-Aufbewahrung aktiviert oder deaktiviert.</td>\n</tr>\n<tr>\n<td>löschen</td>\n<td>Damit wird diese Auto-Aufbewahrung\ngelöscht. Alle aus dieser Auto-Aufbewahrung erzeugte effektive Aufbewahrungszeiten werden ebenfalls gelöscht.</td>\n</tr>\n<tr>\n<td>alle ändern</td>\n<td>Damit wird diese Auto-Aufbewahrung\nJETZT auf ALLE passenden Server -- Sektion -- Testschritt -- Detail --\nEinheit Kombinationen für komprimierte Werte angewendet. Es werden alle\nbestehenden Aufbewahrungszeiten zu den gekennzeichneten Kombinationen geändert.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\r','','ConfigHints'),(25,'de','Auto-Aufbewahrung_fuer_komprimierte_Wert','<p>&Uuml;ber Auto-Aufbewahrung k&ouml;nnen vom Standard (14 Tage) abweichende\nAufbewahrungszeiten f&uuml;r Werte definiert werden.</p>\n\n<p>Einmal t&auml;glich werden alle vorhandenen Daten &uuml;berpr&uuml;ft, ob Server -\nSektion - Testschritt - Detail - Einheit Kombinationen existieren, die zu den\nhier eingetragenen Kombinationen passen und bisher noch keine vom Standard\nabweichende Aufbewahrungszeiten besitzen. Dann werden die passenden\nKombinationen mit den hier definierten Aufbewahrungszeiten ausgestattet.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <thead>\n    <tr valign=\"top\">\n      <th width=\"13%\">Tabellenspalte</th>\n      <th width=\"87%\">\n        <div style=\"text-align: left\">\n        Erkl&auml;rung</div>\n      </th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr valign=\"top\">\n      <td width=\"13%\">Server<br>\n        Sektion<br>\n        Testschritt</td>\n      <td width=\"87%\">Hier wird festgelegt, f&uuml;r welche Server - Sektion -\n        Testschritt Kombination diese Auto-Aufbewahrung gelten soll. Siehe\n        =&gt;(1)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">Detail<br>\n        Einheit</td>\n      <td width=\"87%\">Hier wird festgelegt, f&uuml;r welche Detail - Einheit\n        Kombination diese Auto-Aufbewahrung gelten soll. Siehe =&gt;(1)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">Tage</td>\n      <td width=\"87%\"><font size=\"3\">Eingabe der Aufbewahrungszeit in\n        Tagen.</font></td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">aktiv</td>\n      <td width=\"87%\">Damit wird diese Auto-Aufbewahrung aktiviert oder\n        deaktiviert.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">l&ouml;schen</td>\n      <td width=\"87%\">Damit wird diese Auto-Aufbewahrung gel&ouml;scht. Bestehende\n        Aufbewahrungszeiten werden jedoch nicht gel&ouml;scht.</td>\n    </tr>\n    <tr valign=\"top\">\n      <td width=\"13%\">alle &auml;ndern</td>\n      <td width=\"87%\">Damit wird diese Auto-Aufbewahrung JETZT auf ALLE\n        passenden Server - Sektion - Testschritt - Detail - Einheit\n        Kombinationen angewendet. Es werden auch die schon bestehenden\n        Aufbewahrungszeiten zu diesen Kombinationen ge&auml;ndert.</td>\n    </tr>\n  </tbody>\n</table>\n<hr style=\"color: #0000FF; background-color: #FFFFFF\">\n\n<p><span style=\"font-weight: bold\">(1)</span> Textausdr&uuml;cke in Feldern</p>\n\n<p>In den Feldern k&ouml;nnen konstante Textausdr&uuml;cke, Textausdr&uuml;cke mit\nPlatzhaltern (Wildcards) oder eine komma-getrennte Kombination aus beiden\neingetragen werden. Als Platzhalter k&ouml;nnen \"*\" f&uuml;r einen beliebigen Ausdruck\nund \"?\" f&uuml;r ein beliebiges Zeichen benutzt werden.</p>\n\n<p>Beispiele:</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <tbody>\n    <tr>\n      <td>konstanter Textausdruck:</td>\n      <td>lxabcd5<br>\n        rm300_agr<br>\n        wscdbp93</td>\n    </tr>\n    <tr>\n      <td>Liste von konstanten Textausdr&uuml;cken:</td>\n      <td>lxabcp1,lxabcp2,lvxxx78<br>\n        WSCOWIWEB1,WSCOWIWEB2</td>\n    </tr>\n    <tr>\n      <td>Textausdruck mit Platzhalter:</td>\n      <td>*appserver*</td>\n    </tr>\n    <tr>\n      <td>Liste von konstanten Textausdr&uuml;cken mit Komma<br>\n        getrennt von Textausdr&uuml;cken mit Platzhaltern:</td>\n      <td>wscdb*,wscowi*,wscapp25<br>\n        xpolpa1,xpolpd*,*art*</td>\n    </tr>\n  </tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein\nPlatzhalter \"*\".</p>\n\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdr&uuml;cken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n<p></p>','','ConfigHints'),(143,'de','autoauswahl','<p>Zur übergreifenden Auswertung von Werten beliebiger \nVerfahren -- Server -- Sektion -- Testschritt -- Detail -- Einheit Kombinationen \nkönnen hier Textausdrücke als Muster verwendet werden, um die gewünschte\nErgebnismenge zu definieren.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\"><tr>\n<td>Verfahren</td>\n<td>Optionale Angabe des/der Verfahren, siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Optionale Angabe des/der Server, siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Sektion</td>\n<td>Optionale Angabe der Sektion(en), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Testschritt</td>\n<td>Optionale Angabe des/der Testschritt(e), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Detail</td>\n<td>Optionale Angabe des/der Detail(s), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Einheit</td>\n<td>Optionale Angabe der Einheit(en), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Werte</td>\n<td>Legt fest, ob die aktuellen Werte (online) und/oder die komprimierten Werte berücksichtigt werden sollen.</font></td>\n</tr>\n<tr>\n<td>Ausgabe</td>\n<td>Legt fest, wie die zu verarbeitenden Werte für dieses Auto-Detail dargestellt, bzw welche Funktion auf angewandt werden soll. Siehe \"Ausgabemöglichkeiten\".\n</td>\n</tr>\n<tr>\n<td>Sortierung</td>\n<td>Sortierung des Ergebnisses nach:\n<pre>\n  Server\n  Sektion\n  Testschritt\n  Detail\n  Einheit\n  Wert\n</pre>  \n</td>\n</tr>\n<tr>\n<td>Stil</td>\n<td>legt den Stil der Wertelinien in einer Grafik fest:\n<pre>\n  Dots\n  Points \n  Lines \n  Linespoints \n  Impulses \n  Steps \n  Fsteps \n  Histeps \n  Boxes\n</pre>\n</td>\n</tr>\n<tr>\n<td>Größe der Grafik</td>\n<td>legt die Größe der Grafik fest:\n<pre>\n   640 x  480\n   800 x  600\n  1024 x  768\n  1280 x  960\n  1600 x 1200\n</pre>\n</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausgabemöglichkeiten</h4>\n<p>Es wird die Ausgabefunktion festgelegt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Ausgabe</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\"><tr>\n  <td>Tabelle</td>\n  <td>Die Werte werden als Tabelle mit Zeitstempel angezeigt.</td>\n</tr>\n<tr>\n  <td>letzte Werte</td>\n  <td>Gibt (für jeden Server, je nach Gruppierung) eine einzeilige Tabelle aus, die nur den letzten Wert enthält.</td>\n</tr>\n<tr>\n  <td>Grafik</td>\n  <td>Die Werte werden als Grafik angezeigt, deren Auflösung im Drop-Down Feld \"Grafikgröße\" festgelegt wird.</td>\n</tr>\n<tr>\n  <td>Min</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die das Minimum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Max</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die das Maximum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Mittelwert</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die den arithmetische Mittelwert der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Std.Abweichung</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Standardabweichung der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Summe</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Summe aller Werte enthält.</td>\n</tr>\n<tr>\n  <td>Max-Min</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Differenz von Maximum zum Minimum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Last-First</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Differenz vom (zeitlich) letzten Wertes zum (zeitlich) ersten Wert enthält. Damit lässt sich zB die Zuwachsrate pro Zeiteinheit darstellen.</td>\n</tr>\n<tr>\n  <td>Count</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Anzahl von Werten enthält.</td>\n</tr>\n<tr>\n  <td>Grad</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Steigung der Werte für den gewählten Zeitbereich anzeigt.</td>\n</tr>\n<tr>\n  <td>First</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die den ersten Wert aus dem gewählten Zeitbereich enthält.</td>\n</tr>\n<tr>\n  <td>Beschleunigung</td>\n  <td>&nbsp;</td>\n</tr>\n<tr>\n  <td>Histogramm</td>\n  <td>Gibt ein Histogramm der letzten Werte für die Kombination aller variablen\nAngaben aus. In dem Reportdetail wird dabei üblicherweise eine oder\nmehrere Angaben mit Wildcards versehen. Nur für Werte\nmit identischen Einheiten!<br>\n</td>\n</tr>\n<tr>\n  <td>Hist.Min</td>\n  <td>Gibt ein Histogramm der Minima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Max</td>\n  <td>Gibt ein Histogramm der Maxima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Mittelw</td>\n  <td>Gibt ein Histogramm der Mittelwerte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Std.Ab.</td>\n  <td>Gibt ein Histogramm der Standardabweichungen für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Summe</td>\n  <td>Gibt ein Histogramm der Summen für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Max-Min</td>\n  <td>Gibt ein Histogramm der berechneten Maxima-Minima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Last-First</td>\n  <td>Gibt ein Histogramm der berechnete letzten Werte minus der ersten Werte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Count</td>\n  <td>Gibt ein Histogramm der Anzahl der Werte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Grad</td>\n  <td>Gibt ein Histogramm der Gradienten für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Limits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Limits.</td>\n</tr>\n<tr>\n  <td>KombiLimits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten KombiLimits.</td>\n</tr>\n<tr>\n  <td>isAlive Übersicht</td>\n  <td>Tabellarische Darstellung der definierten isAlive.</td>\n</tr>\n<tr>\n  <td>kompr.Limits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Limits auf komprimierte Werte.</td>\n</tr>\n<tr>\n  <td>KombiDetails Übersicht</td>\n  <td>Tabellarische Darstellung der definierten KombiDetails.</td>\n</tr>\n<tr>\n  <td>Aufbewahrung Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Aufbewahrungszeiten.</td>\n</tr>\n</tbody>\n</table>\r','','ConfigHints'),(151,'de','set_autolimits','<p>Eine Limit-Überwachungen löst eine Benachrichtigung aus, \nsobald ein eingehender Wert einen definierten Grenzwert verletzt.</p>\n<p>Hier werden automatisch zu verwendende Limits-Überwachungen (Auto-Limits) für alle Werte, die zu definierten \nServer -- Sektion -- Testschritt -- Detail -- Einheit Mustern dieses Verfahrens passen, festgelegt.</p>\n<p>Beim Eintreffen von Werten mit bisher nicht vorhandenen \nServer -- Sektion -- Testschritt -- Detail -- Einheit Kombinationen \nwird geprüft, ob diese zu den hier definierten Mustern passen und ggf \nwerden die eingetragenen Limits-Überwachungen wirksam.</p>\n<p>Die Kontrolle auf verletzte Limits-Überwachungen erfolgt zyklisch alle 5 Minuten.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead> <tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>\nServer<br>\nSektion<br>\nTestschritt\n</td>\n<td>Hier wird festgelegt, für welche Server -- Sektion -- Testschritt Muster dieser Auto-Limit gelten soll, siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Detail<br>\nEinheit<br>\nAccess</td>\n<td>Hier wird festgelegt, für welche Detail -- Einheit Muster dieser Auto-Limit gelten soll,\nsiehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>mitteln über</td>\n<td>\nFestlegen, welche Funktion angewendet und wieviele Werte für diese\nFunktion verwendet werden sollen, bevor der Vergleich ausgeführt wird.\nSiehe \"mitteln über\"\n</td>\n</tr>\n<tr>\n<td>Vergleich</td>\n<td>Der Vergleichsoperand. der mit dem aktuellen Wert gegen die Limits\nverwendet wird. Siehe \"Vergleichsoperatoren\"</td>\n</tr>\n<tr>\n<td>\nInfo<br>\nWarn<br>\nFehler\n</td>\n<td>Einer bis drei Grenzwerte, auf die geprüft wird. Es werden unterschiedliche Prioritäten ausgelöst.</td>\n</tr>\n<tr>\n<td>Benachricht.Modus</td>\n<td>Die Benachrichtigung erfolgt erstmals nach Verletzung des hinterlegten Grenzwertes und danach, falls die Bedingung immer noch erfüllt ist, wieder entsprechend dem gewählten Benachrichtigungsmodus.\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Modus</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>sammeln</td>\n    <td>\n      Sammelt eingehende Textwerte, die hinterlegte Grenzwerte verletzen, über ca 10 Minuten, \n      bevor eine Wiederbenachrichtigung ausgelöst wird (ehemals: Logfile Modus/S).\n    </td>\n  </tr>\n  <tr>\n    <td>jeder Wert</td>\n    <td>Jeder eingehende Wert, der den hinterlegten Grenzwert verletzt, löst eine Benachrichtigung aus \n    (ehemals: Logfile Modus/E).\n    </td>\n  </tr>\n  <tr>\n    <td>1h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach einer Stunde.</td>\n  </tr>\n  <tr>\n    <td>12h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach zwölf Stunden.</td>\n  </tr>\n  <tr>\n    <td>24h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach 24 Stunden.</td>\n  </tr>\n </tbody>\n</table>\nBesonderheit: Bei Nicht-Verletzung des Info Grenzwerts wird die Wiederbenachrichtigung zurückgesetzt.\n<!-- kein Level ist erfüllt und Info ist gesetzt, dann wird die Wiederbenachrichtigung zurückgesetzt -->\n</td>\n</tr>\n<tr>\n<td>Meldung</td>\n<td>Hier kann eine benutzerdefinierte Meldung (max 3000 Zeichen)\neingetragen werden, eine standardisierte Meldung wird bei\nBenachrichtigungen immer geschickt. In der Meldung können Platzhalter\nund Funktionen verwendet werden, siehe \"Platzhalter und Funktionen in Meldung\"</td>\n</tr>\n<tr>\n<td>Meldungsziel</td>\n<td>Zwei für dieses Verfahren freigegebene Benachrichtigungsziele können über die \nDrop-Down-Listen eingestellt werden.<br>\nDie Checkboxen I W F (Info/Warn/Fehler) legen die Prioritäten\nfest, bei deren Verletzung eine Benachrichtigung an das jeweilige\nMeldungsziel geschickt wird.</td>\n</tr>\n<tr>\n<td>\naktiv<br>\nlöschen<br>\nalle ändern\n</td>\n<td>Damit wird dieser Auto-Limit deaktiviert, aktiviert, gelöscht oder alle hieraus abgeleiteten Limit-Überwachungen werden bzgl der vorgenommenen Änderungen angepasst.</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>mitteln über</h4>\n<p>Über dir Drop-Down-Liste erfolgt die Auswahl\nder Funktion, die in Verbindung mit der Eingabe im Textfeld angewendet\nwird, bevor der Vergleich ausgeführt wird. Hier die Liste der Funktionen:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Funktion</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Last</td>\n<td>Verwende den letzten Wert (chronologisch den jüngsten)</td>\n</tr>\n<tr>\n<td>Avg</td>\n<td>Mittelwert berechnen</td>\n</tr>\n<tr>\n<td>Sum</td>\n<td>Summe berechnen</td>\n</tr>\n<tr>\n<td>Std</td>\n<td>Standardabweichung berechnen</td>\n</tr>\n<tr>\n<td>Min</td>\n<td>minimalen Wert verwenden</td>\n</tr>\n<tr>\n<td>Max</td>\n<td>maximalen Wert verwenden</td>\n</tr>\n<tr>\n<td>Max-Min</td>\n<td>Subtrahiere den minimalen Wert vom maximalen Wert</td>\n</tr>\n<tr>\n<td>Last-First</td>\n<td>Subtrahiere den ersten Wert (ältesten) vom letzten Wert (jüngsten)</td>\n</tr>\n<tr>\n<td>Count</td>\n<td>Anzahl der Werte verwenden</td>\n</tr>\n<tr>\n<td>Grad</td>\n<td>Gradient berechnen</td>\n</tr>\n</tbody>\n</table>\n\n<p>Im Textfeld erfolgt die Eingabe der Anzahl oder des Zeitbereichs, der zur Anwendung der oben gewählten Funktion verwendet werden soll. Eine einfache Zahl legt die Anzahl der letzten Werte fest, die für den Vergleich verwendet werden sollen. Für einen Zeitbereich wird eine Zahl und eine Abkürzung für den Zeitabschnitt eingetragen. Abkürzungen für den Zeitbereich:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>m</td>\n<td>Minuten</td>\n</tr>\n<tr>\n<td>h</td>\n<td>Stunden</td>\n</tr>\n<tr>\n<td>d</td>\n<td>Tage</td>\n</tr>\n</tbody>\n</table>\n\n<p>Beispiele mit Erklärungen zu möglichen Eingaben:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>[ Last ]</td>\n<td>Verwende den letzten Wert für den Vergleich.</td>\n</tr>\n<tr>\n<td>\n[ Avg ]<br>\n[ 10 ]</td>\n<td>Verwende die letzten 10 Werte, bilde daraus den Mittelwert und verwende diesen für den Vergleich.</td>\n</tr>\n<tr>\n<td>\n[ Grad ]<br>\n[ 60m ]\n</td>\n<td>Berechne den Gradienten der Werte aus den letzten 60 Minuten und führe mit diesem Wert dann den Vergleich aus.\n</td>\n</tr>\n<tr>\n<td>\n[ Count ]<br>\n[ 2d ]\n</td>\n<td>Ermittle die Anzahl der Werte für die letzten 2 Tage (48h) und verwende diese Anzahl für den Vergleich.\n</td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Vergleichsoperatoren</h4>\n<p>Erklärung der einsetzbaren Vergleichsoperatoren für die\nDefinition von Limits. Die verwendbaren Vergleichsoperatoren sind\nteilweise abhängig von den Datentypen der Werte, auf die sie\nangewendet werden.</p>\n<p><span style=\"font-weight: bold;\">Definition</span>\nvon Ausdrücken, die zur weiteren Beschreibung der Vergleichsoperatoren verwendet werden:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<td>Ausdruck</td>\n<td>Bedeutung</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent für die Menge von Integer und Float verwendet</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird für beliebige Textausdrücke verwendet</td>\n</tr>\n<tr>\n<td>&lt;value&gt;</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n<tr>\n<td>&lt;limit&gt;</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler \n<!-- als DiffLimit (TODO) --> eingetragen ist</td>\n</tr>\n<tr>\n<td>&lt;regexp&gt;</td>\n<td>ist ein regulärer Ausdruck, der POSIX 1003.2 (wie zB in\n\"man 7 regex\" beschrieben) entsprechen muss und der bei\nInfo/Warn/Fehler eingetragen ist. Er wird anstelle des &lt;limit&gt; verwendet</td>\n</tr>\n</tbody>\n</table>\n\n<p>Vor dem Vergleich werden die Datentypen von &lt;value&gt;\nund &lt;limit&gt; angepasst. Die <span style=\"font-weight: bold;\">Datentypumwandlung</span>\nerfolgt nach folgender Vorschrift:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Datentyp<br>\n        &lt;value&gt;</td>\n    <td>Datentyp<br>\n        &lt;limit&gt;</td>\n    <td>Vergleich wird durchgeführt als Datentyp</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>Integer</td>\n  <td>Integer</td>\n  <td>Integer</td>\n</tr>\n<tr>\n  <td>Integer</td>\n  <td>Float</td>\n  <td>Float</td>\n</tr>\n<tr>\n  <td>Float</td>\n  <td>Integer</td>\n  <td>Float</td>\n</tr>\n<tr>\n  <td>String</td>\n  <td>beliebig</td>\n  <td>String</td>\n</tr>\n<tr>\n  <td>beliebig</td>\n  <td>String</td>\n  <td>String<br>\n</td>\n</tr>\n</tbody>\n</table>\n\n<p>Allgemein gilt dabei für die Vergleiche:</p>\n<ul>\n  <li>Bei String-Vergleichen wird Groß-Kleinschreibung unterschieden.</li>\n  <li>\"!\" ist die Negation des Vergleichs.</li>\n  <li>\"|\"\n    <ul>\n      <li>Integer und Float: bilden Absolutwerte von beiden Ausdrücken bevor verglichen wird (abs)</li>\n      <li>String: vergleicht beide Ausdrücke unabhängig von Groß-Kleinschreibung (ignore case)</li>\n    </ul>\n  </li>\n</ul>\n<p> <span style=\"color: rgb(255, 0, 0);\">Hinweis:</span>\nDie (Text-)Vergleiche erfolgen gegen den\ngesamten Textausdruck eines Wertes, liegen mehrere Textausdrücke zum\ngleichen Zeitstempel vor, so wird nur der LETZTE! Textausdruck\nverglichen.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgeführter Vergleich</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich</td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\">value</td><td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich&nbsp;(abs/ignore case)</td></tr><tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\">value</td><td style=\"text-align: center; font-family: monospace;\">!==|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich, keine Datentypenumwandlung (immer String) (ignore case)</td></tr><tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält\nnicht&nbsp;<span style=\"font-family: monospace;\">limit</span>\nals Substring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält\nnicht&nbsp;<span style=\"font-family: monospace;\">limit</span>\nals Substring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does\nnot match&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does\nnot match&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case) </td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in Meldung</h4>\n\n<p>Im Text von \'Meldung\' können folgende Platzhalter und Funktionen\nverwendet werden, die vor der Versendung der Benachrichtigung durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Platzhalter</td>\n    <td>wird ersetzt durch</td>\n    <td style=\"text-align: center;\">Limits</td>\n    <td style=\"text-align: center;\">KombiLimits</td>\n    <td style=\"text-align: center;\">isAlive</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGEOVER</td>\n    <td>die Anzahl der Werte oder Zeitbereich von \"mitteln über\"</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$COMPARE</td>\n    <td>den angewandten Vergleich</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$DETAIL</td>\n    <td>das Detail (die Überschrift der Tabellenspalte)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$DOMAIN</td>\n    <td>die Bezeichnung des Verfahrens</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTDATE</td>\n    <td>der Zeitstempel des letzten vorhanden Werts</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTVALUE</td>\n    <td>der letzte Wert</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$LIMIT</td>\n    <td>den verletzten Limit (Info/Warn/Fehler)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$PREVVALUE</td>\n    <td>der Wert des vorigen Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$SAVEDATE</td>\n    <td>der Zeitstempel, an dem der letzte Wert im ULS eingegangen ist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$SECTION</td>\n    <td>die Sektion</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$SERVER</td>\n    <td>den Namen des Rechners</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TESTSTEP</td>\n    <td>die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$TIMEDIFF</td>\n    <td>die festgestellte Zeitdifferenz (die die Frist überschritten hat und zur Auslösung der Benachrichtigung\n    geführt hat)</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TIMELIMIT</td>\n    <td>die definierte Frist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$UNIT</td>\n    <td>die Einheit des Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$VALUE</td>\n    <td>der (uU berechnete) Wert, der die Limits-Verletzung ausgelöst hat</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n</tbody>\n</table>\n\n<p>Funktionen</p>\n<p>Die folgenden Funktionen könnne in Meldungstexten verwendet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr style=\"font-weight: bold;\">\n    <td>Funktion</td>\n    <td>Berechnung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGE_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Berechnet den arithmetischen Mittelwert für eine Anzahl von Werten eines Details.</td>\n  </tr>\n  <tr>\n    <td>$COUNT_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Ermittelt die Anzahl der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$DEV_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n  <td>Ermittelt die Standardabweichung der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n  <td>$DIFF_OF(&lt;detail&gt;[/&lt;unit&gt;])</td>\n<td>Ermittelt die Differenz (Unix Kommando diff) der letzten beiden Werte (können\nauch Dateien sein) und liefert maximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei würde\nes sich sinnvollerweise um Werte mit Textinhalten handeln. Unterstützte Dateiformate mit Komprimierung\nsind:.gz und .bz2. Alle anderen Dateiformate werden verglichen wie sie sind.\n</td>\n</tr><tr>\n<td>$DIFFER_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt, ob der erste Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen, sich&nbsp; zum letzten Wert unterscheidet. Ergibt 0 oder 1 als Ergebnis.</td>\n</tr><tr>\n<td>$FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$GRAD_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den Gradienten (lineare Steigung) der Werte des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_range&gt; [ &lt;time_past&gt;])</td>\n<td>Berechnet die lineare Steigung pro &lt;time_range&gt; (Standard: 1d) für Werte, die\nfür das angegebene Detail vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist &lt;time_past&gt; nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den &lt;time_range&gt;\numgerechnet. Man kann also die Werte der letzten 24h\nbetrachten (&lt;time_past&gt; = 24h) und daraus den Gradienten pro 8 Stunden\n(&lt;time_range&gt; = 8h) berechnen.\n</td>\n</tr>\n<tr>\n<td>$LAST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den letzten (aktuellsten) Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen. Dies kann ein neuerer&nbsp;Wert sein als der über $VALUE_OF ermittelte.</td>\n</tr><tr>\n<td>$LAST-FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Maximum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Minimum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_future&gt; [, &lt;time_past&gt;])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der für ein Detail vorliegenden Werte innerhalb eines\nzurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte einem linearen Wachstum unterliegen. Wird &lt;time_past&gt; nicht\nangegeben, dann wird &lt;time_future&gt; verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten Hälfte von &lt;time_past&gt; liegen\nund die in der zweiten Hälfte von &lt;time_past&gt; liegen, wird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der angenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten Steigung wird der Endwert zu &lt;time_future&gt; berechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(&lt;detail&gt;[/&lt;unit&gt;],&lt;&gt; &lt;regexp&gt;, &lt;time_range&gt;)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregulären Ausdrucks &lt;regexp&gt; in allen Werten des &lt;detail&gt;,\ndie in &lt;time_range&gt; (nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Summe der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$UNIT_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ermittelt die Einheit des &lt;detail&gt;</td>\n</tr><tr>\n<td>$VALUE_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ist&nbsp;der&nbsp;Wert des &lt;detail&gt; zum Zeitpunkt der Überwachungskontrolle. Dies ist nicht unbedingt der neueste Wert für dieses &lt;detail&gt;. </td>\n</tr>\n</tbody>\n</table>\n\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\r','','ConfigHints'),(152,'de','autolimits_nt',' <!-- no contents -->\n <p>TODO</p>\r','','ConfigHints'),(158,'de','set_detailremark','<p>Für jedes Detail kann manuell eine Beschreibung hinterlegt werden. \nDie Beschreibung gilt nur für die Detail -- Einheit Kombination der aktuellen \nVerfahren -- Server -- Sektion -- Testschritt Auswahl.\nEs ist keine allgemeine Beschreibung für alle Detail -- Einheit Kombinationen mit den gleichen Bezeichnungen.\n</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Detail</td>\n    <td>Für jede existierende Detail -- Einheit Kombination wird eine Zeile zum Festlegen und Bearbeiten von Beschreibungen angezeigt.</td>\n  </tr>\n  <tr>\n    <td>Beschreibung</td>\n    <td>Beschreibung für diese Detail -- Einheit Kombination.</td>\n  </tr>\n</tbody>\n</table>','','ConfigHints'),(63,'de','DiffLimits_festlegen','<p>DiffLimits k&ouml;nnen zu allen Details eingetragen, gel&ouml;scht oder\nge&auml;ndert\nwerden. Die Kontrolle auf verletzte DiffLimits findet regelm&auml;&szlig;ig\nstatt.\n</p>\n<p>Es wird jeweils der vorige Wert vom aktuellen (neuesten) Wert\nsubtrahiert\nund das Ergebnis (die Differenz) mit dem eingetragenen DiffLimit von\nInfo/Warn/Fehler verglichen. Bei Textausdr&uuml;cken ist nur ein\ngleich/ungleich\nm&ouml;glich und ist auch <b>nur</b> f&uuml;r einzeilige Werte\nverwendbar. Ist ein\nDiffLimit verletzt, so wird eine Meldung an das Meldungsziel versandt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<col width=\"38*\"><col width=\"218*\"><thead>\n<tr>\n<td width=\"15%\"><span style=\"font-weight: bold;\">Tabellenspalte</span><span style=\"font-weight: bold;\"></span></td>\n<td width=\"85%\"><span style=\"font-weight: bold;\">Erkl&auml;rung</span></td>\n</tr>\n</thead> <tbody>\n<tr>\n<td width=\"15%\">Detail</td>\n<td width=\"85%\">F&uuml;r jedes existierende Detail wird\neine Zeile zum festlegen und bearbeiten von DiffLimits angezeigt.</td>\n</tr>\n<tr>\n<td width=\"15%\">letzte Differenz</td>\n<td width=\"85%\">Voriger Wert subtrahiert vom\naktuellen Wert mit Einheit f&uuml;r numerische Details, bzw voriger und aktueller Textausdruck.</td>\n</tr>\n<tr>\n<td width=\"15%\">Vergleich</td>\n<td width=\"85%\">Der auf die letzte Differenz zu den\nDiffLimits anzuwendende Vergleichsoperator. Siehe \"Vergleichsoperatoren \'DiffLimits\'\"</td>\n</tr>\n<tr>\n<td width=\"15%\">Info<br>\nWarn<br>\nFehler</td>\n<td width=\"85%\">Diese drei DiffLimits k&ouml;nnen\neingetragen werden. Sie unterscheiden sich durch eine jeweils h&ouml;here\nPriorit&auml;t im Remedy Ticket (nur bei Remedy Meldungszielen). Verletzt\ndie ermittelte Differenz einen von diesen DiffLimits, so wird eine\nMeldung ausgel&ouml;st. Bei Details mit Textausdr&uuml;cken kann nur die\nPriorit&auml;t ausgew&auml;hlt werden.</td>\n</tr>\n<tr>\n<td width=\"15%\">Meldung</td>\n<td width=\"85%\">Hier kann eine&nbsp;benutzerdefinierte Meldung\n(max 1000 Zeichen) eingetragen werden, eine standardisierte\nBenachrichtigung wird immer geschickt. Siehe \"Platzhalter und Funktionen in \'Meldung\'\"</td>\n</tr>\n<tr>\n<td width=\"15%\">Meldungsziel</td>\n<td width=\"85%\">Eine Drop-Down-Liste mit den\nverf&uuml;gbaren Benachrichtigungszielen, die f&uuml;r dieses Verfahren definiert\nsind.</td>\n</tr>\n<tr>\n<td width=\"15%\">aktiv</td>\n<td width=\"85%\">Damit kann ein DiffLimit aktiviert\noder deaktiviert werden.</td>\n</tr>\n<tr>\n<td width=\"15%\">l&ouml;schen/Auto</td>\n<td width=\"85%\">Damit wird diese\nDiffLimit-Definition gel&ouml;scht. Wurde der DiffLimit &uuml;ber eine\nAuto-DiffLimit Definition erzeugt, so kann sie nicht gel&ouml;scht werden\n(nur deaktiviert).</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine\nBemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Vergleichsoperatoren \'DiffLimits\'</h4>\n<p>Erkl&auml;rung der einsetzbaren&nbsp;Vergleichsoperatoren bei\nder\nDefinition von DiffLimits. Die verwendbaren Vergleichsoperatoren\nsind&nbsp;abh&auml;ngig von den Datentypen der Werte, auf die\nsie\nangewendet werden. </p>\n<p><span style=\"font-weight: bold;\">Definition</span>\nvon Ausdr&uuml;cken, die zur weiteren Beschreibung der\nVergleichsoperatoren verwendet werden:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Ausdruck</td>\n<td>Bedeutung</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent f&uuml;r die Menge von Integer und Float\nverwendet (Details mit numerischen Werten)</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird f&uuml;r beliebige Textausdr&uuml;cke verwendet (Details mit\nTextwerten)</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">diff</td>\n<td>ist die Subtraktion des vorigen Werts vom\naktuellen Wert</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">limit</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler\nals DiffLimit eingetragen ist</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">voriger Wert</td>\n<td>ist der vorige Wert</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">aktueller Wert</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n</tbody>\n</table>\n<p>Allgemein gilt dabei f&uuml;r die Vergleiche:</p>\n<ul>\n<li>Bei String-Vergleichen wird Gro&szlig;-Kleinschreibung\nunterschieden.</li>\n<li>\"!\" ist die Negation des Vergleichs.</li>\n<li>\"|\"\n<ul>\n<li>Integer, Float: bildet Absolutwerte von beiden\nAusdr&uuml;cken bevor verglichen wird (abs)</li>\n<li>String: vergleicht beide Ausdr&uuml;cke unabh&auml;ngig von\nGro&szlig;-Kleinschreibung (ignore case)<br>\n</li>\n</ul>\n</li>\n</ul>\n\n<p><span style=\"font-weight: bold;\">Vergleichsoperatoren\nf&uuml;r Zahlen</span></p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgef&uuml;hrter Vergleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich <sup>(1)</sup></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich (abs) <sup>(1)</sup></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich <sup>(1)</sup></td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\"><span style=\"font-family: monospace;\">diff</span></td><td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich (abs)&nbsp;<sup>(1)</sup></td></tr></tbody>\n</table>\n<p><sup>(1)</sup> Diese Vergleiche werden auf <span style=\"font-weight: bold;\">jeden</span> eingehenden\nWert durchgef&uuml;hrt mit ggf der Ausl&ouml;sung von Benachrichtigungen!</p>\n<p><span style=\"font-weight: bold;\">Vergleichsoperatoren\nf&uuml;r Strings</span></p>\n<p>Alle Vergleiche f&uuml;r Strings werden auf <span style=\"font-weight: bold;\">jeden</span> eingehenden\nWert durchgef&uuml;hrt mit ggf der Ausl&ouml;sung von Benachrichtigungen!\nDie Vergleiche erfolgen gegen den\ngesamten Textausdruck eines Wertes, liegen mehrere Textausdr&uuml;cke zum\ngleichen Zeitstempel vor, so wird nur der <span style=\"font-weight: bold;\">letzte</span> Textausdruck\nverglichen.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgef&uuml;hrter Vergleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">==</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">==|</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>gleich (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">!==</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>ungleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">!==|</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>ungleich (ignore case)</td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in \'Meldung\'</h4>\n<!-- Fussnoten o&auml; verwenden, um isAlive, DiffLimits und andere zu unterscheiden ansonsten alle in einer Tabelle darstellen -->\n<p>Im Text von \"Meldung\" k&ouml;nnen folgende Platzhalter und\nFunktionen\nverwendet werden, die vor der Versendung der \"Meldung\" durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n<p>Platzhalter</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<col width=\"56\"> <col width=\"200\"> <thead>\n<tr style=\"font-weight: bold;\" valign=\"top\">\n<td width=\"22%\">Platzhalter</td>\n<td width=\"78%\">wird ersetzt durch</td><td style=\"text-align: center;\">Limits</td><td style=\"text-align: center;\">DiffLimits</td><td style=\"text-align: center;\">KombiLimits</td><td style=\"text-align: center;\">isAlive</td>\n</tr>\n</thead> <tbody>\n<tr>\n<td>$AVERAGEOVER</td>\n<td>die Anzahl der Werte oder Zeitbereich\nvon \"mitteln &uuml;ber\"</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$COMPARE</td>\n<td width=\"78%\">den angewandte Vergleich</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$DETAIL</td>\n<td width=\"78%\">das Detail (die &Uuml;berschrift der\nTabellenspalte)</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr><td>$DIFF</td><td>Differenz des Vergleichs oder der Subtraktion des vorigen Werts vom aktuellen Wert</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td></tr><tr valign=\"top\">\n<td width=\"20%\">$LASTDATE\n</td>\n<td width=\"78%\">Zeitstempel des letzten vorhanden\nWerts</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$LIMIT</td>\n<td width=\"78%\">den verletzten Limit\n(Info/Warn/Fehler)</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr><td>$PREVVALUE</td><td>Wert des vorigen Werts</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td></tr><tr valign=\"top\">\n<td width=\"22%\">$SECTION</td>\n<td width=\"78%\">die Sektion</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$SERVER</td>\n<td width=\"78%\">den Namen des Rechners</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$TESTSTEP</td>\n<td width=\"78%\">die Bezeichnung des Testschritts,\nggf mit Doppelpunkten bei rekursiven Testschritten</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"20%\">$TIMEDIFF\n</td>\n<td width=\"78%\">die festgestellte Zeitdifferenz (die\ndie Frist &uuml;berschritten hat und zur Ausl&ouml;sung der Benachrichtigung\ngef&uuml;hrt hat)</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"20%\">$TIMELIMIT\n</td>\n<td width=\"78%\">Definierte Frist</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$UNIT</td>\n<td width=\"78%\">die Einheit des Werts</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$VALUE</td>\n<td width=\"78%\">den aktuellen Wert, der die\nLimits-Verletzung ausgel&ouml;st hat</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n</tbody>\n</table><p>Funktionen</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n<tr>\n<td>$AVERAGE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Berechnet den arithmetischen Mittelwert f&uuml;r eine Anzahl\nvon Werten eines Details.<br>\n</td>\n</tr>\n<tr>\n<td>$COUNT_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Anzahl der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$DIFF_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>)\n</td>\n<td>Ermittelt\ndie Differenz (Unix Kommando diff) der letzten beiden Werte (k&ouml;nnen\nauch Dateien sein) und liefert\nmaximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei w&uuml;rde\nes sich sinnvollerweise um Werte mit Textinhalten\nhandeln.&nbsp;Unterst&uuml;tzte Dateiformate mit Komprimierung\nsind:&nbsp;.gz und&nbsp;.bz2. Alle anderen Dateiformate werden\nverglichen wie sie sind.\n</td>\n</tr>\n<tr>\n<td>$GRAD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt den Gradienten (lineare Steigung)\nder Werte des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>, <span style=\"font-family: monospace;\">time_range</span>\n[ <span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet die lineare Steigung pro <span style=\"font-family: monospace;\">time_range</span>\n(Standard: 1d) f&uuml;r Werte, die\nf&uuml;r das angegebene Detail vom aktuellen Zeitpunkt bis <span style=\"font-family: monospace;\">time_past</span>\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist <span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis <span style=\"font-family: monospace;\">time_past</span>\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten\nquadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den <span style=\"font-family: monospace;\">time_range</span>\numgerechnet. Man kann also die Werte der\nletzten 24h\nbetrachten (<span style=\"font-family: monospace;\">time_past</span>\n= 24h) und daraus den Gradienten\npro 8 Stunden\n(<span style=\"font-family: monospace;\">time_range</span>\n= 8h) berechnen.<br>\n</td>\n</tr>\n<tr>\n<td>$LAST-FIRST_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten\nWert aus allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Maximum der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Minimum der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>, <span style=\"font-family: monospace;\">time_future</span>\n[, <span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der f&uuml;r ein Detail vorliegenden Werte innerhalb eines\nzur&uuml;ckliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte\neinem linearen Wachstum unterliegen. Wird <span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, dann wird <span style=\"font-family: monospace;\">time_future</span>\nverwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten H&auml;lfte von <span style=\"font-family: monospace;\">time_past</span>\nliegen\nund die in der zweiten H&auml;lfte von <span style=\"font-family: monospace;\">time_past</span>\nliegen,\nwird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der\nangenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten\nSteigung wird der Endwert zu <span style=\"font-family: monospace;\">time_future</span>\nberechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>],<span style=\"font-family: monospace;\"></span> <span style=\"font-family: monospace;\">regexp</span>, <span style=\"font-family: monospace;\">time_range</span>)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregul&auml;ren Ausdrucks <span style=\"font-family: monospace;\">regexp</span>\nin allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">time_range</span>\n(nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$STD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Standardabweichung der Werte des\n<span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Summe der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$VALUE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>)</td>\n<td>Ermittelt den letzten Wert des <span style=\"font-family: monospace;\">detail</span> </td>\n</tr>\n</tbody>\n</table>\n<h4>Beschreibung der variablen Ausdr&uuml;cke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<th>variabler Ausdruck</th>\n<th style=\"vertical-align: top;\">Erkl&auml;rung</th>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">integer</span></td>\n<td>Ganze Zahl zur Angabe der Anzahl der Werte\noder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">range</span></td>\n<td>Kann ein <span style=\"font-family: monospace;\">integer</span>\noder ein <span style=\"font-family: monospace;\">time_range</span>\nsein.<br>\n<span style=\"font-family: monospace;\">integer</span>\n(ohne <span style=\"font-family: monospace;\">time_unit</span>)\nlegt die <span style=\"font-weight: bold;\">Anzahl</span>\nder Werte fest, auf die die Funktion angewendet\nwerden soll. <br>\n<span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span> legt\nden zur&uuml;ckliegenden <span style=\"font-weight: bold;\">Zeitbereich</span>\nfest, f&uuml;r dessen vorhandene Werte die Funktion\nangewendet werden soll. </td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">detail</span></td>\n<td>Exakte Bezeichnung des Details. Keine umschlie&szlig;enden\neinfache oder doppelte Anf&uuml;hrungszeichen verwenden!</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">unit</span></td>\n<td>Mit einem / abgetrennte Einheit, die zu dem Detail\nangegeben werden muss, falls das Detail allein nicht eindeutig f&uuml;r\ndiesen Testschritt ist.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_future</span></td>\n<td>Ein Zeitbereich, im Format von <span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_past</span></td>\n<td>Ein Zeitbereich, im Format von <span style=\"font-family: monospace;\">time_range</span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_range</span></td>\n<td>Ist eine Angabe im Format von <span style=\"font-family: monospace;\">integer</span> <span style=\"font-family: monospace;\">time_unit</span>, z.B.\n8h, 17m, 3d</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_unit</span></td>\n<td>Ein Buchstabe, der die Zeiteinheit festlegt: m\n(Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>','','ConfigHints'),(64,'de','Intro','<h1>ULS - Universal Logging System</h1>\n\n<p>Dies ist eine Kurzbeschreibung zum ULS.</p>\n\n<p>Das ULS dient zum Abspeichern und Auswerten von numerischen Werten,\nTextausdr&uuml;cken, Start-Stop-Zeiten und Aufbewahren von ganzen Dateien\n(LOBs).</p>\n\n<h3>Funktionen</h3>\n\n<p>Speichern:<br />\nDatenquellen (&uuml;berwachte Systeme) schicken ermittelte Werte an den zentralen\nULS Server, der diese dann strukturiert in eine Datenbank einsortiert. Ein\nWert geh&ouml;rt immer zu einem bestimmten Zeitstempel (siehe auch \"Struktur der\nDaten\"). Daten werden f&uuml;r 14 Tage aufbewahrt (konfigurierbar).</p>\n\n<p>Auswerten:<br />\n&Uuml;ber einen Webbrowser k&ouml;nnen die gespeicherten (und die komprimierten, s.u.)\nWerte tabellarisch und grafisch angezeigt werden (nur numerisch und\nStart-Stop-Zeiten). Daten aus verschiedenen Servern k&ouml;nnen f&uuml;r frei\ndefinierbare Zeitbereiche in Auswertungen miteinander kombiniert werden.\nSolche Kombinationen lassen sich als Favoriten abspeichern.</p>\n\n<p>&Uuml;berwachen:<br />\nF&uuml;r hinterlegte &Uuml;berwachungen werden zyklisch die gespeicherten Daten\n&uuml;berpr&uuml;ft und ggf eine Benachrichtigung ausgel&ouml;st. Benachrichtigungen\nerfolgen per E-Mail (direkt, Remedy, SMS) oder per SNMP (ZIS). &Uuml;berpr&uuml;ft wird\nu.a. auf die Verletzung von definierten Grenzwerten und das Ausbleiben von\nDaten nach Ablauf einer angegebenen Frist.</p>\n\n<p>Automatisiertes Definieren von &Uuml;berwachungen:<br />\n&Uuml;berwachungen k&ouml;nnen als &uuml;bergeordnete Regel hinterlegt werden. Diese Regeln\nwerden t&auml;glich gepr&uuml;ft und ggf werden daraus konkrete &Uuml;berwachungen erzeugt\n(s.o.).</p>\n\n<p>Berichte erstellen:<br />\nEs k&ouml;nnen Berichte als eine Zusammenstellung von Auswertungen f&uuml;r Zeitr&auml;ume\ndefiniert werden. &Uuml;ber einen vergebenen Namen k&ouml;nnen alle zugelassenen\nBenutzer diesen Bericht ausf&uuml;hren. &Uuml;ber einen Wochenplan kann ein Bericht\nauch als PDF Dokument t&auml;glich an E-Mail Adressen verschickt werden.</p>\n\n<p>Komprimieren:<br />\nDaten k&ouml;nnen nach Regeln &uuml;ber Funktionen komprimiert und langfristig\naufbewahrt werden. Die Komprimierung kann st&uuml;ndlich, t&auml;glich, w&ouml;chentlich\noder monatlich erfolgen.</p>\n\n<h3>Struktur der Daten</h3>\n\n<p>Jeder Wert geh&ouml;rt exakt zu einer Kombination aus Zeitstempel, Detail und\nEinheit, Testschritt, Sektion und Server. Jeder Server ist exakt einem\nVerfahren zugeordnet.</p>\n\n<p>Ein <span style=\"font-weight: bold\">Verfahren</span> hat mehrere Server\n(zB \"RASCHREG\", \"WSCCL1N1\", \"lvabspd01\"),<br />\nein <span style=\"font-weight: bold\">Server</span> hat mehrere Sektionen (zB\n\"System\", \"Windows\", \"Informix\", \"Oracle\", \"Application Server\"),<br />\neine <span style=\"font-weight: bold\">Sektion</span> hat mehrere Testschritte\n(zB \"System Load\", \"cpu\", \"redo logs\", \"Database Monitor: PKS\"),<br />\nein <span style=\"font-weight: bold\">Testschritt</span> hat mehrere Details\n(zB \"%idle\", \"usage cpu 0\", \"redo writes\", \"Faelle\"),<br />\nzu einem <span style=\"font-weight: bold\">Detail</span> werden die <span\nstyle=\"font-weight: bold\">Werte</span> mit dem dazugeh&ouml;rigen <span\nstyle=\"font-weight: bold\">Zeitstempel</span> abgelegt.</p>\n\n<p>Im linken Frame des Browsers navigiert man durch Verfahren -- Server --\nSektionen -- Testschritte und im rechten Frame wird eine Tabelle mit den\nDetails und deren Werte zu den Zeitstempeln angezeigt.</p>\n\n<h3>Agenten</h3>\n\n<p>Zu &uuml;berwachende Einheiten m&uuml;ssen selbst Skripts ausf&uuml;hren und die Werte an\nden ULS Server &uuml;bermitteln, bzw werden Skripts auf Servern ausgef&uuml;hrt, um\nEinheiten zu &uuml;berwachen, die selbst keine Skripts ausf&uuml;hren k&ouml;nnen oder\nd&uuml;rfen. Diese Skripts werden als Agenten bezeichnet.</p>\n\n<p>Agenten sind vorhanden f&uuml;r: Linux, HP-UX, Windows Betriebssystem und\nEreignisprotokoll, Networker, Oracle, Informix, Jboss, Durchsuchen von\nProtokolldateien nach Textmustern, ping-Statistiken.</p>\n\n<p>Einige Agenten f&uuml;r die Ermittlung spezieller Werte f&uuml;r bestimmte\nVerfahren: INPOL, ARTUS, EGB</p>','','ConfigHints'),(163,'de','set_kombilimits','<p>KombiLimits kombinieren die Werte von mehreren Detaiils eines Testschritts miteinander \nüber Operatoren und/oder Funktionen zu einer komplexen Überwachung.</p>\n<p>Es können beliebig viele KombiLimit-Überwachungen definiert werden. Die Kontrolle\nerfolgt zyklisch alle 5 Minuten.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<td>Tabellenspalte</td>\n<td>Erklärung</td>\n</tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Bedingung</td>\n<td>Hier wird die zu prüfende Bedingung eingetragen. Die unterstützten\nFunktionen und Operatoren sind weiter unten beschrieben, \nsiehe \"Funktionen in KombiLimits\".</td>\n</tr>\n<tr>\n<td>Info<br>\nWarn<br>\nFehler</td>\n<td>Festlegen des Prioritätsniveaus.</td>\n</tr>\n<tr>\n<td>Benachricht.Modus</td>\n<td>Die Kombilimit-Überwachung kann deaktiviert oder aktiviert werden.<br>\nDie Benachrichtigung erfolgt erstmals nach Verletzung des definierten Zeitraums und danach erfolgt die Wiederbenachrichtigung, falls die Bedingung immer noch erfüllt ist, entsprechend dem gewählten Benachrichtigungsmodus.\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Modus</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>1h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach einer Stunde.</td>\n  </tr>\n  <tr>\n    <td>12h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach zwölf Stunden.</td>\n  </tr>\n  <tr>\n    <td>24h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach 24 Stunden.</td>\n  </tr>\n </tbody>\n</table>\n</tr>\n<tr>\n<td>Meldung</td>\n<td>Hier kann eine benutzerdefinierte Meldung (max 3000 Zeichen) eingetragen werden,\neine standardisierte Meldung wird bei einer Benachrichtigung immer geschickt. Siehe\n\"Platzhalter und Funktionen in Meldung\"</td>\n</tr>\n<tr>\n<td>Meldungsziel</td>\n<td>Zwei für dieses Verfahren freigegebene Benachrichtigungsziele können über die \nDrop-Down-Listen eingestellt werden.</td>\n</tr>\n<tr>\n<td>\nAktionen\n</td>\n    <td>Link <span class=\"internal_link\">Änderungen</span> zur Anzeige der Bearbeitungshistorie.<br>\n      Löschen des Limits.<br>\n      Zu einer Verfahrens- oder Gruppen-Überwachung umwandeln. Danach kann über den Link <span class=\"internal_link\">auto</span> die Auto-Limit-Überwachung aufgerufen \n    und ggf abgeändert werden.<br>\n    Über die Checkbox \"zurücksetzen\" können die Änderungen zum Verfahrens- oder Gruppen-Limit rückgängig gemacht werden.<br>\n   Link <span class=\"internal_link\">Ü.Pause</span> zum direkten Anlegen einer Überwachungspause.\n    </td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Funktionen in KombiLimits</h4>\n<p>Für jede Bedingung können ein oder mehrere Vergleiche eingetragen werden, die mit logischen Operatoren miteinander verbunden sind. Ggf sollten Vergleiche eingeklammert werden. Die in dieser Tabelle verwendeten Platzhalter sind weiter unten beschrieben. Konstante Zahlen können verwendet werden.</p>\n<p>Beispiel für Bedingung:</p>\n<pre>\n  $VALUE_OF(number of logs not backed up) &gt; $VALUE_OF(number of logs) / 2 &amp;&amp; $VALUE_OF(duration/s) &gt; 37\n</pre>\n\n<h4>Funktionen in KombiLimits</h4>\n\n<!-- <h4>Funktionen in KombiDetails und KombiLimits</h4>  --> \n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n</thead>\n<tbody>\n<tr>\n  <td>\n    $ACCEL_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td> \n    Ermittelt die Krümmung der Kurve durch die Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen. \n    Es werden mindestens drei Werte benötigt. Das Ergebnis wird in \n    <tt>unit/h<sup>2</sup></tt> berechnet.\n  </td>\n</tr>\n<tr>\n  <td>\n    $AVERAGE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Berechnet den arithmetischen Mittelwert für die Werte \n    des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $COUNT_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $DIFFER_OF(<tt>detail</tt>[/<tt>unit</tt>][,<tt>range</tt>])\n  </td>\n  <td>\n    Ermittelt, ob sich der erste und letzte Wert aus <tt>range</tt> \n    (Anzahl oder Zeitbereich) unterscheiden. \n    Als Standard wird <tt>range</tt> mit 2 belegt. \n    Das Ergebnis ist 0 (null) oder 1.\n  </td>\n</tr>\n<tr>\n  <td>\n    $FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den ersten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRAD_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den Gradienten (lineare Steigung) der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRADIENT(<tt>detail</tt>[/<tt>unit</tt>],<tt>time_range</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet die lineare Steigung pro <tt>time_range</tt>\n    (Standard: 1d) für Werte, die für das angegebene Detail \n    vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorhanden sind. Bei der Berechnung wird prinzipiell von \n    einem linearen Wachstum ausgegangen. Ist <tt>time_past</tt> \n    nicht angegeben, werden die letzten 24h verwendet (eine Zahl \n    allein wird als Tage interpretiert).\n    <br><br>\n    Genauer: aus allen Werten, die vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen \n    Abweichung ermittelt. Die Steigung dieser Geraden wird auf den <tt>time_range</tt>\n    umgerechnet. Man kann also die Werte der letzten 24h betrachten (<tt>time_past</tt>\n    = 24h) und daraus den Gradienten pro 8 Stunden (<tt>time_range</tt> = 8h) berechnen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST-FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom letzten zum ersten\n    Wert aus allen Werten des <tt>detail</tt>, die \n    in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>Ermittelt das Maximum der Werte des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX-MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom Maximalwert zum Minimalwert\n    aus allen Werten des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt das Minimum der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREDICTION(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>time_future</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet einen (in der Zukunft) zu erwartenden Wert\n    anhand der für ein Detail vorliegenden Werte innerhalb eines\n    zurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\n    werden, deren Werte einem linearen Wachstum unterliegen. Wird <tt>time_past</tt> \n    nicht angegeben, dann wird <tt>time_future</tt> verwendet.\n    <br><br>\n    Genauer: aus allen Werten, die in der ersten Hälfte von <tt>time_past</tt>\n    liegen und die in der zweiten Hälfte von <tt>time_past</tt>\n    liegen, wird jeweils ein arithmetischer Mittelwert gebildet und daraus die Steigung der\n    angenommenen linearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der \n    ermittelten Steigung wird der Endwert zu <tt>time_future</tt> berechnet.<br>\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREV_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den vorletzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td>\n    $REGCOUNT(<tt>detail</tt>[/<tt>unit</tt>],<tt>regexp</tt>,<tt>time_range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Treffer (matching pattern) des\n    regulären Ausdrucks <tt>regexp</tt> in allen Werten des <tt>detail</tt>,\n    die in <tt>time_range</tt> (nur Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $STD_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Standardabweichung der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $SUM_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Summe der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $VALUE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n</tbody>\n</table>\n\n\n\n<h4>Variable Ausdrücke in KombiLimits</h4>\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\n<h4>Operatoren in der definition von KombiLimits</h4>\n\n<p>Die Operatoren können verwendet werden, um verschiedene Funktionen miteinander zu kombinieren.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>MySQL Operatoren</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody>\n<tr>\n<td>&lt;, &gt;, =, !=, &lt;&gt;, &gt;=, &lt;=</td>\n<td>kleiner, größer, gleich, ungleich, ungleich, größer gleich, kleiner gleich</td>\n</tr>\n<tr>\n<td>+, -, *, /</td>\n<td>Addition, Subtraktion, Multiplikation, Division</td>\n</tr>\n<tr>\n<td>&amp;&amp;, AND, ||, OR</td>\n<td>logisches UND, logisches ODER</td>\n</tr>\n<tr>\n<td>( )</td>\n<td>Klammern für die Festlegung der Reihenfolge der Abarbeitung der Ausdrücke.</td>\n</tr>\n</tbody>\n</table>\n<p>\nNeben den oben beschriebenen Operatoren können auch fast alle\nFunktionen der MySQL Datenbank verwendet werden. Im folgenden nur ein\npaar Beispiele. Die vollständige Liste ist unter z.B.: \n<a target=\"_blank\" href=\"http://dev.mysql.com/doc/refman/5.0/en/string-functions.html\">MySQL 5.0 Reference Manual :: 11 Functions and Operators</a> \nnachzulesen. In den Funktionen können NICHT <tt>detail</tt>[/<tt\">unit</tt>] direkt \nverwendet werden, sondern nur über die Verwendung obiger Funktionen.\n</p>\n<p>Beispiel:</p>\n<pre>\n  ABS($VALUE_OF(mittlere Antwortzeit) - $VALUE_OF(Antwortzeit)) &gt;= 1.5\n</pre>\n\n\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in Meldung</h4>\n\n<p>Im Text von \'Meldung\' können folgende Platzhalter und Funktionen\nverwendet werden, die vor der Versendung der Benachrichtigung durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Platzhalter</td>\n    <td>wird ersetzt durch</td>\n    <td style=\"text-align: center;\">Limits</td>\n    <td style=\"text-align: center;\">KombiLimits</td>\n    <td style=\"text-align: center;\">isAlive</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGEOVER</td>\n    <td>die Anzahl der Werte oder Zeitbereich von \"mitteln über\"</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$COMPARE</td>\n    <td>den angewandten Vergleich</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$DETAIL</td>\n    <td>das Detail (die Überschrift der Tabellenspalte)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$DOMAIN</td>\n    <td>die Bezeichnung des Verfahrens</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTDATE</td>\n    <td>der Zeitstempel des letzten vorhanden Werts</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTVALUE</td>\n    <td>der letzte Wert</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$LIMIT</td>\n    <td>den verletzten Limit (Info/Warn/Fehler)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$PREVVALUE</td>\n    <td>der Wert des vorigen Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$SAVEDATE</td>\n    <td>der Zeitstempel, an dem der letzte Wert im ULS eingegangen ist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$SECTION</td>\n    <td>die Sektion</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$SERVER</td>\n    <td>den Namen des Rechners</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TESTSTEP</td>\n    <td>die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$TIMEDIFF</td>\n    <td>die festgestellte Zeitdifferenz (die die Frist überschritten hat und zur Auslösung der Benachrichtigung\n    geführt hat)</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TIMELIMIT</td>\n    <td>die definierte Frist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$UNIT</td>\n    <td>die Einheit des Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$VALUE</td>\n    <td>der (uU berechnete) Wert, der die Limits-Verletzung ausgelöst hat</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n</tbody>\n</table>\n\n<p>Funktionen</p>\n<p>Die folgenden Funktionen könnne in Meldungstexten verwendet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr style=\"font-weight: bold;\">\n    <td>Funktion</td>\n    <td>Berechnung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGE_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Berechnet den arithmetischen Mittelwert für eine Anzahl von Werten eines Details.</td>\n  </tr>\n  <tr>\n    <td>$COUNT_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Ermittelt die Anzahl der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$DEV_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n  <td>Ermittelt die Standardabweichung der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n  <td>$DIFF_OF(&lt;detail&gt;[/&lt;unit&gt;])</td>\n<td>Ermittelt die Differenz (Unix Kommando diff) der letzten beiden Werte (können\nauch Dateien sein) und liefert maximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei würde\nes sich sinnvollerweise um Werte mit Textinhalten handeln. Unterstützte Dateiformate mit Komprimierung\nsind:.gz und .bz2. Alle anderen Dateiformate werden verglichen wie sie sind.\n</td>\n</tr><tr>\n<td>$DIFFER_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt, ob der erste Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen, sich&nbsp; zum letzten Wert unterscheidet. Ergibt 0 oder 1 als Ergebnis.</td>\n</tr><tr>\n<td>$FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$GRAD_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den Gradienten (lineare Steigung) der Werte des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_range&gt; [ &lt;time_past&gt;])</td>\n<td>Berechnet die lineare Steigung pro &lt;time_range&gt; (Standard: 1d) für Werte, die\nfür das angegebene Detail vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist &lt;time_past&gt; nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den &lt;time_range&gt;\numgerechnet. Man kann also die Werte der letzten 24h\nbetrachten (&lt;time_past&gt; = 24h) und daraus den Gradienten pro 8 Stunden\n(&lt;time_range&gt; = 8h) berechnen.\n</td>\n</tr>\n<tr>\n<td>$LAST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den letzten (aktuellsten) Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen. Dies kann ein neuerer&nbsp;Wert sein als der über $VALUE_OF ermittelte.</td>\n</tr><tr>\n<td>$LAST-FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Maximum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Minimum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_future&gt; [, &lt;time_past&gt;])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der für ein Detail vorliegenden Werte innerhalb eines\nzurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte einem linearen Wachstum unterliegen. Wird &lt;time_past&gt; nicht\nangegeben, dann wird &lt;time_future&gt; verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten Hälfte von &lt;time_past&gt; liegen\nund die in der zweiten Hälfte von &lt;time_past&gt; liegen, wird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der angenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten Steigung wird der Endwert zu &lt;time_future&gt; berechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(&lt;detail&gt;[/&lt;unit&gt;],&lt;&gt; &lt;regexp&gt;, &lt;time_range&gt;)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregulären Ausdrucks &lt;regexp&gt; in allen Werten des &lt;detail&gt;,\ndie in &lt;time_range&gt; (nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Summe der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$UNIT_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ermittelt die Einheit des &lt;detail&gt;</td>\n</tr><tr>\n<td>$VALUE_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ist&nbsp;der&nbsp;Wert des &lt;detail&gt; zum Zeitpunkt der Überwachungskontrolle. Dies ist nicht unbedingt der neueste Wert für dieses &lt;detail&gt;. </td>\n</tr>\n</tbody>\n</table>\n\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n','','ConfigHints'),(164,'de','set_kombidetails','<p>KombiDetails kombinieren die Werte von mehreren Details eines Testschritts miteinander \nüber Operatoren und/oder Funktionen zu einem neuen Detail (Tabellenspalte).</p>\n<p>Es können beliebig viele KombiDetail Definitionen definiert werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>\nDetail<br>\nEinheit\n</td>\n<td>Es wird die exakte Bezeichnung des gewünschten KombiDetails (Tabellenspaltenüberschrift) \nund die dazu gewünschte Einheit festgelegt.</td>\n</tr><tr>\n<td>Ausdruck</td>\n<td>Hier wird die zu verwendende Berechnung, eine Kombination aus ULS-Funktionen und \nMySQL Operatoren und Funktionen,  eingetragen. \nSiehe \"Funktionen in KombiDetails\"</td>\n</tr>\n<td>\naktiv<br>\nlöschen<br>\nAuto\n</td>\n<td>Damit wird diese KombiDetail Definition deaktiviert, aktiviert, gelöscht oder zu einer \nAuto-KombiDetail Definition umgewandelt. Danach kann über den Link \n<span style=\"color: rgb(0, 0, 255);\">auto</span> die Auto-KombiDetail Definition aufgerufen \nund ggf abgeändert werden.\n</td></tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Funktionen in KombiDetails</h4>\n<p>Für jeden Ausdruck können ein oder mehrere Funktionen eingetragen werden, die ggf mit  Operatoren miteinander verbunden sind.</p>\n<p>Beispiele:</p>\n<pre>\n  $REF(numeric 2) 0\n  ABS($LAST-FIRST_OF(numeric 8,2))\n  100 - $VALUE_OF(%idle)\n</pre>\n\n<h4>Funktionen in KombiDetails</h4>\n\n<!-- <h4>Funktionen in KombiDetails und KombiLimits</h4>  --> \n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n</thead>\n<tbody>\n<tr>\n  <td>\n    $ACCEL_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td> \n    Ermittelt die Krümmung der Kurve durch die Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen. \n    Es werden mindestens drei Werte benötigt. Das Ergebnis wird in \n    <tt>unit/h<sup>2</sup></tt> berechnet.\n  </td>\n</tr>\n<tr>\n  <td>\n    $AVERAGE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Berechnet den arithmetischen Mittelwert für die Werte \n    des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $COUNT_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $DIFFER_OF(<tt>detail</tt>[/<tt>unit</tt>][,<tt>range</tt>])\n  </td>\n  <td>\n    Ermittelt, ob sich der erste und letzte Wert aus <tt>range</tt> \n    (Anzahl oder Zeitbereich) unterscheiden. \n    Als Standard wird <tt>range</tt> mit 2 belegt. \n    Das Ergebnis ist 0 (null) oder 1.\n  </td>\n</tr>\n<tr>\n  <td>\n    $FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den ersten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRAD_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den Gradienten (lineare Steigung) der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRADIENT(<tt>detail</tt>[/<tt>unit</tt>],<tt>time_range</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet die lineare Steigung pro <tt>time_range</tt>\n    (Standard: 1d) für Werte, die für das angegebene Detail \n    vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorhanden sind. Bei der Berechnung wird prinzipiell von \n    einem linearen Wachstum ausgegangen. Ist <tt>time_past</tt> \n    nicht angegeben, werden die letzten 24h verwendet (eine Zahl \n    allein wird als Tage interpretiert).\n    <br><br>\n    Genauer: aus allen Werten, die vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen \n    Abweichung ermittelt. Die Steigung dieser Geraden wird auf den <tt>time_range</tt>\n    umgerechnet. Man kann also die Werte der letzten 24h betrachten (<tt>time_past</tt>\n    = 24h) und daraus den Gradienten pro 8 Stunden (<tt>time_range</tt> = 8h) berechnen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST-FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom letzten zum ersten\n    Wert aus allen Werten des <tt>detail</tt>, die \n    in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>Ermittelt das Maximum der Werte des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX-MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom Maximalwert zum Minimalwert\n    aus allen Werten des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt das Minimum der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREDICTION(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>time_future</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet einen (in der Zukunft) zu erwartenden Wert\n    anhand der für ein Detail vorliegenden Werte innerhalb eines\n    zurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\n    werden, deren Werte einem linearen Wachstum unterliegen. Wird <tt>time_past</tt> \n    nicht angegeben, dann wird <tt>time_future</tt> verwendet.\n    <br><br>\n    Genauer: aus allen Werten, die in der ersten Hälfte von <tt>time_past</tt>\n    liegen und die in der zweiten Hälfte von <tt>time_past</tt>\n    liegen, wird jeweils ein arithmetischer Mittelwert gebildet und daraus die Steigung der\n    angenommenen linearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der \n    ermittelten Steigung wird der Endwert zu <tt>time_future</tt> berechnet.<br>\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREV_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den vorletzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n<!--\n<tr>\n  <td>\n    $REGCOUNT(<tt>detail</tt>[/<tt>unit</tt>],<tt>regexp</tt>,<tt>time_range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Treffer (matching pattern) des\n    regulären Ausdrucks <tt>regexp</tt> in allen Werten des <tt>detail</tt>,\n    die in <tt>time_range</tt> (nur Zeitbereich) liegen.\n  </td>\n</tr>\n-->\n<tr>\n  <td>\n    $STD_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Standardabweichung der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $SUM_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Summe der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $VALUE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n</tbody>\n</table>\n\n\n\n<h4>Variable Ausdrücke in KombiDetails</h4>\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\n<h4>Operatoren in der Definition von KombiDetails</h4>\n\n<p>Die Operatoren können verwendet werden, um verschiedene Funktionen miteinander zu kombinieren.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>MySQL Operatoren</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody>\n<tr>\n<td>&lt;, &gt;, =, !=, &lt;&gt;, &gt;=, &lt;=</td>\n<td>kleiner, größer, gleich, ungleich, ungleich, größer gleich, kleiner gleich</td>\n</tr>\n<tr>\n<td>+, -, *, /</td>\n<td>Addition, Subtraktion, Multiplikation, Division</td>\n</tr>\n<tr>\n<td>&amp;&amp;, AND, ||, OR</td>\n<td>logisches UND, logisches ODER</td>\n</tr>\n<tr>\n<td>( )</td>\n<td>Klammern für die Festlegung der Reihenfolge der Abarbeitung der Ausdrücke.</td>\n</tr>\n</tbody>\n</table>\n<p>\nNeben den oben beschriebenen Operatoren können auch fast alle\nFunktionen der MySQL Datenbank verwendet werden. Im folgenden nur ein\npaar Beispiele. Die vollständige Liste ist unter z.B.: \n<a target=\"_blank\" href=\"http://dev.mysql.com/doc/refman/5.0/en/string-functions.html\">MySQL 5.0 Reference Manual :: 11 Functions and Operators</a> \nnachzulesen. In den Funktionen können NICHT <tt>detail</tt>[/<tt\">unit</tt>] direkt \nverwendet werden, sondern nur über die Verwendung obiger Funktionen.\n</p>\n<p>Beispiel:</p>\n<pre>\n  ABS($VALUE_OF(mittlere Antwortzeit) - $VALUE_OF(Antwortzeit)) &gt;= 1.5\n</pre>\n\n\n','','ConfigHints'),(167,'de','set_limits','<!-- Changes:\n  set_limits, de\n\n  -----\n  2018-06-21, sandix: Changed description for \"action\"\n  2016-09-07, roveda: Changed to new format\n\n  -----\n  includes: \n\n-->\n<h2>Limits festlegen</h2>\n\n<p>\n  Eine Limit-Überwachungen löst eine Benachrichtigung aus, \n  sobald ein eingehender Wert einen definierten Grenzwert verletzt.\n</p>\n<p>\n  Limits können zu allen Details eingetragen,\n  gelöscht oder geändert werden. Die Kontrolle auf verletzte Grenzwerte\n  findet in zyklischen Zeitintervallen von 5 Minuten statt. Generell wird\n  die Verwendung von Auto-Limits gegenüber expliziter Limit-Definitionen \n  für Verfahren - Server - Sektion - Teststchritt - Detail - Einheit Kombinationen \n  vorgezogen.\n</p>\n\n<table>\n  <thead>\n    <tr>\n      <td>Tabellenspalte</td>\n      <td>Erklärung</td>\n    </tr>\n  </thead>\n  <tbody>\n  <tr>\n    <td>Detail</td>\n    <td>Für jedes existierende Detail wird\n    eine Zeile zum Festlegen von Limits angezeigt. Am Ende der Tabelle wird\n    eine Zeile zum Eintragen von weiteren Limits angeboten.\n    </td>\n  </tr>\n  <tr>\n    <td>letzter Wert</td>\n    <td>Der letzte (neueste) Wert für das jeweilige Detail wird angezeigt.</td>\n  </tr>\n  <tr>\n    <td>Funktion</td>\n    <td>Es wird festgelegt, welche Funktion auf die Werte (siehe: <a href=\"#_limit_functions_de\">Limit-Funktionen</a>) angewendet werden soll.</td>\n  </tr>\n  <tr>\n    <td>Argument</td>\n    <td>\n      Festlegen, wieviele Werte oder welcher Zeitbereich für die Funktion verwendet werden sollen, \n      bevor der Vergleich ausgeführt wird. Bestimmte Funktionen benötigen bestimmte Angaben, bzw. \n      ignorieren abweichende Angaben (z.B. Last, Differ). Siehe <a href=\"#argument\">Argument</a>.\n    </td>\n  </tr>\n  <tr>\n    <td>Vergleich</td>\n    <td>\n      Der Vergleichsoperator, der mit dem berechneten oder ermittelten Wert (auf Basis von Funktion und Argument) \n      bei der Prüfung gegen die Limits verwendet wird.\n    </td>\n  </tr>\n  <tr>\n    <td>Info</td>\n    <td>\n      Grenzwert, bei dem eine Benachrichtigung mit Info Level ausgelöst wird.\n      Das Auslösen der Benachrichtigung kann beim Meldungsziel über die Checkbox <tt>[x] I</tt> aktiviert und deaktiviert werden.\n      Sobald der Info Grenzwert unterschritten, bzw. die Grenzwertbedingung NICHT mehr erfüllt ist (also alles ok ist), \n      wird die Wiederbenachrichtigung aktiv, sodass bei erneuter Verletzung der Grenzwertbedingung sofort eine Benachrichtung erfolgen würde.\n    </td>\n  </tr>\n  <tr>\n    <td>Warn</td>\n    <td>\n      Grenzwert, bei dem eine Benachrichtigung mit Warn Level ausgelöst wird.\n      Das Auslösen der Benachrichtigung kann beim Meldungsziel über die Checkbox <tt>[x] W</tt> aktiviert und deaktiviert werden.\n    </td>\n  </tr>\n  <tr>\n    <td>Fehler</td>\n    <td>\n      Grenzwert, bei dem eine Benachrichtigung mit Fehler Level ausgelöst wird.\n      Das Auslösen der Benachrichtigung kann beim Meldungsziel über die Checkbox <tt>[x] E</tt> aktiviert und deaktiviert werden.\n    </td>\n  </tr>\n  <tr>\n    <td>Excludes</td>\n    <td>\n      Werte, die ignoriert werden sollen. Meistens nur bei Logfiles sinnvoll.\n    </td>\n  </tr>\n  <tr>\n    <td>Benachricht.Modus</td>\n    <td>\n      Die Limit-Überwachung kann deaktiviert oder aktiviert werden.<br>\n      Die Benachrichtigung erfolgt erstmals nach Verletzung der hinterlegten Grenzwertbedingung und nachfolgend, \n      falls die Grenzwertbedingung immer noch erfüllt ist, nach Ablauf des durch den gewählten Benachrichtigungsmodus gewählten Zeitraum.\n    <table>\n    <thead>\n      <tr>\n        <td>Modus</td>\n        <td>Erklärung</td>\n      </tr>\n    </thead>\n    <tbody>\n      <tr>\n        <td>sammeln</td>\n        <td>\n          Sammelt eingehende Textwerte, die hinterlegte Grenzwertbedingungen verletzen, über ca 10 Minuten, \n          bevor eine Wiederbenachrichtigung ausgelöst wird.\n        </td>\n      </tr>\n      <tr>\n        <td>jeder Wert</td>\n        <td>Jeder(!) eingehende Wert, der die hinterlegte Grenzwertbedingung verletzt, löst eine Benachrichtigung aus.\n        </td>\n      </tr>\n      <tr>\n        <td>1h</td>\n        <td>Die Wiederbenachrichtigung erfolgt nach einer Stunde, falls die hinterlegte Grenzwertbedingung immer noch verletzt ist.</td>\n      </tr>\n      <tr>\n        <td>6h</td>\n        <td>Die Wiederbenachrichtigung erfolgt nach 6 Stunden, falls die hinterlegte Grenzwertbedingung immer noch verletzt ist.</td>\n      </tr>\n      <tr>\n        <td>12h</td>\n        <td>Die Wiederbenachrichtigung erfolgt nach 12 Stunden, falls die hinterlegte Grenzwertbedingung immer noch verletzt ist.</td>\n      </tr>\n      <tr>\n        <td>24h</td>\n        <td>Die Wiederbenachrichtigung erfolgt nach 24 Stunden, falls die hinterlegte Grenzwertbedingung immer noch verletzt ist.</td>\n      </tr>\n     </tbody>\n    </table>\n    Besonderheit: Bei Nicht-Verletzung des Info Grenzwerts wird die Wiederbenachrichtigung zurückgesetzt.\n    <!-- kein Level ist erfüllt und Info ist gesetzt, dann wird die Wiederbenachrichtigung zurückgesetzt -->\n    </td>\n  </tr>\n  <tr>\n    <td>Meldung</td>\n    <td>\n      Hier kann eine benutzerdefinierte Meldung (max 3000 Zeichen)\n      eingetragen werden, eine standardisierte Meldung wird bei\n      Benachrichtigungen immer geschickt. In der Meldung können Platzhalter\n      und Funktionen verwendet werden, siehe \"Platzhalter und Funktionen in Meldung\"\n    </td>\n  </tr>\n  <tr>\n    <td>Meldungsziel</td>\n    <td>Zwei für dieses Verfahren freigegebene Benachrichtigungsziele können über die \n    Drop-Down-Listen eingestellt werden.<br>\n    Die Checkboxen I W F (Info/Warn/Fehler) legen die Prioritäten \n    fest, bei deren Verletzung eine Benachrichtigung an das jeweilige\n    Meldungsziel geschickt wird.</td>\n    </td>\n  </tr>\n  <tr>\n    <td>\n    Aktionen\n    </td>\n    <td>Link <span class=\"internal_link\">Änderungen</span> zur Anzeige der Bearbeitungshistorie.<br>\n      Löschen des Limits.<br>\n      Zu einer Verfahrens- oder Gruppen-Überwachung umwandeln. Danach kann über den Link <span class=\"internal_link\">auto</span> die Auto-Limit-Überwachung aufgerufen \n    und ggf abgeändert werden.<br>\n    Über die Checkbox \"zurücksetzen\" können die Änderungen zum Verfahrens- oder Gruppen-Limit rückgängig gemacht werden.<br>\n   Link <span class=\"internal_link\">Ü.Pause</span> zum direkten Anlegen einer Überwachungspause.\n    </td>\n  </tr>\n  <tr>\n    <td>Bemerkung</td>\n    <td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n  </tr>\n  </tbody>\n</table>\n\n<hr>\n \n<h4>Vergleichsoperatoren</h4>\n<p>\n  Erklärung der einsetzbaren Vergleichsoperatoren für die\n  Definition von Limits. Die verwendbaren Vergleichsoperatoren sind\n  teilweise abhängig von den Datentypen der Werte, auf die sie\n  angewendet werden.\n</p>\n<p><span style=\"font-weight: bold;\">Definition</span>\nvon Ausdrücken, die zur weiteren Beschreibung der Vergleichsoperatoren verwendet werden:</p>\n<table>\n<thead>\n<tr>\n<td>Ausdruck</td>\n<td>Bedeutung</td>\n</tr>\n</thead>\n<tbody>\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent für die Menge von Integer und Float verwendet</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird für beliebige Textausdrücke verwendet</td>\n</tr>\n<tr>\n<td>&lt;value&gt;</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n<tr>\n<td>&lt;limit&gt;</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler \n<!-- als DiffLimit (TODO) --> eingetragen ist</td>\n</tr>\n<tr>\n<td>&lt;regexp&gt;</td>\n<td>ist ein regulärer Ausdruck, der POSIX 1003.2 (wie zB in\n\"man 7 regex\" beschrieben) entsprechen muss und der bei\nInfo/Warn/Fehler eingetragen ist. Er wird anstelle des &lt;limit&gt; verwendet</td>\n</tr>\n</tbody>\n</table>\n\n<p>Vor dem Vergleich werden die Datentypen von &lt;value&gt;\nund &lt;limit&gt; angepasst. Die <span style=\"font-weight: bold;\">Datentypumwandlung</span>\nerfolgt nach folgender Vorschrift:</p>\n<table>\n<thead >\n  <tr>\n    <td>Datentyp<br>\n        &lt;value&gt;</td>\n    <td>Datentyp<br>\n        &lt;limit&gt;</td>\n    <td>Vergleich wird durchgeführt als Datentyp</td>\n  </tr>\n</thead>\n<tbody>\n<tr>\n  <td>Integer</td>\n  <td>Integer</td>\n  <td>Integer</td>\n</tr>\n<tr>\n  <td>Integer</td>\n  <td>Float</td>\n  <td>Float</td>\n</tr>\n<tr>\n  <td>Float</td>\n  <td>Integer</td>\n  <td>Float</td>\n</tr>\n<tr>\n  <td>String</td>\n  <td>beliebig</td>\n  <td>String</td>\n</tr>\n<tr>\n  <td>beliebig</td>\n  <td>String</td>\n  <td>String<br>\n</td>\n</tr>\n</tbody>\n</table>\n\n<p>Allgemein gilt dabei für die Vergleiche:</p>\n<ul>\n  <li>Bei String-Vergleichen wird Groß-Kleinschreibung unterschieden.</li>\n  <li>\"!\" ist die Negation des Vergleichs.</li>\n  <li>\"|\"\n    <ul>\n      <li>Integer und Float: bilden Absolutwerte von beiden Ausdrücken bevor verglichen wird (abs)</li>\n      <li>String: vergleicht beide Ausdrücke unabhängig von Groß-Kleinschreibung (ignore case)</li>\n    </ul>\n  </li>\n</ul>\n<p>\n  <span class=\"note\">Hinweis:</span>\n  Die (Text-)Vergleiche erfolgen gegen den\n  gesamten Textausdruck eines Wertes, liegen mehrere Textausdrücke zum\n  gleichen Zeitstempel vor, so wird nur der LETZTE! Textausdruck\n  verglichen.\n</p>\n\n<table>\n  <thead>\n    <tr>\n      <td style=\"text-align: center;\">Operand</td>\n      <td style=\"text-align: center;\">Vergleichsoperator</td>\n      <td style=\"text-align: center;\">Operand</td>\n      <td>durchgeführter Vergleich</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>kleiner</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>kleiner (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>kleiner gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>kleiner gleich (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>größer</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>größer (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>größer gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>größer gleich (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>gleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>gleich (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>ungleich</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>ungleich (abs/ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">==</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>gleich, keine Datentypenumwandlung (immer String)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">==|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>gleich, keine Datentypenumwandlung (immer String) (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">!==</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>ungleich, keine Datentypenumwandlung (immer String)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">!==|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td>ungleich, keine Datentypenumwandlung (immer String) (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">~~</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td><tt>value</tt> enthält <tt>limit</tt> als Substring</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">~~|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td><tt>value</tt> enthält <tt>limit</tt> als Substring (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">!~~</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td><tt>value</tt> enthält nicht <tt>limit</tt> als Substring</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">!~~|</td>\n      <td style=\"text-align: center; font-family: monospace;\">limit</td>\n      <td><tt>value</tt> enthält nicht <tt>limit</tt> als Substring (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">~</td>\n      <td style=\"text-align: center; font-family: monospace;\">regexp</td>\n      <td><tt>value</tt> matches <tt>regexp</tt></td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">!~</td>\n      <td style=\"text-align: center; font-family: monospace;\">regexp</td>\n      <td><tt>value</tt> does not match <tt>regexp</tt></td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">~|</td>\n      <td style=\"text-align: center; font-family: monospace;\">regexp</td>\n      <td><tt>value</tt> matches <tt>regexp</tt> (ignore case)</td>\n    </tr>\n    <tr>\n      <td style=\"text-align: center; font-family: monospace;\">value</td>\n      <td style=\"text-align: center; font-family: monospace;\">!~|</td>\n      <td style=\"text-align: center; font-family: monospace;\">regexp</td>\n      <td><tt>value</tt> does not match <tt>regexp</tt> (ignore case) </td>\n    </tr>\n  </tbody>\n</table>\n\n \n<hr>\n \n<h3>Platzhalter und Funktionen in Meldung</h3>\n\n<p>Im Text von \'Meldung\' können folgende Platzhalter und Funktionen\nverwendet werden, die vor der Versendung der Benachrichtigung durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n\n<table>\n<thead >\n  <tr>\n    <td>Platzhalter</td>\n    <td>wird ersetzt durch</td>\n    <td style=\"text-align: center;\">Limits</td>\n    <td style=\"text-align: center;\">KombiLimits</td>\n    <td style=\"text-align: center;\">isAlive</td>\n  </tr>\n</thead> \n<tbody>\n  <tr>\n    <td>$AVERAGEOVER</td>\n    <td>die Anzahl der Werte oder Zeitbereich von <a href=\"#argument\">Argument</a></td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$CLASS</td>\n    <td>die Serverklasse des Servers</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$COMPARE</td>\n    <td>den angewandten Vergleich</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$DETAIL</td>\n    <td>das Detail (die Überschrift der Tabellenspalte)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$DOMAIN</td>\n    <td>die Bezeichnung des Verfahrens</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTDATE</td>\n    <td>der Zeitstempel des letzten vorhanden Werts</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTVALUE</td>\n    <td>der letzte Wert</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$LIMIT</td>\n    <td>den verletzten Limit (Info/Warn/Fehler)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$PREVVALUE</td>\n    <td>der Wert des vorigen Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$SAVEDATE</td>\n    <td>der Zeitstempel, an dem der letzte Wert im ULS eingegangen ist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$SECTION</td>\n    <td>die Sektion</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$SERVER</td>\n    <td>den Namen des Rechners</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TESTSTEP</td>\n    <td>die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$TIMEDIFF</td>\n    <td>die festgestellte Zeitdifferenz (die die Frist überschritten hat und zur Auslösung der Benachrichtigung geführt hat)</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TIMELIMIT</td>\n    <td>die definierte Frist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$UNIT</td>\n    <td>die Einheit des Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$VALUE</td>\n    <td>der (uU berechnete) Wert, der die Limits-Verletzung ausgelöst hat</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n</tbody>\n</table>\n\n<hr>\n\n<h3>Funktionen</h3>\n<p>Die folgenden Funktionen könnnen in Meldungstexten verwendet werden.</p>\n<table>\n  <thead >\n    <tr>\n      <td>Funktion</td>\n      <td>Berechnung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>$AVERAGE_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>Berechnet den arithmetischen Mittelwert für eine Anzahl von Werten eines Details.</td>\n    </tr>\n    <tr>\n      <td>$COUNT_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>Ermittelt die Anzahl der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n    </tr>\n    <tr>\n      <td>$DEV_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>Ermittelt die Standardabweichung der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n    </tr>\n    <tr>\n      <td>$DIFF_OF(&lt;detail&gt;[/&lt;unit&gt;])</td>\n      <td>\n        Ermittelt die Differenz (Unix Kommando diff) der letzten beiden Werte (können\n        auch Dateien sein) und liefert maximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei würde\n        es sich sinnvollerweise um Werte mit Textinhalten handeln. Unterstützte Dateiformate mit Komprimierung\n        sind:.gz und .bz2. Alle anderen Dateiformate werden verglichen wie sie sind.\n      </td>\n    </tr>\n    <tr>\n      <td>$DIFFER_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>\n        Ermittelt, ob der erste Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n        (Anzahl oder Zeitbereich) liegen, sich zum letzten Wert unterscheidet. Ergibt 0 oder 1 als Ergebnis.\n      </td>\n    </tr>\n    <tr>\n      <td>$FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>Ermittelt den ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n    </tr>\n    <tr>\n      <td>$GRAD_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>\n        Ermittelt den Gradienten (lineare Steigung) der Werte des &lt;detail&gt;,\n        die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.\n      </td>\n    </tr>\n    <tr>\n      <td>$GRADIENT(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_range&gt; [ &lt;time_past&gt;])</td>\n      <td>\n        Berechnet die lineare Steigung pro &lt;time_range&gt; (Standard: 1d) für Werte, die\n        für das angegebene Detail vom aktuellen Zeitpunkt bis &lt;time_past&gt;\n        vorhanden sind. Bei der Berechnung wird\n        prinzipiell von einem linearen Wachstum ausgegangen. Ist &lt;time_past&gt; nicht\n        angegeben, werden die letzten 24h\n        verwendet (eine Zahl allein wird als Tage interpretiert).<br>\n        <br>\n        Genauer: aus allen Werten, die vom aktuellen Zeitpunkt bis &lt;time_past&gt;\n        vorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen\n        Abweichung ermittelt. Die Steigung dieser Geraden wird auf den &lt;time_range&gt;\n        umgerechnet. Man kann also die Werte der letzten 24h\n        betrachten (&lt;time_past&gt; = 24h) und daraus den Gradienten pro 8 Stunden\n        (&lt;time_range&gt; = 8h) berechnen.\n      </td>\n    </tr>\n    <tr>\n      <td>$LAST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>\n        Ermittelt den letzten (aktuellsten) Wert aus allen Werten des &lt;detail&gt;,\n        die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen. Dies kann ein neuerer&nbsp;Wert sein als der über $VALUE_OF ermittelte.\n      </td>\n    </tr>\n    <tr>\n      <td>$LAST-FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>Ermittelt die Differenz vom letzten zum ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n    </tr>\n    <tr>\n      <td>$MAX_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>Ermittelt das Maximum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n    </tr>\n    <tr>\n      <td>$MAX-MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>\n        Ermittelt die Differenz vom Maximalwert zum Minimalwert\n        aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n        (Anzahl oder Zeitbereich) liegen.\n      </td>\n    </tr>\n    <tr>\n      <td>$MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>Ermittelt das Minimum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n    </tr>\n    <tr>\n      <td>$PREDICTION(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_future&gt; [, &lt;time_past&gt;])</td>\n      <td>\n        Berechnet einen (in der Zukunft) zu erwartenden Wert\n        anhand der für ein Detail vorliegenden Werte innerhalb eines\n        zurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\n        werden, deren Werte einem linearen Wachstum unterliegen. Wird &lt;time_past&gt; nicht\n        angegeben, dann wird &lt;time_future&gt; verwendet.<br>\n        <br>\n        Genauer: aus allen Werten, die in der ersten Hälfte von &lt;time_past&gt; liegen\n        und die in der zweiten Hälfte von &lt;time_past&gt; liegen, wird jeweils ein\n        arithmetischer Mittelwert gebildet und daraus die Steigung der angenommenen\n        linearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\n        ermittelten Steigung wird der Endwert zu &lt;time_future&gt; berechnet.\n      </td>\n    </tr>\n    <tr>\n      <td>$REGCOUNT(&lt;detail&gt;[/&lt;unit&gt;],&lt;&gt; &lt;regexp&gt;, &lt;time_range&gt;)</td>\n      <td>\n        Ermittelt die Anzahl der Treffer (matching pattern) des\n        regulären Ausdrucks &lt;regexp&gt; in allen Werten des &lt;detail&gt;,\n        die in &lt;time_range&gt; (nur Zeitbereich) liegen.\n      </td>\n    </tr>\n    <tr>\n      <td>$SUM_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n      <td>Ermittelt die Summe der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n    </tr>\n    <tr>\n      <td>$UNIT_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n      <td>Ermittelt die Einheit des &lt;detail&gt;</td>\n    </tr>\n    <tr>\n      <td>$VALUE_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n      <td>Ist&nbsp;der&nbsp;Wert des &lt;detail&gt; zum Zeitpunkt der Überwachungskontrolle. Dies ist nicht unbedingt der neueste Wert für dieses &lt;detail&gt;. </td>\n    </tr>\n  </tbody>\n</table>\n\n<hr>\n\n<h3>Beschreibung der variablen Ausdrücke</h3>\n<table>\n  <thead >\n    <tr>\n      <th>variabler Ausdruck</th>\n      <th>Erklärung</th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td><tt>integer</tt></td>\n      <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n    </tr>\n    <tr>\n      <td><tt>range</tt></td>\n      <td>\n        Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n        <tt>integer</tt> (ohne <tt>time_unit</tt>)\n        legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n        <br>\n        <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n        vorhandene Werte die Funktion angewendet werden soll.\n      </td>\n    </tr>\n    <tr>\n      <td><tt>detail</tt></td>\n      <td>\n        Exakte Bezeichnung des Details. Keine umschließenden\n        einfache oder doppelte Anführungszeichen verwenden!\n      </td>\n    </tr>\n    <tr>\n      <td><tt>unit</tt></td>\n      <td>\n        Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n        angegeben werden muss, falls das Detail allein nicht eindeutig für\n        diesen Testschritt ist.\n      </td>\n    </tr>\n    <tr>\n      <td><tt>as_unit</tt></td>\n      <td>\n        Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n        werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n        besitzen, wie die Einheit des <tt>detail</tt>.\n      </td>\n    </tr>\n    <tr>\n      <td><tt>time_future</tt></td>\n      <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n    </tr>\n    <tr>\n      <td><tt>time_past</tt></td>\n      <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n    </tr>\n    <tr>\n      <td><tt>time_range</tt></td>\n      <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n    </tr>\n    <tr>\n      <td><tt>time_unit</tt></td>\n      <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n    </tr>\n  </tbody>\n</table>\n','_limit_functions_de,_limit_arguments_de','ConfigHints'),(170,'de','publicfavorites','<p>Aktivieren und Deaktivieren von freigegebenen Favoriten von anderen Benutzern.</p>\n<p>Nicht alle freigegebene Favoriten sind für jeden Benutzer sinnvoll einsetzbar. \nJeder Benutzer kann hier festlegen, welche freigegebenen Favoriten er sehen möchte.</p> \n<p>Zur Weiterbearbeitung eines freigegebenen Favoriten im eigenen Umfeld, \nkann dieser unter dem gleichen oder einem anderen Namen als eigener \nFavorit abgespeichert und damit weiterbearbeitet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Tabellenspalte</td>\n<td> Erklärung </td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>Favorit</td>\n  <td>Die Bezeichnung des Favoriten.</td>\n</tr>\n<tr>\n  <td>aktiv</td>\n  <td>Ist für mich unter \"Favoriten\" sichtbar, wenn aktiv.</td>\n</tr>\n<tr>\n  <td>Favorit kopieren nach</td>\n  <td>Markieren und unter gleicher oder anderer Bezeichnung in meine Favoriten kopieren. \n  Diese Funktion steht nur für Auto-Favoriten zur Verfügung.\n  </td>\n</tr>\n</tbody>\n</table>\r','','ConfigHints'),(171,'de','publicreports','<p>Aktivieren und Deaktivieren von freigegebenen Reports von anderen Benutzern.</p>\n<p>Nicht alle freigegebene Reports sind für jeden Benutzer sinnvoll einsetzbar. \nJeder Benutzer kann hier festlegen, welche freigegebenen Reports er sehen möchte.</p> \n<p>Zur Weiterbearbeitung eines freigegebenen Reports im eigenen Umfeld, \nkann dieser unter dem gleichen oder einem anderen Namen als eigener \nReport abgespeichert und damit weiterbearbeitet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Tabellenspalte</td>\n<td> Erklärung </td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>Report</td>\n  <td>Die Bezeichnung des freigegebenen Reports.</td>\n</tr>\n<tr>\n  <td>aktiv</td>\n  <td>Ist für mich unter \"Reports\" sichtbar, wenn aktiv.</td>\n</tr>\n<tr>\n  <td>Report kopieren nach</td>\n  <td>Markieren und unter gleicher oder anderer Bezeichnung in meine Reports kopieren. \n  Diese Funktion steht nur für Reports mit ausschließlich Auto-Reportdetails zur Verfügung.\n  </td>\n</tr>\n</tbody>\n</table>\r','','ConfigHints'),(168,'de','mailreports_bearbeiten','<!-- Changes:\n  mailreports_bearbeiten, de\n  2016-04-11, roveda: New features added\n-->\n<h2>Mail-Reports bearbeiten</h2>\n\n<!-- ----------------------------------------------------------------------- -->\n\n<p>Jeder selbsterstellte Report kann an definierbaren Wochentagen und zu einer bestimmten Uhrzeit als\nPDF-Datei an eine E-Mail-Adresse verschickt werden oder in einem Verzeichnis\nauf dem ULS-Server abgelegt werden.</p>\n\n<table>\n  <thead>\n    <tr>\n      <td>Tabellenspalte</td>\n      <td>Erklärung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>Report</td>\n      <td>Drop-Down Liste der verfügbaren Reports. Es können nur selbst erstellte Reports ausgewählt werden.</td>\n    </tr>\n    <tr>\n      <td>Mailtext</td>\n      <td>Optionaler Text, der als Mail-Body zur E-Mail verwendet wird, die den Report verschickt.</td>\n    </tr>\n    <tr>\n      <td>Zeitplan</td>\n      <td>\n        Alle Angaben sind mit UND miteinander verknüpft, also nur wenn alle Angaben zusammenpassen, wird der Report versendet.\n        <table>\n          <thead>\n            <tr>\n              <td>Zeitplanabschnitt</td>\n              <td>Erklärung</td>\n              <td>Beispiele</td>\n            </tr>\n          </thead>\n          <tbody>\n            <tr>\n              <td>aktiv</td>\n              <td>Eine Checkbox, die festlegt, ob dieser Zeitplan, also das Versenden des Reports per E-Mail, überhaupt stattfindet.</td>\n              <td>&nbsp;</td>\n            </tr>\n            <tr>\n              <td>Wochentage</td>\n              <td>Für jeden Wochentag eine Checkbox, an dem der Report erstellt und abgeschickt werden soll.</td>\n              <td>&nbsp;</td>\n            </tr>\n            <tr>\n              <td>Stunden:</td>\n              <td>\n                Liste oder Bereich der (vollen) Stunden, an denen der Report verschickt wird. \n                Als Standard, wenn nichts eingegegeben ist, wird 5 verwendet, also 05:00 Uhr morgens.\n                Die Erstellung und der Versand wird i.A. um 15 Minuten verzögert, um Werte zu berücksichtigen, \n                die ggf. über eine langsame Verbindung übertragen werden.\n              </td>\n              <td>\n                5 (05:00 Uhr)<br>\n                1-4,10 (zu jeder Stunde von 01:00 Uhr bis 04:00 Uhr und um 10:00 Uhr)\n              </td>\n            </tr>\n            <tr>\n              <td>Monatstage:</td>\n              <td>\n                Liste oder Bereich der Monatstage, an denen der Report zu obigen Stunden verschickt wird. \n              </td>\n              <td>\n                1 (am ersten des Monats)<br>\n                1-7 (z.B. in Verbindung mit ausschließlich aktiviertem \"Mo\" in Wochentage, ist das der erste Montag im Monat)\n              </td>\n            </tr>\n          </tbody>\n        </table>\n    <tr>\n      <td>E-Mail Adresse</td>\n      <td>E-Mail Adresse oder mit Komma getrennte Liste von E-Mail Adressen, an die der Report geschickt werden soll.</td>\n    </tr>\n    <tr>\n      <td>Report Ziel</td>\n      <td>\n        Hinterlegte Adresse an die der Report geschickt werden soll, bzw lokales Verzeichnis\n        auf dem ULS-Server, in das der Report geschrieben werden soll.\n      </td>\n    </tr>\n    <tr>\n      <td>Dateiname</td>\n      <td>Name der PDF-Datei. Es können folgende Platzhalter verwendet werden:\n        <table>\n          <thead>\n            <tr>\n              <td>Platzhalter</td>\n              <td>Erklärung</td>\n              <td>Beispiele</td>\n            </tr>\n          </thead>\n          <tbody>\n            <tr>\n              <td>%a</td>\n              <td>Wochentag, 2stellig</td>\n              <td>Mo Di Mi Do Fr Sa So</td>\n            </tr><tr>\n              <td>%b</td>\n              <td>Monat, 3stellig</td>\n              <td>Jan Feb Mär Apr</td>\n            </tr><tr>\n              <td>%d</td>\n              <td>Tag des Monats</td>\n              <td>01 02 10 22 31</td>\n            </tr><tr>\n              <td>%H</td>\n              <td>Stunde</td>\n              <td>01 09 14 23</td>\n            </tr><tr>\n              <td>%m</td>\n              <td>Monat, 2stellig</td>\n              <td>01 07 12</td>\n            </tr><tr>\n              <td>%M</td>\n              <td>Minute</td>\n              <td>07 23</td>\n            </tr><tr>\n              <td>%R</td>\n              <td>Name des Reports wie in Spalte \"Report\" dargestellt</td>\n              <td>Mein erster ULS Report</td>\n            </tr><tr>\n              <td>%y</td>\n              <td>Jahr, 2stellig</td>\n              <td>05 06 07</td>\n            </tr><tr>\n              <td>%Y</td>\n              <td>Jahr, 4stellig</td>\n              <td>2004 2016</td>\n            </tr><tr>\n              <td>%%</td>\n              <td>das % Zeichen selbst</td>\n              <td>%</td>\n            </tr>\n          </tbody>\n        </table>\n          Empfehlung: %R, %Y-%m-%d (\"Mein erster ULS Report, 2016-04-11\").\n        </td>\n    </tr>\n    <tr>\n      <td>Ausgabeformat</td>\n      <td>\n        Auswahl des Formats für die PDF Erstellung des Reports. \n        U.U. können sehr breite Tabellen nicht korrekt dargestellt werden, \n        da die absolute Breite des Zielformates (z.B.: A4) nicht ausreicht.\n        Dann kann versucht werden, dieses Problem durch ein größeres Format oder ein Querformat zu umgehen.\n        Sind Dateien (als BLOB Werte) Bestandteil des Reports, so werden sie nur versandt, wenn das \n        Ausgabeformat entsprechend ausgewählt wird.\n        <table>\n          <thead>\n            <tr>\n              <td>Ausgabeformat</td>\n              <td>Erklärung</td>\n            </tr>\n          </thead>\n          <tbody>\n            <tr>\n              <td>PDF a4 portrait</td>\n              <td>Standardausgabeformat. Der Report wird als PDF auf A4 Größe im Hochformat gerendert und verschickt.</td>\n            </tr><tr>\n              <td>PDF a4 landscape</td>\n              <td>Der Report wird als PDF auf A4 Größe im Querformat gerendert und verschickt.</td>\n            </tr><tr>\n              <td>PDF a3 portrait</td>\n              <td>Der Report wird als PDF auf A3 Größe im Hochformat gerendert und verschickt.</td>\n            </tr><tr>\n              <td>PDF a3 landscape</td>\n              <td>Der Report wird als PDF auf A3 Größe im Querformat gerendert und verschickt.</td>\n            </tr><tr>\n              <td>PDF+Files a4 portrait</td>\n              <td>\n                Der Report wird als PDF gerendert auf A4 Größe im Hochformat gerendert und  \n                mit den im Report enthaltenen Dateien (BLOB Werte) als Anhänge verschickt.\n              </td>\n            </tr><tr>\n              <td>PDF+Files a4 landscape</td>\n              <td>\n                Der Report wird als PDF gerendert auf A4 Größe im Querformat gerendert und  \n                mit den im Report enthaltenen Dateien (BLOB Werte) als Anhänge verschickt.\n              </td>\n            </tr><tr>\n              <td>PDF+Files a3 portrait</td>\n              <td>\n                Der Report wird als PDF gerendert auf A4 Größe im Hochformat gerendert und  \n                mit den im Report enthaltenen Dateien (BLOB Werte) als Anhänge verschickt.\n              </td>\n            </tr><tr>\n              <td>PDF+Files a3 landscape</td>\n              <td>\n                Der Report wird als PDF gerendert auf A4 Größe im Querformat gerendert und  \n                mit den im Report enthaltenen Dateien (BLOB Werte) als Anhänge verschickt.\n              </td>\n            </tr><tr>\n              <td>Files only</td>\n              <td>Nur die im Report enthaltenen Dateien (BLOB Werte) werden als Anhänge verschickt.</td>\n           </tr>\n          </tbody>\n        </table>\n      </td>\n    </tr>\n    <tr>\n      <td>mit Seitenumbrüchen</td>\n      <td>Nach jedem Reportdetail wird eine neue Seite begonnen.</td>\n    </tr>\n    <tr>\n      <td>Aktionen</td>\n      <td>\n        <table>\n          <tbody>\n            <tr>\n              <td><span class=\"internal_link\">Änderungen</span></td>\n              <td>Weblink auf eine neue Seite, die alle Änderungen an dem jeweiligen Mail-Report anzeigt.</td>\n            </tr>\n            <tr>\n              <td>jetzt senden</td>\n              <td>Der Report wird unabhängig vom Zeitplan jetzt erstellt und an die eingestellte(n) Adresse(n) verschickt.</td>\n            </tr>\n            <tr>\n              <td>löschen</td>\n              <td>Diese Mail-Report Definition wird gelöscht, der Report selbst bleibt erhalten.</td>\n            </tr>\n          </tbody>\n        </table>\n      </td>\n    </tr>\n  </tbody>\n</table>\n','','ConfigHints'),(169,'de','set_options','<!-- Changes:\n  set_options, de\n  2015-11-30, roveda: Created the help page.\n  2017-06-20, roveda: Adaption to new version 1.9.2\n-->\n\n<p>Einstellung verschiedener Optionen f&uuml;r die Darstellung und Verarbeitung von Werten im ULS für den aktuellen Benutzer.</p>\n<table>\n  <thead>\n    <tr>\n      <td>Option</td>\n      <td>Erkl&auml;rung</td>\n    </tr>\n  </thead>\n<tbody>\n  <tr>\n    <td>zeige Online-Hilfetexte</td>\n    <td>\n      Im unteren Bereich von Webseiten werden zus&auml;tzliche\n      Hilfstexte angezeigt (falls verf&uuml;gbar).\n    </td>\n  </tr>\n  <tr>\n    <td>Username anzeigen</td>\n    <td>Der aktuell eingeloggte ULS Benutzername wird oben rechts im top Frame unter den Logos angezeigt.</td>\n  </tr>\n  <tr>\n    <td>Reload Limit Übersichten</td>\n    <td>Die Anzeige der \"Status Übersicht\" wird zyklisch aktualisiert.</td>\n  </tr>\n  <tr>\n    <td>freigegebene Favoriten gruppieren</td>\n    <td>\n      Freigegebene Favoriten können zur besseren Übersicht gruppiert angezeigt \n      werden. Die Gruppierung kann nach verschiedenen Kriterien erfolgen.\n      <table>\n        <tbody>\n          <tr>\n            <td>nein</td>\n            <td>Es erfolgt keine Gruppierung.</td>\n          </tr>\n          <tr>\n            <td>nach Verfahren</td>\n            <td>Die Favoriten werden nach den Verfahren gruppiert, für die sie freigegeben sind.</td>\n          </tr>\n          <tr>\n            <td>nach Gruppe</td>\n            <td>Die Favoriten werden nach den Gruppen gruppiert, für die sie freigegeben sind.</td>\n          </tr>\n        </tbody>\n      </table>\n    </td>\n  </tr>\n  <tr>\n    <td>freigegebene Reports gruppieren</td>\n    <td>\n      Freigegebene Reports können zur besseren Übersicht gruppiert angezeigt \n      werden. Die Gruppierung kann nach verschiedenen Kriterien erfolgen.\n      <table>\n        <tbody>\n          <tr>\n            <td>nein</td>\n            <td>Es erfolgt keine Gruppierung.</td>\n          </tr>\n          <tr>\n            <td>nach Verfahren</td>\n            <td>Die Reports werden nach den Verfahren gruppiert, für die sie freigegeben sind.</td>\n          </tr>\n          <tr>\n            <td>nach Gruppe</td>\n            <td>Die Reports werden nach den Gruppen gruppiert, für die sie freigegeben sind.</td>\n          </tr>\n        </tbody>\n      </table>\n    </td>\n\n  </tr>\n  <tr>\n    <td>Maximale Anzahl Details pro Tabelle</td>\n    <td>\n      Maximale Anzahl von Tabellenspalten (Details), die in einer Tabelle nebeneinander dargestellt werden sollen. \n      Sind mehr Tabellenspalten (Details) vorhanden, dann wird eine weitere Tabelle\n      nachfolgend angezeigt.\n    </td>\n  </tr>\n  <tr>\n    <td>Maximale Anzahl Details pro Grafik</td>\n    <td>\n      Maximale Anzahl von Details, die in einer Grafik\n      gleichzeitig dargestellt werden. Sind mehr Details vorhanden, so wird\n      eine weitere Grafik nachfolgend angezeigt.\n    </td>\n  </tr>\n  <tr>\n    <td>Standardgröße für Grafiken</td>\n    <td>\n      Hiermit die Standardgr&ouml;&szlig;e der angezeigten Grafiken\n      festgelegt. Damit kann eine Anpassung an den verwendeten Monitor\n      vorgenommen werden. Die Grafikgr&ouml;&szlig;en in PDF-Reports werden an anderer Stelle festgelegt.\n    </td>\n  </tr>\n  <tr>\n    <td>csv Trennzeichen</td>\n    <td>Legt den Spaltenbegrenzer für das CSV-Format fest.</td>\n  </tr>\n  <tr>\n    <td>csv Zeitformat</td>\n    <td>Legt das Format für Zeitstempel beim Konvertieren ins CSV-Format fest.</td>\n  </tr>\n\n<!--- default pages -->\n  <tr>\n    <td>Startseite</td>\n    <td>\n      Legt die automatisch anzuzeigende Seite, den Favoriten oder den Bericht fest, \n      der im rechten Frame nach dem Einloggen (oder Drücken von [F5]) angezeigt wird.\n    </td>\n  </tr>\n  <tr>\n    <td>Serverseite</td>\n    <td>\n      Dieser Favorit oder Report wird angezeigt, wenn ein Server angeklickt wird.\n      Der Favorit oder der Bericht darf sinnvollerweise keine Eintragung bei Verfahren oder \n      Server enthalten und sollte schnell erstellt werden können.\n    </td>\n  </tr>\n  <tr>\n    <td>Sektion Seite</td>\n    <td>\n      Dieser Favorit oder Report wird angezeigt, wenn ein Server angeklickt wird.\n      Der Favorit oder der Bericht darf sinnvollerweise keine Eintragung bei Verfahren oder \n      Server enthalten und sollte schnell erstellt werden können.\n    </td>\n  </tr>\n\n<!-- Hauptmenue -->\n  <tr>\n    <td>Hauptmenü N</td>\n    <td>\nDiese Einträge können zur Gestaltung des personalisierten Hauptmenüs verwendet werden. \nIn den ersten 7 Hauptmenü Einträgen kann eine systemseitig vorgegebene Funktion oder \nein verfügbarer Favorit oder Report festgelegt werden. Mit der Auswahl von <tt>ausblenden</tt> wird der jeweilige \nMenüpunkt deaktiviert.\nAb Eintrag 8 können weitere verfügbare Favoriten oder Reports festgelegt werden, die als weitere \nMenüpunkte im Hauptmenü angezeigt werden.\n    </td>\n  </tr>\n\n<!-- UTT menue -->\n  <tr>\n    <td>UTT Menü N</td>\n    <td>\nDiese Einträge können zur Gestaltung des personalisierten UTT Menüs verwendet werden. \nIn den ersten 3 UTT Menü Einträgen kann eine systemseitig vorgegebene Funktion oder \nein verfügbarer Favorit oder Report festgelegt werden. Mit der Auswahl von <tt>ausblenden</tt> wird der jeweilige \nMenüpunkt deaktiviert.\nAb Eintrag 4 können weitere verfügbare Favoriten oder Reports festgelegt werden, die als weitere \nMenüpunkte im UTT Menü angezeigt werden.\n    </td>\n  </tr>\n\n<!-- UTT Einstellungen -->\n  <tr>\n    <td>UTT-Notify E-Mail Adresse</td>\n    <td>Hinterlegen der eigenen E-Mail Adresse für UTT Benachrichtigungen.</td>\n  </tr>\n  <tr>\n    <td>UTT Notify Level</td>\n    <td>\n      Beim Auftreten von UTT Benachrichtigungen mit den ausgew&auml;hlten Priorit&auml;ten,\n      wird eine Benachrichtigungs-E-Mail an die hinterlegte E-Mail Adresse verschickt.\n    </td>\n  </tr>\n  <tr>\n    <td>UTT Sortierung</td>\n    <td>\n      Über die drop-down Liste wird die Tabellenspalte festgelegt, nach der die UTT Benachrichtigungen standardmäßig sortiert werden.\n      <tt>[ ] Desc</tt> kehrt die Sortierreihenfolge um.\n    </td>\n  </tr>\n  <tr>\n    <td>UTT Links: Werte nach Event</td>\n    <td>\n      Bei Klick auf den Link zu <span class=\"internal_link\">Sektion - Testschritt - Detail</span> innerhalb eines UTT \n      werden diese angegebene Anzahl von neueren (jüngeren) Werten \n      nach dem <tt>Zeitstempel des alarmierten Wertes</tt> angezeigt.\n    </td>\n  </tr>\n  <tr>\n    <td>UTT Anzahl Tickets pro Seite</td>\n    <td>Initiale Anzahl von anzuzeigenden UTT Tickets pro Seite in der ULS Ticket Übersicht.</td>\n  </tr>\n  <tr>\n    <td>Anzahl UTTs in Historyliste</td>\n    <td>\n      Anzahl der zuletzt bearbeiteten <tt>ULS Benachrichtigungs ID</tt> in der Drop-Down Liste zum Schnellzugriff auf vorherige UTT Tickets.\n      (Nur in der Maske zur Bearbeitung eines UTT verfügbar)\n    </td>\n  </tr>\n  <tr>\n    <td>lange Meldungen als Hinweis in der Übersicht</td>\n    <td>\nLange Texte von Meldungen werden in der Übersicht der ULS Tickets abgekürzt.\nDurch Aktivieren dieser Checkbox werden die vollständigen Texte als Popup-Hinweis \nangezeigt, wenn die Maus über den verkürzten Text bewegt wird.\n    </td>\n  </tr>\n  <tr>\n    <td>erweiterbare lange Meldungen in der Übersicht</td>\n    <td>\nLange Texte von Meldungen werden in der Übersicht der ULS Tickets abgekürzt.\nDurch Aktivieren dieser Checkbox können die vollständigen Texte durch Klicken auf &darr; angezeigt, \nbzw. durch Klicken auf &uarr; wieder reduziert werden.\n    </td>\n  </tr>\n  <tr>\n    <td>lange Werte im Ticket verkürzen</td>\n    <td>\nBesonders lange Werte werden im ULS Ticket verkürzt dargestellt. \nSie können über &darr; und &uarr; erweitert, bzw. reduziert werden.\n</td>\n  </tr>\n  <tr>\n    <td>lange Meldungstexte im Ticket verkürzen</td>\n    <td>\nBesonders lange Meldungstexte werden im ULS Ticket verkürzt dargestellt.\nSie können über &darr; und &uarr; erweitert, bzw. reduziert werden.\n    </td>\n  </tr>\n</tbody>\n</table>\n','','ConfigHints'),(176,'de','set_ueberwachungspausen','<p>Überwachungspausen werden definiert, wenn in einem bestimmten Zeitraum\neinmalig, langfristig oder regelmäßig die Überwachung der Limits, KombiLimits \nund isAlive für einen Server oder eine Server -- Sektion Kombination ausgesetzt werden soll.\n</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Tabellenspalte</td>\n<td>Erklärung</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>\nServer<br>\nSektion\n</td>\n<td>Hier wird der Server, eine mit Komma\ngetrennte Liste von Servern oder ein Textausdruck mit Platzhaltern\neingetragen, für die diese Überwachungspause gelten soll. Die\nÜberwachungspause kann weiter eingeschränkt werden durch die Angabe von\neiner oder mehreren Sektionen oder einem entsprechenden Textausdruck,\nsiehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Datum Von Bis</td>\n<td>Die Überwachungspause gilt genau in dem Zeitraum der beiden Datumsangaben.\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Von</td>\n    <td>Bis</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>&lt;leer&gt;</td>\n    <td>&lt;leer&gt;</td>\n    <td>Die Überwachungspause gilt unbegrenzt lange.</td>\n  </tr>\n  <tr>\n    <td>&lt;leer&gt;</td>\n    <td>YYYY-MM-DD</td>\n    <td>Die Überwachungspause gilt bis zum angegebenen Datum 23:59h, bzw. \"Zeit Bis\".</td>\n  </tr>\n  <tr>\n    <td>YYYY-MM-DD</td>\n    <td>&lt;leer&gt;</td>\n    <td>Die Überwachungspause beginnt am angegebenen Datum 00:00h, bzw \"Zeit Von\" und gilt unbegrenzt.</td>\n  </tr>\n  <tr>\n    <td>YYYY-MM-DD</td>\n    <td>YYYY-MM-DD</td>\n    <td>Die Überwachungspause gilt genau in dem Zeitraum der beiden Datumsangaben.</td>\n  </tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td>Tage</td>\n<td>Hier werden die Wochentage festgelegt, an denen die Überwachungspause \nim Zeitraum von \"Datum Von Bis\" nur aktiv sein soll.</td>\n</tr>\n<tr>\n<td>Zeit Von Bis</td>\n<td>Der Zeitraum (Zeitangabe, HH:MM),\nfür den diese Überwachungspause im Zeitraum von \"Datum Von Bis\" und an\nden festgelegten Wochentagen gelten soll.</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr><tr>\n<td>löschen</td>\n<td>Damit kann die entsprechende Überwachungspause gelöscht werden.</td>\n</tr>\n</tbody>\n</table>\n<p>Es können mehrere Überwachungspausen für einen Server festgelegt werden.\nAlle Eintragungen einer Überwachungspause sind von links nach\nrechts logisch und-verknüpft. Abgelaufene Überwachungspausen werden\nautomatisch nach Ablauf gelöscht.</p>\n<p><span style=\"color: rgb(255, 0, 0);\">Hinweis:</span><br>\nIst für einen Server eine oder mehrere Limits mit \"mitteln über\"\neine größere Anzahl von Werten oder ein Zeitbereich definiert, \nso werden bei dem zu berechnenden Endwert trotzdem Werte aus\nder Überwachungspause verwendet. Dies ist ggf bei der Definition der\nÜberwachungspause(n) und bei \"mitteln über\" zu beachten.</p>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\r','','ConfigHints'),(178,'de','set_isalive','<p>Eine isAlive-Überwachung prüft das Ausbleiben von Werten und löst eine Benachrichtigung aus, \nwenn ein definierter Zeitraum überschritten wird.</p>\n<p>isAlive-Überwachungen können zu allen Details eingetragen, gelöscht oder geändert werden.\nDie Kontrolle auf überschrittene Fristen erfolgt zyklisch alle 5 Minuten.</p>\n<p>Es wird die Differenz vom Zeitstempel des letzten Werts und dem aktuellen\nDatum und der Uhrzeit gebildet. Das Ergebnis wird mit der eingetragenen\nFrist verglichen. Ist die Frist überschritten, so wird eine Meldung an das\nMeldungsziel versandt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Tabellenspalte</td>\n<td>Erklärung</td>\n</tr>\n</thead><tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Detail</td>\n<td>Für jedes existierende Detail wird eine Zeile zum festlegen von isAlive angezeigt.\nIn der untersten Zeile können weitere isAlive-Überwachungen eingetragen werden, z.B.: \nfür weiter Meldungsziele.\n</td>\n</tr>\n<tr>\n<td>letzter Wert vor</td>\n<td>Zeitpunkt, zu dem der letzte Wert eingegangen ist.\n</tr>\n<tr>\n<td>Zeitraum</td>\n<td>Eingabe der Frist (Zahl mit Zeiteinheit), nach der eine Benachrichtigung ausgelöst werden soll.</td>\n</tr>\n<td>Benachricht.Modus</td>\n<td>Die isAlive-Überwachung kann deaktiviert oder aktiviert werden.<br>\nDie Benachrichtigung erfolgt erstmals nach Verletzung des definierten Zeitraums und danach erfolgt die Wiederbenachrichtigung, falls die Bedingung immer noch erfüllt ist, entsprechend dem gewählten Benachrichtigungsmodus.\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Benachrichtigungsmodus</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>1h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach einer Stunde.</td>\n  </tr>\n  <tr>\n    <td>12h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach zwölf Stunden.</td>\n  </tr>\n  <tr>\n    <td>24h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach 24 Stunden.</td>\n  </tr>\n  <tr>\n    <td>Zeitraum</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach dem eingestellten Zeitraum, mindestens jedoch erst 24 Stunden später.</td>\n  </tr>\n </tbody>\n</table>\n  Ist automatisch schließen angehakt, werden generierte UTTs automatisch geschlossen, wenn wieder Werte einlaufen.</td></tr>\n<tr>\n<td>Meldung</td>\n<td>Hier kann eine benutzerdefinierte Meldung (max 3000 Zeichen) eingetragen werden,\neine standardisierte Meldung wird bei einer Benachrichtigung immer geschickt. Siehe\n\"Platzhalter und Funktionen in Meldung\"</td>\n</tr>\n<tr>\n<td>Meldungsziel</td>\n<td>Zwei für dieses Verfahren freigegebene Benachrichtigungsziele können über die \nDrop-Down-Listen eingestellt werden.</td>\n</tr>\n<td>\nAktionen\n</td>\n    <td>Link <span class=\"internal_link\">Änderungen</span> zur Anzeige der Bearbeitungshistorie.<br>\n      Löschen des Limits.<br>\n      Zu einer Verfahrens- oder Gruppen-Überwachung umwandeln. Danach kann über den Link <span class=\"internal_link\">auto</span> die Auto-Limit-Überwachung aufgerufen \n    und ggf abgeändert werden.<br>\n    Über die Checkbox \"zurücksetzen\" können die Änderungen zum Verfahrens- oder Gruppen-Limit rückgängig gemacht werden.<br>\n   Link <span class=\"internal_link\">Ü.Pause</span> zum direkten Anlegen einer Überwachungspause.\n    </td>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in Meldung</h4>\n\n<p>Im Text von \'Meldung\' können folgende Platzhalter und Funktionen\nverwendet werden, die vor der Versendung der Benachrichtigung durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Platzhalter</td>\n    <td>wird ersetzt durch</td>\n    <td style=\"text-align: center;\">Limits</td>\n    <td style=\"text-align: center;\">KombiLimits</td>\n    <td style=\"text-align: center;\">isAlive</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGEOVER</td>\n    <td>die Anzahl der Werte oder Zeitbereich von \"mitteln über\"</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$COMPARE</td>\n    <td>den angewandten Vergleich</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$DETAIL</td>\n    <td>das Detail (die Überschrift der Tabellenspalte)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$DOMAIN</td>\n    <td>die Bezeichnung des Verfahrens</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTDATE</td>\n    <td>der Zeitstempel des letzten vorhanden Werts</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTVALUE</td>\n    <td>der letzte Wert</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$LIMIT</td>\n    <td>den verletzten Limit (Info/Warn/Fehler)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$PREVVALUE</td>\n    <td>der Wert des vorigen Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$SAVEDATE</td>\n    <td>der Zeitstempel, an dem der letzte Wert im ULS eingegangen ist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$SECTION</td>\n    <td>die Sektion</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$SERVER</td>\n    <td>den Namen des Rechners</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TESTSTEP</td>\n    <td>die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$TIMEDIFF</td>\n    <td>die festgestellte Zeitdifferenz (die die Frist überschritten hat und zur Auslösung der Benachrichtigung\n    geführt hat)</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TIMELIMIT</td>\n    <td>die definierte Frist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$UNIT</td>\n    <td>die Einheit des Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$VALUE</td>\n    <td>der (uU berechnete) Wert, der die Limits-Verletzung ausgelöst hat</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n</tbody>\n</table>\n\n<p>Funktionen</p>\n<p>Die folgenden Funktionen könnne in Meldungstexten verwendet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr style=\"font-weight: bold;\">\n    <td>Funktion</td>\n    <td>Berechnung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGE_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Berechnet den arithmetischen Mittelwert für eine Anzahl von Werten eines Details.</td>\n  </tr>\n  <tr>\n    <td>$COUNT_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Ermittelt die Anzahl der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$DEV_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n  <td>Ermittelt die Standardabweichung der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n  <td>$DIFF_OF(&lt;detail&gt;[/&lt;unit&gt;])</td>\n<td>Ermittelt die Differenz (Unix Kommando diff) der letzten beiden Werte (können\nauch Dateien sein) und liefert maximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei würde\nes sich sinnvollerweise um Werte mit Textinhalten handeln. Unterstützte Dateiformate mit Komprimierung\nsind:.gz und .bz2. Alle anderen Dateiformate werden verglichen wie sie sind.\n</td>\n</tr><tr>\n<td>$DIFFER_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt, ob der erste Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen, sich&nbsp; zum letzten Wert unterscheidet. Ergibt 0 oder 1 als Ergebnis.</td>\n</tr><tr>\n<td>$FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$GRAD_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den Gradienten (lineare Steigung) der Werte des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_range&gt; [ &lt;time_past&gt;])</td>\n<td>Berechnet die lineare Steigung pro &lt;time_range&gt; (Standard: 1d) für Werte, die\nfür das angegebene Detail vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist &lt;time_past&gt; nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den &lt;time_range&gt;\numgerechnet. Man kann also die Werte der letzten 24h\nbetrachten (&lt;time_past&gt; = 24h) und daraus den Gradienten pro 8 Stunden\n(&lt;time_range&gt; = 8h) berechnen.\n</td>\n</tr>\n<tr>\n<td>$LAST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den letzten (aktuellsten) Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen. Dies kann ein neuerer&nbsp;Wert sein als der über $VALUE_OF ermittelte.</td>\n</tr><tr>\n<td>$LAST-FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Maximum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Minimum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_future&gt; [, &lt;time_past&gt;])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der für ein Detail vorliegenden Werte innerhalb eines\nzurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte einem linearen Wachstum unterliegen. Wird &lt;time_past&gt; nicht\nangegeben, dann wird &lt;time_future&gt; verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten Hälfte von &lt;time_past&gt; liegen\nund die in der zweiten Hälfte von &lt;time_past&gt; liegen, wird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der angenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten Steigung wird der Endwert zu &lt;time_future&gt; berechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(&lt;detail&gt;[/&lt;unit&gt;],&lt;&gt; &lt;regexp&gt;, &lt;time_range&gt;)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregulären Ausdrucks &lt;regexp&gt; in allen Werten des &lt;detail&gt;,\ndie in &lt;time_range&gt; (nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Summe der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$UNIT_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ermittelt die Einheit des &lt;detail&gt;</td>\n</tr><tr>\n<td>$VALUE_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ist&nbsp;der&nbsp;Wert des &lt;detail&gt; zum Zeitpunkt der Überwachungskontrolle. Dies ist nicht unbedingt der neueste Wert für dieses &lt;detail&gt;. </td>\n</tr>\n</tbody>\n</table>\n\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n','','ConfigHints'),(179,'de','myllimits','<p>Hier werden die ausgelösten Kompr-Limit Benachrichtigungen der letzten 48 Stunden angezeigt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Tabellenspalte</td>\n<td>Erklärung</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Status</td>\n<td>Zeigt einen blauen, gelben oder roten Indikator an,\nabhängig vom verletzten Kompr-Limit (Info, Warn, Fehler). Mit Klick auf\ndiesen Indikator wird die dazugehörige Tabelle oder Wertegrafik (ab\nGestern) angezeigt.</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Name des Servers, bei dem die Kompr-Limit-Überwachung ausgelöst wurde.</td>\n</tr>\n<tr>\n<td>URL</td>\n<td>Sektion -- Testschritt -- Detail Kombination, bei der die Kompr-Limit-Überwachung ausgelöst wurde. \nMit Klick auf diesen Weblink wird die zugehörige Überwachungsdefinition angezeigt.</td>\n</tr>\n<tr>\n<td>letzter Wert</td>\n<td>Anzeige des letzten, <span style=\"font-weight: bold;\">aktuellen</span> Wertes,\nder für diese Sektion -- Testschritt -- Detail Kombination im ULS vorliegt.</td>\n</tr>\n<tr>\n<td>Zeitstempel</td>\n<td>Der Zeitstempel vom letzten (neuesten) Wert.</td>\n</tr>\n<tr>\n<td>Meldungszeit</td>\n<td>Der Zeitstempel, an dem die Kompr-Limit-Überwachung ausgelöst wurde.</td>\n</tr>\n</tbody>\n</table>\n<p>Sektion -- Testschritt -- Detail Kombinationen werden nicht mehr angezeigt, wenn:</p>\n<ul>\n<li>die Kompr-Limits aufgrund der neu berechneten komprimierten Werte nicht mehr verletzt sind,</li>\n<li>die Kompr-Limit-Definition deaktiviert oder gelöscht wurde,</li>\n<li>alle komprimierten Werte dieser Server -- Sektion -- Testschritt -- Detail Kombinationen (durch den ULS Server) gelöscht wurden.</li>\n</ul>\r','','ConfigHints'),(52,'de','Auto-DiffLimits_festlegen','\n<p>&Uuml;ber Auto-DiffLimits k&ouml;nnen DiffLimits automatisiert definiert werden.</p><p>Bei einem DiffLimit&nbsp;wird jeweils der vorige Wert vom aktuellen (neuesten) Wert\nsubtrahiert\nund das Ergebnis (die Differenz) mit dem eingetragenen DiffLimit von\nInfo/Warn/Fehler verglichen. Bei Textausdr&uuml;cken ist nur ein\ngleich/ungleich\nm&ouml;glich und ist auch <b>nur</b> f&uuml;r einzeilige Werte\nverwendbar.</p><p>Zyklisch werden alle vorhandenen Daten &uuml;berpr&uuml;ft, ob\nServer\n-Sektion - Testschritt - Detail - Einheit Kombinationen existieren, die\nzu\nden hier eingetragenen Kombinationen passen und bisher noch keine\ndefinierten DiffLimits besitzen. Nur dann werden die passenden\nKombinationen\nmit\nden hier definierten DiffLimits ausgestattet.\n</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead><tr valign=\"top\">\n<th style=\"text-align: left;\">Tabellenspalte</th>\n<th style=\"text-align: left;\">Erkl&auml;rung </th>\n</tr>\n</thead> <tbody>\n<tr valign=\"top\">\n<td>Server<br>\nSektion<br>\nTestschritt</td>\n<td>Festlegen, f&uuml;r welche Server - Sektion -\nTestschritt Kombination dieser Auto-DiffLimit gelten soll. Siehe \"Ausdr&uuml;cke in Textfeldern\"</td>\n</tr>\n<tr valign=\"top\">\n<td>Detail<br>\nEinheit<br>\nAccess</td>\n<td>Festlegen, f&uuml;r welche Detail - Einheit\nKombination dieser Auto-DiffLimit gelten soll. Siehe \"Ausdr&uuml;cke in Textfeldern\"</td>\n</tr>\n\n<tr valign=\"top\">\n<td>Vergleich</td>\n<td>Der auf die ermittelte Differenz&nbsp;anzuwendende Vergleichsoperator.&nbsp;Siehe \"Vergleichsoperatoren \'DiffLimits\'\"</td>\n</tr>\n<tr valign=\"top\">\n<td>Info<br>\nWarn<br>\nFehler</td>\n<td>Drei DiffLimits k&ouml;nnen\neingetragen werden. Sie unterscheiden sich durch eine jeweils h&ouml;here\nPriorit&auml;t&nbsp;(nur bei Remedy Meldungszielen). Verletzt\ndie ermittelte Differenz einen dieser DiffLimits, so wird eine\nBenachrichtigung ausgel&ouml;st. Bei Vergleiche auf gleich oder ungleich (f&uuml;r Textausdr&uuml;cke und Zahlen) kann nur die\nPriorit&auml;t ausgew&auml;hlt werden, daf&uuml;r wird&nbsp;ein beliebiges Zeichen&nbsp;in das\nentsprechende Textfeld eingetragen.</td>\n</tr>\n\n<tr valign=\"top\">\n<td>Meldung</td>\n<td>Hier kann\neine benutzerdefinierte Meldung (max 1000 Zeichen) eingetragen werden, eine\nstandardisierte Benachrichtigung wird immer geschickt. Siehe \"Platzhalter und Funktionen in \'Meldung\'\"</td>\n</tr>\n<tr valign=\"top\">\n<td>Meldungsziel</td>\n<td>Zwei\nDrop-Down-Listen mit den verf&uuml;gbaren Benachrichtigungszielen, die f&uuml;r\ndieses Verfahren definiert sind. <br>\nDie Checkboxen I W F (Info/Warn/Fehler) legen&nbsp;fest, bei welchen\nGrenzwertverletzungen eine Benachrichtigung an das jeweilige\nMeldungsziel geschickt wird.</td>\n</tr>\n<tr valign=\"top\">\n<td>aktiv</td>\n<td>Damit wird dieser Auto-DiffLimit aktiviert oder deaktiviert.</td>\n</tr>\n<tr valign=\"top\">\n<td>l&ouml;schen</td>\n<td>Damit wird dieser Auto-DiffLimit und alle von ihm erzeugten DiffLimits gel&ouml;scht.</td>\n</tr>\n<tr valign=\"top\">\n<td>alle &auml;ndern</td>\n<td>Damit wird dieser Auto-DiffLimit JETZT auf ALLE passenden\nServer - Sektion - Testschritt - Detail - Einheit Kombinationen\nangewendet. Es werden auch die schon bestehenden DiffLimits zu diesen\nKombinationen ge&auml;ndert. Schon bestehende DiffLimits, die manuell\ndeaktiviert wurden, bleiben deaktiviert.</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine\nBemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdr&uuml;cke in Textfeldern</h4>\n<p>In den Feldern k&ouml;nnen konstante Textausdr&uuml;cke, Textausdr&uuml;cke\nmit Platzhaltern (Wildcards) oder eine komma-getrennte Kombination aus\nbeiden eingetragen werden. Als Platzhalter k&ouml;nnen \"*\" f&uuml;r einen\nbeliebigen\nAusdruck und \"?\" f&uuml;r ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td>konstanter Textausdruck:</td>\n<td>lxabcd5<br>\nrm300_agr<br>\nwscdbp93</td>\n</tr>\n<tr>\n<td>Liste von konstanten Textausdr&uuml;cken:</td>\n<td>lxabcp1,lxabcp2,lvxxx78<br>\nWSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n<td>Textausdruck mit Platzhalter:</td>\n<td>*appserver*</td>\n</tr>\n<tr>\n<td>Liste von konstanten Textausdr&uuml;cken mit Komma<br>\ngetrennt von Textausdr&uuml;cken mit Platzhaltern:</td>\n<td>wscdb*,wscowi*,wscapp25<br>\nxpolpa1,xpolpd*,*art*</td>\n</tr>\n</tbody>\n</table>\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet,\nalso wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja\nals\nSeparator einer Liste von Textausdr&uuml;cken verwendet wird, sollte\nanstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Vergleichsoperatoren \'DiffLimits\'</h4>\n<p>Erkl&auml;rung der einsetzbaren&nbsp;Vergleichsoperatoren bei\nder\nDefinition von DiffLimits. Die verwendbaren Vergleichsoperatoren\nsind&nbsp;abh&auml;ngig von den Datentypen der Werte, auf die\nsie\nangewendet werden. </p>\n<p><span style=\"font-weight: bold;\">Definition</span>\nvon Ausdr&uuml;cken, die zur weiteren Beschreibung der\nVergleichsoperatoren verwendet werden:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Ausdruck</td>\n<td>Bedeutung</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent f&uuml;r die Menge von Integer und Float\nverwendet (Details mit numerischen Werten)</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird f&uuml;r beliebige Textausdr&uuml;cke verwendet (Details mit\nTextwerten)</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">diff</td>\n<td>ist die Subtraktion des vorigen Werts vom\naktuellen Wert</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">limit</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler\nals DiffLimit eingetragen ist</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">voriger Wert</td>\n<td>ist der vorige Wert</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">aktueller Wert</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n</tbody>\n</table>\n<p>Allgemein gilt dabei f&uuml;r die Vergleiche:</p>\n<ul>\n<li>Bei String-Vergleichen wird Gro&szlig;-Kleinschreibung\nunterschieden.</li>\n<li>\"!\" ist die Negation des Vergleichs.</li>\n<li>\"|\"\n<ul>\n<li>Integer, Float: bildet Absolutwerte von beiden\nAusdr&uuml;cken bevor verglichen wird (abs)</li>\n<li>String: vergleicht beide Ausdr&uuml;cke unabh&auml;ngig von\nGro&szlig;-Kleinschreibung (ignore case)<br>\n</li>\n</ul>\n</li>\n</ul>\n\n<p><span style=\"font-weight: bold;\">Vergleichsoperatoren\nf&uuml;r Zahlen</span></p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgef&uuml;hrter Vergleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich <sup>(1)</sup></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich (abs) <sup>(1)</sup></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich <sup>(1)</sup></td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\"><span style=\"font-family: monospace;\">diff</span></td><td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich (abs)&nbsp;<sup>(1)</sup></td></tr></tbody>\n</table>\n<p><sup>(1)</sup> Diese Vergleiche werden auf <span style=\"font-weight: bold;\">jeden</span> eingehenden\nWert durchgef&uuml;hrt mit ggf der Ausl&ouml;sung von Benachrichtigungen!</p>\n<p><span style=\"font-weight: bold;\">Vergleichsoperatoren\nf&uuml;r Strings</span></p>\n<p>Alle Vergleiche f&uuml;r Strings werden auf <span style=\"font-weight: bold;\">jeden</span> eingehenden\nWert durchgef&uuml;hrt mit ggf der Ausl&ouml;sung von Benachrichtigungen!\nDie Vergleiche erfolgen gegen den\ngesamten Textausdruck eines Wertes, liegen mehrere Textausdr&uuml;cke zum\ngleichen Zeitstempel vor, so wird nur der <span style=\"font-weight: bold;\">letzte</span> Textausdruck\nverglichen.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgef&uuml;hrter Vergleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">==</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">==|</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>gleich (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">!==</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>ungleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">!==|</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>ungleich (ignore case)</td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in \'Meldung\'</h4>\n<!-- Fussnoten o&auml; verwenden, um isAlive, DiffLimits und andere zu unterscheiden ansonsten alle in einer Tabelle darstellen -->\n<p>Im Text von \"Meldung\" k&ouml;nnen folgende Platzhalter und\nFunktionen\nverwendet werden, die vor der Versendung der \"Meldung\" durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n<p>Platzhalter</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<col width=\"56\"> <col width=\"200\"> <thead>\n<tr style=\"font-weight: bold;\" valign=\"top\">\n<td width=\"22%\">Platzhalter</td>\n<td width=\"78%\">wird ersetzt durch</td><td style=\"text-align: center;\">Limits</td><td style=\"text-align: center;\">DiffLimits</td><td style=\"text-align: center;\">KombiLimits</td><td style=\"text-align: center;\">isAlive</td>\n</tr>\n</thead> <tbody>\n<tr>\n<td>$AVERAGEOVER</td>\n<td>die Anzahl der Werte oder Zeitbereich\nvon \"mitteln &uuml;ber\"</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$COMPARE</td>\n<td width=\"78%\">den angewandte Vergleich</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$DETAIL</td>\n<td width=\"78%\">das Detail (die &Uuml;berschrift der\nTabellenspalte)</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr><td>$DIFF</td><td>Differenz des Vergleichs oder der Subtraktion des vorigen Werts vom aktuellen Wert</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td></tr><tr valign=\"top\">\n<td width=\"20%\">$LASTDATE\n</td>\n<td width=\"78%\">Zeitstempel des letzten vorhanden\nWerts</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$LIMIT</td>\n<td width=\"78%\">den verletzten Limit\n(Info/Warn/Fehler)</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr><td>$PREVVALUE</td><td>Wert des vorigen Werts</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td></tr><tr valign=\"top\">\n<td width=\"22%\">$SECTION</td>\n<td width=\"78%\">die Sektion</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$SERVER</td>\n<td width=\"78%\">den Namen des Rechners</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$TESTSTEP</td>\n<td width=\"78%\">die Bezeichnung des Testschritts,\nggf mit Doppelpunkten bei rekursiven Testschritten</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"20%\">$TIMEDIFF\n</td>\n<td width=\"78%\">die festgestellte Zeitdifferenz (die\ndie Frist &uuml;berschritten hat und zur Ausl&ouml;sung der Benachrichtigung\ngef&uuml;hrt hat)</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"20%\">$TIMELIMIT\n</td>\n<td width=\"78%\">Definierte Frist</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$UNIT</td>\n<td width=\"78%\">die Einheit des Werts</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$VALUE</td>\n<td width=\"78%\">den aktuellen Wert, der die\nLimits-Verletzung ausgel&ouml;st hat</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n</tbody>\n</table><p>Funktionen</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n<tr>\n<td>$AVERAGE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Berechnet den arithmetischen Mittelwert f&uuml;r eine Anzahl\nvon Werten eines Details.<br>\n</td>\n</tr>\n<tr>\n<td>$COUNT_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Anzahl der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$DIFF_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>)\n</td>\n<td>Ermittelt\ndie Differenz (Unix Kommando diff) der letzten beiden Werte (k&ouml;nnen\nauch Dateien sein) und liefert\nmaximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei w&uuml;rde\nes sich sinnvollerweise um Werte mit Textinhalten\nhandeln.&nbsp;Unterst&uuml;tzte Dateiformate mit Komprimierung\nsind:&nbsp;.gz und&nbsp;.bz2. Alle anderen Dateiformate werden\nverglichen wie sie sind.\n</td>\n</tr>\n<tr>\n<td>$GRAD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt den Gradienten (lineare Steigung)\nder Werte des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>, <span style=\"font-family: monospace;\">time_range</span>\n[ <span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet die lineare Steigung pro <span style=\"font-family: monospace;\">time_range</span>\n(Standard: 1d) f&uuml;r Werte, die\nf&uuml;r das angegebene Detail vom aktuellen Zeitpunkt bis <span style=\"font-family: monospace;\">time_past</span>\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist <span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis <span style=\"font-family: monospace;\">time_past</span>\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten\nquadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den <span style=\"font-family: monospace;\">time_range</span>\numgerechnet. Man kann also die Werte der\nletzten 24h\nbetrachten (<span style=\"font-family: monospace;\">time_past</span>\n= 24h) und daraus den Gradienten\npro 8 Stunden\n(<span style=\"font-family: monospace;\">time_range</span>\n= 8h) berechnen.<br>\n</td>\n</tr>\n<tr>\n<td>$LAST-FIRST_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten\nWert aus allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Maximum der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Minimum der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>, <span style=\"font-family: monospace;\">time_future</span>\n[, <span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der f&uuml;r ein Detail vorliegenden Werte innerhalb eines\nzur&uuml;ckliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte\neinem linearen Wachstum unterliegen. Wird <span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, dann wird <span style=\"font-family: monospace;\">time_future</span>\nverwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten H&auml;lfte von <span style=\"font-family: monospace;\">time_past</span>\nliegen\nund die in der zweiten H&auml;lfte von <span style=\"font-family: monospace;\">time_past</span>\nliegen,\nwird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der\nangenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten\nSteigung wird der Endwert zu <span style=\"font-family: monospace;\">time_future</span>\nberechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>],<span style=\"font-family: monospace;\"></span> <span style=\"font-family: monospace;\">regexp</span>, <span style=\"font-family: monospace;\">time_range</span>)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregul&auml;ren Ausdrucks <span style=\"font-family: monospace;\">regexp</span>\nin allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">time_range</span>\n(nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$STD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Standardabweichung der Werte des\n<span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Summe der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$VALUE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>)</td>\n<td>Ermittelt den letzten Wert des <span style=\"font-family: monospace;\">detail</span> </td>\n</tr>\n</tbody>\n</table>\n<h4>Beschreibung der variablen Ausdr&uuml;cke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<th>variabler Ausdruck</th>\n<th style=\"vertical-align: top;\">Erkl&auml;rung</th>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">integer</span></td>\n<td>Ganze Zahl zur Angabe der Anzahl der Werte\noder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">range</span></td>\n<td>Kann ein <span style=\"font-family: monospace;\">integer</span>\noder ein <span style=\"font-family: monospace;\">time_range</span>\nsein.<br>\n<span style=\"font-family: monospace;\">integer</span>\n(ohne <span style=\"font-family: monospace;\">time_unit</span>)\nlegt die <span style=\"font-weight: bold;\">Anzahl</span>\nder Werte fest, auf die die Funktion angewendet\nwerden soll. <br>\n<span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span> legt\nden zur&uuml;ckliegenden <span style=\"font-weight: bold;\">Zeitbereich</span>\nfest, f&uuml;r dessen vorhandene Werte die Funktion\nangewendet werden soll. </td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">detail</span></td>\n<td>Exakte Bezeichnung des Details. Keine umschlie&szlig;enden\neinfache oder doppelte Anf&uuml;hrungszeichen verwenden!</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">unit</span></td>\n<td>Mit einem / abgetrennte Einheit, die zu dem Detail\nangegeben werden muss, falls das Detail allein nicht eindeutig f&uuml;r\ndiesen Testschritt ist.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_future</span></td>\n<td>Ein Zeitbereich, im Format von <span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_past</span></td>\n<td>Ein Zeitbereich, im Format von <span style=\"font-family: monospace;\">time_range</span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_range</span></td>\n<td>Ist eine Angabe im Format von <span style=\"font-family: monospace;\">integer</span> <span style=\"font-family: monospace;\">time_unit</span>, z.B.\n8h, 17m, 3d</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_unit</span></td>\n<td>Ein Buchstabe, der die Zeiteinheit festlegt: m\n(Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>','','ConfigHints'),(146,'de','set_autokombilimits','<p>KombiLimits kombinieren die Werte von mehreren Detaiils eines Testschritts miteinander \nüber Operatoren und/oder Funktionen zu einer komplexen Überwachung.</p>\n<p>Hier werden automatisch zu verwendende KombiLimit-Überwachungen (Auto-KombiLimits) für alle Werte, die zu definierten \nServer -- Sektion -- Testschritt Mustern dieses Verfahrens passen, festgelegt.</p>\n<p>Bei Eingang von Werten mit bisher nicht vorhandenen \nServer -- Sektion -- Testschritt Kombinationen \nwird geprüft, ob diese zu den hier definierten Mustern passen und ggf werden die eingetragenen KombiLimit-Überwachungen wirksam.</p>\n<p>Die Kontrolle auf erfüllte KombiLimit-Überwachungen erfolgt zyklisch alle 5 Minuten.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead> <tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>\nServer<br>\nSektion<br>\nTestschritt\n</td>\n<td>Hier wird festgelegt, für welche \nServer -- Sektion -- Testschritt Kombination dieses Auto-KombiLimit gelten soll. \nSiehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Access</td>\n<td>&nbsp;</td>\n</tr>\n<tr>\n<td>Bedingung</td>\n<td>Hier wird die zu prüfende Bedingung eingetragen. Siehe \"Funktionen in KombiLimits\"</td>\n</tr>\n<tr>\n<td>\nInfo<br>\nWarn<br>\nFehler\n</td>\n<td>Festlegen des Prioritätsniveaus.</td>\n</tr>\n<tr>\n<td>Benachricht.Modus</td>\n<td>Die Benachrichtigung erfolgt erstmals nach Verletzung des definierten Zeitraums und danach erfolgt die Wiederbenachrichtigung, falls die Bedingung immer noch erfüllt ist, entsprechend dem gewählten Benachrichtigungsmodus.\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Modus</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>1h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach einer Stunde.</td>\n  </tr>\n  <tr>\n    <td>12h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach zwölf Stunden.</td>\n  </tr>\n  <tr>\n    <td>24h</td>\n    <td>Die Wiederbenachrichtigung erfolgt nach 24 Stunden.</td>\n  </tr>\n </tbody>\n</table>\n</tr>\n<tr>\n<td>Meldung</td>\n<td>Hier kann eine benutzerdefinierte Meldung (max 3000 Zeichen) eingetragen werden,\neine standardisierte Meldung wird bei einer Benachrichtigung immer geschickt. Siehe\n\"Platzhalter und Funktionen in Meldung\"</td>\n</tr>\n<tr>\n<td>Meldungsziel</td>\n<td>Zwei für dieses Verfahren freigegebene Benachrichtigungsziele können über die \nDrop-Down-Listen eingestellt werden.</td>\n</tr>\n<tr>\n<td>\naktiv<br>\nlöschen<br>\nalle ändern\n</td>\n<td>Damit wird dieser Auto-KombiLimit deaktiviert, aktiviert, gelöscht oder alle hieraus abgeleiteten KombiLimit-Überwachungen werden bzgl der vorgenommenen Änderungen angepasst.</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Funktionen in KombiLimits</h4>\n<p>Für jede Bedingung können ein oder mehrere Vergleiche eingetragen werden, die mit logischen Operatoren miteinander verbunden sind. Ggf sollten Vergleiche eingeklammert werden. Die in dieser Tabelle verwendeten Platzhalter sind weiter unten beschrieben. Konstante Zahlen können verwendet werden.</p>\n<p>Beispiel für Bedingung:</p>\n<pre>\n  $VALUE_OF(number of logs not backed up) &gt; $VALUE_OF(number of logs) / 2 &amp;&amp; $VALUE_OF(duration/s) &gt; 37\n</pre>\n\n<h4>Funktionen in KombiLimits</h4>\n\n<!-- <h4>Funktionen in KombiDetails und KombiLimits</h4>  --> \n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n</thead>\n<tbody>\n<tr>\n  <td>\n    $ACCEL_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td> \n    Ermittelt die Krümmung der Kurve durch die Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen. \n    Es werden mindestens drei Werte benötigt. Das Ergebnis wird in \n    <tt>unit/h<sup>2</sup></tt> berechnet.\n  </td>\n</tr>\n<tr>\n  <td>\n    $AVERAGE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Berechnet den arithmetischen Mittelwert für die Werte \n    des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $COUNT_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $DEV_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Standardabweichung der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $DIFFER_OF(<tt>detail</tt>[/<tt>unit</tt>][,<tt>range</tt>])\n  </td>\n  <td>\n    Ermittelt, ob sich der erste und letzte Wert aus <tt>range</tt> \n    (Anzahl oder Zeitbereich) unterscheiden. \n    Als Standard wird <tt>range</tt> mit 2 belegt. \n    Das Ergebnis ist 0 (null) oder 1.\n  </td>\n</tr>\n<tr>\n  <td>\n    $FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den ersten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRAD_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den Gradienten (lineare Steigung) der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRADIENT(<tt>detail</tt>[/<tt>unit</tt>],<tt>time_range</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet die lineare Steigung pro <tt>time_range</tt>\n    (Standard: 1d) für Werte, die für das angegebene Detail \n    vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorhanden sind. Bei der Berechnung wird prinzipiell von \n    einem linearen Wachstum ausgegangen. Ist <tt>time_past</tt> \n    nicht angegeben, werden die letzten 24h verwendet (eine Zahl \n    allein wird als Tage interpretiert).\n    <br><br>\n    Genauer: aus allen Werten, die vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen \n    Abweichung ermittelt. Die Steigung dieser Geraden wird auf den <tt>time_range</tt>\n    umgerechnet. Man kann also die Werte der letzten 24h betrachten (<tt>time_past</tt>\n    = 24h) und daraus den Gradienten pro 8 Stunden (<tt>time_range</tt> = 8h) berechnen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST-FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom letzten zum ersten\n    Wert aus allen Werten des <tt>detail</tt>, die \n    in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>Ermittelt das Maximum der Werte des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX-MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom Maximalwert zum Minimalwert\n    aus allen Werten des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt das Minimum der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREDICTION(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>time_future</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet einen (in der Zukunft) zu erwartenden Wert\n    anhand der für ein Detail vorliegenden Werte innerhalb eines\n    zurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\n    werden, deren Werte einem linearen Wachstum unterliegen. Wird <tt>time_past</tt> \n    nicht angegeben, dann wird <tt>time_future</tt> verwendet.\n    <br><br>\n    Genauer: aus allen Werten, die in der ersten Hälfte von <tt>time_past</tt>\n    liegen und die in der zweiten Hälfte von <tt>time_past</tt>\n    liegen, wird jeweils ein arithmetischer Mittelwert gebildet und daraus die Steigung der\n    angenommenen linearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der \n    ermittelten Steigung wird der Endwert zu <tt>time_future</tt> berechnet.<br>\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREV_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den vorletzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td>\n    $REGCOUNT(<tt>detail</tt>[/<tt>unit</tt>],<tt>regexp</tt>,<tt>time_range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Treffer (matching pattern) des\n    regulären Ausdrucks <tt>regexp</tt> in allen Werten des <tt>detail</tt>,\n    die in <tt>time_range</tt> (nur Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $SUM_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Summe der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $VALUE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n</tbody>\n</table>\n\n\n\n<h4>Variable Ausdrücke in KombiLimits</h4>\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\n<h4>Operatoren in der definition von KombiLimits</h4>\n\n<p>Die Operatoren können verwendet werden, um verschiedene Funktionen miteinander zu kombinieren.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>MySQL Operatoren</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody>\n<tr>\n<td>&lt;, &gt;, =, !=, &lt;&gt;, &gt;=, &lt;=</td>\n<td>kleiner, größer, gleich, ungleich, ungleich, größer gleich, kleiner gleich</td>\n</tr>\n<tr>\n<td>+, -, *, /</td>\n<td>Addition, Subtraktion, Multiplikation, Division</td>\n</tr>\n<tr>\n<td>&amp;&amp;, AND, ||, OR</td>\n<td>logisches UND, logisches ODER</td>\n</tr>\n<tr>\n<td>( )</td>\n<td>Klammern für die Festlegung der Reihenfolge der Abarbeitung der Ausdrücke.</td>\n</tr>\n</tbody>\n</table>\n<p>\nNeben den oben beschriebenen Operatoren können auch fast alle\nFunktionen der MySQL Datenbank verwendet werden. Im folgenden nur ein\npaar Beispiele. Die vollständige Liste ist unter z.B.: \n<a target=\"_blank\" href=\"http://dev.mysql.com/doc/refman/5.0/en/string-functions.html\">MySQL 5.0 Reference Manual :: 11 Functions and Operators</a> \nnachzulesen. In den Funktionen können NICHT <tt>detail</tt>[/<tt\">unit</tt>] direkt \nverwendet werden, sondern nur über die Verwendung obiger Funktionen.\n</p>\n<p>Beispiel:</p>\n<pre>\n  ABS($VALUE_OF(mittlere Antwortzeit) - $VALUE_OF(Antwortzeit)) &gt;= 1.5\n</pre>\n\n\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in Meldung</h4>\n\n<p>Im Text von \'Meldung\' können folgende Platzhalter und Funktionen\nverwendet werden, die vor der Versendung der Benachrichtigung durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Platzhalter</td>\n    <td>wird ersetzt durch</td>\n    <td style=\"text-align: center;\">Limits</td>\n    <td style=\"text-align: center;\">KombiLimits</td>\n    <td style=\"text-align: center;\">isAlive</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGEOVER</td>\n    <td>die Anzahl der Werte oder Zeitbereich von \"mitteln über\"</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$COMPARE</td>\n    <td>den angewandten Vergleich</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$DETAIL</td>\n    <td>das Detail (die Überschrift der Tabellenspalte)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$DOMAIN</td>\n    <td>die Bezeichnung des Verfahrens</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTDATE</td>\n    <td>der Zeitstempel des letzten vorhanden Werts</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTVALUE</td>\n    <td>der letzte Wert</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$LIMIT</td>\n    <td>den verletzten Limit (Info/Warn/Fehler)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$PREVVALUE</td>\n    <td>der Wert des vorigen Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$SAVEDATE</td>\n    <td>der Zeitstempel, an dem der letzte Wert im ULS eingegangen ist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$SECTION</td>\n    <td>die Sektion</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$SERVER</td>\n    <td>den Namen des Rechners</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TESTSTEP</td>\n    <td>die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$TIMEDIFF</td>\n    <td>die festgestellte Zeitdifferenz (die die Frist überschritten hat und zur Auslösung der Benachrichtigung\n    geführt hat)</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TIMELIMIT</td>\n    <td>die definierte Frist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$UNIT</td>\n    <td>die Einheit des Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$VALUE</td>\n    <td>der (uU berechnete) Wert, der die Limits-Verletzung ausgelöst hat</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n</tbody>\n</table>\n\n<p>Funktionen</p>\n<p>Die folgenden Funktionen könnne in Meldungstexten verwendet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr style=\"font-weight: bold;\">\n    <td>Funktion</td>\n    <td>Berechnung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGE_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Berechnet den arithmetischen Mittelwert für eine Anzahl von Werten eines Details.</td>\n  </tr>\n  <tr>\n    <td>$COUNT_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Ermittelt die Anzahl der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$DEV_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n  <td>Ermittelt die Standardabweichung der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n  <td>$DIFF_OF(&lt;detail&gt;[/&lt;unit&gt;])</td>\n<td>Ermittelt die Differenz (Unix Kommando diff) der letzten beiden Werte (können\nauch Dateien sein) und liefert maximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei würde\nes sich sinnvollerweise um Werte mit Textinhalten handeln. Unterstützte Dateiformate mit Komprimierung\nsind:.gz und .bz2. Alle anderen Dateiformate werden verglichen wie sie sind.\n</td>\n</tr><tr>\n<td>$DIFFER_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt, ob der erste Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen, sich&nbsp; zum letzten Wert unterscheidet. Ergibt 0 oder 1 als Ergebnis.</td>\n</tr><tr>\n<td>$FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$GRAD_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den Gradienten (lineare Steigung) der Werte des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_range&gt; [ &lt;time_past&gt;])</td>\n<td>Berechnet die lineare Steigung pro &lt;time_range&gt; (Standard: 1d) für Werte, die\nfür das angegebene Detail vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist &lt;time_past&gt; nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den &lt;time_range&gt;\numgerechnet. Man kann also die Werte der letzten 24h\nbetrachten (&lt;time_past&gt; = 24h) und daraus den Gradienten pro 8 Stunden\n(&lt;time_range&gt; = 8h) berechnen.\n</td>\n</tr>\n<tr>\n<td>$LAST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den letzten (aktuellsten) Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen. Dies kann ein neuerer&nbsp;Wert sein als der über $VALUE_OF ermittelte.</td>\n</tr><tr>\n<td>$LAST-FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Maximum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Minimum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_future&gt; [, &lt;time_past&gt;])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der für ein Detail vorliegenden Werte innerhalb eines\nzurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte einem linearen Wachstum unterliegen. Wird &lt;time_past&gt; nicht\nangegeben, dann wird &lt;time_future&gt; verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten Hälfte von &lt;time_past&gt; liegen\nund die in der zweiten Hälfte von &lt;time_past&gt; liegen, wird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der angenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten Steigung wird der Endwert zu &lt;time_future&gt; berechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(&lt;detail&gt;[/&lt;unit&gt;],&lt;&gt; &lt;regexp&gt;, &lt;time_range&gt;)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregulären Ausdrucks &lt;regexp&gt; in allen Werten des &lt;detail&gt;,\ndie in &lt;time_range&gt; (nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Summe der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$UNIT_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ermittelt die Einheit des &lt;detail&gt;</td>\n</tr><tr>\n<td>$VALUE_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ist&nbsp;der&nbsp;Wert des &lt;detail&gt; zum Zeitpunkt der Überwachungskontrolle. Dies ist nicht unbedingt der neueste Wert für dieses &lt;detail&gt;. </td>\n</tr>\n</tbody>\n</table>\n\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\n','','ConfigHints'),(147,'de','Auto-KombiDetails_festlegen','<p>KombiDetails kombinieren die Werte von mehreren Detaiils eines Testschritts miteinander \nüber Operatoren und/oder Funktionen zu einem neuen Detail (Tabellenspalte). Das KombiDetail \nwird automatisch in der Tabelle zu den passenden Server -- Sektion -- Testschritt Kombinationen \nangezeigt und kann auch in Reports verwendet werden. Eine Überwachung kann zum KombiDetail \nnicht definiert werden.</p>\n<p>Hier werden automatisch zu verwendende KombiDetail-Definitionen (Auto-KombiDetails) festgelegt, \ndie zu definierten Server -- Sektion -- Testschritt Mustern dieses Verfahrens passen.</p>\n<p>Bei Eingang von Werten mit bisher nicht vorhandenen \nServer -- Sektion -- Testschritt Kombinationen \nwird geprüft, ob diese zu den hier definierten Mustern passen und ggf werden die eingetragenen KombiDetail-Definitionen wirksam.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>\nServer<br>\nSektion<br>\nTestschritt\n</td>\n<td>Hier wird festgelegt, für welche \nServer -- Sektion -- Testschritt Kombination dieses Auto-KombiDetail gelten soll. \nSiehe \"Ausdrücke in Textfeldern\"</td>\n</tr><tr>\n  <td>Access</td>\n  <td>&nbsp;</td>\n</tr><tr>\n<td>\nDetail<br>\nEinheit\n</td>\n<td>Es wird die exakte Bezeichnung des gewünschten KombiDetails (Tabellenspaltenüberschrift) \nfestgelegt und die dazu gewünschte Einheit festgelegt.</td>\n</tr><tr>\n<td>Ausdruck</td>\n<td>Hier wird die zu verwendende Berechnung, eine Kombination aus ULS-Funktionen und \nMySQL Operatoren und Funktionen,  eingetragen. \nSiehe \"Funktionen in KombiDetails\"</td>\n</tr>\n<td>\naktiv<br>\nlöschen<br>\nalle ändern\n</td>\n<td>Damit wird dieses Auto-KombiDetail deaktiviert, aktiviert, gelöscht oder alle hieraus abgeleiteten KombiDetail-Definitionen werden bzgl der vorgenommenen Änderungen angepasst.</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Funktionen in KombiDetails</h4>\n<p>Für jeden Ausdruck können ein oder mehrere Funktionen eingetragen werden, die ggf mit  Operatoren miteinander verbunden sind.</p>\n<p>Beispiele:</p>\n<pre>\n  $REF(numeric 2) 0\n  ABS($LAST-FIRST_OF(numeric 8,2))\n  100 - $VALUE_OF(%idle)\n</pre>\n\n<h4>Funktionen in KombiDetails</h4>\n\n<!-- <h4>Funktionen in KombiDetails und KombiLimits</h4>  --> \n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n</thead>\n<tbody>\n<tr>\n  <td>\n    $ACCEL_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td> \n    Ermittelt die Krümmung der Kurve durch die Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen. \n    Es werden mindestens drei Werte benötigt. Das Ergebnis wird in \n    <tt>unit/h<sup>2</sup></tt> berechnet.\n  </td>\n</tr>\n<tr>\n  <td>\n    $AVERAGE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Berechnet den arithmetischen Mittelwert für die Werte \n    des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $COUNT_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $DIFFER_OF(<tt>detail</tt>[/<tt>unit</tt>][,<tt>range</tt>])\n  </td>\n  <td>\n    Ermittelt, ob sich der erste und letzte Wert aus <tt>range</tt> \n    (Anzahl oder Zeitbereich) unterscheiden. \n    Als Standard wird <tt>range</tt> mit 2 belegt. \n    Das Ergebnis ist 0 (null) oder 1.\n  </td>\n</tr>\n<tr>\n  <td>\n    $FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den ersten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRAD_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den Gradienten (lineare Steigung) der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRADIENT(<tt>detail</tt>[/<tt>unit</tt>],<tt>time_range</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet die lineare Steigung pro <tt>time_range</tt>\n    (Standard: 1d) für Werte, die für das angegebene Detail \n    vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorhanden sind. Bei der Berechnung wird prinzipiell von \n    einem linearen Wachstum ausgegangen. Ist <tt>time_past</tt> \n    nicht angegeben, werden die letzten 24h verwendet (eine Zahl \n    allein wird als Tage interpretiert).\n    <br><br>\n    Genauer: aus allen Werten, die vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen \n    Abweichung ermittelt. Die Steigung dieser Geraden wird auf den <tt>time_range</tt>\n    umgerechnet. Man kann also die Werte der letzten 24h betrachten (<tt>time_past</tt>\n    = 24h) und daraus den Gradienten pro 8 Stunden (<tt>time_range</tt> = 8h) berechnen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST-FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom letzten zum ersten\n    Wert aus allen Werten des <tt>detail</tt>, die \n    in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>Ermittelt das Maximum der Werte des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX-MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom Maximalwert zum Minimalwert\n    aus allen Werten des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt das Minimum der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREDICTION(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>time_future</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet einen (in der Zukunft) zu erwartenden Wert\n    anhand der für ein Detail vorliegenden Werte innerhalb eines\n    zurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\n    werden, deren Werte einem linearen Wachstum unterliegen. Wird <tt>time_past</tt> \n    nicht angegeben, dann wird <tt>time_future</tt> verwendet.\n    <br><br>\n    Genauer: aus allen Werten, die in der ersten Hälfte von <tt>time_past</tt>\n    liegen und die in der zweiten Hälfte von <tt>time_past</tt>\n    liegen, wird jeweils ein arithmetischer Mittelwert gebildet und daraus die Steigung der\n    angenommenen linearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der \n    ermittelten Steigung wird der Endwert zu <tt>time_future</tt> berechnet.<br>\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREV_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den vorletzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td>\n    $REGCOUNT(<tt>detail</tt>[/<tt>unit</tt>],<tt>regexp</tt>,<tt>time_range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Treffer (matching pattern) des\n    regulären Ausdrucks <tt>regexp</tt> in allen Werten des <tt>detail</tt>,\n    die in <tt>time_range</tt> (nur Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $STD_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Standardabweichung der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $SUM_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Summe der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $VALUE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n</tbody>\n</table>\n\n\n\n<h4>Variable Ausdrücke in KombiDetails</h4>\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\n<h4>Operatoren in der Definition von KombiDetails</h4>\n\n<p>Die Operatoren können verwendet werden, um verschiedene Funktionen miteinander zu kombinieren.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>MySQL Operatoren</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody>\n<tr>\n<td>&lt;, &gt;, =, !=, &lt;&gt;, &gt;=, &lt;=</td>\n<td>kleiner, größer, gleich, ungleich, ungleich, größer gleich, kleiner gleich</td>\n</tr>\n<tr>\n<td>+, -, *, /</td>\n<td>Addition, Subtraktion, Multiplikation, Division</td>\n</tr>\n<tr>\n<td>&amp;&amp;, AND, ||, OR</td>\n<td>logisches UND, logisches ODER</td>\n</tr>\n<tr>\n<td>( )</td>\n<td>Klammern für die Festlegung der Reihenfolge der Abarbeitung der Ausdrücke.</td>\n</tr>\n</tbody>\n</table>\n<p>\nNeben den oben beschriebenen Operatoren können auch fast alle\nFunktionen der MySQL Datenbank verwendet werden. Im folgenden nur ein\npaar Beispiele. Die vollständige Liste ist unter z.B.: \n<a target=\"_blank\" href=\"http://dev.mysql.com/doc/refman/5.0/en/string-functions.html\">MySQL 5.0 Reference Manual :: 11 Functions and Operators</a> \nnachzulesen. In den Funktionen können NICHT <tt>detail</tt>[/<tt\">unit</tt>] direkt \nverwendet werden, sondern nur über die Verwendung obiger Funktionen.\n</p>\n<p>Beispiel:</p>\n<pre>\n  ABS($VALUE_OF(mittlere Antwortzeit) - $VALUE_OF(Antwortzeit)) &gt;= 1.5\n</pre>\n\n\r','','ConfigHints'),(150,'de','Auto-Komprimierung_festlegen','\n<p>Eingehende Werte können auf Stunden-, Tages-, Wochen- und Monatskennzahlen komprimiert werden.</p>\n<p>Für die Komprimierung stehen eine Reihe von Funktionen zur Verfügung,\ndie für vorgegebenen Zeitbereiche auf die Werte angewendet werden können. \nDie Ergebnisse dieser angewandten Funktionen werden dann\nwieder als komprimierte Werte für neue Details \n(strukturiert benannt nach den Ursprungsdetails) eingefügt.</p>\n<p>Hier werden automatisch zu verwendende Komprimierungen für alle Werte, die zu definierten \nServer -- Sektion -- Testschritt -- Detail -- Einheit Mustern dieses Verfahrens passen, festgelegt.</p>\n<p>Bei Eingang von Werten mit bisher nicht vorhandenen \nServer -- Sektion -- Testschritt -- Detail -- Einheit Kombinationen \nwird geprüft, ob diese zu den hier definierten Mustern passen und ggf werden die eingetragenen  Komprimierungen wirksam.</p>\n<p>Die Komprimierung erfolgt einmal am Tag, einmal am Montagmorgen und einmal am Ersten des Monats, jeweils für den zurückliegenden Zeitbereich.</p>\n\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\" >\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<th>Tabellenspalte</th>\n<th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>\nServer<br>\nSektion<br>\nTestschritt<br>\nDetail<br>\nEinheit<br>\nAccess\n</td>\n<td>Hier wird festgelegt, für welche \nServer -- Sektion -- Testschritt -- Detail -- Einheit Kombination \ndiese Auto-Komprimierung gelten soll. Über \"Access\" (falls angezeigt) wird der Zugriff auf besonders\ngeschützte Werte geregelt. Siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n\n<td>\nstündlich<br>\ntäglich<br>\nwöchentlich<br>\nmonatlich\n</td>\n<td>Liste von anwendbaren Komprimierungsfunktionen. Jede\nZeile steht für einen Zeitbereich der Tabellenspaltenüberschrift. Die\nFunktion wird jeweils immer für den entsprechenden Zeitbereich auf die\nWerte angewandt. Siehe \"Komprimierungsfunktionen\" </td>\n</tr>\n<tr>\n<td>\naktiv<br>\nlöschen\n</td>\n<td>Damit wird eine Auto-Komprimierung aktiviert, deaktiviert oder gelöscht.</td>\n</tr>\n</tbody>\n</table>\n<h4>Benamung der resultierenden Details</h4>\n<p>Die aus der Anwendung der Funktionen resultierenden Details für die komprimierten Werte werden\nnach folgendem Schema benannt:</p>\n<pre>\n  &lt;funktion&gt;[&lt;zeitbereich&gt;](&lt;detail&gt;)\n   --------   -----------    ------ Detail, auf das die Komprimierung angewandt wird\n   |          |\n   |          + H (Stunde), D (Tag), W (Woche), M (Monat)\n   |\n   + Eine der Komprimierungsfunktionen, siehe \"Komprimierungsfunktionen\"\n</pre>\n<p>Beispiel:<br>\nFür das Detail \"size\" wurde eine stündliche Komprimierung mit Anwendung\nder Funktion \"Avg\" definiert. Die berechneten Werte würden dann unter dem Detail </p>\n<pre>\n  Avg[H](size)\n</pre>\n<p>abgelegt werden.</p>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n\n<h4>Komprimierungsfunktionen</h4>\n<p>Die Funktionen beziehen sich immer auf den jeweiligen Zeitbereich.</p>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n    <tr>\n      <td>Funktion</td>\n      <td>Berechnung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>Accel</td>\n      <td>Berechnung der Beschleunigung</td>\n    </tr>\n    <tr>\n      <td>Avg</td>\n      <td>Berechnung des arithmetischen Mittelwerts</td>\n    </tr>\n    <tr>\n      <td>Count</td>\n      <td>Berechnung der Anzahl der Werte</td>\n    </tr>\n    <tr>\n      <td>Dev</td>\n      <td>Berechnung der Standardabweichung</td>\n    </tr>\n    <tr>\n      <td>Differ</td>\n      <td>Berechnung, ob eine Differenz vorliegt ???</td>\n    </tr>\n    <tr>\n      <td>First</td>\n      <td>Bestimmung des ersten Wertes</td>\n    </tr>\n    <tr>\n      <td>Grad</td>\n      <td>Berechnung des Gradienten</td>\n    </tr>\n    <tr>\n      <td>Last</td>\n      <td>Bestimmung des letzten Wertes</td>\n    </tr>\n    <tr>\n      <td>Last-First</td>\n      <td>Berechnung der Differenz vom letzten zum ersten Wert</td>\n    </tr>\n    <tr>\n      <td>Max</td>\n      <td>Berechnung des Maximums</td>\n    </tr>\n    <tr>\n      <td>Max-Min</td>\n      <td>Berechnung der Differenz vom Maximum zum Minimum</td>\n    </tr>\n    <tr>\n      <td>Min</td>\n      <td>Berechnung des Minimums</td>\n    </tr>\n    <tr>\n      <td>Size</td>\n      <td>Berechnung der Größe eines BLOBs, einer Datei oder eines Textausdrucks.</td>\n    </tr>\n    <tr>\n      <td>Sum</td>\n      <td>Berechnung der Summe</td>\n    </tr>\n  </tbody>\n</table>\n\r','','ConfigHints'),(155,'de','favorit_autodetails_bearbeiten','<p>Bearbeiten des Auto-Details eines Favoriten.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>Verfahren</td>\n  <td style=\"width: 87%;\">Optionale Angabe des/der Verfahren, siehe \"Ausdrücke in Textfelden\"</td>\n</tr>\n<tr>\n  <td>Server</td>\n  <td>Optionale Angabe des/der Server, siehe \"Ausdrücke in Textfeldern\".</td>\n</tr>\n<tr>\n  <td>Sektion</td>\n  <td>Optionale Angabe der Sektion(en), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n  <td>Testschritt</td>\n  <td>Optionale Angabe des/der Testschritt(e), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n  <td>Detail</td>\n  <td>Optionale Angabe des/der Detail(s), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n  <td>Einheit</td>\n  <td>Optionale Angabe der Einheit(en), siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n  <td>Zeitraum</td>\n  <td>Eine Drop-Down-Liste mit allen verfügbaren vorgegebenen dynamischen Zeitabschnitten. Es muss der undefinierte (leere) Eintrag ausgewählt werden, wenn \"Von\" und \"Bis\" verwendet werden sollen. Über den Zeitbereich wird prinzipiell die Menge der zu verarbeitenden Werte selektiert. Siehe \"Zeitraum\".</td>\n</tr>\n<tr>\n  <td>Offset</td>\n  <td>der Offset entspicht den Pfeilen bei Grafiken und Tabellen. Eine -3 z.B. ist der angezeigte Zeitraum drei mal zurück. Beispiel: Man hat letzte Woche ausgewählt, dann ist -3 vor 4 Wochen. Bei Gestern ist -3 dann vor 4 Tagen.</td>\n</tr>\n<tr>\n  <td>Von</td>\n  <td>Hier kann ein konkreter Zeitstempel\nim Format YYYY-MM-DD hh:mm:ss eingetragen werden. Es legt den\nAnfangszeitpunkt des zu verwendenden Zeitraums fest, siehe \"Zeitraum\nmit Von und Bis\".</td>\n</tr>\n<tr>\n  <td>Bis</td>\n  <td>Hier\nkann ein konkreter Zeitstempel im Format YYYY-MM-DD hh:mm:ss\neingetragen werden. Es legt den Endzeitpunkt des zu verwendenden\nZeitraums fest, siehe \"Zeitraum Von Bis\".</td>\n</tr>\n<tr>\n<td>Ausgabe</td>\n<td>Diese\nDrop-Down Liste legt fest, wie die zu verarbeitenden Werte für dieses\nReportdetail dargestellt, bzw welche Funktion auf sie angewendet werden\nsoll, siehe \"Ausgabemöglichkeiten\"<br>\n</td>\n</tr>\n<tr>\n<td>Grafikgröße</td>\n<td>legt die Größe der Grafik fest:\n<pre>\n   640 x  480\n   800 x  600\n  1024 x  768\n  1280 x  960\n  1600 x 1200\n</pre>\n</td>\n</tr>\n<tr>\n<td>Stil</td>\n<td>legt den Stil der Wertelinien in einer Grafik fest:\n<pre>\n  Dots\n  Points \n  Lines \n  Linespoints \n  Impulses \n  Steps \n  Fsteps \n  Histeps \n  Boxes\n</pre>\n</td>\n</tr>\n<tr>\n<td># D</td>\n<td>legt die Anzahl maximalen Tabellenspalten in einer Tabelle fest, bzw die maximale Anzahl von Wertelinien in einer Grafik.</td>\n</tr>\n<tr>\n<td>Gruppierung</td>\n<td>Gruppierung der Ausgabe nach:\n<ul>\n  <li>Server</li>\n  <!-- <li>Server, Testschritt</li> -->\n  <li>Sektion</li>\n  <!-- <li>Sektion, Testschritt</li> -->\n  <li>Testschritt</li>\n  <li>Detail</li>\n  <li>Wochentag</li>\n  <!-- <li>Stunde</li> -->\n  <!-- <li>Wert</li> -->\n</ul>\n<!-- \'Wert\' funktioniert nur bei der Ausgabe von \'letzte Werte\' -->\n</td>\n</tr>\n<tr>\n  <td>Gruppen Fußzeile</td>\n  <td>Es können Zusatzberechnungen zu der Gruppierung aktiviert werden. Gruppen Fußzeilen sind nur möglich, wenn alle beteiligten Details die gleiche Einheit haben.\n  </td>\n</tr>\n<tr>\n  <td>Sortierung</td>\n  <td>Sortierung des Ergebnisses nach:\n<pre>\n  Server\n  Sektion\n  Testschritt\n  Detail\n  Einheit\n  Wert\n</pre>  \n  </td>\n</tr>\n<tr>\n  <td>Werte</td>\n  <td>legt fest, ob aktuelle (online) Werte und/oder komprimierte Werte in diesem Reportdetail berücksichtigt werden sollen.</td>\n</tr>\n</tbody>\n</table>\n\n<p>Folgende zusätzliche Angaben sind im erweiterten Modus möglich.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead> <tr>\n<th>Tabellenspalte</th>\n<th> Erklärung </th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>y1 Achse</td>\n  <td>\n    <table  border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n    <tbody style=\"vertical-align: top;text-align: left;\">\n      <tr>\n        <td>Einheit</td>\n        <td>Einheit für die Y-Achse festlegen.</td>\n      </tr>\n      <tr>\n        <td>Min</td>\n        <td>Minimum der Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>Max</td>\n        <td>Maximum der Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>Stil</td>\n        <td>Stil aller Details dieser Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>logarithmisch</td>\n        <td>logarithmische Skalierung festlegen.</td>\n      </tr>\n      </tbody>\n    </table>\n  </td>\n</tr>\n<tr>\n  <td>y2 Achse</td>\n  <td>\n    <table  border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n    <tbody style=\"vertical-align: top;text-align: left;\">\n      <tr>\n        <td>Einheit</td>\n        <td>Einheit für die Y-Achse festlegen.</td>\n      </tr>\n      <tr>\n        <td>Min</td>\n        <td>Minimum der Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>Max</td>\n        <td>Maximum der Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>Stil</td>\n        <td>Stil aller Details dieser Y-Achse.</td>\n      </tr>\n      <tr>\n        <td>logarithmisch</td>\n        <td>logarithmische Skalierung festlegen.</td>\n      </tr>\n      </tbody>\n    </table>\n    </td>\n</tr>\n<tr>\n  <td>Zeit</td>\n  <td>Nur die Werte aus diesem Tageszeitraum werden bei der Ausgabe berücksichtigt.\n    <table  border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n    <tbody style=\"vertical-align: top;text-align: left;\">\n      <tr>\n        <td>von</td>\n        <td>Startuhrzeit festlegen, Format: hh:mm.</td>\n      </tr>\n      <tr>\n        <td>bis</td>\n        <td>Startuhrzeit festlegen, Format: hh:mm.</td>\n      </tr>\n     </tbody>\n    </table>\n  </td>\n</tr>\n<tr>\n  <td>Wochentage</td>\n  <td>Nur Werte aus den aktivierten Wochentagen werden bei der Ausgabe berücksichtigt. Ist keiner aktiviert, gilt keine Einschränkung.</td>\n</tr>\n<tr>\n  <td>Werte</td>\n  <td>Die Werte können über mehrere Bedingungen gefiltert werden.</td>\n</tr>\n</tbody>\n</table>\n  \n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Zeitraum</h4>\n<p>Festlegen des gewünschten Zeitraums für den die Werte dargestellt werden sollen.<br>\n</p>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <th>Zeitraum</th>\n    <th>Erklärung</th>\n  </tr>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>zwei Stunden</td>\n    <td>die Werte der zwei letzten vollständigen Stunden</td>\n  </tr>\n  <tr>\n    <td>ab zwei Stunden</td>\n    <td>die Werte der zwei letzten vollständigen Stunden und bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>Heute</td>\n    <td>alle Werte ab heute 00:00:00 Uhr </td>\n  </tr>\n  <tr>\n    <td>Gestern</td>\n    <td>nur die Werte von gestern</td>\n  </tr>\n  <tr>\n    <td>ab Gestern</td>\n    <td>die Werte von gestern bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>diese Woche</td>\n    <td>alle Werte ab Montag dieser Woche 00:00:00 Uhr bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>7 Tage</td>\n    <td>die Werte der letzten 7 Tage bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>ab 7 Tage</td>\n    <td>die Werte der letzten 7 Tage und bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>letzte Woche</td>\n    <td>die Werte von Montag bis Sonntag der vorigen Woche</td>\n  </tr>\n  <tr>\n    <td>ab letzter Woche</td>\n    <td>alle Werte ab Montag der vorigen Woche bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>Monat</td>\n    <td>die Werte ab dem Datum des gestrigen Tages des vorigen Monats bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>letzter Monat</td>\n    <td>die Werte ab dem 01. des vorigen Monats bis zum letzten Tag des vorigen Monats</td>\n  </tr>\n  <tr>\n    <td>ab letztem Monat</td>\n    <td>die Werte ab dem 01. des vorigen Monats bis zum aktuellen Zeitpunkt</td>\n  </tr>\n  <tr>\n    <td>3 Monate</td>\n    <td>die Werte der letzten 3 vollständigen Monate</td>\n  </tr>\n  <tr>\n    <td>Jahr</td>\n    <td>die Werte ab dem Datum des gestrigen Tages des vorigen Jahres bis gestern 24:00:00 Uhr</td>\n  </tr>\n  <tr>\n    <td>komplett</td>\n    <td>alle vorhandenen Werte ohne zeitliche Einschränkung</td>\n  </tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Zeitraum Von Bis</h4>\n<p>Über diese beiden konkreten Zeitstempel kann ein exakt definierter\nZeitraum angegeben werden, der nicht über die vorgegebenen Zeiträume\neinstellbar ist. Die beiden Zeitstempel sind konstant.</p>\n<p>Das Format ist immer \"YYYY-MM-DD hh:mm:ss\" (ISO 8601 / EN 28601).\n\n</p>\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausgabemöglichkeiten</h4>\n<p>Es wird die Ausgabefunktion festgelegt.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Ausgabe</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\"><tr>\n  <td>Tabelle</td>\n  <td>Die Werte werden als Tabelle mit Zeitstempel angezeigt.</td>\n</tr>\n<tr>\n  <td>letzte Werte</td>\n  <td>Gibt (für jeden Server, je nach Gruppierung) eine einzeilige Tabelle aus, die nur den letzten Wert enthält.</td>\n</tr>\n<tr>\n  <td>Grafik</td>\n  <td>Die Werte werden als Grafik angezeigt, deren Auflösung im Drop-Down Feld \"Grafikgröße\" festgelegt wird.</td>\n</tr>\n<tr>\n  <td>Min</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die das Minimum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Max</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die das Maximum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Mittelwert</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die den arithmetische Mittelwert der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Std.Abweichung</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Standardabweichung der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Summe</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Summe aller Werte enthält.</td>\n</tr>\n<tr>\n  <td>Max-Min</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Differenz von Maximum zum Minimum der Werte enthält.</td>\n</tr>\n<tr>\n  <td>Last-First</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Differenz vom (zeitlich) letzten Wertes zum (zeitlich) ersten Wert enthält. Damit lässt sich zB die Zuwachsrate pro Zeiteinheit darstellen.</td>\n</tr>\n<tr>\n  <td>Count</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Anzahl von Werten enthält.</td>\n</tr>\n<tr>\n  <td>Grad</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die die Steigung der Werte für den gewählten Zeitbereich anzeigt.</td>\n</tr>\n<tr>\n  <td>First</td>\n  <td>Gibt (für jeden Server) eine einzeilige Tabelle aus, die den ersten Wert aus dem gewählten Zeitbereich enthält.</td>\n</tr>\n<tr>\n  <td>Beschleunigung</td>\n  <td>&nbsp;</td>\n</tr>\n<tr>\n  <td>Histogramm</td>\n  <td>Gibt ein Histogramm der letzten Werte für die Kombination aller variablen\nAngaben aus. In dem Reportdetail wird dabei üblicherweise eine oder\nmehrere Angaben mit Wildcards versehen. Nur für Werte\nmit identischen Einheiten!<br>\n</td>\n</tr>\n<tr>\n  <td>Hist.Min</td>\n  <td>Gibt ein Histogramm der Minima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Max</td>\n  <td>Gibt ein Histogramm der Maxima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Mittelw</td>\n  <td>Gibt ein Histogramm der Mittelwerte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Std.Ab.</td>\n  <td>Gibt ein Histogramm der Standardabweichungen für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Summe</td>\n  <td>Gibt ein Histogramm der Summen für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Max-Min</td>\n  <td>Gibt ein Histogramm der berechneten Maxima-Minima für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Last-First</td>\n  <td>Gibt ein Histogramm der berechnete letzten Werte minus der ersten Werte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Count</td>\n  <td>Gibt ein Histogramm der Anzahl der Werte für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Hist.Grad</td>\n  <td>Gibt ein Histogramm der Gradienten für die Kombination aller variablen Angaben aus. Nur für Werte mit identischen Einheiten!</td>\n</tr>\n<tr>\n  <td>Limits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Limits.</td>\n</tr>\n<tr>\n  <td>KombiLimits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten KombiLimits.</td>\n</tr>\n<tr>\n  <td>isAlive Übersicht</td>\n  <td>Tabellarische Darstellung der definierten isAlive.</td>\n</tr>\n<tr>\n  <td>kompr.Limits Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Limits auf komprimierte Werte.</td>\n</tr>\n<tr>\n  <td>KombiDetails Übersicht</td>\n  <td>Tabellarische Darstellung der definierten KombiDetails.</td>\n</tr>\n<tr>\n  <td>Aufbewahrung Übersicht</td>\n  <td>Tabellarische Darstellung der definierten Aufbewahrungszeiten.</td>\n</tr>\n</tbody>\n</table>\n','','ConfigHints'),(157,'de','myalllimits','<p>Anzeigen der ausgelösten Benachrichtigungen.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Status</td>\n<td>Zeigt die Tabelle oder die Grafik zum Detail an, das die Benachrichtigung ausgelöst hat.</td>\n</tr>\n<tr>\n<td>Server</td>\n<td>Server, der die Benachrichtigung ausgelöst hat.</td>\n</tr>\n<tr>\n<td>URL</td>\n<td>Link zur Definition der Überwachung (isAlive, Limit, KombiLimit)</td>\n</tr>\n<tr>\n<td>letzter Wert</td>\n<td>der letzte, <b>aktuell</b> ermittelte Wert für dieses Detail.</td>\n</tr>\n<tr>\n<td>Meldungszeit</td>\n<td>Datum und Uhrzeit der Auslösung der Benachrichtigung.</td>\n</tr>\n<tr>\n<td>erledigt</td>\n<td>Benachrichtigungen können damit als erledigt gekennzeichnet werden, sie werden dann aus dieser Tabelle entfernt.</td>\n</tr>\n</tbody>\n</table>\n\r','','ConfigHints'),(166,'de','Komprimierung_festlegen','<p>Eingehende Werte können auf Stunden-, Tages-, Wochen- und Monatskennzahlen komprimiert werden.</p>\n<p>Für die Komprimierung stehen eine Reihe von Funktionen zur Verfügung,\ndie für vorgegebenen Zeitbereiche auf die Werte angewendet werden können. \nDie Ergebnisse dieser angewandten Funktionen werden dann\nwieder als komprimierte Werte für neue Details \n(strukturiert benannt nach den Ursprungsdetails) eingefügt.</p>\n<p>\nIm Hauptmenü muss \"komprimierte Werte\" ausgewählt werden, um\nZugriff auf die komprimierten Werte zu erhalten. Bei\n\"Auto-Detailauswahl\", bzw. bei der Bearbeitung von \"Autodetails für\nReports\" muss die entsprechende Checkbox ausgewählt werden.</p>\n\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<th>Tabellenspalte</th>\n<th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Detail</td>\n<td>Eine Liste aller Details für diese \nVerfahren -- Server -- Sektion -- Testschritt Kombination, \nfür die Komprimierungen definiert werden können.</td>\n</tr>\n<tr>\n<td>Stündlich<br>\nTäglich<br>\nWöchentlich<br>\nMonatlich</td>\n<td>Liste von anwendbaren Komprimierungsfunktionen. Jede\nZeile steht für einen Zeitbereich der Tabellenspaltenüberschrift. Die\nFunktion wird jeweils immer für den entsprechenden Zeitbereich auf die\nWerte angewandt. Siehe \"Komprimierungsfunktionen\"<br>\n</td>\n</tr>\n</tbody>\n</table>\n\n<p>Die aus der Anwendung der Funktionen resultierenden Details für die komprimierten Werte werden\nnach folgendem Schema benannt:</p>\n<pre>\n  &lt;funktion&gt;[&lt;zeitbereich&gt;](&lt;detail&gt;)\n   --------   -----------   ------- Detail, auf das die Komprimierung angewandt wird\n   |          |\n   |          + H (Stunde), D (Tag), W (Woche), M (Monat)\n   |\n   + Eine der Komprimierungsfunktionen, siehe \"Komprimierungsfunktionen\"\n</pre>\n<p>Beispiel:<br>\nFür das Detail \"size\" wurde eine stündliche Komprimierung mit Anwendung\nder Funktion \"Avg\" definiert. Die berechneten Werte würden dann unter dem \nDetail \"Avg[H](size)\" abgelegt werden.</p>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n\n<h4>Komprimierungsfunktionen</h4>\n<p>Die Funktionen beziehen sich immer auf den jeweiligen Zeitbereich.</p>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n    <tr>\n      <td>Funktion</td>\n      <td>Berechnung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>Accel</td>\n      <td>Berechnung der Beschleunigung</td>\n    </tr>\n    <tr>\n      <td>Avg</td>\n      <td>Berechnung des arithmetischen Mittelwerts</td>\n    </tr>\n    <tr>\n      <td>Count</td>\n      <td>Berechnung der Anzahl der Werte</td>\n    </tr>\n    <tr>\n      <td>Dev</td>\n      <td>Berechnung der Standardabweichung</td>\n    </tr>\n    <tr>\n      <td>Differ</td>\n      <td>Berechnung, ob eine Differenz vorliegt ???</td>\n    </tr>\n    <tr>\n      <td>First</td>\n      <td>Bestimmung des ersten Wertes</td>\n    </tr>\n    <tr>\n      <td>Grad</td>\n      <td>Berechnung des Gradienten</td>\n    </tr>\n    <tr>\n      <td>Last</td>\n      <td>Bestimmung des letzten Wertes</td>\n    </tr>\n    <tr>\n      <td>Last-First</td>\n      <td>Berechnung der Differenz vom letzten zum ersten Wert</td>\n    </tr>\n    <tr>\n      <td>Max</td>\n      <td>Berechnung des Maximums</td>\n    </tr>\n    <tr>\n      <td>Max-Min</td>\n      <td>Berechnung der Differenz vom Maximum zum Minimum</td>\n    </tr>\n    <tr>\n      <td>Min</td>\n      <td>Berechnung des Minimums</td>\n    </tr>\n    <tr>\n      <td>Size</td>\n      <td>Berechnung der Größe eines BLOBs, einer Datei oder eines Textausdrucks.</td>\n    </tr>\n    <tr>\n      <td>Sum</td>\n      <td>Berechnung der Summe</td>\n    </tr>\n  </tbody>\n</table>\n\r','','ConfigHints'),(194,'de','_aggregation_general_info_de','<!-- Changes:\n  _aggregation_general_info_de, de\n  2015-12-02, roveda: Created the help page.\n-->\n\n<hr>\n<h3 id=\"_aggregation_general_info_de\">Allgemeines zur Komprimierung (Aggregation)</h3> \n\n<p>\nIm ULS werden online Werte und komprimierte (oder aggregierte) Werte unterschieden.\nDie online Werte sind die tatsächlich durch einen Agenten übertragenen Werte mit ihren originalen Werten, \nzugeordnet zu ihren Erfassungszeitpunkten.\n</p>\n<p>\nKomprimierte Werte können per Definition durch den ULS-Server aus den online Werten berechnet \nund abgespeichert werden. Die Komprimierung kann pro Stunde, täglich, wöchentlich, monatlich \noder für bestimmte Wertetypen auch speziell auf jeden Wert stattfinden.\n</p>\n<p>\nDie Berechnung der komprimierten Werte erfolgt jeweils nach Ablauf des definierten Komprimierungszeitraums, \nminimal jedoch täglich. Der definierte Komprimierungszeitraum ist gleichzeitig auch der minimale Aufbewahrungszeitraum. \nD.h. auch wenn üblicherweise die Aufbewahrungszeit für online Werte nur 14 Tage beträgt, werden \ndie Werte dennoch mindestens für einen Monat aufbewahrt, wenn für diese Werte eine entsprechende monatliche \nKomprimierung definiert wurde.\n</p>\n\n','','ConfigHints'),(75,'de','__Ausgabemoeglichkeiten','<h4>Ausgabem&ouml;glichkeiten</h4>\n<p>Es wird die Ausgabefunktion festgelegt.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <tbody>\n    <tr>\n      <td>Tabelle</td>\n      <td>Die Werte werden als Tabelle mit Zeitstempel angezeigt.</td>\n    </tr>\n    <tr>\n      <td>letzte Werte</td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die nur den letzten Wert enth&auml;lt.</td>\n    </tr>\n    <tr>\n      <td>Grafik<br>\n      <br>\n      </td>\n      <td>Die Werte werden als Grafik angezeigt, deren Aufl&ouml;sung im Drop-Down Feld \"Grafikgr&ouml;&szlig;e\" festgelegt wird:<br><div style=\"margin-left: 40px;\">\n640x480<br>\n800x600<br>\n1024x768<br>\n1280x960<br>\n1600x1200 </div></td>\n    </tr>\n    <tr>\n      <td>Min</td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die das Minimum der Werte enth&auml;lt.</td>\n    </tr>\n    <tr>\n      <td>Max</td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die das Maximum der Werte enth&auml;lt.</td>\n    </tr>\n    <tr>\n      <td>Mittelwert<br>\n      </td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die den arithmetische Mittelwert der Werte enth&auml;lt.</td>\n    </tr>\n    <tr>\n      <td>Std.Abweichung</td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die die Standardabweichung der Werte enth&auml;lt.</td>\n    </tr>\n    <tr>\n      <td>Summe</td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die die Summe aller Werte enth&auml;lt.</td>\n    </tr>\n    <tr>\n      <td>Max-Min</td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die die Differenz von Maximum zum Minimum der Werte enth&auml;lt.</td>\n    </tr>\n    <tr>\n      <td>Last-First</td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Differenz vom (zeitlich) letzten Wertes zum (zeitlich)\nersten Wert enth&auml;lt. Damit l&auml;sst sich zB die Zuwachsrate pro\nZeiteinheit darstellen.</td>\n    </tr>\n    <tr>\n      <td>Count</td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die die Anzahl von Werten enth&auml;lt.</td>\n    </tr>\n    <tr>\n      <td>Grad<br>\n      </td>\n      <td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle aus, die die Steigung der Werte\nf&uuml;r den gew&auml;hlten Zeitbereich anzeigt.<br>\n      </td>\n    </tr>\n    <tr>\n      <td>Histogramm<br>\n      </td>\n      <td>Gibt ein\nHistogramm der letzten Werte f&uuml;r die Kombination aller variablen\nAngaben aus. In dem Reportdetail wird dabei &uuml;blicherweise eine oder\nmehrere Angaben mit Wildcards versehen. Nur f&uuml;r Werte\nmit identischen Einheiten!<br>\n      </td>\n    </tr>\n    \n    <tr><td>Hist.Min</td><td>Gibt ein\nHistogramm der Minima f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr><td>Hist.Max</td><td>Gibt ein\nHistogramm der Maxima f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr><td>Hist.Mittelwert</td><td>Gibt ein\nHistogramm der Mittelwerte f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr><td>Hist.Std.Ab.</td><td>Gibt ein\nHistogramm der Standardabweichungen f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr><td>Hist.Summe</td><td>Gibt ein\nHistogramm der Summen f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr><td>Hist.Max-Min</td><td>Gibt ein\nHistogramm der berechneten Maxima-Minima f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr><td>Hist.Last-First</td><td>Gibt ein\nHistogramm der berechnete letzten Werte minus der ersten Werte f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr><td>Hist.Count</td><td>Gibt ein\nHistogramm der Anzahl der Werte f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr><td>Hist.Grad</td><td>Gibt ein\nHistogramm der Gradienten f&uuml;r die Kombination aller\nvariablen Angaben aus. Nur f&uuml;r Werte mit identischen Einheiten!</td></tr><tr>\n      <td>Limits &Uuml;bersicht<br>\n      </td>\n      <td>Tabellarische Darstellung der definierten Limits f&uuml;r die Kombination aller Verfahren und Server.<br>\n      </td>\n    </tr>\n    <tr>\n      <td>DiffLimits &Uuml;bersicht<br>\n      </td>\n      <td>Tabellarische\nDarstellung der definierten DiffLimits f&uuml;r die Kombination aller\nVerfahren und Server.</td>\n    </tr>\n    <tr>\n      <td>isAlive &Uuml;bersicht<br>\n      </td>\n      <td>Tabellarische Darstellung der definierten isAlive f&uuml;r die Kombination aller Verfahren und Server.</td>\n    </tr>\n  </tbody>\n</table>','','ConfigHints'),(76,'de','__Ausgabemoeglichkeiten_Textmodus','<h4>Ausgabem&ouml;glichkeiten im Textmodus</h4>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td><span style=\"font-weight: bold;\">einzutragender\nAusdruck</span></td>\n<td><span style=\"font-weight: bold;\">Ausgabe\nals</span></td>\n</tr>\n<tr>\n<td>Tabelle</td>\n<td>Alle Werte werden als Tabelle mit Zeitstempel\nangezeigt.</td>\n</tr>\n<tr>\n<td>letzte_Werte</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die nur den letzten Wert aus dem Zeitraum enth&auml;lt.</td>\n</tr>\n<tr>\n<td>grafik</td>\n<td>Die Werte werden als Grafik angezeigt, deren\nAufl&ouml;sung hier festgelegt wird.</td>\n</tr>\n<tr>\n<td>min</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die das Minimum der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>max</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die das Maximum der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>avg</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die den arithmetische Mittelwert der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>std</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Standardabweichung der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>sum</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Summe aller Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>max-min</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Differenz vom Maximum zum Minimum der Werte enth&auml;lt.</td>\n</tr>\n<tr>\n<td>last-first</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Differenz vom (zeitlich) letzten Wert zum (zeitlich)\nersten Wert enth&auml;lt. Damit l&auml;sst sich zB die Zuwachsrate pro\nZeiteinheit darstellen.</td>\n</tr>\n<tr>\n<td>count</td>\n<td>Gibt (f&uuml;r jeden Server) eine einzeilige Tabelle\naus, die die Anzahl der Werte enth&auml;lt.</td>\n</tr><tr><td>grad</td><td></td></tr><tr><td>histogramm</td><td></td></tr><tr><td>histmin</td><td></td></tr><tr><td></td><td></td></tr>\n</tbody>\n</table>','','ConfigHints'),(77,'de','__Funktionen_in_KombiLimits','<h4>Funktionen in KombiLimits</h4>\n<p>F&uuml;r jede Bedingung k&ouml;nnen ein oder mehrere Vergleiche\neingetragen werden,\ndie mit logischen Operatoren miteinander verbunden sind. Ggf sollten\nVergleiche eingeklammert werden. Die in dieser Tabelle verwendeten\nPlatzhalter sind weiter unten beschrieben. Konstante Zahlen k&ouml;nnen\nverwendet werden.</p>\n<p>Beispiel f&uuml;r Bedingung:<br>\n$VALUE_OF(number of logs not backed up) &gt; $VALUE_OF(number of\nlogs) / 2\n&amp;&amp; $VALUE_OF(duration/s) &gt; 37</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n<tr>\n<td>$AVERAGE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Berechnet den arithmetischen Mittelwert f&uuml;r eine Anzahl\nvon Werten eines Details.<br>\n</td>\n</tr>\n<tr>\n<td>$COUNT_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Anzahl der&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRAD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt den Gradienten (lineare Steigung)\nder&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>,&nbsp;<span style=\"font-family: monospace;\">time_range</span>\n[,&nbsp;<span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet die lineare Steigung pro&nbsp;<span style=\"font-family: monospace;\">time_range</span>\n(Standard: 1d)&nbsp; f&uuml;r Werte, die\nf&uuml;r das angegebene Detail vom aktuellen Zeitpunkt bis&nbsp;<span style=\"font-family: monospace;\">time_past</span>\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist&nbsp;<span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis&nbsp;<span style=\"font-family: monospace;\">time_past</span>\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten\nquadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den&nbsp;<span style=\"font-family: monospace;\">time_range</span>\numgerechnet. Man kann also die Werte der\nletzten 24h\nbetrachten (<span style=\"font-family: monospace;\">time_past</span>\n= 24h) und daraus den Gradienten\npro 8 Stunden\n(<span style=\"font-family: monospace;\">time_range</span>\n= 8h) berechnen.<br>\n</td>\n</tr>\n<tr>\n<td>$LAST-FIRST_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom letzten&nbsp;zum ersten\nWert aus allen&nbsp;Werten des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Maximum der&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen&nbsp;Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Minimum der&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>,&nbsp;<span style=\"font-family: monospace;\">time_future</span>\n[,&nbsp;<span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der f&uuml;r ein Detail vorliegenden Werte innerhalb eines\nzur&uuml;ckliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte\neinem linearen Wachstum unterliegen. Wird <span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, dann wird <span style=\"font-family: monospace;\">time_future</span>&nbsp;verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten H&auml;lfte von&nbsp;<span style=\"font-family: monospace;\">time_past</span>\nliegen\nund die in der zweiten H&auml;lfte von&nbsp;<span style=\"font-family: monospace;\">time_past</span>\nliegen,\nwird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der\nangenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten\nSteigung wird der Endwert zu&nbsp;<span style=\"font-family: monospace;\">time_future</span>\nberechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>],<span style=\"font-family: monospace;\"></span>&nbsp;<span style=\"font-family: monospace;\">regexp</span>, <span style=\"font-family: monospace;\">time_range</span>)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregul&auml;ren Ausdrucks <span style=\"font-family: monospace;\">regexp</span>\nin allen&nbsp;Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">time_range</span>\n(nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$STD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Standardabweichung der&nbsp;Werte des\n<span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Summe der&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$VALUE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>)</td>\n<td>Ermittelt den letzten Wert des <span style=\"font-family: monospace;\">detail</span> </td>\n</tr>\n</tbody>\n</table>\n<h4>Beschreibung der variablen Ausdr&uuml;cke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<th>variabler Ausdruck</th>\n<th style=\"vertical-align: top;\">Erkl&auml;rung</th>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">integer</span></td>\n<td>Ganze Zahl zur Angabe der Anzahl &nbsp;der Werte\noder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">range</span></td>\n<td>Kann ein <span style=\"font-family: monospace;\">integer</span>\noder ein <span style=\"font-family: monospace;\">time_range</span>\nsein.<br>\n<span style=\"font-family: monospace;\">integer</span>\n(ohne <span style=\"font-family: monospace;\">time_unit</span>)\nlegt die <span style=\"font-weight: bold;\">Anzahl</span>\nder Werte fest, auf die die Funktion angewendet\nwerden soll. <br>\n<span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span>&nbsp;legt\nden zur&uuml;ckliegenden <span style=\"font-weight: bold;\">Zeitbereich</span>\nfest, f&uuml;r dessen vorhandene Werte&nbsp;die Funktion\nangewendet&nbsp;werden soll. </td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">detail</span></td>\n<td>Exakte Bezeichnung des Details. Keine umschlie&szlig;enden\neinfache oder doppelte Anf&uuml;hrungszeichen verwenden!</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">unit</span></td>\n<td>Mit einem / abgetrennte Einheit, die zu dem Detail\nangegeben werden muss, falls das Detail allein nicht eindeutig f&uuml;r\ndiesen Testschritt ist.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_future</span></td>\n<td>Ein Zeitbereich, im Format von&nbsp;<span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_past</span></td>\n<td>Ein Zeitbereich, im Format von&nbsp;<span style=\"font-family: monospace;\">time_range</span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_range</span></td>\n<td>Ist eine Angabe im Format von <span style=\"font-family: monospace;\">integer</span> <span style=\"font-family: monospace;\">time_unit</span>, z.B.\n8h, 17m, 3d</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_unit</span></td>\n<td>Ein Buchstabe, der die&nbsp;Zeiteinheit festlegt: m\n(Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n<h4>Operatoren</h4>\n<p>Die Operatoren k&ouml;nnen verwendet werden, um verschiedene\nFunktionen\nmiteinander zu kombinieren.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<th>MySQL Operatoren</th>\n<th style=\"text-align: left;\">Erkl&auml;rung</th>\n</tr>\n<tr>\n<td>&lt;, &gt;,&nbsp;=, !=, &lt;&gt;, &gt;=, &lt;=</td>\n<td>kleiner, gr&ouml;&szlig;er, gleich, ungleich, ungleich, gr&ouml;&szlig;er gleich,\nkleiner gleich</td>\n</tr>\n<tr>\n<td>+, -, *, /</td>\n<td>Addition, Subtraktion, Multiplikation, Division</td>\n</tr>\n<tr>\n<td>&amp;&amp;, AND, ||, OR</td>\n<td>logisches UND, logisches ODER</td>\n</tr>\n<tr>\n<td>( )</td>\n<td>Klammern f&uuml;r die Festlegung der Reihenfolge der\nAbarbeitung der Ausdr&uuml;cke.</td>\n</tr>\n</tbody>\n</table>\n<p>Neben den oben beschriebenen Operatoren k&ouml;nnen auch fast alle Funktionen der MySQL Datenbank verwendet werden. Im folgenden nur ein paar Beispiele. Die vollst&auml;ndige Liste ist unter z.B.:&nbsp;<a target=\"_blank\" href=\"http://dev.mysql.com/doc/refman/5.0/en/string-functions.html\">MySQL 5.0 Reference Manual :: 11 Functions and Operators</a> nachzulesen. In den Funktionen k&ouml;nnen NICHT&nbsp;<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]&nbsp;direkt verwendet werden, sondern nur &uuml;ber die Verwendung obiger Funktionen. Beispiel::</p><p>ABS($VALUE_OF(mittlere Antwortzeit) - $VALUE_OF(Antwortzeit)) &gt;= 1.5</p><table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\"><tbody><tr><th>MySQL Funktion</th><th>Erkl&auml;rung</th></tr><tr><td>ABS(<span style=\"font-family: monospace;\">ausdruck</span>)</td><td>Absoluter Wert</td></tr><tr><td>INSTR(<span style=\"font-family: monospace;\">ausdruck</span>, <span style=\"font-family: monospace;\">gesucht</span>)</td><td>liefert die erste Position, an der das Gesuchte&nbsp;im Ausdruck gefunden wird</td></tr><tr><td><span style=\"font-family: monospace;\">ausdruck</span> LIKE <span style=\"font-family: monospace;\">muster</span></td><td>Vergleicht\nden Ausdruck mit dem Muster, \'%\' ist Platzhalter f&uuml;r beliebig viele\nZeichen, \'_\' ist Platzhalter f&uuml;r genau ein Zeichen.</td></tr><tr><td>POWER(x,y)</td><td>Berechnet x<sup>y</sup> </td></tr><tr><td>ROUND(<span style=\"font-family: monospace;\">ausdruck</span>, <span style=\"font-family: monospace;\">stellen</span>)</td><td>Rundet den Ausdruck auf die Anzahl der angegebenen Stellen</td></tr></tbody></table>','','ConfigHints'),(192,'de','_aggregation_functions_de','<!-- Changes:\n  _aggregation_functions_de, de\n  2015-11-30, roveda: Created the help page.\n  2015-12-02, roveda: added missing functions (but still explanation to do)\n-->\n\n<hr>\n<h3 id=\"_aggregation_functions_de\">Komprimierungsfunktionen</h3> \n<p>Alle Komprimierungsfunktionen beziehen sich auf den Komprimierungszeitraum, wenn nicht anders angegeben.</p>\n<table>\n  <tbody>\n    <tr>\n      <th>Funktion</th>\n      <th>Berechnung</th>\n    </tr>\n    <tr>\n      <td>Accel</td>\n      <td>Es wird die Krümmung der \"Quadratischen Regression bestimmt\". Gespeichert wird die Krümmung pro Stunde², so dass für die neue Einheit gilt: &lt;Einheit der Werte&gt;/h².</td>\n    </tr>\n    <tr>\n      <td>Age</td>\n      <td>Berechnung des berechnet das Alter des Zeitstempels in Sekunden der Werte.</td>\n    </tr>\n    <tr>\n      <td>Avg</td>\n      <td>Berechnung des arithmetischen Mittelwerts der Werte.</td>\n    </tr>\n    <tr>\n      <td>Count</td>\n      <td>Berechnug der Anzahl&nbsp;(!!!) der Werte.</td>\n    </tr>\n    <tr>\n      <td>Dev</td>\n      <td>Berechnug der Standardabweichung der Werte.</td>\n    </tr>\n    <tr>\n      <td>Differ</td>\n      <td>Vergleich des letzten und ersten Wertes, liefert 1 für ungleich und 0 für gleich. Da sinnlos, wird die Funktion in der nächsten Version entfernt.</td>\n    </tr>\n    <tr>\n      <td>DiffOf</td>\n      <td>Bei jedem Wert (jeder Datei) werden die Unterschiede zum vorherigen Werte bestimmt. Die geänderten Zeilen werden gespeichert.</td>\n    </tr>\n    <tr>\n      <td>Grad</td>\n      <td>Berechnung des Gradienten der Werte. Es wird die Ausgleichsgerade nach Gauß berechnet. Gespeichert wird die Steigung pro Stunde, so dass für die neue Einheit gilt: &lt;Einheit der Werte&gt;/h.</td>\n    </tr>\n    <tr>\n      <td>First</td>\n      <td>Verwende den letzten Wert.</td>\n    </tr>\n    <tr>\n      <td>FirstLine</td>\n      <td>Erste Zeile einer Datei oder eines Wertes, der aus mehreren Zeilen besteht.</td>\n    </tr>\n    <tr>\n      <td>FirstSize</td>\n      <td>Größe in Bytes des ertsen Wertes oder der ersten Datei des Zeitraumes.</td>\n    </tr>\n    <tr>\n      <td>Last/AVG</td>\n      <td>Verhältinis des letzten Wertes zum Mittelwert der übrigen Werte.</td>\n    </tr>\n    <tr>\n      <td>Last-First</td>\n      <td>Berechnung der Differenz vom letzten zum ersten Wert.</td>\n    </tr>\n    <tr>\n      <td>LastLine</td>\n      <td>Letzte Zeile einer Datei oder eines Wertes, der aus mehreren Zeilen besteht.</td>\n    </tr>\n    <tr>\n      <td>LastSize</td>\n      <td>Größe in Bytes des letzten Wertes oder der letzten Datei des Zeitraumes.</td>\n    </tr>\n    <tr>\n      <td>Max</td>\n      <td>Berechnung des Maximums der Werte.</td>\n    </tr>\n    <tr>\n      <td>Max-Min</td>\n      <td>Berechnung der Differenz vom Maximum zum Minimum der Werte.</td>\n    </tr>\n    <tr>\n      <td>Min</td>\n      <td>Berechnung des Minimums der Werte.</td>\n    </tr>\n    <tr>\n      <td>Size</td>\n      <td>Berechne die Größe von jedem Wert.</td>\n    </tr>\n    <tr>\n      <td>Std</td>\n      <td>Berechnung der Standardabweichung der Werte.</td>\n    </tr>\n    <tr>\n      <td>Sum</td>\n      <td>Berechnung der Summe der Werte.</td>\n    </tr>\n  </tbody>\n</table>\n\n','','ConfigHints'),(79,'de','__Platzhalter_und_Funktionen_in_Meldung','<h4>Platzhalter und Funktionen in \'Meldung\'</h4>\n<!-- Fussnoten o&auml; verwenden, um isAlive, DiffLimits und andere zu unterscheiden ansonsten alle in einer Tabelle darstellen -->\n<p>Im Text von \"Meldung\" k&ouml;nnen folgende Platzhalter und\nFunktionen\nverwendet werden, die vor der Versendung der \"Meldung\" durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n<p>Platzhalter</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<col width=\"56\"> <col width=\"200\"> <thead>\n<tr style=\"font-weight: bold;\" valign=\"top\">\n<td width=\"22%\">Platzhalter</td>\n<td width=\"78%\">wird ersetzt durch</td><td style=\"text-align: center;\">Limits</td><td style=\"text-align: center;\">DiffLimits</td><td style=\"text-align: center;\">KombiLimits</td><td style=\"text-align: center;\">isAlive</td>\n</tr>\n</thead> <tbody>\n<tr>\n<td>$AVERAGEOVER</td>\n<td>die Anzahl der Werte oder Zeitbereich\nvon \"mitteln &uuml;ber\"</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$COMPARE</td>\n<td width=\"78%\">den angewandte Vergleich</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$DETAIL</td>\n<td width=\"78%\">das Detail (die &Uuml;berschrift der\nTabellenspalte)</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr><td>$DIFF</td><td>Differenz des Vergleichs oder der Subtraktion des vorigen Werts vom aktuellen Wert</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td></tr><tr valign=\"top\">\n<td width=\"20%\">$LASTDATE\n</td>\n<td width=\"78%\">Zeitstempel des letzten vorhanden\nWerts</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$LIMIT</td>\n<td width=\"78%\">den verletzten Limit\n(Info/Warn/Fehler)</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n<tr><td>$PREVVALUE</td><td>Wert des vorigen Werts</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td></tr><tr valign=\"top\">\n<td width=\"22%\">$SECTION</td>\n<td width=\"78%\">die Sektion</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$SERVER</td>\n<td width=\"78%\">den Namen des Rechners</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$TESTSTEP</td>\n<td width=\"78%\">die Bezeichnung des Testschritts,\nggf mit Doppelpunkten bei rekursiven Testschritten</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"20%\">$TIMEDIFF\n</td>\n<td width=\"78%\">die festgestellte Zeitdifferenz (die\ndie Frist &uuml;berschritten hat und zur Ausl&ouml;sung der Benachrichtigung\ngef&uuml;hrt hat)</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"20%\">$TIMELIMIT\n</td>\n<td width=\"78%\">Definierte Frist</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$UNIT</td>\n<td width=\"78%\">die Einheit des Werts</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">x</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$VALUE</td>\n<td width=\"78%\">den aktuellen Wert, der die\nLimits-Verletzung ausgel&ouml;st hat</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">x</td><td style=\"text-align: center;\">-</td><td style=\"text-align: center;\">-</td>\n</tr>\n</tbody>\n</table><p>Funktionen</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n<tr>\n<td>$AVERAGE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Berechnet den arithmetischen Mittelwert f&uuml;r eine Anzahl\nvon Werten eines Details.<br>\n</td>\n</tr>\n<tr>\n<td>$COUNT_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Anzahl der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$DIFF_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>)\n</td>\n<td>Ermittelt\ndie Differenz (Unix Kommando diff) der letzten beiden Werte (k&ouml;nnen\nauch Dateien sein) und liefert\nmaximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei w&uuml;rde\nes sich sinnvollerweise um Werte mit Textinhalten\nhandeln.&nbsp;Unterst&uuml;tzte Dateiformate mit Komprimierung\nsind:&nbsp;.gz und&nbsp;.bz2. Alle anderen Dateiformate werden\nverglichen wie sie sind.\n</td>\n</tr>\n<tr>\n<td>$GRAD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt den Gradienten (lineare Steigung)\nder Werte des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>, <span style=\"font-family: monospace;\">time_range</span>\n[ <span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet die lineare Steigung pro <span style=\"font-family: monospace;\">time_range</span>\n(Standard: 1d) f&uuml;r Werte, die\nf&uuml;r das angegebene Detail vom aktuellen Zeitpunkt bis <span style=\"font-family: monospace;\">time_past</span>\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist <span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis <span style=\"font-family: monospace;\">time_past</span>\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten\nquadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den <span style=\"font-family: monospace;\">time_range</span>\numgerechnet. Man kann also die Werte der\nletzten 24h\nbetrachten (<span style=\"font-family: monospace;\">time_past</span>\n= 24h) und daraus den Gradienten\npro 8 Stunden\n(<span style=\"font-family: monospace;\">time_range</span>\n= 8h) berechnen.<br>\n</td>\n</tr>\n<tr>\n<td>$LAST-FIRST_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten\nWert aus allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Maximum der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Minimum der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>, <span style=\"font-family: monospace;\">time_future</span>\n[, <span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der f&uuml;r ein Detail vorliegenden Werte innerhalb eines\nzur&uuml;ckliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte\neinem linearen Wachstum unterliegen. Wird <span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, dann wird <span style=\"font-family: monospace;\">time_future</span>\nverwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten H&auml;lfte von <span style=\"font-family: monospace;\">time_past</span>\nliegen\nund die in der zweiten H&auml;lfte von <span style=\"font-family: monospace;\">time_past</span>\nliegen,\nwird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der\nangenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten\nSteigung wird der Endwert zu <span style=\"font-family: monospace;\">time_future</span>\nberechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>],<span style=\"font-family: monospace;\"></span> <span style=\"font-family: monospace;\">regexp</span>, <span style=\"font-family: monospace;\">time_range</span>)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregul&auml;ren Ausdrucks <span style=\"font-family: monospace;\">regexp</span>\nin allen Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">time_range</span>\n(nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$STD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Standardabweichung der Werte des\n<span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Summe der Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$VALUE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>)</td>\n<td>Ermittelt den letzten Wert des <span style=\"font-family: monospace;\">detail</span> </td>\n</tr>\n</tbody>\n</table>\n<h4>Beschreibung der variablen Ausdr&uuml;cke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<th>variabler Ausdruck</th>\n<th style=\"vertical-align: top;\">Erkl&auml;rung</th>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">integer</span></td>\n<td>Ganze Zahl zur Angabe der Anzahl der Werte\noder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">range</span></td>\n<td>Kann ein <span style=\"font-family: monospace;\">integer</span>\noder ein <span style=\"font-family: monospace;\">time_range</span>\nsein.<br>\n<span style=\"font-family: monospace;\">integer</span>\n(ohne <span style=\"font-family: monospace;\">time_unit</span>)\nlegt die <span style=\"font-weight: bold;\">Anzahl</span>\nder Werte fest, auf die die Funktion angewendet\nwerden soll. <br>\n<span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span> legt\nden zur&uuml;ckliegenden <span style=\"font-weight: bold;\">Zeitbereich</span>\nfest, f&uuml;r dessen vorhandene Werte die Funktion\nangewendet werden soll. </td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">detail</span></td>\n<td>Exakte Bezeichnung des Details. Keine umschlie&szlig;enden\neinfache oder doppelte Anf&uuml;hrungszeichen verwenden!</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">unit</span></td>\n<td>Mit einem / abgetrennte Einheit, die zu dem Detail\nangegeben werden muss, falls das Detail allein nicht eindeutig f&uuml;r\ndiesen Testschritt ist.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_future</span></td>\n<td>Ein Zeitbereich, im Format von <span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_past</span></td>\n<td>Ein Zeitbereich, im Format von <span style=\"font-family: monospace;\">time_range</span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_range</span></td>\n<td>Ist eine Angabe im Format von <span style=\"font-family: monospace;\">integer</span> <span style=\"font-family: monospace;\">time_unit</span>, z.B.\n8h, 17m, 3d</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_unit</span></td>\n<td>Ein Buchstabe, der die Zeiteinheit festlegt: m\n(Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>','','ConfigHints'),(80,'de','__Reports_Verfahren_Benutzer','\n\n<h4>Reports, Verfahren und Benutzer</h4>\nEin Benutzer besitzt die Zugriffsrechte auf <span\n style=\"font-weight: bold;\">mehrere</span> Verfahren.\nEr erstellt einen Report,\nder sich auf Werte dieser Verfahren bezieht. Diesen Report gibt er f&uuml;r\nalle\nULS Benutzer <span style=\"font-weight: bold;\">eines</span>\nVerfahrens frei.\nEin anderer Benutzer kann also diesen Report aufrufen, es wird jedoch\nu.U.\nnicht alles angezeigt, falls der Benutzer nicht auf alle im Report\nreferenzierten Verfahren Zugriff hat.</p>','','ConfigHints'),(81,'de','__Vergleichsoperatoren','<h4>Vergleichsoperatoren \'Limits\'</h4>\n<p>Erkl&auml;rung der einsetzbaren&nbsp;Vergleichsoperatoren f&uuml;r die\nDefinition von Limits. Die verwendbaren Vergleichsoperatoren sind\nteilweise abh&auml;ngig von den&nbsp;Datentypen der Werte, auf die sie\nangewendet werden. </p>\n<p><span style=\"font-weight: bold;\">Definition</span>\nvon Ausdr&uuml;cken, die zur weiteren Beschreibung der\nVergleichsoperatoren verwendet werden:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Ausdruck</td>\n<td>Bedeutung</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent f&uuml;r die Menge von Integer und Float\nverwendet</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird f&uuml;r beliebige Textausdr&uuml;cke verwendet</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">value</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">limit</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler\nals DiffLimit eingetragen ist</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">regexp</td>\n<td>ist ein regul&auml;rer Ausdruck, der POSIX 1003.2 (wie zB in\n\"man 7 regex\" beschrieben) entsprechen muss und der bei\nInfo/Warn/Fehler eingetragen ist. Er wird anstelle des&nbsp;<span style=\"font-family: monospace;\">limit</span> verwendet</td>\n</tr>\n</tbody>\n</table>\n<p>Vor dem Vergleich werden die Datentypen von <span style=\"font-family: monospace;\">value</span>\nund&nbsp;<span style=\"font-family: monospace;\">limit</span>\nangepasst. Die\n<span style=\"font-weight: bold;\">Datentypumwandlung</span>\nerfolgt nach folgender Vorschrift:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td> Datentyp<br>\n<span style=\"font-family: monospace;\">value</span></td>\n<td> Datentyp<br>\n<span style=\"font-family: monospace;\">limit</span></td>\n<td style=\"vertical-align: top;\">Vergleich wird\ndurchgef&uuml;hrt als Datentyp</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>Integer</td>\n<td>Integer</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>Float</td>\n<td>Float</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>Integer</td>\n<td>Float</td>\n</tr>\n<tr>\n<td>String</td>\n<td>beliebig</td>\n<td>String</td>\n</tr>\n<tr>\n<td>beliebig</td>\n<td>String</td>\n<td>String<br>\n</td>\n</tr>\n</tbody>\n</table>\n<p>Allgemein gilt dabei f&uuml;r die Vergleiche:</p>\n<ul>\n<li>Bei String-Vergleichen wird Gro&szlig;-Kleinschreibung\nunterschieden.</li>\n<li>\"!\" ist die Negation des Vergleichs.</li>\n<li>\"|\"\n<ul>\n<li>Integer, Float: bildet Absolutwerte von beiden\nAusdr&uuml;cken bevor verglichen wird (abs)</li>\n<li>String: vergleicht beide Ausdr&uuml;cke unabh&auml;ngig von\nGro&szlig;-Kleinschreibung (ignore case)<br>\n</li>\n</ul>\n</li>\n</ul>\n<p> <span style=\"color: rgb(255, 0, 0);\">Hinweis:</span>\nDie (Text-)Vergleiche erfolgen gegen den\ngesamten Textausdruck eines Wertes, liegen mehrere Textausdr&uuml;cke zum\ngleichen Zeitstempel vor, so wird nur der LETZTE! Textausdruck\nverglichen.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgef&uuml;hrter Vergleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich</td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\">value</td><td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich&nbsp;(abs/ignore case)</td></tr><tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\">value</td><td style=\"text-align: center; font-family: monospace;\">!==|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich, keine Datentypenumwandlung (immer String) (ignore case)</td></tr><tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enth&auml;lt&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enth&auml;lt&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enth&auml;lt\nnicht&nbsp;<span style=\"font-family: monospace;\">limit</span>\nals Substring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enth&auml;lt\nnicht&nbsp;<span style=\"font-family: monospace;\">limit</span>\nals Substring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does\nnot match&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does\nnot match&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case) </td>\n</tr>\n</tbody>\n</table>','','ConfigHints'),(82,'de','__Vergleichsoperatoren_DiffLimits','<h4>Vergleichsoperatoren \'DiffLimits\'</h4>\n<p>Erkl&auml;rung der einsetzbaren&nbsp;Vergleichsoperatoren bei\nder\nDefinition von DiffLimits. Die verwendbaren Vergleichsoperatoren\nsind&nbsp;abh&auml;ngig von den Datentypen der Werte, auf die\nsie\nangewendet werden. </p>\n<p><span style=\"font-weight: bold;\">Definition</span>\nvon Ausdr&uuml;cken, die zur weiteren Beschreibung der\nVergleichsoperatoren verwendet werden:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Ausdruck</td>\n<td>Bedeutung</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent f&uuml;r die Menge von Integer und Float\nverwendet (Details mit numerischen Werten)</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird f&uuml;r beliebige Textausdr&uuml;cke verwendet (Details mit\nTextwerten)</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">diff</td>\n<td>ist die Subtraktion des vorigen Werts vom\naktuellen Wert</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">limit</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler\nals DiffLimit eingetragen ist</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">voriger Wert</td>\n<td>ist der vorige Wert</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">aktueller Wert</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n</tbody>\n</table>\n<p>Allgemein gilt dabei f&uuml;r die Vergleiche:</p>\n<ul>\n<li>Bei String-Vergleichen wird Gro&szlig;-Kleinschreibung\nunterschieden.</li>\n<li>\"!\" ist die Negation des Vergleichs.</li>\n<li>\"|\"\n<ul>\n<li>Integer, Float: bildet Absolutwerte von beiden\nAusdr&uuml;cken bevor verglichen wird (abs)</li>\n<li>String: vergleicht beide Ausdr&uuml;cke unabh&auml;ngig von\nGro&szlig;-Kleinschreibung (ignore case)<br>\n</li>\n</ul>\n</li>\n</ul>\n\n<p><span style=\"font-weight: bold;\">Vergleichsoperatoren\nf&uuml;r Zahlen</span></p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgef&uuml;hrter Vergleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich (abs)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich <sup>(1)</sup></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich (abs) <sup>(1)</sup></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">diff</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich <sup>(1)</sup></td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\"><span style=\"font-family: monospace;\">diff</span></td><td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich (abs)&nbsp;<sup>(1)</sup></td></tr></tbody>\n</table>\n<p><sup>(1)</sup> Diese Vergleiche werden auf <span style=\"font-weight: bold;\">jeden</span> eingehenden\nWert durchgef&uuml;hrt mit ggf der Ausl&ouml;sung von Benachrichtigungen!</p>\n<p><span style=\"font-weight: bold;\">Vergleichsoperatoren\nf&uuml;r Strings</span></p>\n<p>Alle Vergleiche f&uuml;r Strings werden auf <span style=\"font-weight: bold;\">jeden</span> eingehenden\nWert durchgef&uuml;hrt mit ggf der Ausl&ouml;sung von Benachrichtigungen!\nDie Vergleiche erfolgen gegen den\ngesamten Textausdruck eines Wertes, liegen mehrere Textausdr&uuml;cke zum\ngleichen Zeitstempel vor, so wird nur der <span style=\"font-weight: bold;\">letzte</span> Textausdruck\nverglichen.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgef&uuml;hrter Vergleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">==</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">==|</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>gleich (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">!==</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>ungleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">voriger\nWert</td>\n<td style=\"text-align: center; font-family: monospace;\">!==|</td>\n<td style=\"text-align: center; font-family: monospace;\">aktueller\nWert</td>\n<td>ungleich (ignore case)</td>\n</tr>\n</tbody>\n</table>','','ConfigHints'),(83,'de','__Zeitraum','<h4>Zeitraum</h4>\n<p>Festlegen des gew&uuml;nschten Zeitraums f&uuml;r den die Werte\ndargestellt werden sollen.<br>\n</p>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<th>Zeitraum</th>\n<th>Erkl&auml;rung</th>\n</tr>\n<tr>\n<td>zwei Stunden</td>\n<td>die Werte der zwei letzten vollst&auml;ndigen Stunden</td>\n</tr>\n<tr>\n<td>ab zwei Stunden</td>\n<td>die Werte der zwei letzten vollst&auml;ndigen Stunden und\nbis zum aktuellen Zeitpunkt</td>\n</tr>\n<tr>\n<td>Heute</td>\n<td>alle Werte ab heute 00:00:00 Uhr </td>\n</tr>\n<tr>\n<td>Gestern</td>\n<td>nur die Werte von gestern</td>\n</tr>\n<tr>\n<td>ab Gestern</td>\n<td>die Werte von gestern bis zum aktuellen Zeitpunkt</td>\n</tr>\n<tr>\n<td>diese Woche</td>\n<td>alle Werte ab Montag dieser Woche 00:00:00 Uhr&nbsp;bis\nzum aktuellen Zeitpunkt</td>\n</tr>\n<tr>\n<td>7 Tage</td>\n<td>die Werte der letzten 7 Tage bis gestern 24:00:00 Uhr</td>\n</tr>\n<tr>\n<td>ab 7 Tage</td>\n<td>die Werte der letzten 7 Tage&nbsp;und bis zum\naktuellen Zeitpunkt</td>\n</tr>\n<tr>\n<td>letzte Woche</td>\n<td>die Werte von Montag bis Sonntag der vorigen Woche </td>\n</tr>\n<tr>\n<td>ab letzter Woche</td>\n<td>alle Werte ab Montag der vorigen Woche bis zum\naktuellen Zeitpunkt</td>\n</tr>\n<tr>\n<td>Monat</td>\n<td>die Werte ab dem Datum des gestrigen Tages des\nvorigen&nbsp;Monats&nbsp;bis gestern 24:00:00 Uhr</td>\n</tr>\n<tr>\n<td>letzter Monat</td>\n<td>die Werte ab dem 01. des vorigen Monats bis zum letzten\nTag des&nbsp;vorigen Monats</td>\n</tr>\n<tr>\n<td>ab letztem Monat</td>\n<td>die Werte ab dem 01. des vorigen Monats bis\nzum&nbsp;aktuellen Zeitpunkt</td>\n</tr>\n<tr>\n<td>3 Monate</td>\n<td>die Werte der letzten 3 vollst&auml;ndigen Monate</td>\n</tr>\n<tr>\n<td>Jahr</td>\n<td>die Werte ab dem Datum des gestrigen Tages des vorigen\nJahres bis gestern 24:00:00 Uhr</td>\n</tr>\n<tr>\n<td>komplett</td>\n<td>alle vorhandenen Werte ohne zeitliche Einschr&auml;nkung</td>\n</tr>\n</tbody>\n</table>','','ConfigHints'),(84,'de','__Zeitraum_Textmodus','<h4>Zeitraum im Textmodus </h4>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td><span style=\"font-weight: bold;\">einzutragender\nAusdruck</span></td>\n<td><span style=\"font-weight: bold;\">verwendeter\nZeitraum</span></td>\n</tr>\n<tr>\n<td>zweistd</td>\n<td>die letzten zwei Stunden</td>\n</tr>\n<tr>\n<td>heute</td>\n<td>Heute</td>\n</tr>\n<tr>\n<td>gestern</td>\n<td>Gestern 00:00h bis 23:59h</td>\n</tr>\n<tr>\n<td>abgestern</td>\n<td>ab gestern 00:00h bis heute 23:59h</td>\n</tr>\n<tr>\n<td>woche</td>\n<td>diese Woche</td>\n</tr>\n<tr>\n<td>7tage</td>\n<td>die zur&uuml;ckliegenden 7 Tage und heute</td>\n</tr>\n<tr>\n<td>letztewoche</td>\n<td>die letzte Woche von Montag 00:00h bis Sonntag\n23:59h</td>\n</tr>\n<tr>\n<td>abwoche</td>\n<td>ab Monatg 00:00h letzter Woche bis heute 23:59h</td>\n</tr>\n<tr>\n<td>komplett</td>\n<td>der kompletter Zeitraum, f&uuml;r den ausgew&auml;hlten\nWerte vorliegen</td>\n</tr>\n<tr>\n<td>YYYY-MM-DD hh:mm:ss,YYYY-MM-DD hh:mm:ss</td>\n<td>exakt f&uuml;r den so definierten Zeitraum, auch wenn\nkeine Werte (mehr) daf&uuml;r vorliegen</td>\n</tr>\n</tbody>\n</table>','','ConfigHints'),(85,'de','__Zeitraum_von_bis','<h4>Zeitraum Von Bis</h4>\n<p>&Uuml;ber diese beiden konkreten Zeitstempel kann ein exakt definierter\nZeitraum angegeben werden, der nicht &uuml;ber die vorgegebenen Zeitr&auml;ume\neinstellbar ist. Die beiden Zeitstempel sind konstant.</p>\n<p>Das Format ist immer \"YYYY-MM-DD hh:mm:ss\" (ISO 8601 / EN 28601).','','ConfigHints'),(86,'de','__mitteln_ueber','<h4>mitteln &uuml;ber</h4>\n<p>&Uuml;ber dir Drop-Down-Liste erfolgt die Auswahl\nder Funktion, die in Verbindung mit der Eingabe im Textfeld angewendet\nwird, bevor der Vergleich ausgef&uuml;hrt wird. Hier die Liste der Funktionen:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td>Last<br>\n</td>\n<td>Verwende nur den letzten Wert (chronologisch der\nj&uuml;ngste)<br>\n</td>\n</tr>\n<tr>\n<td>Avg<br>\n</td>\n<td>Mittelwert berechnen<br>\n</td>\n</tr>\n<tr>\n<td>Sum<br>\n</td>\n<td>Summe berechnen<br>\n</td>\n</tr>\n<tr>\n<td>Std<br>\n</td>\n<td>Standardabweichung berechnen<br>\n</td>\n</tr>\n<tr>\n<td>Min<br>\n</td>\n<td>minimalen Wert verwenden<br>\n</td>\n</tr>\n<tr>\n<td>Max<br>\n</td>\n<td>maximalen Wert verwenden<br>\n</td>\n</tr>\n<tr>\n<td>Max-Min<br>\n</td>\n<td>Subtrahiere den minimalen Wert vom maximalen Wert<br>\n</td>\n</tr>\n<tr>\n<td>Last-First<br>\n</td>\n<td>Subtrahiere den ersten Wert (&auml;ltesten) vom letzten Wert\n(j&uuml;ngsten)<br>\n</td>\n</tr>\n<tr>\n<td>Count</td>\n<td>Anzahl der Werte verwenden<br>\n</td>\n</tr>\n<tr>\n<td>Grad</td>\n<td>Gradient berechnen<br>\n</td>\n</tr>\n</tbody>\n</table>\n<p>Im Textfeld erfolgt die Eingabe der Anzahl oder des Zeitbereichs, der zur Anwendung\nder oben gew&auml;hlten Funktion verwendet werden soll.\nEine einfache Zahl legt die Anzahl der letzten Werte fest, die f&uuml;r den\nVergleich verwendet werden sollen.\nF&uuml;r einen Zeitbereich wird eine Zahl und eine Abk&uuml;rzung f&uuml;r den\nZeitabschnitt eingetragen. Abk&uuml;rzungen f&uuml;r den Zeitbereich:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td>m</td>\n<td>Minuten</td>\n</tr>\n<tr>\n<td>h</td>\n<td>Stunden</td>\n</tr>\n<tr>\n<td>d</td>\n<td>Tage</td>\n</tr>\n</tbody>\n</table>\n<p>Beispiele mit Erkl&auml;rungen zu&nbsp;m&ouml;glichen\nEingaben:</p>\n<table style=\"border-collapse: collapse;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td>[ Last&nbsp;]<br>\n</td>\n<td>Verwende den letzten Wert f&uuml;r den Vergleich.<br>\n</td>\n</tr>\n<tr>\n<td>[ Avg ]<br>\n[ 10 ]<br>\n</td>\n<td>Verwende\ndie letzten 10 Werte, bilde daraus den Mittelwert und verwende diesen\nf&uuml;r den Vergleich.<br>\n</td>\n</tr>\n<tr>\n<td>[ Grad ]<br>\n[ 60m ]<br>\n</td>\n<td>Berechne\nden Gradienten der Werte aus den letzten 60 Minuten und f&uuml;hre mit\ndiesem Wert dann den Vergleich aus.<br>\n</td>\n</tr>\n<tr>\n<td>[ Count ]<br>\n[ 2d ]<br>\n</td>\n<td>Ermittle\ndie Anzahl der Werte f&uuml;r die letzten 2 Tage (48h) und verwende diese\nAnzahl f&uuml;r den Vergleich.<br>\n</td>\n</tr>\n</tbody>\n</table>','','ConfigHints'),(142,'de','autocompress_nt','<p>Textmodus für Auto-Komprimierungen.</p>\n<p>Mit [<span style=\"background-color: rgb(192, 192, 192);\">Export</span>]\nerhält man die aktuellen Auto-Komprimierungen im Textmodus-Format angezeigt.</p>\n\n <!-- \nserver=lxartp\nsection=oracle db*\nteststep=buffer cache\ndetail=size,used,hit ratio\nunit=\nhourly=last,avg,sum,dev,min,max,max-min,last-first,count,grad,first,accel,differ,size\ndaily=avg,min,max\nweekly=avg,min,max\nmonthly=\naccess=all\n-->\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Parametername</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n\n  <tr>\n    <td>\n      server=<br>\n      section=<br>\n      teststep=<br>\n      detail=<br>\n      unit=<br>\n    </td>\n    <td>Definiert das Server -- Sektion -- Testschritt -- Detail -- Einheit Muster, \n    jede Angabe kann dabei ein Textmuster enthalten, wie in \"Ausdrücke in Textfeldern\" beschrieben.\n    </td>\n  </tr>\n  <tr>\n    <td>\n      hourly=<br>\n      daily=<br>\n      weekly=<br>\n      monthly=\n    </td>\n    <td>\n      Kommagetrennte Liste der auszuführenden Komprimierungsfunktionen, \n      mögliche Funktionen: last, avg, sum, dev, min, max, max-min, last-first, count, grad, first, accel, differ, size<br>\n      siehe auch \"Komprimierungsfunktionen\".\n    </td>\n  </tr>\n  <tr>\n    <td>access=</td>\n    <td>&nbsp;</td>\n  </tr>\n </tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n\n<h4>Komprimierungsfunktionen</h4>\n<p>Die Funktionen beziehen sich immer auf den jeweiligen Zeitbereich.</p>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n  <thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n    <tr>\n      <td>Funktion</td>\n      <td>Berechnung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>Accel</td>\n      <td>Berechnung der Beschleunigung</td>\n    </tr>\n    <tr>\n      <td>Avg</td>\n      <td>Berechnung des arithmetischen Mittelwerts</td>\n    </tr>\n    <tr>\n      <td>Count</td>\n      <td>Berechnung der Anzahl der Werte</td>\n    </tr>\n    <tr>\n      <td>Dev</td>\n      <td>Berechnung der Standardabweichung</td>\n    </tr>\n    <tr>\n      <td>Differ</td>\n      <td>Berechnung, ob eine Differenz vorliegt ???</td>\n    </tr>\n    <tr>\n      <td>First</td>\n      <td>Bestimmung des ersten Wertes</td>\n    </tr>\n    <tr>\n      <td>Grad</td>\n      <td>Berechnung des Gradienten</td>\n    </tr>\n    <tr>\n      <td>Last</td>\n      <td>Bestimmung des letzten Wertes</td>\n    </tr>\n    <tr>\n      <td>Last-First</td>\n      <td>Berechnung der Differenz vom letzten zum ersten Wert</td>\n    </tr>\n    <tr>\n      <td>Max</td>\n      <td>Berechnung des Maximums</td>\n    </tr>\n    <tr>\n      <td>Max-Min</td>\n      <td>Berechnung der Differenz vom Maximum zum Minimum</td>\n    </tr>\n    <tr>\n      <td>Min</td>\n      <td>Berechnung des Minimums</td>\n    </tr>\n    <tr>\n      <td>Size</td>\n      <td>Berechnung der Größe eines BLOBs, einer Datei oder eines Textausdrucks.</td>\n    </tr>\n    <tr>\n      <td>Sum</td>\n      <td>Berechnung der Summe</td>\n    </tr>\n  </tbody>\n</table>\n\r','','ConfigHints'),(144,'de','set_autollimits','<p>Eine Kompr-Limit-Überwachungen löst eine Benachrichtigung aus, \nsobald ein komprimierter Wert einen definierten Grenzwert verletzt.</p>\n<p>Hier werden automatisch zu verwendende Kompr-Limits-Überwachungen (Auto-Kompr-Limits) \nfür alle komprimierten Werte, die zu definierten \nServer -- Sektion -- Testschritt -- Detail -- Einheit Mustern dieses Verfahrens passen, festgelegt.</p>\n<p>Sobald neu berechnete komprimierte Werte mit bisher nicht vorhandenen \nServer -- Sektion -- Testschritt -- Detail -- Einheit Kombinationen auftreten \nwird geprüft, ob diese zu den hier definierten Mustern passen und ggf \nwerden die eingetragenen Kompr-Limits-Überwachungen wirksam.</p>\n<p>Die Kontrolle auf verletzte Kompr-Limits-Überwachungen erfolgt einmalig kurz nach 24:00 Uhr, nach \nder Berechnung aller zu komprimierenden Werte.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead> <tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>\nServer<br>\nSektion<br>\nTestschritt\n</td>\n<td>Hier wird festgelegt, für welche Server -- Sektion -- Testschritt Muster dieser Auto-Kompr-Limit gelten soll, siehe \"Ausdrücke in Textfeldern\"</td>\n</tr>\n<tr>\n<td>Detail<br>\nEinheit<br>\nAccess</td>\n<td>Hier wird festgelegt, für welche Detail -- Einheit Muster dieser Auto-Kompr-Limit gelten soll,\nsiehe \"Ausdrücke in Textfeldern\". ACHTUNG: hierbei ist zu beachten, dass \nan dieser Stelle die Bezeichnungen der komprimierten Details zu berücksichtigen sind! Also zB \"Avg[H](size)\"!</td>\n</tr>\n<tr>\n<td>mitteln über</td>\n<td>\nFestlegen, welche Funktion angewendet und wieviele Werte für diese\nFunktion verwendet werden sollen, bevor der Vergleich ausgeführt wird.\nSiehe \"mitteln über\"\n</td>\n</tr>\n<tr>\n<td>Vergleich</td>\n<td>Der Vergleichsoperand. der mit dem aktuellen Wert gegen die Kompr-Limits\nverwendet wird. Siehe \"Vergleichsoperatoren\"</td>\n</tr>\n<tr>\n<td>\nInfo<br>\nWarn<br>\nFehler\n</td>\n<td>Einer bis drei Grenzwerte, auf die geprüft wird. Es werden unterschiedliche Prioritäten ausgelöst.</td>\n</tr>\n<tr>\n<td>Meldung</td>\n<td>Hier kann eine benutzerdefinierte Meldung (max 3000 Zeichen)\neingetragen werden, eine standardisierte Meldung wird bei\nBenachrichtigungen immer geschickt. In der Meldung können Platzhalter\nund Funktionen verwendet werden, siehe \"Platzhalter und Funktionen in Meldung\"</td>\n</tr>\n<tr>\n<td>Meldungsziel</td>\n<td>Zwei für dieses Verfahren freigegebene Benachrichtigungsziele können über die \nDrop-Down-Listen eingestellt werden.<br>\nDie Checkboxen I W F (Info/Warn/Fehler) legen die Prioritäten\nfest, bei deren Verletzung eine Benachrichtigung an das jeweilige\nMeldungsziel geschickt wird.</td>\n</tr>\n<tr>\n<td>\naktiv<br>\nlöschen<br>\nalle ändern\n</td>\n<td>Damit wird dieser Auto-Kompr-Limit deaktiviert, aktiviert, gelöscht oder alle hieraus abgeleiteten Kompr-Limit-Überwachungen werden bzgl der vorgenommenen Änderungen angepasst.</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>mitteln über</h4>\n<p>Über dir Drop-Down-Liste erfolgt die Auswahl\nder Funktion, die in Verbindung mit der Eingabe im Textfeld angewendet\nwird, bevor der Vergleich ausgeführt wird. Hier die Liste der Funktionen:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Funktion</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Last</td>\n<td>Verwende den letzten Wert (chronologisch den jüngsten)</td>\n</tr>\n<tr>\n<td>Avg</td>\n<td>Mittelwert berechnen</td>\n</tr>\n<tr>\n<td>Sum</td>\n<td>Summe berechnen</td>\n</tr>\n<tr>\n<td>Std</td>\n<td>Standardabweichung berechnen</td>\n</tr>\n<tr>\n<td>Min</td>\n<td>minimalen Wert verwenden</td>\n</tr>\n<tr>\n<td>Max</td>\n<td>maximalen Wert verwenden</td>\n</tr>\n<tr>\n<td>Max-Min</td>\n<td>Subtrahiere den minimalen Wert vom maximalen Wert</td>\n</tr>\n<tr>\n<td>Last-First</td>\n<td>Subtrahiere den ersten Wert (ältesten) vom letzten Wert (jüngsten)</td>\n</tr>\n<tr>\n<td>Count</td>\n<td>Anzahl der Werte verwenden</td>\n</tr>\n<tr>\n<td>Grad</td>\n<td>Gradient berechnen</td>\n</tr>\n</tbody>\n</table>\n\n<p>Im Textfeld erfolgt die Eingabe der Anzahl oder des Zeitbereichs, der zur Anwendung der oben gewählten Funktion verwendet werden soll. Eine einfache Zahl legt die Anzahl der letzten Werte fest, die für den Vergleich verwendet werden sollen. Für einen Zeitbereich wird eine Zahl und eine Abkürzung für den Zeitabschnitt eingetragen. Abkürzungen für den Zeitbereich:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>m</td>\n<td>Minuten</td>\n</tr>\n<tr>\n<td>h</td>\n<td>Stunden</td>\n</tr>\n<tr>\n<td>d</td>\n<td>Tage</td>\n</tr>\n</tbody>\n</table>\n\n<p>Beispiele mit Erklärungen zu möglichen Eingaben:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>[ Last ]</td>\n<td>Verwende den letzten Wert für den Vergleich.</td>\n</tr>\n<tr>\n<td>\n[ Avg ]<br>\n[ 10 ]</td>\n<td>Verwende die letzten 10 Werte, bilde daraus den Mittelwert und verwende diesen für den Vergleich.</td>\n</tr>\n<tr>\n<td>\n[ Grad ]<br>\n[ 60m ]\n</td>\n<td>Berechne den Gradienten der Werte aus den letzten 60 Minuten und führe mit diesem Wert dann den Vergleich aus.\n</td>\n</tr>\n<tr>\n<td>\n[ Count ]<br>\n[ 2d ]\n</td>\n<td>Ermittle die Anzahl der Werte für die letzten 2 Tage (48h) und verwende diese Anzahl für den Vergleich.\n</td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Vergleichsoperatoren</h4>\n<p>Erklärung der einsetzbaren Vergleichsoperatoren für die\nDefinition von Limits. Die verwendbaren Vergleichsoperatoren sind\nteilweise abhängig von den Datentypen der Werte, auf die sie\nangewendet werden.</p>\n<p><span style=\"font-weight: bold;\">Definition</span>\nvon Ausdrücken, die zur weiteren Beschreibung der Vergleichsoperatoren verwendet werden:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<td>Ausdruck</td>\n<td>Bedeutung</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent für die Menge von Integer und Float verwendet</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird für beliebige Textausdrücke verwendet</td>\n</tr>\n<tr>\n<td>&lt;value&gt;</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n<tr>\n<td>&lt;limit&gt;</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler \n<!-- als DiffLimit (TODO) --> eingetragen ist</td>\n</tr>\n<tr>\n<td>&lt;regexp&gt;</td>\n<td>ist ein regulärer Ausdruck, der POSIX 1003.2 (wie zB in\n\"man 7 regex\" beschrieben) entsprechen muss und der bei\nInfo/Warn/Fehler eingetragen ist. Er wird anstelle des &lt;limit&gt; verwendet</td>\n</tr>\n</tbody>\n</table>\n\n<p>Vor dem Vergleich werden die Datentypen von &lt;value&gt;\nund &lt;limit&gt; angepasst. Die <span style=\"font-weight: bold;\">Datentypumwandlung</span>\nerfolgt nach folgender Vorschrift:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Datentyp<br>\n        &lt;value&gt;</td>\n    <td>Datentyp<br>\n        &lt;limit&gt;</td>\n    <td>Vergleich wird durchgeführt als Datentyp</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>Integer</td>\n  <td>Integer</td>\n  <td>Integer</td>\n</tr>\n<tr>\n  <td>Integer</td>\n  <td>Float</td>\n  <td>Float</td>\n</tr>\n<tr>\n  <td>Float</td>\n  <td>Integer</td>\n  <td>Float</td>\n</tr>\n<tr>\n  <td>String</td>\n  <td>beliebig</td>\n  <td>String</td>\n</tr>\n<tr>\n  <td>beliebig</td>\n  <td>String</td>\n  <td>String<br>\n</td>\n</tr>\n</tbody>\n</table>\n\n<p>Allgemein gilt dabei für die Vergleiche:</p>\n<ul>\n  <li>Bei String-Vergleichen wird Groß-Kleinschreibung unterschieden.</li>\n  <li>\"!\" ist die Negation des Vergleichs.</li>\n  <li>\"|\"\n    <ul>\n      <li>Integer und Float: bilden Absolutwerte von beiden Ausdrücken bevor verglichen wird (abs)</li>\n      <li>String: vergleicht beide Ausdrücke unabhängig von Groß-Kleinschreibung (ignore case)</li>\n    </ul>\n  </li>\n</ul>\n<p> <span style=\"color: rgb(255, 0, 0);\">Hinweis:</span>\nDie (Text-)Vergleiche erfolgen gegen den\ngesamten Textausdruck eines Wertes, liegen mehrere Textausdrücke zum\ngleichen Zeitstempel vor, so wird nur der LETZTE! Textausdruck\nverglichen.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgeführter Vergleich</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich</td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\">value</td><td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich&nbsp;(abs/ignore case)</td></tr><tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\">value</td><td style=\"text-align: center; font-family: monospace;\">!==|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich, keine Datentypenumwandlung (immer String) (ignore case)</td></tr><tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält\nnicht&nbsp;<span style=\"font-family: monospace;\">limit</span>\nals Substring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält\nnicht&nbsp;<span style=\"font-family: monospace;\">limit</span>\nals Substring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does\nnot match&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does\nnot match&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case) </td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in Meldung</h4>\n\n<p>Im Text von \'Meldung\' können folgende Platzhalter und Funktionen\nverwendet werden, die vor der Versendung der Benachrichtigung durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Platzhalter</td>\n    <td>wird ersetzt durch</td>\n    <td style=\"text-align: center;\">Limits</td>\n    <td style=\"text-align: center;\">KombiLimits</td>\n    <td style=\"text-align: center;\">isAlive</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGEOVER</td>\n    <td>die Anzahl der Werte oder Zeitbereich von \"mitteln über\"</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$COMPARE</td>\n    <td>den angewandten Vergleich</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$DETAIL</td>\n    <td>das Detail (die Überschrift der Tabellenspalte)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$DOMAIN</td>\n    <td>die Bezeichnung des Verfahrens</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTDATE</td>\n    <td>der Zeitstempel des letzten vorhanden Werts</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTVALUE</td>\n    <td>der letzte Wert</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$LIMIT</td>\n    <td>den verletzten Limit (Info/Warn/Fehler)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$PREVVALUE</td>\n    <td>der Wert des vorigen Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$SAVEDATE</td>\n    <td>der Zeitstempel, an dem der letzte Wert im ULS eingegangen ist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$SECTION</td>\n    <td>die Sektion</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$SERVER</td>\n    <td>den Namen des Rechners</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TESTSTEP</td>\n    <td>die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$TIMEDIFF</td>\n    <td>die festgestellte Zeitdifferenz (die die Frist überschritten hat und zur Auslösung der Benachrichtigung\n    geführt hat)</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TIMELIMIT</td>\n    <td>die definierte Frist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$UNIT</td>\n    <td>die Einheit des Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$VALUE</td>\n    <td>der (uU berechnete) Wert, der die Limits-Verletzung ausgelöst hat</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n</tbody>\n</table>\n\n<p>Funktionen</p>\n<p>Die folgenden Funktionen könnne in Meldungstexten verwendet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr style=\"font-weight: bold;\">\n    <td>Funktion</td>\n    <td>Berechnung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGE_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Berechnet den arithmetischen Mittelwert für eine Anzahl von Werten eines Details.</td>\n  </tr>\n  <tr>\n    <td>$COUNT_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Ermittelt die Anzahl der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$DEV_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n  <td>Ermittelt die Standardabweichung der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n  <td>$DIFF_OF(&lt;detail&gt;[/&lt;unit&gt;])</td>\n<td>Ermittelt die Differenz (Unix Kommando diff) der letzten beiden Werte (können\nauch Dateien sein) und liefert maximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei würde\nes sich sinnvollerweise um Werte mit Textinhalten handeln. Unterstützte Dateiformate mit Komprimierung\nsind:.gz und .bz2. Alle anderen Dateiformate werden verglichen wie sie sind.\n</td>\n</tr><tr>\n<td>$DIFFER_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt, ob der erste Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen, sich&nbsp; zum letzten Wert unterscheidet. Ergibt 0 oder 1 als Ergebnis.</td>\n</tr><tr>\n<td>$FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$GRAD_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den Gradienten (lineare Steigung) der Werte des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_range&gt; [ &lt;time_past&gt;])</td>\n<td>Berechnet die lineare Steigung pro &lt;time_range&gt; (Standard: 1d) für Werte, die\nfür das angegebene Detail vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist &lt;time_past&gt; nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den &lt;time_range&gt;\numgerechnet. Man kann also die Werte der letzten 24h\nbetrachten (&lt;time_past&gt; = 24h) und daraus den Gradienten pro 8 Stunden\n(&lt;time_range&gt; = 8h) berechnen.\n</td>\n</tr>\n<tr>\n<td>$LAST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den letzten (aktuellsten) Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen. Dies kann ein neuerer&nbsp;Wert sein als der über $VALUE_OF ermittelte.</td>\n</tr><tr>\n<td>$LAST-FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Maximum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Minimum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_future&gt; [, &lt;time_past&gt;])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der für ein Detail vorliegenden Werte innerhalb eines\nzurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte einem linearen Wachstum unterliegen. Wird &lt;time_past&gt; nicht\nangegeben, dann wird &lt;time_future&gt; verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten Hälfte von &lt;time_past&gt; liegen\nund die in der zweiten Hälfte von &lt;time_past&gt; liegen, wird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der angenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten Steigung wird der Endwert zu &lt;time_future&gt; berechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(&lt;detail&gt;[/&lt;unit&gt;],&lt;&gt; &lt;regexp&gt;, &lt;time_range&gt;)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregulären Ausdrucks &lt;regexp&gt; in allen Werten des &lt;detail&gt;,\ndie in &lt;time_range&gt; (nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Summe der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$UNIT_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ermittelt die Einheit des &lt;detail&gt;</td>\n</tr><tr>\n<td>$VALUE_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ist&nbsp;der&nbsp;Wert des &lt;detail&gt; zum Zeitpunkt der Überwachungskontrolle. Dies ist nicht unbedingt der neueste Wert für dieses &lt;detail&gt;. </td>\n</tr>\n</tbody>\n</table>\n\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\r','','ConfigHints'),(145,'de','autollimits_nt',' <!--\n server=lxartp\nsection=Oracle DB [artusp]\nteststep=pga\ndetail=Max[H](aggregate PGA target parameter)\nunit=MB\nfunction=last\nover=1\nrelation=>\ninfolevel=\nwarnlevel=700\nerrorlevel=\nmessage=Zu hoch\ndestination1=Mail:Mähl, Rüdiger\ndest1levels=IWF\ndestination2=\ndest2levels=IWF\nremark=\naccess=all \n-->\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Parametername</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>\n      server=<br>\n      section=<br>\n      teststep=<br>\n      detail=<br>\n      unit=<br>\n    </td>\n    <td>\n      Server -- Sektion -- Testschritt -- Detail -- Einheit Muster festlegen, \n      jede Angabe kann dabei ein Textmuster enthalten, \n      wie in \"Ausdrücke in Textfeldern\" beschrieben.\n    </td>\n  </tr><tr>\n    <td>function=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>over=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>relation=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>infolevel=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>warnlevel=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>errorlevel=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>message=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>\n      destination1=<br>\n      dest1levels=\n    </td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>\n      destination2=<br>\n      dest2levels=\n    </td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>remark=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>access=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr>\n </tbody>\n</table>\n\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\r','','ConfigHints'),(148,'de','autokombidetails_nt',' <!--\n server=lxulsq\nsection=System\nteststep=System Load\ndetail=x\nunit=cm\nexpression=100 - $VALUE_OF(%idle/%)\nremark=\naccess=all \n-->\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Parametername</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>\n      server=<br>\n      section=<br>\n      teststep=<br>\n      detail=<br>\n      unit=<br>\n    </td>\n    <td>\n      Server -- Sektion -- Testschritt -- Detail -- Einheit Muster festlegen, \n      jede Angabe kann dabei ein Textmuster enthalten, \n      wie in \"Ausdrücke in Textfeldern\" beschrieben.\n    </td>\n  </tr><tr>\n    <td>expression=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>remark=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>access=</td>\n    <td>\n      &nbsp;\n    </td>\n\n  </tr>\n </tbody>\n</table>\n\n\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\r','','ConfigHints'),(149,'de','autokombilimits_nt',' <!--\n server=\nsection=Oracle DB*\nteststep=sessions and processes\ncondition=$VALUE_OF(processes) >= $VALUE_OF(max processes) * 0.9\nlevel=WARN\nnotifymode=24\nmessage=Anzahl der $VALUE_OF(processes) Oracle Prozesse nähert sich dem eingestellten Grenzwert von $VALUE_OF(max processes).\ndestination1=ITSM:Unix_Linux_DA\ndestination2=\nremark=\naccess=all \n-->\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Parametername</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>\n      server=<br>\n      section=<br>\n      teststep=<br>\n    </td>\n    <td>\n      Server -- Sektion -- Testschritt Muster festlegen, \n      jede Angabe kann dabei ein Textmuster enthalten, \n      wie in \"Ausdrücke in Textfeldern\" beschrieben.\n    </td>\n  </tr><tr>\n    <td>condition=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>level=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>notifymode=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>message=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>\n      destination1=<br>\n      destination2=\n    </td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>remark=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr><tr>\n    <td>access=</td>\n    <td>\n      &nbsp;\n    </td>\n  </tr>\n </tbody>\n</table>\n\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\r','','ConfigHints'),(160,'de','report_details_nt',' <!--\nseparation=\nname=\n# \n wird in newline umgewandelt\ndescription=\ndomain=\nserver=\nsection=\nteststep=\ndetail=\nunit=\n\n# 2hours since2hours today yesterday sinceyesterday \n# week 7days since7days lastweek sincelastweek\n# month sincelastmonth lastmonth last3months\n# year lastyear complete\nperiod=\n\n# [O]nline, [C]ompressed\nvalues=\n\noffset=0\n\n# table last chart min max avg dev sum max-min last-first count \n# grad histogram histmin histmax histavg histdev histsum \n# histmax-min histlast-first histcount histgrad lstlim lstisalive \n# accel lstcomprlim lstcombilim lstcombidet lstrettime first\n# csv?\noutput=\n\n# 640x480 800x600 1024x768 1280x960 1600x1200\nchartsize=\n\n# dots points lines linespoints impulses steps fsteps histeps boxes\nstyle=\n\n#     # D\nmaxdetails=0\n\n# [S]erver se[C]tion [T]eststep [D]etail [W]eekday [V]alue\ngroupby=\n# avg,sum,min,max,count\ngroupfooter=\n\ny1unit=\ny1min=\ny1max=\n# 1 zum Aktivieren\ny1log=\n\n# dots points lines linespoints impulses steps fsteps histeps boxes\ny1plotstyle=\n\ny2unit=\ny2min=\ny2max=\n# 1 zum Aktivieren\ny2log=\n\n# dots points lines linespoints impulses steps fsteps histeps boxes\ny2plotstyle=\n\n# hh:mm\ntimefrom=\ntimeto=\n\n# Mo,Tu,We,Th,Fr,Sa,Su\nweekdays=\n\n# < <= > >= = != ~ !~ ~~ !~~\nrelop1=\ncompval1=\n# { AND | OR }\nop2=\n# < <= > >= = != ~ !~ ~~ !~~\nrelop2=\ncompval2=\n# { AND | OR }\nop3=\n# < <= > >= = != ~ !~ ~~ !~~\nrelop3=\ncompval3=\n# { AND | OR }\nop4=\n# < <= > >= = != ~ !~ ~~ !~~\nrelop4=\ncompval4=\n-->\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Parametername</td>\n    <td>Beschreibung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>separation=</td>\n    <td>\n      Abtrennung zum vorigen Reportdetail festlegen. HTML erlaubt\n    </td>\n  </tr><tr>\n    <td>\n      name=<br>\n      description=\n    </td>\n    <td>\n      Name (Überschrift) des Reportdetails und eine Beschreibung festlegen.\n      Da nur eine Zeile zulässig ist, kann \'\n\' für den Beginn einer neuen \n      Zeile verwendet werden.\n    </td>\n  </tr><tr>\n    <td>\n      domaine=<br>\n      server=<br>\n      section=<br>\n      teststep=<br>\n      detail=<br>\n      unit=\n    </td>\n    <td>\n      Verfahren -- Server -- Sektion -- Testschritt -- Detail -- Einheit Muster festlegen, \n      jede Angabe kann dabei ein Textmuster enthalten, \n      wie in \"Ausdrücke in Textfeldern\" beschrieben.\n    </td>\n  </tr><tr>\n    <td>period=</td>\n    <td>\n      Zeitbereich festlegen. Verwende einen Ausdruck von: \n      2hours since2hours today yesterday sinceyesterday \n      week 7days since7days lastweek sincelastweek\n      month sincelastmonth lastmonth last3months\n      year lastyear complete\n    </td>\n  </tr><tr>\n    <td>values=</td>\n    <td>\n      Verwende [O]nline und/oder [C]ompressed\n    </td>\n  </tr><tr>\n    <td>offset=</td>\n    <td>\n      Trage eine negative Zahl (Zeitabschnitte zurück) ein.\n    </td>\n  </tr><tr>\n    <td>output=</td>\n    <td>\n      Festlegen des Ausgabe oder der anzuwendende Funktion auf die \n      selektierten Werte. Wähle eine Angabe aus: \n        table last chart min max avg dev sum max-min last-first count \n        grad histogram histmin histmax histavg histdev histsum \n        histmax-min histlast-first histcount histgrad lstlim lstisalive \n        accel lstcomprlim lstcombilim lstcombidet lstrettime first\n        csv\n    </td>\n  </tr><tr>\n    <td>chartsize=</td>\n    <td>\n      Nur für \"output=chart\": legt die Grafikgröße fest: \n      640x480, 800x600, 1024x768, 1280x960, 1600x1200\n    </td>\n  </tr><tr>\n    <td>style=</td>\n    <td>\n      Nur für \"output=chart\": legt die Darstellung der Werte in der Grafik\n      fest: dots, points, lines, linespoints, impulses, steps, fsteps, histeps, boxes\n    </td>\n  </tr><tr>\n    <td>maxdetails=</td>\n    <td>\n     Festlegen der maximalen Anzahl der in einer Tabelle oder Grafik darzustellenden Details, \n     z.B.: 5.\n    </td>\n  </tr><tr>\n   <td>groupby=</td>\n    <td>\n      Gruppieren der Ergebnismenge nach einer Angabe: \n      [S]erver, se[C]tion, [T]eststep, [D]etail, [W]eekday, [V]alue\n    </td>\n  </tr><tr>\n   <td>groupfooter=</td>\n    <td>\n      Bei einer gewählten Gruppierung können Zusatzberechnungen aktiviert werden.\n      Mehrere Angabe sind möglich: avg, sum, min, max, count\n    </td>\n  </tr><tr>\n\n   <td>\n     y1unit=<br>\n     y2unit=\n    </td>\n    <td>\n      Festlegen der Einheit für die linke oder rechte Y-Achse, die Ergebnismenge muss \n      diese Einheit enthalten, sonst erfolgt keine Ausgabe. Werte mit anderen \n      Einheiten werden nicht angezeigt.\n    </td>\n  </tr><tr>\n   <td>\n     y1min=<br>\n     y2min=\n   </td>\n    <td>\n      Festlegen des Minimums für die linke Y-Achse.\n    </td>\n  </tr><tr>\n   <td>\n     y1max=<br>\n     y2max=\n   </td>\n    <td>\n      Festlegen des Maximums für die linke Y-Achse.\n    </td>\n  </tr><tr>\n   <td>\n     y1log=<br>\n     y2log=\n   </td>\n    <td>\n      Die linke Y-Achse soll logarithmisch skaliert werden.\n    </td>\n  </tr><tr>\n   <td>\n     y1plotstyle=<br>\n     y2plotstyle=\n   </td>\n    <td>\n      Definiert den Anzeigestil aller Details der linken Y-Achse.\n    </td>\n  </tr><tr>\n\n   <td>\n    timefrom=<br>\n    timeto=\n   </td>\n    <td>\n      Angabe eines Zeitfensters (hh:mm), das nur für die Ausgabe berücksichtigt wird.\n    </td>\n  </tr><tr>\n   <td>weekdays=</td>\n    <td>\n      Nur die angegebenen Wochentage werden für die Ausgabe berücksichtigt.  Gebe einen oder mehrere Wochentage, getrennt mit Komma an (Mo,Tu,We,Th,Fr,Sa,Su)\n    </td>\n  </tr><tr>\n   <td>\n     relop1=\n   </td>\n    <td>\n      Wertefilter definieren, einen relationalen Operator angeben. Zulässige Operatoren: &lt;, &lt;=, &gt;, &gt;=, =, !=, ~, !~, ~~, !~~\n    </td>\n  </tr><tr>\n\n   <td>compval1=</td>\n    <td>\n      Vergleichswert für den Wertefilter angeben.\n    </td>\n  </tr><tr>\n\n   <td>op2=</td>\n    <td>\n      Angabe des Verknüpfungsoperators für den 2ten Wertefilter. Mögliche Operatoren: AND, OR.\n    </td>\n  </tr><tr>\n\n   <td>\n     relop2=\n   </td>\n    <td>\n      2ten Wertefilter definieren, einen relationalen Operator angeben. Zulässige Operatoren: &lt;, &lt;=, &gt;, &gt;=, =, !=, ~, !~, ~~, !~~\n    </td>\n  </tr><tr>\n\n   <td>compval2=</td>\n    <td>\n      Vergleichswert für 2ten Wertefilter angeben.\n    </td>\n  </tr><tr>\n\n   <td>op3=</td>\n    <td>\n      Angabe des Verknüpfungsoperators für den 3ten Wertefilter. Mögliche Operatoren: AND, OR.\n    </td>\n  </tr><tr>\n\n   <td>\n     relop3=\n   </td>\n    <td>\n      3ten Wertefilter definieren, einen relationalen Operator angeben. Zulässige Operatoren: &lt;, &lt;=, &gt;, &gt;=, =, !=, ~, !~, ~~, !~~\n    </td>\n  </tr><tr>\n\n   <td>compval3=</td>\n    <td>\n      Vergleichswert für 3ten Wertefilter angeben.\n    </td>\n  </tr><tr>\n\n   <td>op4=</td>\n    <td>\n      Angabe des Verknüpfungsoperators für den 4ten Wertefilter. Mögliche Operatoren: AND, OR.\n    </td>\n  </tr><tr>\n\n   <td>\n     relop4=\n   </td>\n    <td>\n      4ten Wertefilter definieren, einen relationalen Operator angeben. Zulässige Operatoren: &lt;, &lt;=, &gt;, &gt;=, =, !=, ~, !~, ~~, !~~\n    </td>\n  </tr><tr>\n\n   <td>compval4=</td>\n    <td>\n      Vergleichswert für 4ten Wertefilter angeben.\n    </td>\n  </tr>\n </tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\r','','ConfigHints'),(161,'de','set_servergroups','<!-- Changes:\n  set_servergroups, de\n  2015-11-30, roveda: Created the help page.\n-->\n<h2>Servergruppen bearbeiten</h2>\n<p>\n  Jeder Benutzer kann private Zusammenstellungen von Serven als Servergruppen erstellen. \n  Diese Zusammenstellungen werden neben den Verfahren zusätzlich angezeigt. Es werden \n  KEINE NEUEN Server noch NEUE Verfahren definiert.\n</p>\n<table>\n<thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody>\n  <tr>\n    <td>Name</td>\n    <td>Bezeichnung dieser Zusammenstellung von Servern.</td>\n  </tr>\n  <tr>\n    <td>Position</td>\n    <td>\n      Es kann dies Positon festgelegt werden, wo die Servergruppe eingeordnet und angezeigt werden soll.\n      <table>\n      <tbody>\n        <tr>\n          <td>Anfang</td>\n          <td>Die Servergruppe wird am Anfang der Verfahrensliste angezeigt.</td>\n        </tr>\n        <tr>\n          <td>Verfahren</td>\n          <td>Die Servergruppe wird in die Verfahrensliste alphabetisch einsortiert.</td>\n        </tr>\n        <tr>\n          <td>Ende</td>\n          <td>Die Servergruppe wird am Ende der Verfahrensliste angehängt.</td>\n        </tr>\n       </tbody>\n      </table>\n    </td>\n  </tr>\n  <tr>\n    <td>Verfahrensauswahl</td>\n    <td>TODO</td>\n  </tr>\n  <tr>\n    <td>Verfahren</td>\n    <td>Liste der Verfahren, aus denen die entsprechenden Server zusammengefasst werden sollen.</td>\n  </tr>\n  <tr>\n    <td>Klassen</td>\n    <td>Liste der Klassen, aus denen die entsprechenden Server zusammengefasst werden sollen.</td>\n  </tr>\n  <tr>\n    <td>Server</td>\n    <td>Liste der Server, die zusammengefasst werden sollen.</td>\n  </tr>\n  <tr>\n    <td>aktiv</td>\n    <td>De-/Aktivierung dieser Servergruppendefinition.</td>\n  </tr>\n  <tr>\n    <td>löschen</td>\n    <td>Löschen eines bestehenden Eintrags.</td>\n  </tr>\n  <tr>\n    <td>Bemerkung</td>\n    <td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n  </tr>\n </tbody>\n</table>\n\n\n\n','','ConfigHints'),(162,'de','Favoriten_bearbeiten','<p>Bearbeiten der Favoriten.</p>\n<p>Es können die eigenen und die von anderen Benutzern freigegebenen \nFavoriten bearbeitet werden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Link</td>\n<td>Erklärung </td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><span style=\"color: rgb(0, 0, 255);\">Freigegebene Favoriten</span></td>\n  <td>Bearbeiten der von anderen Benutzern freigegebenen Favoriten.</td>\n</tr>\n</tbody>\n</table>\n\n<p></p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td>Tabellenspalte</td>\n<td>Erklärung </td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>Name</td>\n  <td>Die Bezeichnung des Favoriten.</td>\n</tr>\n<tr>\n  <td>Url</td>\n  <td>Link zur Definition des Favoriten (nur für Auto-Favoriten).</td>\n</tr>\n<tr>\n  <td>Verfahren</td>\n  <td>Freigabe dieses Favoriten für alle Benutzer, die Zugriff auf das ausgewählte Verfahren haben.</td>\n</tr>\n<tr>\n  <td>löschen</td>\n  <td>Löschen dieses Favoriten.</td>\n</tr>\n</tbody>\n</table>\r','','ConfigHints'),(165,'de','set_llimits','<p>Eine Kompr-Limit-Überwachungen löst eine Benachrichtigung aus, \nsobald ein komprimierter Wert einen definierten Grenzwert verletzt.</p>\n<p>Kompr-Limits können zu allen Details eingetragen,\ngelöscht oder geändert werden. Generell wird\ndie Verwendung von Auto-Kompr-Limits gegenüber einzelner Kompr-Limit-Definitionen\nvorgezogen. </p>\n<p>Die Kontrolle auf verletzte Kompr-Limits-Überwachungen erfolgt einmalig kurz nach 24:00 Uhr, nach \nder Berechnung aller zu komprimierenden Werte.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead> <tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Detail</td>\n<td>Hier wird festgelegt, für welches Detail  dieser Kompr-Limit gelten soll,\nsiehe \"Ausdrücke in Textfeldern\". ACHTUNG: hierbei ist zu beachten, dass \nan dieser Stelle die Bezeichnungen der komprimierten Details zu berücksichtigen sind! Also zB \"Avg[H](size)\"!</td>\n</tr>\n<tr>\n<td>mitteln über</td>\n<td>\nFestlegen, welche Funktion angewendet und wieviele Werte für diese\nFunktion verwendet werden sollen, bevor der Vergleich ausgeführt wird.\nSiehe \"mitteln über\"\n</td>\n</tr>\n<tr>\n<td>Vergleich</td>\n<td>Der Vergleichsoperand. der mit dem aktuellen Wert gegen die Kompr-Limits\nverwendet wird. Siehe \"Vergleichsoperatoren\"</td>\n</tr>\n<tr>\n<td>\nInfo<br>\nWarn<br>\nFehler\n</td>\n<td>Einer bis drei Grenzwerte, auf die geprüft wird. Es werden unterschiedliche Prioritäten ausgelöst.</td>\n</tr>\n<tr>\n<td>Meldung</td>\n<td>Hier kann eine benutzerdefinierte Meldung (max 3000 Zeichen)\neingetragen werden, eine standardisierte Meldung wird bei\nBenachrichtigungen immer geschickt. In der Meldung können Platzhalter\nund Funktionen verwendet werden, siehe \"Platzhalter und Funktionen in Meldung\"</td>\n</tr>\n<tr>\n<td>Meldungsziel</td>\n<td>Zwei für dieses Verfahren freigegebene Benachrichtigungsziele können über die \nDrop-Down-Listen eingestellt werden.<br>\nDie Checkboxen I W F (Info/Warn/Fehler) legen die Prioritäten\nfest, bei deren Verletzung eine Benachrichtigung an das jeweilige\nMeldungsziel geschickt wird.</td>\n</tr>\n<tr>\n<td>\naktiv<br>\nlöschen<br>\nAuto</td>\n<td>Damit wird diese Kompr-Limit-Überwachung deaktiviert, aktiviert, gelöscht oder zu einer \nAuto-Kompr-Limit-Überwachung umgewandelt. Danach kann über den Link \n<span style=\"color: rgb(0, 0, 255);\">auto</span> die Auto-Kompr-Limit-Überwachung aufgerufen \nund ggf abgeändert werden.\n</td>\n</tr>\n<tr>\n<td>Bemerkung</td>\n<td>Hier kann eine Bemerkung zu dieser Definition eingetragen werden.</td>\n</tr>\n</tbody>\n</table>\n\n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Ausdrücke in Textfeldern</h4>\n<p>In den Feldern können konstante Textausdrücke, Textausdrücke\nmit Platzhaltern (Wildcards), negierte Textausdrücke (mit voranstehendem \"!\") oder eine komma-getrennte Kombination aus allen eingetragen werden. Als Platzhalter können \"*\" für einen beliebigen Ausdruck und \"?\" für ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>konstanter Textausdruck:</td>\n  <td style=\"font-family: monospace;\">lxabcd5<br>\n  rm300_agr<br>\n  wscdbp93</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken:</td>\n  <td style=\"font-family: monospace;\">lxabcp1,lxabcp2,lvxxx78<br>\n  WSCOWIWEB1,WSCOWIWEB2</td>\n</tr>\n<tr>\n  <td>Textausdruck mit Platzhalter:</td>\n  <td style=\"font-family: monospace;\">*appserver*<br>!*q*</td>\n</tr>\n<tr>\n  <td>Liste von konstanten Textausdrücken mit Komma<br>\n  getrennt von Textausdrücken mit Platzhaltern:</td>\n  <td style=\"font-family: monospace;\">wscdb*,!wscdbt*,wscapp25<br>\n  xpolpa1,xpolpd*,*art*,!*artpd?<br>lxproject*,!lxprojectq*</td>\n</tr>\n</tbody>\n</table>\n\n<p>Leere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \"*\".</p>\n<p>Kommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdrücken verwendet wird, sollte anstelle des\nKommas der Platzhalter \"?\" verwendet werden.</p>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>mitteln über</h4>\n<p>Über dir Drop-Down-Liste erfolgt die Auswahl\nder Funktion, die in Verbindung mit der Eingabe im Textfeld angewendet\nwird, bevor der Vergleich ausgeführt wird. Hier die Liste der Funktionen:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n  <tr>\n    <td>Funktion</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Last</td>\n<td>Verwende den letzten Wert (chronologisch den jüngsten)</td>\n</tr>\n<tr>\n<td>Avg</td>\n<td>Mittelwert berechnen</td>\n</tr>\n<tr>\n<td>Sum</td>\n<td>Summe berechnen</td>\n</tr>\n<tr>\n<td>Std</td>\n<td>Standardabweichung berechnen</td>\n</tr>\n<tr>\n<td>Min</td>\n<td>minimalen Wert verwenden</td>\n</tr>\n<tr>\n<td>Max</td>\n<td>maximalen Wert verwenden</td>\n</tr>\n<tr>\n<td>Max-Min</td>\n<td>Subtrahiere den minimalen Wert vom maximalen Wert</td>\n</tr>\n<tr>\n<td>Last-First</td>\n<td>Subtrahiere den ersten Wert (ältesten) vom letzten Wert (jüngsten)</td>\n</tr>\n<tr>\n<td>Count</td>\n<td>Anzahl der Werte verwenden</td>\n</tr>\n<tr>\n<td>Grad</td>\n<td>Gradient berechnen</td>\n</tr>\n</tbody>\n</table>\n\n<p>Im Textfeld erfolgt die Eingabe der Anzahl oder des Zeitbereichs, der zur Anwendung der oben gewählten Funktion verwendet werden soll. Eine einfache Zahl legt die Anzahl der letzten Werte fest, die für den Vergleich verwendet werden sollen. Für einen Zeitbereich wird eine Zahl und eine Abkürzung für den Zeitabschnitt eingetragen. Abkürzungen für den Zeitbereich:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>m</td>\n<td>Minuten</td>\n</tr>\n<tr>\n<td>h</td>\n<td>Stunden</td>\n</tr>\n<tr>\n<td>d</td>\n<td>Tage</td>\n</tr>\n</tbody>\n</table>\n\n<p>Beispiele mit Erklärungen zu möglichen Eingaben:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>[ Last ]</td>\n<td>Verwende den letzten Wert für den Vergleich.</td>\n</tr>\n<tr>\n<td>\n[ Avg ]<br>\n[ 10 ]</td>\n<td>Verwende die letzten 10 Werte, bilde daraus den Mittelwert und verwende diesen für den Vergleich.</td>\n</tr>\n<tr>\n<td>\n[ Grad ]<br>\n[ 60m ]\n</td>\n<td>Berechne den Gradienten der Werte aus den letzten 60 Minuten und führe mit diesem Wert dann den Vergleich aus.\n</td>\n</tr>\n<tr>\n<td>\n[ Count ]<br>\n[ 2d ]\n</td>\n<td>Ermittle die Anzahl der Werte für die letzten 2 Tage (48h) und verwende diese Anzahl für den Vergleich.\n</td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Vergleichsoperatoren</h4>\n<p>Erklärung der einsetzbaren Vergleichsoperatoren für die\nDefinition von Limits. Die verwendbaren Vergleichsoperatoren sind\nteilweise abhängig von den Datentypen der Werte, auf die sie\nangewendet werden.</p>\n<p><span style=\"font-weight: bold;\">Definition</span>\nvon Ausdrücken, die zur weiteren Beschreibung der Vergleichsoperatoren verwendet werden:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n<td>Ausdruck</td>\n<td>Bedeutung</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent für die Menge von Integer und Float verwendet</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird für beliebige Textausdrücke verwendet</td>\n</tr>\n<tr>\n<td>&lt;value&gt;</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n<tr>\n<td>&lt;limit&gt;</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler \n<!-- als DiffLimit (TODO) --> eingetragen ist</td>\n</tr>\n<tr>\n<td>&lt;regexp&gt;</td>\n<td>ist ein regulärer Ausdruck, der POSIX 1003.2 (wie zB in\n\"man 7 regex\" beschrieben) entsprechen muss und der bei\nInfo/Warn/Fehler eingetragen ist. Er wird anstelle des &lt;limit&gt; verwendet</td>\n</tr>\n</tbody>\n</table>\n\n<p>Vor dem Vergleich werden die Datentypen von &lt;value&gt;\nund &lt;limit&gt; angepasst. Die <span style=\"font-weight: bold;\">Datentypumwandlung</span>\nerfolgt nach folgender Vorschrift:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Datentyp<br>\n        &lt;value&gt;</td>\n    <td>Datentyp<br>\n        &lt;limit&gt;</td>\n    <td>Vergleich wird durchgeführt als Datentyp</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td>Integer</td>\n  <td>Integer</td>\n  <td>Integer</td>\n</tr>\n<tr>\n  <td>Integer</td>\n  <td>Float</td>\n  <td>Float</td>\n</tr>\n<tr>\n  <td>Float</td>\n  <td>Integer</td>\n  <td>Float</td>\n</tr>\n<tr>\n  <td>String</td>\n  <td>beliebig</td>\n  <td>String</td>\n</tr>\n<tr>\n  <td>beliebig</td>\n  <td>String</td>\n  <td>String<br>\n</td>\n</tr>\n</tbody>\n</table>\n\n<p>Allgemein gilt dabei für die Vergleiche:</p>\n<ul>\n  <li>Bei String-Vergleichen wird Groß-Kleinschreibung unterschieden.</li>\n  <li>\"!\" ist die Negation des Vergleichs.</li>\n  <li>\"|\"\n    <ul>\n      <li>Integer und Float: bilden Absolutwerte von beiden Ausdrücken bevor verglichen wird (abs)</li>\n      <li>String: vergleicht beide Ausdrücke unabhängig von Groß-Kleinschreibung (ignore case)</li>\n    </ul>\n  </li>\n</ul>\n<p> <span style=\"color: rgb(255, 0, 0);\">Hinweis:</span>\nDie (Text-)Vergleiche erfolgen gegen den\ngesamten Textausdruck eines Wertes, liegen mehrere Textausdrücke zum\ngleichen Zeitstempel vor, so wird nur der LETZTE! Textausdruck\nverglichen.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\">\n<tr>\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgeführter Vergleich</td>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>größer gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich</td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\">value</td><td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich&nbsp;(abs/ignore case)</td></tr><tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr><td style=\"text-align: center; font-family: monospace;\">value</td><td style=\"text-align: center; font-family: monospace;\">!==|</td><td style=\"text-align: center; font-family: monospace;\">limit</td><td>ungleich, keine Datentypenumwandlung (immer String) (ignore case)</td></tr><tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält\nnicht&nbsp;<span style=\"font-family: monospace;\">limit</span>\nals Substring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enthält\nnicht&nbsp;<span style=\"font-family: monospace;\">limit</span>\nals Substring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does\nnot match&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does\nnot match&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case) </td>\n</tr>\n</tbody>\n</table>\n\n \n<hr style=\"width: 100%; height: 2px; color: rgb(110, 58, 166);\">\n \n<h4>Platzhalter und Funktionen in Meldung</h4>\n\n<p>Im Text von \'Meldung\' können folgende Platzhalter und Funktionen\nverwendet werden, die vor der Versendung der Benachrichtigung durch den\nentsprechenden Ausdruck ersetzt werden.</p>\n\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr>\n    <td>Platzhalter</td>\n    <td>wird ersetzt durch</td>\n    <td style=\"text-align: center;\">Limits</td>\n    <td style=\"text-align: center;\">KombiLimits</td>\n    <td style=\"text-align: center;\">isAlive</td>\n  </tr>\n</thead> \n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGEOVER</td>\n    <td>die Anzahl der Werte oder Zeitbereich von \"mitteln über\"</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$COMPARE</td>\n    <td>den angewandten Vergleich</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n  <tr>\n    <td>$DETAIL</td>\n    <td>das Detail (die Überschrift der Tabellenspalte)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$DOMAIN</td>\n    <td>die Bezeichnung des Verfahrens</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTDATE</td>\n    <td>der Zeitstempel des letzten vorhanden Werts</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$LASTVALUE</td>\n    <td>der letzte Wert</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$LIMIT</td>\n    <td>den verletzten Limit (Info/Warn/Fehler)</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$PREVVALUE</td>\n    <td>der Wert des vorigen Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr><tr>\n    <td>$SAVEDATE</td>\n    <td>der Zeitstempel, an dem der letzte Wert im ULS eingegangen ist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$SECTION</td>\n    <td>die Sektion</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$SERVER</td>\n    <td>den Namen des Rechners</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TESTSTEP</td>\n    <td>die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr><tr>\n    <td>$TIMEDIFF</td>\n    <td>die festgestellte Zeitdifferenz (die die Frist überschritten hat und zur Auslösung der Benachrichtigung\n    geführt hat)</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$TIMELIMIT</td>\n    <td>die definierte Frist</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$UNIT</td>\n    <td>die Einheit des Werts</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">x</td>\n  </tr>\n  <tr>\n    <td>$VALUE</td>\n    <td>der (uU berechnete) Wert, der die Limits-Verletzung ausgelöst hat</td>\n    <td style=\"text-align: center;\">x</td>\n    <td style=\"text-align: center;\">-</td>\n    <td style=\"text-align: center;\">-</td>\n  </tr>\n</tbody>\n</table>\n\n<p>Funktionen</p>\n<p>Die folgenden Funktionen könnne in Meldungstexten verwendet werden.</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n  <tr style=\"font-weight: bold;\">\n    <td>Funktion</td>\n    <td>Berechnung</td>\n  </tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n  <tr>\n    <td>$AVERAGE_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Berechnet den arithmetischen Mittelwert für eine Anzahl von Werten eines Details.</td>\n  </tr>\n  <tr>\n    <td>$COUNT_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n    <td>Ermittelt die Anzahl der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$DEV_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n  <td>Ermittelt die Standardabweichung der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n  <td>$DIFF_OF(&lt;detail&gt;[/&lt;unit&gt;])</td>\n<td>Ermittelt die Differenz (Unix Kommando diff) der letzten beiden Werte (können\nauch Dateien sein) und liefert maximal 200 unterschiedliche Zeilen der verglichenen Werte. Dabei würde\nes sich sinnvollerweise um Werte mit Textinhalten handeln. Unterstützte Dateiformate mit Komprimierung\nsind:.gz und .bz2. Alle anderen Dateiformate werden verglichen wie sie sind.\n</td>\n</tr><tr>\n<td>$DIFFER_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt, ob der erste Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen, sich&nbsp; zum letzten Wert unterscheidet. Ergibt 0 oder 1 als Ergebnis.</td>\n</tr><tr>\n<td>$FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den ersten Wert aus allen Werten des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr><tr>\n<td>$GRAD_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den Gradienten (lineare Steigung) der Werte des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_range&gt; [ &lt;time_past&gt;])</td>\n<td>Berechnet die lineare Steigung pro &lt;time_range&gt; (Standard: 1d) für Werte, die\nfür das angegebene Detail vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist &lt;time_past&gt; nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis &lt;time_past&gt;\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den &lt;time_range&gt;\numgerechnet. Man kann also die Werte der letzten 24h\nbetrachten (&lt;time_past&gt; = 24h) und daraus den Gradienten pro 8 Stunden\n(&lt;time_range&gt; = 8h) berechnen.\n</td>\n</tr>\n<tr>\n<td>$LAST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt den letzten (aktuellsten) Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen. Dies kann ein neuerer&nbsp;Wert sein als der über $VALUE_OF ermittelte.</td>\n</tr><tr>\n<td>$LAST-FIRST_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom letzten zum ersten Wert aus allen Werten des &lt;detail&gt;,\ndie in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Maximum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen Werten des &lt;detail&gt;, die in &lt;range&gt;\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt das Minimum der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;, &lt;time_future&gt; [, &lt;time_past&gt;])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der für ein Detail vorliegenden Werte innerhalb eines\nzurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte einem linearen Wachstum unterliegen. Wird &lt;time_past&gt; nicht\nangegeben, dann wird &lt;time_future&gt; verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten Hälfte von &lt;time_past&gt; liegen\nund die in der zweiten Hälfte von &lt;time_past&gt; liegen, wird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der angenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten Steigung wird der Endwert zu &lt;time_future&gt; berechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(&lt;detail&gt;[/&lt;unit&gt;],&lt;&gt; &lt;regexp&gt;, &lt;time_range&gt;)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregulären Ausdrucks &lt;regexp&gt; in allen Werten des &lt;detail&gt;,\ndie in &lt;time_range&gt; (nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(&lt;detail&gt;[/&lt;unit&gt;], &lt;range&gt;)</td>\n<td>Ermittelt die Summe der Werte des &lt;detail&gt;, die in &lt;range&gt; (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$UNIT_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ermittelt die Einheit des &lt;detail&gt;</td>\n</tr><tr>\n<td>$VALUE_OF(&lt;detail&gt;[/&lt;unit&gt;]&lt;&gt;)</td>\n<td>Ist&nbsp;der&nbsp;Wert des &lt;detail&gt; zum Zeitpunkt der Überwachungskontrolle. Dies ist nicht unbedingt der neueste Wert für dieses &lt;detail&gt;. </td>\n</tr>\n</tbody>\n</table>\n\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<thead style=\"font-weight: bold;vertical-align: top;text-align: left;\" >\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody style=\"vertical-align: top;text-align: left;\">\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n\r','','ConfigHints'),(174,'de','set_sstsort','<!-- \n  set_sstsort, de\n\n  -----\n  Changes:\n  2015-12-03 roveda: Created the help page\n\n  -----\n  includes: \n-->\n<hr>\n<h2>Sortierung für Details festlegen</h2>\n<p>\nFestlegen der Reihenfolge von Details für die Testschritte einer Sektion.\n</p>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td>\n      Testschritt\n    </td>\n    <td>\n      Liste der Testschritte für die aktuelle Sektion.\n    </td>\n  </tr>\n\n  <tr>\n    <td>Detailsortierung</td>\n    <td>\n      Drop-Down Liste mit den möglichen Sortierungsmöglichkeiten (keine, Name, Einheit).\n    </td>\n  </tr>\n </tbody>\n</table>\n\n','','ConfigHints'),(137,'en','set_limits','<p>Limit (limit values) can to all details registered, to be deleted or\nchanged. Control on injured limit values finds in regular time intervals\ninstead of (5 minutes). The use is generally preferred of autolimit\nopposite individual limit definitions.</p>\n<p>As standard becomes the current (newest) value with that registered\nlimit values of info./warn/errors comparative. If one of the limit values\nis injured, then the message text is dispatched to the message goal.\nThis function mode can be adapted by other data.\n</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<col width=\"38\"> <col width=\"218\"> <thead>\n<tr style=\"font-weight: bold;\">\n<td width=\"15%\">columns</td>\n<td width=\"85%\">description</td>\n</tr>\n</thead> <tbody>\n<tr>\n<td height=\"15\" width=\"15%\">Detail</td>\n<td width=\"85%\">For each existing detail becomes a line to specify of limit\nindicated. At the end a line is offered to the table to registering\nof further limits.<br>\n</td>\n</tr>\n<tr>\n<td style=\"width: 15%;\">aktueller Wert<br>\nmitteln &uuml;ber<br>\n</td>\n<td width=\"85%\">Der letzte (neueste) Wert ggf mit\nEinheit f&uuml;r das Detail wird angezeigt.<br>\n<br>\n<table style=\"width: 100%;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td style=\"text-align: left; vertical-align: top;\">Drop-Down\nListe<br>\n</td>\n<td style=\"text-align: left; vertical-align: top;\">Auswahl\nder Funktion, die in Verbindung mit der Eingabe im Textfeld angewendet\nwird, bevor der Vergleich ausgef&uuml;hrt wird:<br>\n<br>\n<table style=\"border-collapse: collapse;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td>Last<br>\n</td>\n<td>Verwende nur den letzten Wert (chronologisch der j&uuml;ngste)<br>\n</td>\n</tr>\n<tr>\n<td>Avg<br>\n</td>\n<td>Mittelwert berechnen<br>\n</td>\n</tr>\n<tr>\n<td>Sum<br>\n</td>\n<td>Summe berechnen<br>\n</td>\n</tr>\n<tr>\n<td>Std<br>\n</td>\n<td>Standardabweichung berechnen<br>\n</td>\n</tr>\n<tr>\n<td>Min<br>\n</td>\n<td>minimalen Wert verwenden<br>\n</td>\n</tr>\n<tr>\n<td>Max<br>\n</td>\n<td>maximalen Wert verwenden<br>\n</td>\n</tr>\n<tr>\n<td>Max-Min<br>\n</td>\n<td>Subtrahiere den minimalen Wert vom maximalen Wert<br>\n</td>\n</tr>\n<tr>\n<td>Last-First<br>\n</td>\n<td>Subtrahiere den ersten Wert (&auml;ltesten) vom letzten Wert (j&uuml;ngsten)<br>\n</td>\n</tr>\n<tr>\n<td>Count</td>\n<td>Anzahl der Werte verwenden<br>\n</td>\n</tr>\n<tr>\n<td>Grad</td>\n<td>Gradient berechnen<br>\n</td>\n</tr>\n</tbody>\n</table>\n<br>\n</td>\n</tr>\n<tr>\n<td>Textfeld</td>\n<td>Eingabe der Anzahl oder des Zeitbereichs, der zur Anwendung der oben gew&auml;hlten Funktion verwendet werden soll.<br>\n<br>\nEine einfache Zahl legt die Anzahl der letzten Werte fest, die mit der\nFunktion verkn&uuml;pft f&uuml;r den Vergleich verwendet werden sollen.<br>\n<br>\nF&uuml;r einen Zeitbereich wird eine Zahl und eine Abk&uuml;rzung f&uuml;r den Zeitabschnitt eingetragen. =&gt; (3)<br>\n<br>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td>m</td>\n<td>Minuten</td>\n</tr>\n<tr>\n<td>h</td>\n<td>Stunden</td>\n</tr>\n<tr>\n<td>d</td>\n<td>Tage</td>\n</tr>\n</tbody>\n</table>\n\n</td>\n</tr>\n</tbody>\n</table>\n<p>\"mitteln &uuml;ber\" ist bei eingeschaltetem \"Logfile Modus\" unwirksam.</p>\n</td>\n</tr>\n<tr>\n<td width=\"15%\">Vergleich</td>\n<td width=\"85%\">Der Vergleichsoperator. der mit dem aktuellen Wert gegen die Limits verwendet wird. =&gt;(1)</td>\n</tr>\n<tr>\n<td width=\"15%\">Info<br>\nWarn<br>\nFehler</td>\n<td width=\"85%\">Drei Limits k&ouml;nnen eingetragen werden, die sich durch\njeweils h&ouml;here Priorit&auml;t im Remedy Ticket unterscheiden. Verletzt der\naktuelle Wert einen von diesen Limits, so wird eine Meldung ausgel&ouml;st.</td>\n</tr>\n<tr>\n<td width=\"15%\">Logfile Modus S/E</td>\n<td width=\"85%\">(nur f&uuml;r Textwerte) Ist der Logfile\nModus aktiviert, so werden f&uuml;r jeden eingegangenen Wert seit der\nletzten &Uuml;berpr&uuml;fung die Limits gepr&uuml;ft und ggf eine Benachrichtigung\nausgel&ouml;st, auch wenn der neueste Wert keine Verletzung der Limits mehr\naufweist. Kurzfristig auftretende Verletzungen der Limits gehen damit\nnicht verloren. Sobald ein Logfile Modus f&uuml;r ein Info/Warn/Fehler\nGrenzwert aktiviert ist, werden andere Info/Warn/Fehler ignoriert, f&uuml;r\ndie kein Logfile Modus aktiviert wurde.\n<p>ACHTUNG: diese Einstellung kann uU zu einem erheblichen\nAufkommen von Benachrichtigungen f&uuml;hren, insbesondere wenn f&uuml;r\nInfo/Warn/Fehler nichts eingetragen wurde, und sollte nur nach\nR&uuml;cksprache eingesetzt werden!</p>\n<p>S/E steht f&uuml;r geSammelte oder Einzelne Benachrichtigung\nbei Verletzung der Limits. <br>\nS := alle zutreffenden Werte werden zusammen in einer Benachrichtigung\nversandt<br>\nE := jeder zutreffender Wert wird in einer Benachrichtigung versandt</p>\n<p>\"mitteln &uuml;ber\" ist bei eingeschalteten \"Logfile Modus\" unwirksam.</p>\n</td>\n</tr>\n<tr>\n<td width=\"15%\">Meldung</td>\n<td width=\"85%\">Hier kann eine zus&auml;tzliche Meldung\n(max 1000 Zeichen) eingetragen werden, eine standardisierte\nBenachrichtigung wird immer geschickt. In der Meldung k&ouml;nnen\nPlatzhalter und Funktionen verwendet werden =&gt;(2)</td>\n</tr>\n<tr>\n<td width=\"15%\">Meldungsziel</td>\n<td width=\"85%\">Zwei Drop-down-Listen mit den\nverf&uuml;gbaren Benachrichtigungszielen, die f&uuml;r dieses Verfahren definiert\nsind.Weitere Benachrichtigungsziele sind &uuml;ber weitere Limitdefinitionen\nm&ouml;glich.<br>\n<p>Die Checkboxen I W F (Info/Warn/Fehler) legen die Limits\nfest, bei deren Verletzung eine Benachrichtigung an das jeweilige\nMeldungsziel geschickt wird.</p>\n</td>\n</tr>\n<tr>\n<td width=\"15%\">aktiv</td>\n<td width=\"85%\">Damit kann ein Grenzwert aktiviert oder auch deaktiviert werden.</td>\n</tr>\n<tr>\n<td width=\"15%\">l&ouml;schen/Auto</td>\n<td width=\"85%\">Damit wird diese Limit-Definition\ngel&ouml;scht. Wenn die Definition &uuml;ber Auto-Limits erfolgte, kann sie nicht\ngel&ouml;scht, sondern nur deaktiviert werden.<br>\n</td>\n</tr>\n<tr>\n<td style=\"\" colspan=\"1\">Bemerkung</td>\n<td style=\"\" colspan=\"1\">Hier kann eine Bemerkung zu dieser Definition eingetragen werden.<br>\n</td>\n</tr>\n</tbody>\n</table>\n<hr style=\"color: rgb(0, 0, 255); background-color: rgb(255, 255, 255);\">\n<h4> (1) Die Vergleichsoperatoren</h4>\n<p>Definitionen von Ausdr&uuml;cken, die zur weiteren Beschreibung derVergleichsoperator verwendet werden:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Datentyp</td>\n<td>Bedeutung</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>sind ganze Zahlen</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>sind rationale Zahlen (mit DezimalPUNKT!)</td>\n</tr>\n<tr>\n<td>Zahlen</td>\n<td>wird als Equivalent f&uuml;r die Menge von Integer und Float verwendet</td>\n</tr>\n<tr>\n<td>String</td>\n<td>wird f&uuml;r beliebige Textausdr&uuml;cke verwendet</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">value</td>\n<td>ist der aktuelle Wert</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">limit</td>\n<td>ist ein konstanter Ausdruck, der bei Info/Warn/Fehler als DiffLimit eingetragen ist</td>\n</tr>\n<tr>\n<td style=\"font-family: monospace;\">regexp</td>\n<td>ist ein regul&auml;rer Ausdruck, der POSIX 1003.2 (wie zB in\n\"man 7 regex\" beschrieben) entsprechen muss und der bei\nInfo/Warn/Fehler eingetragen ist. Er wird anstelle des\n&lt;limit&gt; verwendet</td>\n</tr>\n</tbody>\n</table>\n<p>Vor dem Vergleich werden die Ausdr&uuml;cke &lt;wert&gt;\nund &lt;limit&gt; erst in gleiche Datentypen umgewandelt. Die\nDatentypumwandlung erfolgt nach folgender Vorschrift:</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td> Datentyp<br><span style=\"font-family: monospace;\">value</span></td>\n<td> Datentyp<br>\n<span style=\"font-family: monospace;\">limit</span></td>\n<td style=\"vertical-align: top;\">Vergleich wird durchgef&uuml;hrt als Datentyp</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>Integer</td>\n<td>Integer</td>\n</tr>\n<tr>\n<td>Integer</td>\n<td>Float</td>\n<td>Float</td>\n</tr>\n<tr>\n<td>Float</td>\n<td>Integer</td>\n<td>Float</td>\n</tr>\n<tr>\n<td>String</td>\n<td>beliebig</td>\n<td>String</td>\n</tr>\n<tr>\n<td>beliebig</td>\n<td>String</td>\n<td>String<br>\n</td>\n</tr>\n</tbody>\n</table>\n<p>Allgemein gilt dabei f&uuml;r die Vergleiche:</p>\n<ul>\n<li>Bei String-Vergleichen wird Gro&szlig;-Kleinschreibung unterschieden.</li>\n<li>\"!\" ist die Negation des Vergleichs.</li>\n<li>\"|\"\n<ul>\n<li>Integer, Float: bildet Absolutwerte von beiden Ausdr&uuml;cken bevor verglichen wird (abs)</li>\n<li>String: vergleicht beide Ausdr&uuml;cke unabh&auml;ngig von Gro&szlig;-Kleinschreibung (ignore case)<br>\n</li>\n</ul>\n</li>\n</ul>\n<p> <span style=\"color: rgb(255, 0, 0); background-color: rgb(255, 255, 255);\">Hinweis:</span>\n<brstyle =\"color: #ff0000;=\" background-color=\"\" #ffffff=\"\"> Die (Text-)Vergleiche erfolgen gegen den\ngesamten Textausdruck eines Wertes, liegen mehrere Textausdr&uuml;cke zum\ngleichen Zeitstempel vor, so wird nur der LETZTE! Textausdruck\nverglichen.<br>\n</brstyle>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td style=\"text-align: center;\">Operand</td>\n<td style=\"text-align: center;\">Vergleichsoperator</td>\n<td style=\"text-align: center;\">Operand</td>\n<td>durchgef&uuml;hrter Vergleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&lt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>kleiner gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">&gt;=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gr&ouml;&szlig;er gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">=|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich (abs/ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\" align=\"center\">!=</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">==|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>gleich, keine Datentypenumwandlung (immer String)\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!==</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td>ungleich, keine Datentypenumwandlung (immer String)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enth&auml;lt&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enth&auml;lt&nbsp;<span style=\"font-family: monospace;\">limit</span> als\nSubstring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enth&auml;lt nicht&nbsp;<span style=\"font-family: monospace;\">limit</span> als Substring</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~~|</td>\n<td style=\"text-align: center; font-family: monospace;\">limit</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;enth&auml;lt nicht&nbsp;<span style=\"font-family: monospace;\">limit</span> als Substring (ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does not match&nbsp;<span style=\"font-family: monospace;\">regexp</span></td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;matches&nbsp;<span style=\"font-family: monospace;\">regexp</span>\n(ignore case)</td>\n</tr>\n<tr>\n<td style=\"text-align: center; font-family: monospace;\">value</td>\n<td style=\"text-align: center; font-family: monospace;\">!~|</td>\n<td style=\"text-align: center; font-family: monospace;\">regexp</td>\n<td><span style=\"font-family: monospace;\">value</span>&nbsp;does not match&nbsp;<span style=\"font-family: monospace;\">regexp</span> (ignore case)\n</td>\n</tr>\n</tbody>\n</table>\n</p>\n<h4>(2)&nbsp;Platzhalter und Funktionen in Meldung</h4>\n<p>Im Text von \"Meldung\" k&ouml;nnen folgende Platzhalter verwendet\nwerden, die vor der Versendung der \"Meldung\" durch den entsprechenden\nAusdruck ersetztwerden.<br>\n</p>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<col width=\"56\"> <col width=\"200\"> <thead>\n<tr style=\"font-weight: bold;\" valign=\"top\">\n<td width=\"22%\">Platzhalter</td>\n<td width=\"78%\">wird ersetzt durch</td>\n</tr>\n</thead> <tbody>\n<tr>\n<td>$AVERAGEOVER</td>\n<td>die Anzahl der Werte, &uuml;ber die gemittelt wurde (\"mitteln &uuml;ber\")</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$COMPARE</td>\n<td width=\"78%\">den angewandte Vergleich</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$DETAIL</td>\n<td width=\"78%\">das Detail (die &Uuml;berschrift der Tabellenspalte)</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$LIMIT</td>\n<td width=\"78%\">den verletzten Limit (Info/Warn/Fehler)</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$SECTION</td>\n<td width=\"78%\">die Sektion</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$SERVER</td>\n<td width=\"78%\">den Namen des Rechners</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$TESTSTEP</td>\n<td width=\"78%\">die Bezeichnung des Testschritts, ggf mit Doppelpunkten bei rekursiven Testschritten</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$UNIT</td>\n<td width=\"78%\">die Einheit des Werts</td>\n</tr>\n<tr valign=\"top\">\n<td width=\"22%\">$VALUE</td>\n<td width=\"78%\">den aktuellen Wert, der die Limits-Verletzung ausgel&ouml;st hat</td>\n</tr>\n</tbody>\n</table>\n<h4>Verwendung von Funktionen</h4>\n<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr style=\"font-weight: bold;\">\n<td>Funktion</td>\n<td>Berechnung</td>\n</tr>\n<tr>\n<td>$AVERAGE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Berechnet den arithmetischen Mittelwert f&uuml;r eine Anzahl von Werten eines Details.<br>\n</td>\n</tr>\n<tr>\n<td>$COUNT_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Anzahl der&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRAD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt den Gradienten (lineare Steigung)\nder&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$GRADIENT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>,&nbsp;<span style=\"font-family: monospace;\">time_range</span>\n[,&nbsp;<span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet die lineare Steigung pro&nbsp;<span style=\"font-family: monospace;\">time_range</span>\n(Standard: 1d)&nbsp; f&uuml;r Werte, die\nf&uuml;r das angegebene Detail vom aktuellen Zeitpunkt bis&nbsp;<span style=\"font-family: monospace;\">time_past</span>\nvorhanden sind. Bei der Berechnung wird\nprinzipiell von einem linearen Wachstum ausgegangen. Ist&nbsp;<span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, werden die letzten 24h\nverwendet (eine Zahl allein wird als Tage interpretiert).<br>\n<br>\nGenauer: aus allen Werten, die vom aktuellen Zeitpunkt bis&nbsp;<span style=\"font-family: monospace;\">time_past</span>\nvorliegen, wird eine Gerade nach dem Prinzip der kleinsten\nquadratischen\nAbweichung ermittelt. Die Steigung dieser Geraden wird auf den&nbsp;<span style=\"font-family: monospace;\">time_range</span>\numgerechnet. Man kann also die Werte der\nletzten 24h\nbetrachten (<span style=\"font-family: monospace;\">time_past</span>\n= 24h) und daraus den Gradienten\npro 8 Stunden\n(<span style=\"font-family: monospace;\">time_range</span>\n= 8h) berechnen.<br>\n</td>\n</tr>\n<tr>\n<td>$LAST-FIRST_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom letzten&nbsp;zum ersten\nWert aus allen&nbsp;Werten des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Maximum der&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MAX-MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Differenz vom Maximalwert zum Minimalwert\naus allen&nbsp;Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$MIN_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt das Minimum der&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$PREDICTION(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>,&nbsp;<span style=\"font-family: monospace;\">time_future</span>\n[,&nbsp;<span style=\"font-family: monospace;\">time_past</span>])</td>\n<td>Berechnet einen (in der Zukunft) zu erwartenden Wert\nanhand der f&uuml;r ein Detail vorliegenden Werte innerhalb eines\nzur&uuml;ckliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\nwerden, deren Werte\neinem linearen Wachstum unterliegen. Wird <span style=\"font-family: monospace;\">time_past</span> nicht\nangegeben, dann wird <span style=\"font-family: monospace;\">time_future</span>&nbsp;verwendet.<br>\n<br>\nGenauer: aus allen Werten, die in der ersten H&auml;lfte von&nbsp;<span style=\"font-family: monospace;\">time_past</span>\nliegen\nund die in der zweiten H&auml;lfte von&nbsp;<span style=\"font-family: monospace;\">time_past</span>\nliegen,\nwird jeweils ein\narithmetischer Mittelwert gebildet und daraus die Steigung der\nangenommenen\nlinearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der\nermittelten\nSteigung wird der Endwert zu&nbsp;<span style=\"font-family: monospace;\">time_future</span>\nberechnet.<br>\n</td>\n</tr>\n<tr>\n<td>$REGCOUNT(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>],<span style=\"font-family: monospace;\"></span>&nbsp;<span style=\"font-family: monospace;\">regexp</span>, <span style=\"font-family: monospace;\">time_range</span>)</td>\n<td>Ermittelt die Anzahl der Treffer (matching pattern) des\nregul&auml;ren Ausdrucks <span style=\"font-family: monospace;\">regexp</span>\nin allen&nbsp;Werten des <span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">time_range</span>\n(nur Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$STD_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Standardabweichung der&nbsp;Werte des\n<span style=\"font-family: monospace;\">detail</span>,\ndie in <span style=\"font-family: monospace;\">range</span>\n(Anzahl oder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$SUM_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>], <span style=\"font-family: monospace;\">range</span>)</td>\n<td>Ermittelt die Summe der&nbsp;Werte des <span style=\"font-family: monospace;\">detail</span>, die in <span style=\"font-family: monospace;\">range</span> (Anzahl\noder Zeitbereich) liegen.</td>\n</tr>\n<tr>\n<td>$VALUE_OF(<span style=\"font-family: monospace;\">detail</span>[/<span style=\"font-family: monospace;\">unit</span>]<span style=\"font-family: monospace;\"></span>)</td>\n<td>Ermittelt den letzten Wert des <span style=\"font-family: monospace;\">detail</span>\n</td>\n</tr>\n</tbody>\n</table>\n<h4>Beschreibung der variablen Ausdr&uuml;cke</h4>\n<table style=\"text-align: left;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<th>variabler Ausdruck</th>\n<th style=\"vertical-align: top;\">Erkl&auml;rung</th>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">integer</span></td>\n<td>Ganze Zahl zur Angabe der Anzahl &nbsp;der Werte\noder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">range</span></td>\n<td>Kann ein <span style=\"font-family: monospace;\">integer</span>\noder ein <span style=\"font-family: monospace;\">time_range</span>\nsein.<br>\n<span style=\"font-family: monospace;\">integer</span>\n(ohne <span style=\"font-family: monospace;\">time_unit</span>)\nlegt die <span style=\"font-weight: bold;\">Anzahl</span>\nder Werte fest, auf die die Funktion angewendet\nwerden soll. <br>\n<span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span>&nbsp;legt\nden zur&uuml;ckliegenden <span style=\"font-weight: bold;\">Zeitbereich</span>\nfest, f&uuml;r dessen vorhandene Werte&nbsp;die Funktion\nangewendet&nbsp;werden soll. </td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">detail</span></td>\n<td>Exakte Bezeichnung des Details. Keine umschlie&szlig;enden\neinfache oder doppelte Anf&uuml;hrungszeichen verwenden!</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">unit</span></td>\n<td>Mit einem / abgetrennte Einheit, die zu dem Detail\nangegeben werden muss, falls das Detail allein nicht eindeutig f&uuml;r\ndiesen Testschritt ist.</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_future</span></td>\n<td>Ein Zeitbereich, im Format von&nbsp;<span style=\"font-family: monospace;\">time_range</span><span style=\"font-family: monospace;\"></span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_past</span></td>\n<td>Ein Zeitbereich, im Format von&nbsp;<span style=\"font-family: monospace;\">time_range</span></td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_range</span></td>\n<td>Ist eine Angabe im Format von <span style=\"font-family: monospace;\">integer</span> <span style=\"font-family: monospace;\">time_unit</span>, z.B.\n8h, 17m, 3d</td>\n</tr>\n<tr>\n<td><span style=\"font-family: monospace;\">time_unit</span></td>\n<td>Ein Buchstabe, der die&nbsp;Zeiteinheit festlegt: m\n(Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n<h4>(3) \"mitteln &uuml;ber\"</h4>\n<p>Hinweis: Ist f&uuml;r einen Server eine oder mehrere\n&Uuml;berwachungspausen definiert, sowerden bei dem zu berechnenden\nMittelwert <span style=\"font-weight: bold;\">trotzdem</span>\nWerte aus der &Uuml;berwachungspause verwendet. Dies ist ggf bei der\nDefinition der &Uuml;berwachungpause(n) und bei \"mitteln &uuml;ber\" zu beachten.</p>\n<p>Hier einige Beispiele mit Erkl&auml;rungen zu den m&ouml;glichen\nEingaben bei \"mitteln &uuml;ber\".</p>\n<table style=\"border-collapse: collapse;\" border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td style=\"border: 1px solid rgb(0, 0, 0); width: 60px; text-align: left; letter-spacing: 0pt; word-spacing: 0pt;\">[\nLast ]<br>\n</td>\n<td style=\"border: 1px solid rgb(0, 0, 0); vertical-align: top;\">Verwende\nden letzten Wert f&uuml;r den Vergleich. </td>\n</tr>\n<tr>\n<td style=\"border: 1px solid rgb(0, 0, 0); width: 60px; text-align: left; letter-spacing: 0pt; word-spacing: 0pt;\">[\nAvg ]<br>\n[ 10 ]<br>\n</td>\n<td style=\"border: 1px solid rgb(0, 0, 0); vertical-align: top;\">Verwende\ndie letzten 10 Werte, bilde daraus den Mittelwert und verwende diesen\nf&uuml;r den Vergleich.<br>\n</td>\n</tr>\n<tr>\n<td style=\"border: 1px solid rgb(0, 0, 0); width: 60px; text-align: left; letter-spacing: 0pt; word-spacing: 0pt;\">[\nGrad ]<br>\n[ 60m ]<br>\n</td>\n<td style=\"border: 1px solid rgb(0, 0, 0); vertical-align: top;\">Berechne\nden Gradienten aus den&nbsp;Werten&nbsp;der letzten 60 Minuten\nund f&uuml;hre mit\ndiesem Wert dann den Vergleich aus.<br>\n</td>\n</tr>\n<tr>\n<td style=\"border: 1px solid rgb(0, 0, 0); width: 60px; text-align: left; letter-spacing: 0pt; word-spacing: 0pt;\">[\nCount ]<br>\n[ 2d ]<br>\n</td>\n<td style=\"border: 1px solid rgb(0, 0, 0); vertical-align: top;\">Ermittle\ndie Anzahl der Werte f&uuml;r die letzten 2 Tage (48h) und verwende diese\nAnzahl f&uuml;r den Vergleich.<br>\n</td>\n</tr>\n</tbody>\n</table>\n<p>&nbsp;</p>','','ConfigHints'),(183,'de','helppages','<!-- Changes:\n  helppages, de\n  2014-05-18, roveda: Created the help page.\n  2016-04-12, roveda: Added <b>\n-->\n<hr>\n<h2>Hinweise und Regeln zum Bearbeiten von Hilfeseiten</h2>\n\n<!-- ----------------------------------------------------------------------- -->\n<hr>\n<h3>Dokumentation der Änderungen</h3>\n<p>\nVerwende einen Abschnitt\n<pre>\n&lt;!-- \n  helppage_name, language_id\n\n  -----\n  Changes:\n  2014-05-18, myname: changed this and that\n\n  -----\n  includes: _the_list_of_include_snippets\n\n--&gt;\n</pre>\nam Anfang jeder Hilfeseite. Führe das fort für alle Änderungen.\n</p>\n\n<!-- ----------------------------------------------------------------------- -->\n<hr>\n<h3>Überschriften</h3>\n\nDie oberste Überschrift ist h2, nur die oberste!\nAlle weiteren sind h3 und aufsteigend.\n\n\n<!-- ----------------------------------------------------------------------- -->\n<hr>\n<h3>Textformatierung</h3>\n<p>\n&lt;tt&gt;monospaced font&lt;/tt&gt;\n</p>\n\n<p>\n&lt;b&gt;bold/fett&lt;/b&gt;\n</p>\n\n<p>\n&lt;span class=\"note\"&gt;extra wichtige Notiz in rot&lt;/span&gt;\n</p>\n\n<p>\nrepresentation if a \"button\" is in a text section.\n\n&lt;span class=\"button\"&gt;an uls button&lt;/span&gt;\n\nuse the &amp;nbsp; instead of spaces to avoid line breaks within the expression.\n</p>\n<p>\ninternal link: \n&lt;span class=\"internal_link\"&gt;internal link -> next link&lt;/span&gt;\n\nuse the &amp;nbsp; instead of spaces to avoid line breaks within the expression.\n</p>\n\n\n<!-- ----------------------------------------------------------------------- -->\n<hr>\n<h3>Include-Schnipsel</h3>\n\nReferenz auf ein Includeschnipsel einfügen: <br>\n...wie in &lt;a href=\"#include_schnipsel_name\"&gt;Ausdrücke in Textfeldern&lt;/a&gt; beschrieben...\n</p>\n<p>\nDer Includeschnipsel muss am Anfang enthalten:<br>\n&lt;hr&gt;<br>\n&lt;a name=\"include_schnipsel_name\"/&gt;<br>\n&lt;h3&gt;Überschrift Includeschnipsel&lt;/h3&gt;<br>\nmehr Text<br>\n<br>\noder:<br>\n&lt;hr&gt;<br>\n&lt;h3 id=\"include_schnipsel_name\"&gt;Überschrift Includeschnipsel&lt;/h3&gt;<br>\nmehr Text<br>\n<br>\ndamit die Links funktionieren.\n</p>\n<p>Der Includeschnipsel beginnt mit Unterstrich, hat eine englische Bezeichnung, gefolgt von einer Sprachkennung. Z.B: <tt>_expressions_in_textfields_de</tt>. Nicht vergessen beim Includeschnipsel auch <tt>[x] zeige Online-Hilfetexte</tt> anzuklicken!\n</p>\n\n','','ConfigHints'),(184,'de','serverdoku','<!-- Changes:\n  serverdoku, de\n  2015-11-30, roveda: Created the help page.\n-->\n\n<h2>Serverdoku</h2>\n<p>\n  Die Serverdoku kann beliebige Informationen enthalten, die dem aktuellen Server zugeordnet sind.\n  Die Informationen werden als LOBs dem Server zugeordnet und könnne von einem Agenten aus \n  hochgeladen werden werden oder direkt auf dieser Webseite über den Browser vom Rechner des \n  Anwenders aus.\n</p>\n<p>\n  Auf die Serverdokueinträge kann keine Überwachung gesetzt werden, die Inhalte und LOBs können \n  nicht in Berichten oder als Favoriten weiterverwendet werden. Sie dienen ausschließlich der direkten Dokumentation.\n  Beispiele für eine Serverdoku: \n</p>\n<ul>\n  <li>HTML-Datei mit ausführlichen Hardwareinformationen, z.B. die Ausgabe von \'lshw -html\' (Ubuntu)</li>\n  <li>Tägliche Security Berichte</li>\n  <li>Konfigurationsdateien</li>\n  <li>Inventarinformationen</li>\n</ul>\n\n<table>\n<thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody>\n  <tr>\n    <td>Name</td>\n    <td>\n      Bezeichnung der Serverdoku, gleichzeitig Weblink zum Bearbeiten und Hochladen.\n      Der Name der Serverdoku ist eindeutig, wird eine Serverdoku mit dem gleichen Namen \n      hochgeladen, der schon vorhanden ist, so werden alle Angaben (Datum, Beschreibung, das LOB beim Download) überschrieben.\n    </td>\n  </tr>\n  <tr>\n    <td>Datum</td>\n    <td>Zeitstempel, wann diese Serverdoku hochgeladen wurde.</td>\n  </tr>\n  <tr>\n    <td>Beschreibung</td>\n    <td>Frei definierbare Beschreibung zur Serverdoku.</td>\n  </tr>\n  <tr>\n    <td>Download</td>\n    <td>Das herunterladbare LOB.</td>\n  </tr>\n  <tr>\n    <td>Verfallsdatum</td>\n    <td>Datum, an dem diese Serverdoku automatisch gelöscht wird.</td>\n  </tr>\n  <tr>\n    <td>löschen</td>\n    <td>Diese Serverdoku zum Löschen markieren.</td>\n  </tr>\n </tbody>\n</table>\n','','ConfigHints'),(186,'de','serverdoku_upload','<!-- Changes:\n  serverdoku_upload, de\n  2015-11-30, roveda: Created the help page.\n-->\n\n<h2>Serverdoku Upload</h2>\n<p>\n  Direktes Hochladen einer Datei als Serverdoku zum aktuellen Server.\n  Alle Angaben können direkt geändert werden, die Datei kann vom aktuellen \n  Arbeitsplatzrechner ausgewählt werden.\n</p>\n<p>\n  Die Serverdoku kann beliebige Informationen enthalten, die dem aktuellen Server zugeordnet sind.\n  Die Informationen werden als LOBs dem Server zugeordnet und könnne von einem Agenten aus \n  hochgeladen werden werden oder direkt auf dieser Webseite über den Browser vom Rechner des \n  Anwenders aus.\n</p>\n<p>\n  Auf die Serverdokueinträge kann keine Überwachung gesetzt werden, die Inhalte und LOBs können \n  nicht in Berichten oder als Favoriten weiterverwendet werden. Sie dienen ausschließlich der direkten Dokumentation.\n</p>\n\n<table>\n <tbody>\n  <tr>\n    <td>Name</td>\n    <td>\n      Bezeichnung der Serverdoku.\n    </td>\n  </tr>\n  <tr>\n    <td>Datum</td>\n    <td>Zeitstempel, wann diese Serverdoku hochgeladen wurde.</td>\n  </tr>\n  <tr>\n    <td>Verfallsdatum</td>\n    <td>Datum, an dem diese Serverdoku automatisch gelöscht wird.</td>\n  </tr>\n  <tr>\n    <td>Beschreibung</td>\n    <td>Frei definierbare Beschreibung zur Serverdoku.</td>\n  </tr>\n  <tr>\n    <td>Datei auswählen</td>\n    <td>Per Durchsuchen eine Datei vom Dateisystem des Arbeitsplatzrechners auswählen.</td>\n  </tr>\n </tbody>\n</table>\n','','ConfigHints'),(188,'de','set_autokomprimierung','<!-- Changes:\n  set_autokomprimierung, de\n\n  -----\n  2015-11-30, roveda: Created the help page.\n  2015-12-02, roveda: added general info\n  2015-12-03, roveda: Added the button descriptions\n\n  -----\n  includes: _aggregation_general_info_de,_aggregation_functions_de,_expressions_in_textfields_de\n-->\n<hr>\n<h2>Auto Komprimierung für Verfahren festlegen</h2>\n<p>\nFestlegen der Komprimierungsvorschriften für ein gesamtes Verfahren.\nWelche Werte sollen mit welchen Funktionen komprimiert (oder aggregiert) werden.\nSiehe auch <a href=\"#_aggregation_general_info_de\">Allgemeines zur Komprimierung (Aggregation)</a>\n</p>\n<p>\nBeachte: Nicht alle Komprimierungsfunktionen sind für alle Wertetypen anwendbar.\nGgf. stichprobenartig kontrollieren über <span class=\"button\">Verwalten</span>\n<span class=\"internal_link\">Komprimierung &rArr; Komprimierung festlegen</span>\n</p>\n\n<h3>Beschreibung der Schaltflächen</h3>\n<table>\n <thead>\n  <tr>\n    <td>Schaltfläche</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td><span class=\"button\">Textmodus</span></td>\n    <td>\n      Zeigt alle Komprimierungsdefinitionen in einem Textformat in einer Textbox an.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Änderungen</span></td>\n    <td>\n      Zeigt alle Änderungen für alle Komprimierungsdefinitionen. Auch für gelöschte Definitionen.\n    </td>\n  </tr>\n </tbody>\n</table>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td>\n      Server<br>\n      Sektion<br>\n      Testschritt<br>\n      Detail<br>\n      Einheit\n    </td>\n    <td>\n      Festlegen, für welches Server - Sektion - Testschritt - Detail - Einheit Muster diese Auto-Komprimierung gelten soll, \n      siehe <a href=\"#_expressions_in_textfields_de\">Ausdrücke in Textfeldern</a>\n    </td>\n  </tr>\n\n  <tr>\n    <td>Zeitraum</td>\n    <td>\n      Aktivieren der anzuwendenden Aggregationsfunktionen für die verschiedenen Zeiträume, \n      siehe <a href=\"#_aggregation_functions_de\">Komprimierungsfunktionen</a>\n    </td>\n  </tr>\n  <tr>\n    <td>\n      aktiv<br>\n      löschen\n    </td>\n    <td>Markieren zum Aktivieren oder Löschen. Ggf. ein weiterführender Link zu durchgeführten Änderungen.</td>\n  </tr>\n </tbody>\n</table>\n\n','_aggregation_general_info_de,_aggregation_functions_de,_expressions_in_textfields_de','ConfigHints'),(190,'de','_expressions_in_textfields_de','<!-- Changes:\n  _expressions_in_textfields_de, de\n\n  -----\n  2015-11-30, roveda: Created the help page.\n  2015-12-03, roveda: design changes\n\n  -----\n  no includes possible\n-->\n\n<hr>\n<h3 id=\"_expressions_in_textfields_de\">Ausdrücke in Textfeldern</h3> \n\n<p>In den Feldern k&ouml;nnen:</p>\n<ul>\n  <li>konstante Textausdr&uuml;cke,</li>\n  <li>Textausdr&uuml;cke mit Platzhaltern (Wildcards),</li>\n  <li>negierte Textausdr&uuml;cke (mit voranstehendem \'<tt>!</tt>\') oder</li>\n  <li>eine komma-getrennte Kombination aus allen Möglichkeiten eingetragen werden.\n</ul>\n<p> Als Platzhalter k&ouml;nnen \'<tt>*</tt>\' f&uuml;r einen beliebigen Ausdruck und \'<tt>?</tt>\' f&uuml;r ein beliebiges Zeichen benutzt werden.</p>\n<p>Beispiele:</p>\n<table>\n  <tbody>\n    <tr>\n      <td>konstanter Textausdruck:</td>\n      <td>\n        lxabcd5<br>\n        rm300_agr<br>\n        wscdbp93\n      </td>\n    </tr>\n    <tr>\n      <td>Liste von konstanten Textausdr&uuml;cken:</td>\n      <td>\n        lxabcp1,lxabcp2,lvxxx78<br>\n        WSCOWIWEB1,WSCOWIWEB2\n      </td>\n    </tr>\n    <tr>\n      <td>Textausdruck mit Platzhalter:</td>\n      <td>\n        *appserver*<br>\n        !*q*\n      </td>\n    </tr>\n    <tr>\n      <td>\n        Liste von konstanten Textausdr&uuml;cken mit Komma\n        getrennt von Textausdr&uuml;cken mit Platzhaltern:\n      </td>\n      <td>\n        wscdb*,!wscdbt*,wscapp25<br>\n        xpolpa1,xpolpd*,*art*,!*artpd?<br>\n        lxproject*,!lxprojectq*\n      </td>\n    </tr>\n  </tbody>\n</table>\n\n<p>\nLeere Felder werden als beliebiger Textausdruck ausgewertet, also wie ein Platzhalter \'<tt>*</tt>\'.\n</p>\n<p>\nKommt in dem einzutragenden Textausdruck ein Komma vor, das ja als\nSeparator einer Liste von Textausdr&uuml;cken verwendet wird, sollte anstelle des\nKommas der Platzhalter \'<tt>?</tt>\' verwendet werden.\n</p>\n','','ConfigHints'),(196,'de','set_komprimierung','<!-- Changes:\n  set_komprimierung, de\n  2015-12-02, roveda: Created\n-->\n\n<h2>Komprimierung für Werte eines Details festlegen</h2>\n<p>\nFestlegen der Komprimierungsvorschriften für ein Detail einer Verfahren - Server - Sektion - Testschritt - Detail - Einheit Kombination.\nWelche Werte sollen mit welchen Funktionen komprimiert (oder aggregiert) werden.\nSiehe auch <a href=\"#_aggregation_general_info_de\">Allgemeines zur Komprimierung (Aggregation)</a>\n</p>\n<p>\nEs werde nur die für die jeweiligen Details möglichen Komprimierungsfunktionen angezeigt.\n</p>\n\n<table>\n <tbody>\n  <tr>\n    <td>\n      Detail\n    </td>\n    <td>\n      Liste der für die ausgewählte Verfahren - Server - Sektion - Testschritt Kombination.\n    </td>\n  </tr>\n\n  <tr>\n    <td>Zeitraum</td>\n    <td>\n      Aktivieren der anzuwendenden Aggregationsfunktionen für die verschiedenen Zeiträume, \n      siehe <a href=\"#_aggregation_functions_de\">Komprimierungsfunktionen</a>\n    </td>\n  </tr>\n  <tr>\n    <td>\n      Änderungen\n    </td>\n    <td>Weiterführender Link zu den an dieser Komprimierung durchgeführten Änderungen.</td>\n  </tr>\n </tbody>\n</table>\n\n','_aggregation_general_info_de,_aggregation_functions_de','ConfigHints'),(198,'de','set_gautocompression','<!-- Changes:\n  gautocompression, de\n  2015-12-02, roveda: Created the help page\n-->\n\n<h2>Auto Komprimierung der eine Gruppe festlegen</h2>\n<p>\nFestlegen der Komprimierungsvorschriften für eine Gruppe. \nDie Komprimierungsvorschriften gelten dann für alle Verfahren, für die Gruppe berechtigt ist.\nSobald ein neues Verfahren erstellt wird, werden diese Komprimierungsvorschriften darauf angewendet, \nfalls oder sobald die Gruppe für das Verfahren berechtigt wird.\nSiehe auch <a href=\"#_aggregation_general_info_de\">Allgemeines zur Komprimierung (Aggregation)</a>\n</p>\n<p>\nBeachte: Nicht alle Komprimierungsfunktionen sind für alle Wertetypen anwendbar.\nGgf. stichprobenartig kontrollieren über <span class=\"button\">Verwalten</span>\n<span class=\"internal_link\">Komprimierung -> Komprimierung festlegen</span>\n</p>\n\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td>\n      Verfahren<br>\n      Server<br>\n      Sektion<br>\n      Testschritt<br>\n      Detail<br>\n      Einheit\n    </td>\n    <td>\n      Festlegen, für welches Verfahren - Server - Sektion - Testschritt - Detail - Einheit Muster diese Gruppen Auto-Komprimierung gelten soll, \n      siehe <a href=\"#_expressions_in_textfields_de\">Ausdrücke in Textfeldern</a>\n    </td>\n  </tr>\n\n  <tr>\n    <td>Zeitraum</td>\n    <td>\n      Aktivieren der anzuwendenden Aggregationsfunktionen für die verschiedenen Zeiträume, \n      siehe <a href=\"#_aggregation_functions_de\">Komprimierungsfunktionen</a>\n    </td>\n  </tr>\n  <tr>\n    <td>\n      aktiv<br>\n      löschen\n    </td>\n    <td>Markieren zum Aktivieren oder Löschen. Ggf. ein weiterführender Link zu durchgeführten Änderungen.</td>\n  </tr>\n </tbody>\n</table>\n\n','_aggregation_general_info_de,_aggregation_functions_de,_expressions_in_textfields_de','ConfigHints'),(200,'de','_utt_general_info_de','<!-- Changes:\n  _utt_general_info_de, de\n\n  -----\n  2015-12-03, roveda: Created this help page.\n\n  -----\n  no includes possible\n-->\n\n<hr>\n<h3 id=\"_utt_general_info_de\">Allgemeines zu ULS Ticket Tracking</h3> \n\n<p>\nDas ULS kann für die Überwachung von eingehenden Werten verwendet werden. Diese Werte \nkönnen zyklisch geprüft werden, ob definierte Grenzwerte (Limits, isAlives, KombiLimits) verletzt wurden. \nWenn ja, kann zu der Grenzwertverletzung eine Benachrichtigung ausgelöst werden. \nDas kann der Versand einer E-Mail oder die Erzeugung eines Tickets im ULS internen Ticket Tracking sein.\n</p>\n<p>\nDie erzeugten ULS Tickets können über <span class=\"button\">Hauptmenü</span> <span class=\"internal_link\">Neue&nbsp;Tickets</span>\nangezeigt und im Weiteren bearbeitet werden.\n</p>\n','','ConfigHints'),(202,'de','my_utt','<!-- \n  my_utt, DE\n\n  -----\n  Changes:\n  2015-12-03, roveda: help page created\n\n   -----\n  includes: \n-->\n<hr>\n<h2>ULS Tickets</h2>\n<p>\n  Es werden standardmäßig die noch unbearbeiteten ULS Tickets für die Gruppe des aktuellen ULS Benutzers angezeigt.\n</p>\n<p>\n  Siehe auch <a href=\"#_utt_general_info_de\">Allgemeines zu ULS Ticket Tracking</a>.\n</p>\n\n<h3>Beschreibung der Schaltflächen</h3>\n<table>\n <thead>\n  <tr>\n    <td>Schaltfläche</td>\n    <td>Erklärung</td>\n  </tr>\n </thead> <tbody>\n  <tr>\n    <td><span class=\"button\">aktualisieren</span></td>\n    <td>\n      Aktualisiert die angezeigte Liste der ULS Tickets.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Erweitert</span></td>\n    <td>\n      Zeigt erweiterte Möglichkeiten zur Filterung und Auswahl an.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">alle&nbsp;markieren</span></td>\n    <td>\n      Alle ULS Tickets der aktuell angezeigten Liste werden markiert.\n      Die Markierung ist anhand der Checkboxen sichtbar und kann \n      im Folgenden manuell angepasst werden.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Master&nbsp;setzen</span></td>\n    <td>\n      Alle markierten ULS Tickets werden dem per Radiobutton ausgewähltem \n      Master ULS Ticket zugeordnet. Daraufhin wird nur noch das Master ULS Ticket angezeigt.\n    </td>\n  </tr> </tbody>\n</table>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n<p>\nSind die Überschriften der Tabellenspalten als Link ausgeführt, so wird die \nangezeigte Liste der ULS Tickets nach dieser Angabe sortiert angezeigt.\n</p>\n\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td>Markierung</td>\n    <td>\n      Diese Checkbox zeigt an, ob das jeweilige ULS Ticket markiert ist oder nicht.\n      Dies wird für weitergehende Aktionen (<span class=\"button\">Master&nbsp;setzen</span>) berücksichtigt.\n    </td>\n  </tr>\n  <tr>\n    <td>Master</td>\n    <td>\n      Dieser Radio-Button muss markiert werden, wenn dieses ULS Ticket als Master für weitere, \n      markierte ULS Tickets gesetzt werden soll per <span class=\"button\">Master&nbsp;setzen</span>.\n      Ist ein ULS Ticket als Master gesetzt, so wird neben dem Radio-Button ein \'<tt>M</tt>\' eingeblendet.\n    </td>\n  </tr>\n  <tr>\n    <td>\n      ID<br>\n      Level<br>\n      Gruppe\n    </td>\n    <td>\n      Die eindeutige ID des ULS Tickets, der Level/die Priorität des ausgelösten ULS Tickets\n      und die Gruppe, zu der dieses ULS Ticket zugewiesen ist.\n      Durch Klick auf die <span class=\"internal_link\">ID</span>, wird das ULS Ticket angezeigt.\n    </td>\n  </tr>\n  <tr>\n    <td>Status</td>\n    <td>\n      Der Status des ULS Tickets (neu, in Bearbeitung, gelöst, weitergeleitet, eskaliert, Slave).\n      Mit <span class=\"button\">Erweitert</span> können erweiterte Filtermöglichkeiten angezeigt werden, \n      in denen auch der Status (Bearbeitungsstand) auswählbar ist.\n    </td>\n  </tr>\n  <tr>\n    <td>Verfahren</td>\n    <td>\n      Das Verfahren, zu dem das ULS Ticket gehört.\n    </td>\n  </tr>\n  <tr>\n    <td>Server</td>\n    <td>\n      Der Server, zu dem das ULS Ticket gehört. Per Klick auf <span class=\"internal_link\">Server</span>\n      wird in einem neuen Tab des Browsers die ULS Auswerteoberfläche für den Server angezeigt (ab gestern).\n    </td>\n  </tr>\n  <tr>\n    <td>erstellt</td>\n    <td>\n      Zeitpunkt der Erstellung des ULS Tickets.\n    </td>\n  </tr>\n  <tr>\n    <td>Sektion Testschritt Detail</td>\n    <td>\n      Sektion - Testschritt - Detail Kombination zu der das ULS Ticket erstellt wurde. \n      Ein Klick auf den Link öffnet die ULS Auswerteoberfläche genau zu dieser Kombination (ab gestern).\n    </td>\n  </tr>\n  <tr>\n    <td>Kurzmeldung</td>\n    <td>\n      Die Bedingung, die zur Auslösung der Benachrichtigung und des ULS Tickets geführt hat.\n    </td>\n  </tr>\n  <tr>\n    <td>Meldung</td>\n    <td>\n      Der Meldungstext der ausgelösten Benachrichtigung.\n    </td>\n  </tr>\n  <tr>\n    <td>Verstrichene Zeit</td>\n    <td>\n      Die verstrichene Zeit seit dem Erstellungszeitpunkt.\n    </td>\n  </tr>\n </tbody>\n</table>\n','_utt_general_info_de','ConfigHints'),(206,'de','set_gautorettime','<!-- \n  set_gautorettime, de\n\n  -----\n  Changes:\n  2015-12-03 roveda: Created the help page\n\n  -----\n  includes: _retention_general_info_de,_expressions_in_textfields_de\n-->\n<hr>\n<h2>Auto Aufbewahrung für eine Gruppe festlegen</h2>\n<p>\nFestlegen der Aufbewahrungsvorschriften für eine Gruppe. \nDie Aufbewahrungsvorschriften gelten dann für alle Verfahren, für die die Gruppe berechtigt ist.\nSobald ein neues Verfahren erstellt wird, werden diese Aufbewahrungsvorschriften darauf angewendet, \nfalls oder sobald die Gruppe für das Verfahren berechtigt wird.\nSiehe auch <a href=\"#_retention_general_info_de\">Allgemeines zu Aufbewahrungszeiten</a>\n</p>\n\n<h3>Beschreibung der Schaltflächen</h3>\n<table>\n <thead>\n  <tr>\n    <td>Schaltfläche</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td><span class=\"button\">Textmodus</span></td>\n    <td>\n      Zeigt alle Aufbewahrungsdefinitionen in einem Textformat in einer Textbox an.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Änderungen</span></td>\n    <td>\n      Zeigt alle Änderungen für alle Aufbewahrungsdefinitionen. Auch für gelöschte Definitionen.\n    </td>\n  </tr>\n </tbody>\n</table>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td>\n      Verfahren<br>\n      Server<br>\n      Sektion<br>\n      Testschritt<br>\n      Detail<br>\n      Einheit\n    </td>\n    <td>\n      Festlegen, für welches Verfahren - Server - Sektion - Testschritt - Detail - Einheit Muster diese Gruppen Auto-Aufbewahrung gelten soll, \n      siehe <a href=\"#_expressions_in_textfields_de\">Ausdrücke in Textfeldern</a>\n    </td>\n  </tr>\n\n  <tr>\n    <td>Tage</td>\n    <td>\n      Anzahl der Tage, für die die Werte aufbewahrt werden sollen.\n    </td>\n  </tr>\n  <tr>\n    <td>\n      aktiv\n    </td>\n    <td>Markieren zum Aktivieren.</td>\n  </tr>\n  <tr>\n    <td>\n      löschen\n    </td>\n    <td>Markieren zum Löschen. Ggf. ein weiterführender Link zu durchgeführten Änderungen.</td>\n  </tr>\n </tbody>\n</table>\n\n','_retention_general_info_de,_expressions_in_textfields_de','ConfigHints'),(208,'de','set_gautocomprrettime','<!-- \n  set_gautocomprrettime, de\n\n  -----\n  Changes:\n  2015-12-03 roveda: Created the help page\n\n  -----\n  includes: _retention_general_info_de,_expressions_in_textfields_de\n-->\n<hr>\n<h2>Auto-Aufbewahrung komprimierter Werte für eine Gruppe festlegen</h2>\n<p>\nFestlegen der Aufbewahrungsvorschriften für die komprimierten Werte einer Gruppe. \nDie Aufbewahrungsvorschriften gelten dann für alle Verfahren, für die die Gruppe berechtigt ist.\nSobald ein neues Verfahren erstellt wird, werden diese Aufbewahrungsvorschriften darauf angewendet, \nfalls oder sobald die Gruppe für das Verfahren berechtigt wird und entsprechende Komprimierungsvorschriften existieren.\nSiehe auch <a href=\"#_retention_general_info_de\">Allgemeines zu Aufbewahrungszeiten</a>\n</p>\n\n<h3>Beschreibung der Schaltflächen</h3>\n<table>\n <thead>\n  <tr>\n    <td>Schaltfläche</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td><span class=\"button\">Textmodus</span></td>\n    <td>\n      Zeigt alle Aufbewahrungsdefinitionen in einem Textformat in einer Textbox an.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Änderungen</span></td>\n    <td>\n      Zeigt alle Änderungen für alle Aufbewahrungsdefinitionen. Auch für gelöschte Definitionen.\n    </td>\n  </tr>\n </tbody>\n</table>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td>\n      Verfahren<br>\n      Server<br>\n      Sektion<br>\n      Testschritt<br>\n      Detail<br>\n      Einheit\n    </td>\n    <td>\n      Festlegen, für welches Verfahren - Server - Sektion - Testschritt - Detail - Einheit Muster diese Gruppen Auto-Aufbewahrung gelten soll, \n      siehe <a href=\"#_expressions_in_textfields_de\">Ausdrücke in Textfeldern</a>\n    </td>\n  </tr>\n  <tr>\n    <td>Komprimierung</td>\n    <td>\n      Für welche Komprimierungsfunktion soll die Aufbewahrungszeit festgelegt werden.\n    </td>\n  </tr>\n  <tr>\n    <td>Zeitraum</td>\n    <td>\n      Für welchen Komprimierungszeitraum soll die Aufbewahrungszeit festgelegt werden.\n    </td>\n  </tr>\n\n  <tr>\n    <td>Tage</td>\n    <td>\n      Anzahl der Tage, für die die Werte aufbewahrt werden sollen.\n    </td>\n  </tr>\n  <tr>\n    <td>\n      aktiv<br>\n      löschen\n    </td>\n    <td>\n      Aktivieren, deaktivieren oder löschen dieser Definition. \n    </td>\n  </tr>\n  <tr>\n    <td>Bemerkung</td>\n    <td>Es kann eine Beschreibung zu dieser Auto-Aufbewahrungsdefinition für komprimierte Werte hinterlegt werden.</td>\n  </tr>\n </tbody>\n</table>\n\n','_retention_general_info_de,_expressions_in_textfields_de','ConfigHints'),(210,'de','_kombidetail_functions_de','<!-- Changes:\n  _kombidetail_functions_de, de\n\n  -----\n  2015-11-30, roveda: Created the help page.\n  2015-12-02, roveda: added missing functions (but still explanation to do)\n\n  -----\n  includes: not possible\n-->\n\n<hr>\n<h3 id=\"_kombidetail_functions_de\">Funktionen in KombiDetails</h3> \n\n<p>Für jeden Ausdruck können ein oder mehrere Funktionen eingetragen werden, die ggf mit  Operatoren miteinander verbunden sind.</p>\n<p>Beispiele:</p>\n<pre>\n  $REF(numeric 2) 0\n  ABS($LAST-FIRST_OF(numeric 8,2))\n  100 - $VALUE_OF(%idle)\n</pre>\n\n<h4>Funktionen in KombiDetails</h4>\n\n<!-- <h4>Funktionen in KombiDetails und KombiLimits</h4>  --> \n<table>\n<thead>\n  <tr>\n    <td>Funktion</td>\n    <td>Berechnung</td>\n  </tr>\n</thead>\n<tbody>\n<tr>\n  <td>\n    $ACCEL_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td> \n    Ermittelt die Krümmung der Kurve durch die Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen. \n    Es werden mindestens drei Werte benötigt. Das Ergebnis wird in \n    <tt>unit/h<sup>2</sup></tt> berechnet.\n  </td>\n</tr>\n<tr>\n  <td>\n    $AVERAGE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Berechnet den arithmetischen Mittelwert für die Werte \n    des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $COUNT_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $DIFFER_OF(<tt>detail</tt>[/<tt>unit</tt>][,<tt>range</tt>])\n  </td>\n  <td>\n    Ermittelt, ob sich der erste und letzte Wert aus <tt>range</tt> \n    (Anzahl oder Zeitbereich) unterscheiden. \n    Als Standard wird <tt>range</tt> mit 2 belegt. \n    Das Ergebnis ist 0 (null) oder 1.\n  </td>\n</tr>\n<tr>\n  <td>\n    $FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den ersten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRAD_OF(<tt>detail</tt>[/<tt>unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den Gradienten (lineare Steigung) der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $GRADIENT(<tt>detail</tt>[/<tt>unit</tt>],<tt>time_range</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet die lineare Steigung pro <tt>time_range</tt>\n    (Standard: 1d) für Werte, die für das angegebene Detail \n    vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorhanden sind. Bei der Berechnung wird prinzipiell von \n    einem linearen Wachstum ausgegangen. Ist <tt>time_past</tt> \n    nicht angegeben, werden die letzten 24h verwendet (eine Zahl \n    allein wird als Tage interpretiert).\n    <br><br>\n    Genauer: aus allen Werten, die vom aktuellen Zeitpunkt bis <tt>time_past</tt>\n    vorliegen, wird eine Gerade nach dem Prinzip der kleinsten quadratischen \n    Abweichung ermittelt. Die Steigung dieser Geraden wird auf den <tt>time_range</tt>\n    umgerechnet. Man kann also die Werte der letzten 24h betrachten (<tt>time_past</tt>\n    = 24h) und daraus den Gradienten pro 8 Stunden (<tt>time_range</tt> = 8h) berechnen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>, \n    der in <tt>range</tt> (Anzahl oder Zeitbereich) liegt.\n  </td>\n</tr>\n<tr>\n  <td>\n    $LAST-FIRST_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom letzten zum ersten\n    Wert aus allen Werten des <tt>detail</tt>, die \n    in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>Ermittelt das Maximum der Werte des <tt>detail</tt>, die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MAX-MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Differenz vom Maximalwert zum Minimalwert\n    aus allen Werten des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $MIN_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt das Minimum der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREDICTION(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>time_future</tt>[,<tt>time_past</tt>])\n  </td>\n  <td>\n    Berechnet einen (in der Zukunft) zu erwartenden Wert\n    anhand der für ein Detail vorliegenden Werte innerhalb eines\n    zurückliegenden Zeitbereichs. Dies sollte nur auf Details angewandt\n    werden, deren Werte einem linearen Wachstum unterliegen. Wird <tt>time_past</tt> \n    nicht angegeben, dann wird <tt>time_future</tt> verwendet.\n    <br><br>\n    Genauer: aus allen Werten, die in der ersten Hälfte von <tt>time_past</tt>\n    liegen und die in der zweiten Hälfte von <tt>time_past</tt>\n    liegen, wird jeweils ein arithmetischer Mittelwert gebildet und daraus die Steigung der\n    angenommenen linearen Funktion berechnet. Auf Basis der beiden Mittelwerte und der \n    ermittelten Steigung wird der Endwert zu <tt>time_future</tt> berechnet.<br>\n  </td>\n</tr>\n<tr>\n  <td>\n    $PREV_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den vorletzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td>\n    $REGCOUNT(<tt>detail</tt>[/<tt>unit</tt>],<tt>regexp</tt>,<tt>time_range</tt>)\n  </td>\n  <td>\n    Ermittelt die Anzahl der Treffer (matching pattern) des\n    regulären Ausdrucks <tt>regexp</tt> in allen Werten des <tt>detail</tt>,\n    die in <tt>time_range</tt> (nur Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $STD_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Standardabweichung der Werte des <tt>detail</tt>,\n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $SUM_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>],<tt>range</tt>)\n  </td>\n  <td>\n    Ermittelt die Summe der Werte des <tt>detail</tt>, \n    die in <tt>range</tt> (Anzahl oder Zeitbereich) liegen.\n  </td>\n</tr>\n<tr>\n  <td>\n    $VALUE_OF(<tt>detail</tt>[/<tt>unit</tt>][@<tt>as_unit</tt>])\n  </td>\n  <td>\n    Ermittelt den letzten Wert des <tt>detail</tt>.\n  </td>\n</tr>\n</tbody>\n</table>\n\n\n<h4>Variable Ausdrücke in KombiDetails</h4>\n\n<h4>Beschreibung der variablen Ausdrücke</h4>\n<table>\n<thead>\n<tr>\n  <th>variabler Ausdruck</th>\n  <th>Erklärung</th>\n</tr>\n</thead>\n<tbody>\n<tr>\n  <td><tt>integer</tt></td>\n  <td>Ganze Zahl zur Angabe der Anzahl der Werte oder als Teil eines Zeitbereichs.</td>\n</tr>\n<tr>\n  <td><tt>range</tt></td>\n  <td>\n    Kann ein <tt>integer</tt> oder ein <tt>time_range</tt> sein.<br>\n    <tt>integer</tt> (ohne <tt>time_unit</tt>)\n    legt die Anzahl der Werte fest, auf die die Funktion angewendet werden soll. \n    <br>\n    <tt>time_range</tt> legt den zurückliegenden Zeitbereich fest, für dessen \n    vorhandene Werte die Funktion angewendet werden soll.\n  </td>\n</tr>\n<tr>\n  <td><tt>detail</tt></td>\n  <td>\n    Exakte Bezeichnung des Details. Keine umschließenden\n    einfache oder doppelte Anführungszeichen verwenden!\n  </td>\n</tr>\n<tr>\n  <td><tt>unit</tt></td>\n  <td>\n    Mit einem \'/\' abgetrennte Einheit, die zu dem Detail\n    angegeben werden muss, falls das Detail allein nicht eindeutig für\n    diesen Testschritt ist.\n  </td>\n</tr>\n<tr>\n  <td><tt>as_unit</tt></td>\n  <td>\n    Mit einem \'@\' abgetrennte Einheit, in die der Wert umgerechned \n    werden soll. Die <tt>as_unit</tt> muss dabei die gleiche Basiseinheit \n    besitzen, wie die Einheit des <tt>detail</tt>.\n  </td>\n</tr>\n<tr>\n  <td><tt>time_future</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_past</tt></td>\n  <td>Ein Zeitbereich, im Format von <tt>time_range</tt></td>\n</tr>\n<tr>\n  <td><tt>time_range</tt></td>\n  <td>Ist eine Angabe im Format von <tt>integer</tt><tt>time_unit</tt>, z.B. 8h, 17m, 3d</td>\n</tr>\n<tr>\n  <td><tt>time_unit</tt></td>\n  <td>Ein Buchstabe, der die Zeiteinheit festlegt: m (Minute), h (Stunde), d (Tag)</td>\n</tr>\n</tbody>\n</table>\n\n\n<hr>\n<h4>Operatoren in der Definition von KombiDetails</h4>\n\n<p>Die Operatoren können verwendet werden, um verschiedene Funktionen miteinander zu kombinieren.</p>\n\n<table>\n<thead>\n  <tr>\n    <td>MySQL Operatoren</td>\n    <td>Erklärung</td>\n  </tr>\n</thead>\n<tbody>\n<tr>\n<td>&lt;, &gt;, =, !=, &lt;&gt;, &gt;=, &lt;=</td>\n<td>kleiner, größer, gleich, ungleich, ungleich, größer gleich, kleiner gleich</td>\n</tr>\n<tr>\n<td>+, -, *, /</td>\n<td>Addition, Subtraktion, Multiplikation, Division</td>\n</tr>\n<tr>\n<td>&amp;&amp;, AND, ||, OR</td>\n<td>logisches UND, logisches ODER</td>\n</tr>\n<tr>\n<td>( )</td>\n<td>Klammern für die Festlegung der Reihenfolge der Abarbeitung der Ausdrücke.</td>\n</tr>\n</tbody>\n</table>\n\n<p>\nNeben den oben beschriebenen Operatoren können auch fast alle\nFunktionen der MySQL Datenbank verwendet werden. Im folgenden nur ein\npaar Beispiele. Die vollständige Liste ist unter z.B.: \n<a target=\"_blank\" href=\"http://dev.mysql.com/doc/refman/5.5/en/string-functions.html\">MySQL 5.5 Reference Manual / Functions and Operators / String Functions</a> \nnachzulesen. In den Funktionen können NICHT <tt>detail</tt>[/<tt\">unit</tt>] direkt \nverwendet werden, sondern nur über die Verwendung obiger Funktionen.\n</p>\n<p>Beispiel:</p>\n<pre>\n  ABS($VALUE_OF(mittlere Antwortzeit) - $VALUE_OF(Antwortzeit)) &gt;= 1.5\n</pre>\n','','ConfigHints'),(212,'de','set_autokombidetails','<!-- Changes:\n  set_autokombidetails, de\n\n  -----\n  2015-12-03, roveda: new format\n\n  -----\n  includes: _kombidetails_general_info_de,_kombidetail_functions_de,_expressions_in_textfields_de\n-->\n<hr>\n<h2>Auto Aufbewahrung für Verfahren festlegen</h2>\n\n<p>\nFestlegen von Auto-KombiDetail Definitionen, die zu definierten \nServer - Sektion - Testschritt Mustern dieses Verfahrens passen.\nSiehe auch <a href=\"#_kombidetails_general_info_de\">Allgemeines zu KombiDetails</a>.\n</p>\n<p>\nBei Eingang von Werten mit im ULS bisher nicht vorhandenen \nServer - Sektion - Testschritt Kombinationen \nwird geprüft, ob diese zu den hier definierten Mustern passen und ggf. werden die eingetragenen KombiDetail-Definitionen wirksam.\n</p>\n\n<h3>Beschreibung der Schaltflächen</h3>\n<table>\n <thead>\n  <tr>\n    <td>Schaltfläche</td>\n    <td>Erklärung</td>\n  </tr>\n </thead>\n <tbody>\n  <tr>\n    <td><span class=\"button\">Textmodus</span></td>\n    <td>\n      Zeigt alle Auto-KombiDetail Definitionen in einem Textformat in einer Textbox an.\n    </td>\n  </tr>\n  <tr>\n    <td><span class=\"button\">Änderungen</span></td>\n    <td>\n      Zeigt alle Änderungen für alle Auto-KombiDetail Definitionen. Auch für gelöschte Definitionen.\n    </td>\n  </tr>\n </tbody>\n</table>\n\n<h3>Beschreibung der Tabellenspalten</h3>\n<table>\n <thead>\n  <tr>\n    <td>Tabellenspalte</td>\n    <td>Erklärung</td>\n  </tr>\n </thead> \n <tbody>\n  <tr>\n    <td>\n      Server<br>\n      Sektion<br>\n      Testschritt\n    </td>\n    <td>\n      Festlegen, für welche\n      Server - Sektion - Testschritt Kombination diese Auto-KombiDetail Definition\n      gelten soll. Siehe <a href=\"#_expressions_in_textfields_de\">Ausdrücke in Textfeldern</a>.\n    </td>\n  </tr>\n  <tr>\n    <td>\n      Detail<br>\n      Einheit\n    </td>\n    <td>\n      Es wird die Bezeichnung des gewünschten KombiDetails (Tabellenspaltenüberschrift) \n      festgelegt und die dazu gewünschte Einheit eingetragen.\n    </td>\n  </tr>\n  <tr>\n    <td>Ausdruck</td>\n    <td>\n      Hier wird die zu verwendende Berechnung, eine Kombination aus ULS-Funktionen und \n      MySQL Operatoren und Funktionen,  eingetragen. \n      Siehe <a href=\"#_kombidetail_functions_de\">Funktionen in KombiDetails</a>.\n    </td>\n  </tr>\n  <tr>\n    <td>\n      aktiv<br>\n      löschen<br>\n      Gr.Auto\n    </td>\n    <td>\n      Damit wird diese Auto-KombiDetail Definition aktiviert, deaktiviert oder gelöscht. \n    </td>\n  </tr>\n  <tr>\n    <td>Bemerkung</td>\n    <td>Es kann eine Beschreibung zu dieser Auto-KombiDetail Definition hinterlegt werden.</td>\n  </tr>\n</tbody>\n</table>\n\n','_kombidetails_general_info_de,_kombidetail_functions_de,_expressions_in_textfields_de','ConfigHints'),(214,'de','_kombidetails_general_info_de','<!-- Changes:\n  _kombidetails_general_info_de, de\n\n  -----\n  2015-12-03, roveda: new format\n\n  -----\n  includes: _expressions_in_textfields_de\n-->\n\n<hr>\n<h3 id=\"_kombidetails_general_info_de\">Allgemeines zu KombiDetails</h3> \n\n<p>\nKombiDetails kombinieren die Werte von mehreren Detaiils eines Testschritts miteinander \nüber Operatoren und/oder Funktionen zu einem neuen Detail (Tabellenspalte). Das KombiDetail \nwird automatisch in der Tabelle zu den passenden Server - Sektion - Testschritt Kombinationen \nangezeigt und kann auch in Reports verwendet werden. Eine Überwachung kann zum KombiDetail \nnicht definiert werden.\n</p>\n\n','','ConfigHints'),(220,'de','_limit_functions_de','<!-- Changes:\n  _limit_functions_de, de\n  2016-09-07, roveda: Created the help page.\n-->\n\n<hr>\n<h3 id=\"_limit_functions_de\">Limit-Funktionen</h3> \n<p>\n  Über dir Drop-Down-Liste erfolgt die Auswahl\n  der Funktion, die in Verbindung mit der Eingabe im Textfeld angewendet\n  wird, bevor der Vergleich ausgeführt wird. Hier die Liste der Funktionen:\n</p>\n\n<table>\n  <thead>\n    <tr>\n      <td>Funktion</td>\n      <td>Erklärung</td>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>Accel</td>\n      <td>Beschleunigung des Anstiegs der Werte (in <unit>/h^2)</td>\n    </tr>\n    <tr>\n      <td>Age</td>\n      <td>\n        Alter, nur für Werte mit den Einheiten {DT} und {TT}. Das Ergebnis liegt als \"[E] s\" vor.\n        Als Grenzwerte können dann Angaben wie z.B. \"30 m\" (für 30 Minuten) verwendet werden.\n    </td>\n    </tr>\n    <tr>\n      <td>Avg</td>\n      <td>Mittelwert der Werte</td>\n    </tr>\n    <tr>\n      <td>Count</td>\n      <td>Anzahl der Werte</td>\n    </tr>\n    <tr>\n      <td>Dev</td>\n      <td>Standardabweichung</td>\n    </tr>\n    <tr>\n      <td>Differ</td>\n      <td>TODO</td>\n    </tr>\n    <tr>\n      <td>DiffTo</td>\n      <td>TODO</td>\n    </tr>\n    <tr>\n      <td>First</td>\n      <td>Verwende den ersten Wert (chronologisch den ältesten)</td>\n    </tr>\n    <tr>\n      <td>FirstSize</td>\n      <td>Größe des ersten Werts, Ergebnis in Bytes</td>\n    </tr>\n    <tr>\n      <td>Grad</td>\n      <td>Gradient berechnen</td>\n    </tr>\n    <tr>\n      <td>Last</td>\n      <td>Verwende den letzten Wert (chronologisch den jüngsten)</td>\n    </tr>\n    <tr>\n      <td>Last-First</td>\n      <td>Subtrahiere den ersten Wert (ältesten) vom letzten Wert (jüngsten)</td>\n    </tr>\n    <tr>\n      <td>Last/AVG</td>\n      <td>Verhältnis des letzten Werts zum Durchschnitt bilden</td>\n    </tr>\n    <tr>\n      <td>LastSize</td>\n      <td>Größe des letzten Werts, Ergebnis in Bytes</td>\n    </tr>\n    <tr>\n      <td>Max</td>\n      <td>maximalen Wert verwenden</td>\n    </tr>\n    <tr>\n      <td>Max-Min</td>\n      <td>Subtrahiere den minimalen Wert vom maximalen Wert</td>\n    </tr>\n    <tr>\n      <td>Min</td>\n      <td>minimalen Wert verwenden</td>\n    </tr>\n    <tr>\n      <td>Remaining</td>\n      <td>\n        Verbleibende Zeit, nur für Werte mit den Einheiten {DT} und {TT}.\n        Das Ergebnis liegt als \"[E] s\" vor.\n        Als Grenzwerte können dann Angaben wie z.B. \"30 m\" (für 30 Minuten) verwendet werden.\n    </td>\n    </tr>\n    <tr>\n      <td>Std</td>\n      <td>Standardabweichung berechnen</td>\n    </tr>\n    <tr>\n      <td>Sum</td>\n      <td>Summe berechnen</td>\n    </tr>\n  </tbody>\n</table>\n','','ConfigHints'),(222,'de','_limit_arguments_de','<!-- Changes:\n  _limit_arguments_de, de\n  2016-09-07, roveda: Created the help page.\n-->\n\n<hr>\n<h3 id=\"_limit_arguments_de\">Limit-Argumente</h3> \n\n<p>\n  Im Textfeld erfolgt die Eingabe der Anzahl der Werte oder des Zeitbereichs, \n  der zur Anwendung der oben gewählten Funktion verwendet werden soll. \n  Eine einfache Zahl legt die Anzahl der letzten Werte fest, \n  die für die Anwendung der Funktion verwendet werden sollen (Beispiele: 1, 2, 6).</p>\n<p>\n  Für einen Zeitbereich wird eine Zahl und eine Abkürzung für den Zeitabschnitt eingetragen (Beispiele: 30m, 2h, 4d). \n  Es werden alle vorhandenen Werte aus dem resultierenden zurückliegenden Zeitbereich für die Anwendung der Funktion verwendet.\n</p>\n\n<table>\n  <tbody>\n    <tr>\n      <td>m</td>\n      <td>Minuten</td>\n    </tr>\n    <tr>\n      <td>h</td>\n      <td>Stunden (hours)</td>\n    </tr>\n    <tr>\n      <td>d</td>\n      <td>Tage (days)</td>\n    </tr>\n  </tbody>\n</table>\n','','ConfigHints');

update logging.hilfetexte as htp
  join loggingtmp.htnew using (`lang`,`name`)
  set htp.text = htnew.text, htp.includes = htnew.includes
  where htp.text != htnew.text OR htp.includes != htnew.includes;

insert into logging.hilfetexte (lang, name, text, includes, helpset)
  select htnew.lang, htnew.name, htnew.text, htnew.includes, htnew.helpset
  from loggingtmp.htnew
  left join logging.hilfetexte using (`lang`,`name`)
  where hilfetexte.lang is NULL;

